SystemOrganization addCategory: #LaBook!
SystemOrganization addCategory: 'LaBook-Basics'!
SystemOrganization addCategory: 'LaBook-Basics-Tests'!
SystemOrganization addCategory: 'LaBook-CodeSnippets'!
SystemOrganization addCategory: 'LaBook-ExternalCommands'!
SystemOrganization addCategory: 'LaBook-Model'!
SystemOrganization addCategory: 'LaBook-Model-BOReferences'!
SystemOrganization addCategory: 'LaBook-Model-Log'!
SystemOrganization addCategory: 'LaBook-Model-Queries'!
SystemOrganization addCategory: 'LaBook-Model-Solutions'!
SystemOrganization addCategory: 'LaBook-Model-Tests'!
SystemOrganization addCategory: 'LaBook-Morphic-Addons'!
SystemOrganization addCategory: 'LaBook-View-Addons'!
SystemOrganization addCategory: 'LaBook-View-Basics'!
SystemOrganization addCategory: 'LaBook-View-Log'!
SystemOrganization addCategory: 'LaBook-View-Model'!
SystemOrganization addCategory: 'LaBook-View-Polymorph'!
SystemOrganization addCategory: 'LaBook-View-Solutions'!
SystemOrganization addCategory: 'LaBook-View-Tests'!

Trait named: #TBOReference
	uses: {}
	category: 'LaBook-Model-BOReferences'!

!TBOReference commentStamp: 'CarlosLombardi 5/26/2015 02:02' prior: 0!
A reference to a business object.
!

!TBOReference methodsFor: 'accessing' stamp: 'CarlosLombardi 5/26/2015 02:02'!
description
	"a description of this reference as a text"

	self requirement .! !

!TBOReference methodsFor: 'deletion' stamp: 'CarlosLombardi 5/26/2015 14:51'!
preventsDeletion
	"whether this reference prevents the deletion of the referenced object"

	self requirement .! !

!TBOReference methodsFor: 'deletion' stamp: 'CarlosLombardi 5/26/2015 14:52'!
reactToDeletion
	"I perform the model adjustements needed to soundly delete the referenced object.
	 The default is to do nothing"

! !

Trait named: #TBasicBusinessObject
	uses: {}
	category: 'LaBook-Model'!

!TBasicBusinessObject commentStamp: 'CarlosLombardi 2/11/2015 17:56' prior: 0!
A Trait for basic (contrasting to derived) business objects
!

!TBasicBusinessObject methodsFor: 'accessing' stamp: 'CarlosLombardi 4/28/2014 22:56'!
asBasicBusinessObject
	"the basic business object corresponding to me.
	 In this case it is exactly me, as I am a basic business object "

	^self! !

Trait named: #TBasicBusinessObjectIsElement
	uses: {}
	category: 'LaBook-View-Model'!

!TBasicBusinessObjectIsElement commentStamp: '<historical>' prior: 0!
The behaviour of assuming that the businessObject of an object edit controller is the result of sending #element to it.
!

!TBasicBusinessObjectIsElement methodsFor: 'basic accessing' stamp: 'CarlosLombardi 5/2/2014 09:54'!
asBasicBusinessObject
	"the basic business object corresponding to me.
	 In this case it my element"

	^self element! !

!TBasicBusinessObjectIsElement methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 09:54'!
businessObject
	^ self element! !

Trait named: #TBuildWindowFromForm
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TBuildWindowFromForm commentStamp: '<historical>' prior: 0!
Behavior of building an editor window based solely on the outcome of the #buildForm message
!

!TBuildWindowFromForm methodsFor: 'ui building' stamp: 'CarlosLombardi 2/18/2015 02:41'!
buildWindow
	"builds and returns a window which can be opened to edit my model"

	| newWindow |
	newWindow := self uiBuilder newPluggableDialogWindow: self windowTitle for: self buildForm.
	^ newWindow! !

Trait named: #TBuildWindowFromPane
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TBuildWindowFromPane commentStamp: '<historical>' prior: 0!
Behaviour of building a window consisting solely of the result of buildPane.

Obviously, any class using this behaviour must provide an implementation of #buildPane.
!

!TBuildWindowFromPane methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 11:39'!
buildWindow
	"builds and returns the editing window"

	| newWindow thePane maxWidth |
	newWindow := StandardWindow labelled: self windowTitle.
	thePane := self buildPane.
	thePane setNameTo: 'mainPane'.
	
	"to force recomputation of subpane bounds"
"	thePane fullBounds.
	maxWidth := (thePane submorphs collect: [ :morph | morph width ]) max.
"	
	newWindow addMorph: thePane frame: (0 @ 0 corner: 1 @ 1).
	
	maxWidth := (thePane submorphs collect: [ :morph | morph width ]) max.
	newWindow width: ((maxWidth + 20) max: newWindow width).
	
	^ newWindow
! !

!TBuildWindowFromPane methodsFor: 'accessing' stamp: 'CarlosLombardi 5/26/2015 15:49'!
windowTitle
	"..."

	^self requirement! !

Trait named: #TBusinessObjectEditionInList
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TBusinessObjectEditionInList commentStamp: 'CarlosLombardi 3/26/2015 01:14' prior: 0!
Behaviour of the edit actions to add/edit/remove a BusinessObject in a list edition, where the edition takes place in a separate window. 
Provides implementation for the messages expected by TEditObjectInListButtons.

Assumes that the model of each row in the list is the corresponding BusinessObject.

Sends the following messages to the list editor
"BO management"
- createBusinessObjectEditorFor: aBO
- createNewBusinessObject
- addNewBusinessObject: aBO
- removeBusinessObject: aBO
- textForRemoveBusinessObjectConfirmation: aBO
"UI management"
- invalidateList
- window
- selectedObject
- selectedObject:

Sends the following messages to the BO editor
- businessObject
- edit (expects a Boolean as result)!

!TBusinessObjectEditionInList methodsFor: 'actions' stamp: 'CarlosLombardi 3/14/2015 19:29'!
addElement
	"opens a window to add a new reagent"

	| boEditor editResult newBO oldSelectedBO |
	oldSelectedBO := self selectedObject.
	newBO := self createNewBusinessObject.
	
	boEditor := self createBusinessObjectEditorFor: newBO.
	boEditor uiParent: self window.
	editResult := boEditor edit.
	editResult ifTrue: [ 
		self addNewBusinessObject: boEditor businessObject.
		self invalidateList.
		self selectedObject: (editResult ifTrue: [ boEditor businessObject ] ifFalse: [ oldSelectedBO ])
	].
! !

!TBusinessObjectEditionInList methodsFor: 'actions' stamp: 'CarlosLombardi 3/26/2015 00:55'!
deleteSelected
	"delete action"

	(self window
		proceed: (self textForRemoveBusinessObjectConfirmation: self selectedObject)
		title: 'Confirmación requerida')
	ifTrue: [ 
		self removeBusinessObject: self selectedObject.
		self invalidateList.
	]
! !

!TBusinessObjectEditionInList methodsFor: 'actions' stamp: 'CarlosLombardi 3/14/2015 20:11'!
editSelected
	"edit action"

	| boEditor oldSelectedBO oldKey  |
	oldSelectedBO := self selectedObject.
	oldKey := self keyFor: oldSelectedBO .
	boEditor := self createBusinessObjectEditorFor: self selectedObject.
	boEditor uiParent: self window.
	( (boEditor edit) & (oldKey ~= (self keyFor: oldSelectedBO)) ) 
	ifTrue: [ 
		self invalidateList.
		self selectedObject: oldSelectedBO.
	]
! !

!TBusinessObjectEditionInList methodsFor: 'actions' stamp: 'CarlosLombardi 3/14/2015 20:09'!
keyFor: anObject
	"the 'key' corresponding to this object wrt the list edition. To be overwritten if needed."

	^Time now! !

Trait named: #TBusinessObjectEditionInListOnPlace
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TBusinessObjectEditionInListOnPlace commentStamp: 'CarlosLombardi 3/29/2015 06:10' prior: 0!
Behaviour of the edit actions to add/edit/remove a BusinessObject in a list edition, where a BO edition takes place on the row in the list representing that BO.
Provides implementation for the messages expected by TEditObjectInListButtons for the "add" and "delete" buttons.

Sends the following messages to the list editor
"BO management"
- createNewBusinessObject
- addFirstBO: newBO
- addBO: newBO after: aBO
- textForRemoveBusinessObjectConfirmation: aBO
- removeBusinessObject: aBO
"UI management"
- invalidateList
- selectedObject
- selectedObject:
!

!TBusinessObjectEditionInListOnPlace methodsFor: 'actions' stamp: 'CarlosLombardi 3/29/2015 06:37'!
addElement
	"adds a new object into the list"
	
	| newBO |
	newBO := self createNewBusinessObject.
	self selectedObject 
		ifNil: [ self addFirstBO: newBO ]
		ifNotNil: [ :selected | self addBO: newBO after: selected ] .
	self invalidateList.
	self selectedObject: newBO .
! !

!TBusinessObjectEditionInListOnPlace methodsFor: 'actions' stamp: 'CarlosLombardi 3/29/2015 06:09'!
deleteSelected
	"delete action"

	(self window
		proceed: (self textForRemoveBusinessObjectConfirmation: self selectedObject)
		title: 'Confirmación requerida')
	ifTrue: [ 
		self removeBusinessObject: self selectedObject.
		self invalidateList.
	]
! !

Trait named: #TBusinessObjectEditorEdit
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TBusinessObjectEditorEdit commentStamp: '<historical>' prior: 0!
A simple implementation for the edit action for a BusinessObject editor.
This action includes 
- to open the window, 
- to perform the edition, 
- to update the model if needed
and answers whether the edition was accepted.

Messages sent to the editor
- openModal
- window
- updateModel


!

!TBusinessObjectEditorEdit methodsFor: 'actions' stamp: 'CarlosLombardi 5/2/2014 10:06'!
edit
	"opens a window to edit my reagent"

	self openModal.
	self window cancelled
		ifFalse: [ self updateModel ].
	^ self window cancelled not! !

Trait named: #TCentralizeAttachedFiles
	uses: {}
	category: 'LaBook-View-Log'!

!TCentralizeAttachedFiles commentStamp: '<historical>' prior: 0!
A TCentralizeAttachedFiles is xxxxxxxxx.
!

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 12/1/2015 00:56'!
applyToChildren: aLogEntry with: aRecordPath
	"centralize the children of aLogEntry"

	aLogEntry children do:[ :child|
		self centralizeAttachedFilesForLogEntry: child withRecordPath: aRecordPath.
	]! !

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 11/2/2015 13:50'!
centralizeAttachedFilesForLogEntry: aLogEntry withRecordPath: aRecordPath
	"Centralize arrached files of a log entry in a selected path"

	| newPath pathWithoutPoints |
	
	newPath := aLogEntry rootDirectoryPath.
	pathWithoutPoints := (newPath fullName copyReplaceAll: '.\.' with: '\').
	
	(self fileSystem exists: pathWithoutPoints) ifFalse:[self fileSystem createDirectory:  pathWithoutPoints].
	
	"If the file wasn't created i created it and i add all the path and the tree corresponding"
	self createFilesWithOriginalLocations: aLogEntry with: aRecordPath.
												
	self createDirectoryChildren: aLogEntry with: newPath.
		
	self copyAttachedFiles: aLogEntry with: newPath.
	
	self applyToChildren: aLogEntry with: aRecordPath.
! !

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 11/23/2015 02:08'!
centralizeAttachedFilesFrom: aLogEntry with: anObject

	"Open a directory chooser to select a folder where copy the log entry selected attached files"

	| newPath pathWithoutPoints recordPath |
	
	aLogEntry rootDirectoryPath: anObject ,  '\' , (self replaceBarAndBackslash: aLogEntry). 
										
	"Generate the path of file of the paths originals"
	newPath := aLogEntry rootDirectoryPath.
	pathWithoutPoints := (newPath fullName copyReplaceAll: '.\.' with: '\').
	recordPath := pathWithoutPoints , '\',  'Ubicaciones de archivos originales.txt'.
					
	self centralizeAttachedFilesForLogEntry:  aLogEntry withRecordPath: recordPath. 
	
	! !

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 11/2/2015 13:51'!
copyAttachedFiles: aLogEntry with: aPath.
	"Copy the attached files of a log entry to aPath"

	aLogEntry  attachedFiles do:[:file|
		
		|fileName fullDestiny fullDestinyWithoutPoints |
		
		fileName := (file fullName findTokens: '\') last.
		
		fullDestiny := (aPath , '\' , fileName).
		fullDestinyWithoutPoints := (fullDestiny fullName copyReplaceAll: '.\.' with: '\').
		(self fileSystem exists: fullDestinyWithoutPoints) ifFalse: [
			
			(self fileSystem exists: file fullName)  ifTrue: [ 
														self fileSystem copy: (file fullName copyReplaceAll: '.\.' with: '\') 
							 							to:  fullDestinyWithoutPoints
												     ] 
							]. 
		
		file reference: (fullDestiny copyWithPath: fullDestinyWithoutPoints).
		
	].! !

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 8/25/2015 23:45'!
createDirectoryChildren: aLogEntry with: aPath

	aLogEntry children do:[:child |
		
	      | chPath |
		
		chPath := (aPath,'\', (self replaceBarAndBackslash: child)).
		
		self fileSystem createDirectory: (chPath fullName copyReplaceAll: '.\.' with: '\').

		child rootDirectoryPath: chPath.
		
	].
! !

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 8/25/2015 22:19'!
createFilesWithOriginalLocations: aLogEntry with: aRecordPath

	| recordFile |
	
	(self fileSystem exists: aRecordPath) ifFalse:[recordFile := FileStream newFileNamed: aRecordPath.
												   self pathFileOriginal: recordFile withLogEntry: aLogEntry with: 0.
												   recordFile close.
												  ].! !

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 10/16/2015 04:11'!
openDirectoryWith: aTittle
	
	^self uiBuilder theme 
		chooseDirectoryIn: (self uiBuilder )
		title: aTittle
		path: nil.! !

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 11/2/2015 13:55'!
pathFileOriginal: recordFile withLogEntry: aLogEntry with: aNum
	"Write a record with the original paths of attached files of a logEntry with identation aNum if necesary"
	
	aNum timesRepeat: [ recordFile nextPutAll: ' '].	"Ident for the parent"
	recordFile nextPutAll: (self replaceBarAndBackslash: aLogEntry); cr.									
	aLogEntry  attachedFiles do:[:file|
		
							| fileName pathOriginal|
									
							(aNum + 2) timesRepeat: [ recordFile nextPutAll: ' ']. "Ident for the children"
							fileName := (file fullName findTokens: '\') last. 
							pathOriginal := (file reference) fullName.
							recordFile nextPutAll: fileName , ': ', ((self fileSystem exists: pathOriginal ) ifTrue: [ pathOriginal, ' (Existe)' ] 
																									      ifFalse: [ pathOriginal, ' (No existe)']); cr.
						].
      aLogEntry children do: [:child | self pathFileOriginal: recordFile withLogEntry: child with: aNum + 2]. "Recursion at the children"! !

!TCentralizeAttachedFiles methodsFor: 'centralize' stamp: 'FernandoDiMeglio 8/25/2015 23:51'!
replaceBarAndBackslash: aLogEntry
	"Private - replaces bars and backslashes for creating folders"

	| descriptionWithoutBackslash descriptionWithoutBarAndBackslash |
	
	descriptionWithoutBackslash := aLogEntry description copyReplaceAll: '\' with: '-'.
	descriptionWithoutBarAndBackslash := descriptionWithoutBackslash copyReplaceAll: '/' with: '-'.

	^descriptionWithoutBarAndBackslash.! !

Trait named: #TChildrenLogEntries
	uses: {}
	category: 'LaBook-Model-Log'!

!TChildrenLogEntries commentStamp: 'CarlosLombardi 3/28/2015 01:17' prior: 0!
Behavior common to all the objects having children logEntries.
!

!TChildrenLogEntries methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/28/2015 01:07'!
demoteChild: aLogEntry
	"aLogEntry falls one unit inside my children, i.e. swaps its position with the child immediately below it.
	 If aLogEntry is already my last child, nothing happens.
	 If aLogEntry is not currently one of my children, then an error is raised."
	
	| currentIndex |
	self privateCheckChild: aLogEntry.
	currentIndex := self children indexOf: aLogEntry.
	(currentIndex < self children size) ifTrue: [ self children swap: currentIndex with: currentIndex + 1 ].! !

!TChildrenLogEntries methodsFor: 'log entry tree - private' stamp: 'CarlosLombardi 3/28/2015 01:08'!
privateAddLastChild: aLogEntry
	"Private - add aLogEntry as my last child. 
	Raises an error if aLogEntry is currently one of my children."
	
	(self children includes: aLogEntry) 
		ifTrue: [ self error: 'The entry ' , aLogEntry description , ' is already a child of ', self description ].
	self children addLast: aLogEntry .
! !

!TChildrenLogEntries methodsFor: 'log entry tree - private' stamp: 'CarlosLombardi 3/28/2015 01:08'!
privateCheckChild: aLogEntry
	"Private - raises an error if aLogEntry is not currently one of my children."
	
	(self children includes: aLogEntry) 
		ifFalse: [ self error: 'The entry ' , aLogEntry description , ' is not a child of ', self description ]
! !

!TChildrenLogEntries methodsFor: 'log entry tree - private' stamp: 'CarlosLombardi 3/28/2015 01:08'!
privateRemoveChild: aLogEntry
	"Private - remove aLogEntry from my list of children. 
	Raises an error if aLogEntry is not currently one of my children."
	
	self privateCheckChild: aLogEntry .
	self children remove: aLogEntry .
! !

!TChildrenLogEntries methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/28/2015 01:07'!
promoteChild: aLogEntry
	"aLogEntry rises one unit inside my children, i.e. swaps its position with the child immediately above it.
	 If aLogEntry is already my topmost child, nothing happens.
	 If aLogEntry is not currently one of my children, then an error is raised."
	
	| currentIndex |
	self privateCheckChild: aLogEntry.
	currentIndex := self children indexOf: aLogEntry.
	(currentIndex > 1) ifTrue: [ self children swap: currentIndex with: currentIndex - 1 ].! !

Trait named: #TCompositeTree
	uses: {}
	category: 'LaBook-Model-Log'!

!TCompositeTree commentStamp: 'CarlosLombardi 3/8/2015 10:50' prior: 0!
Operations useful for any tree formed via the Composite pattern.
This trait expects the tree to respond to >>parent and >>children.
!

!TCompositeTree methodsFor: 'tree' stamp: 'CarlosLombardi 3/8/2015 10:51'!
ancestors
	"a list with my ancestors ordered anti-hierarchically (i.e. the corresponding root is the last element)"
	
	^self parent
		ifNil: [ { } ]
		ifNotNil: [ :entry | { entry } , entry ancestors ]! !

!TCompositeTree methodsFor: 'private' stamp: 'CarlosLombardi 3/8/2015 21:24'!
flattenDescendantsFromDepth: n
	" Private. This method is the implementation of flattenDescendantsWithLevel.
	  It answers a list including an Association (depth+n, element) for me and each of my descendants, 
	  such that each element precedes all its descendants, 
	  and the order of the children of a given element is respected. 
	  If I have no children, then I answer myself. 
	  Efficiency is somewhat considered. "

	| result tempArray resultSize  |
	self children ifEmpty: [ ^self ].
	
	"tempArray: (size,descendants) for each of my children"
	tempArray := Array new: self children size.
	self children withIndexDo: [ :child :ix |   | childDescendants childSize |
		childDescendants := child flattenDescendantsFromDepth: n + 1.
		childSize := childDescendants isArray ifTrue: [childDescendants size] ifFalse: [1].
		tempArray at: ix put: (childSize -> childDescendants) .
	].
	
	"Final result is the flattening of tempArray, which mixes arrays and elements"
	resultSize := tempArray inject: 1 into: [:size :childAssoc | size + childAssoc key ]. 
			"I don't use sum: to gain a little bit of efficiency"
	result := Array new: resultSize.
	result at: 1 put: (n -> self).
	tempArray inject: 2 into: [ :ix :childAssoc | 
		childAssoc value isArray
			ifTrue: [ result replaceFrom: ix to: (ix + childAssoc key - 1) with: childAssoc value. ]
			ifFalse: [ result at: ix put: ((n + 1) -> childAssoc value) ].
		ix + childAssoc key
	].
	^result








! !

!TCompositeTree methodsFor: 'private' stamp: 'CarlosLombardi 3/29/2015 04:13'!
flattenDescendantsFromDepth: n excluding: aLogEntry
	" Private. This method is the implementation of flattenDescendantsWithDepthExcluding:.
	  It answers a list including an Association (depth+n, element) for me and each of my descendants, 
	  such that each element precedes all its descendants, 
	  and the order of the children of a given element is respected. 
	  If I have no children, then I answer myself. 
	  In any case, aLogEntry and its descendants are excluded.
	  Efficiency is somewhat considered. "

	| result tempArray resultSize  childrenToBeConsidered |
	childrenToBeConsidered := self children reject: [ :entry | entry = aLogEntry ].
	childrenToBeConsidered ifEmpty: [ ^self ].
	
	"tempArray: (size,descendants) for each of my children"
	tempArray := Array new: childrenToBeConsidered size.
	childrenToBeConsidered withIndexDo: [ :child :ix |   | childDescendants childSize |
		childDescendants := child flattenDescendantsFromDepth: n + 1 excluding: aLogEntry.
		childSize := childDescendants isArray ifTrue: [childDescendants size] ifFalse: [1].
		tempArray at: ix put: (childSize -> childDescendants) .
	].
	
	"Final result is the flattening of tempArray, which mixes arrays and elements"
	resultSize := tempArray inject: 1 into: [:size :childAssoc | size + childAssoc key ]. 
			"I don't use sum: to gain a little bit of efficiency"
	result := Array new: resultSize.
	result at: 1 put: (n -> self).
	tempArray inject: 2 into: [ :ix :childAssoc | 
		childAssoc value isArray
			ifTrue: [ result replaceFrom: ix to: (ix + childAssoc key - 1) with: childAssoc value. ]
			ifFalse: [ result at: ix put: ((n + 1) -> childAssoc value) ].
		ix + childAssoc key
	].
	^result








! !

!TCompositeTree methodsFor: 'tree' stamp: 'CarlosLombardi 3/8/2015 21:24'!
flattenDescendantsWithDepth
	"a list including an Association (depth, element) for me and each of my descendants, 
	  such that each element precedes all its descendants, 
	  and the order of the children of a given element is respected. 
	 Efficiency is somewhat considered. "

	| result |
	result := self flattenDescendantsFromDepth: 0.
	^result isArray ifTrue: [ result ] ifFalse: [ { 0 -> result } ].! !

!TCompositeTree methodsFor: 'tree' stamp: 'CarlosLombardi 3/28/2015 17:30'!
flattenDescendantsWithDepthExcluding: aLogEntry
	"a list including an Association (depth, element) for me and each of my descendants, 
	  such that each element precedes all its descendants, 
	  and the order of the children of a given element is respected. 
	The entry aLogEntry and its descendants are excluded.
	 Efficiency is somewhat considered. "

	| result |
	result := self flattenDescendantsFromDepth: 0 excluding: aLogEntry.
	^result isArray ifTrue: [ result ] ifFalse: [ { 0 -> result } ].! !

Trait named: #TCreateStockEventDetailCopier
	uses: {}
	category: 'LaBook-Model'!

!TCreateStockEventDetailCopier methodsFor: 'copying' stamp: 'CLom 11/25/2014 19:26'!
copierTo: stockEvent
	"creates and answer an object who knows how to copy myself into stockEvent"

	| newCopier |
	newCopier := EventDetailCopier new.
	newCopier 
		source: self ;
		targetEvent: stockEvent.
	^newCopier! !

Trait named: #TDelegateNameEditionInBasicBusinessObject
	uses: {}
	category: 'LaBook-View-Model'!

!TDelegateNameEditionInBasicBusinessObject commentStamp: '<historical>' prior: 0!
The behaviour, for an EditController, of delegating the edition of the name attribute in the basic business object
!

!TDelegateNameEditionInBasicBusinessObject methodsFor: 'name edition' stamp: 'CarlosLombardi 5/2/2014 09:57'!
name
	"the name of the business object being edited"

	^self asBasicBusinessObject name! !

!TDelegateNameEditionInBasicBusinessObject methodsFor: 'name edition' stamp: 'CarlosLombardi 5/2/2014 09:57'!
name: aString
	"the name of the business object being edited"

	self asBasicBusinessObject name: aString! !

Trait named: #TEditObjectInListButtons
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TEditObjectInListButtons commentStamp: '<historical>' prior: 0!
The behaviour of building the buttons for add/edit/remove in a list of BusinessObjects.

Send the following messages to the editor
- addElement
- deleteSelected
- editSelected
!

!TEditObjectInListButtons methodsFor: 'ui building' stamp: 'CarlosLombardi 3/14/2015 19:22'!
buildAddButton
	"build the add button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #addElement
    		label: 'Agregar' translated 
		help: 'Agregar un nuevo elemento' translated.

! !

!TEditObjectInListButtons methodsFor: 'ui building' stamp: 'CarlosLombardi 3/27/2015 00:05'!
buildButtonBar
	"build a UI component to show the buttons to appear under the list"
	
	| buttons buttonBar |
	buttons := OrderedCollection new.
	(self respondsTo: #buildAddButton) ifTrue: [ buttons add: self buildAddButton ]. 
	(self respondsTo: #buildEditButton) ifTrue: [ buttons add: self buildEditButton ].
	(self respondsTo: #buildDeleteButton) ifTrue: [ buttons add: self buildDeleteButton ].
	buttonBar := self uiBuilder newRow: buttons asArray.
	^self buildEmptyColumn
		cellInset: 0 ;
		addMorphBack: (self buildColumnSpacer: 2) ;
		addMorphBack: buttonBar 

! !

!TEditObjectInListButtons methodsFor: 'ui building' stamp: 'CarlosLombardi 3/14/2015 19:22'!
buildDeleteButton
	"build the delete button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #deleteSelected 
		getEnabled: #thereIsSomethingSelected
    		label: 'Eliminar' translated
		help: 'Eliminar el elemento elegido' translated.

! !

!TEditObjectInListButtons methodsFor: 'ui building' stamp: 'CarlosLombardi 3/14/2015 19:22'!
buildEditButton
	"build the edit button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #editSelected 
		getEnabled: #thereIsSomethingSelected
    		label: 'Modificar' translated
		help: 'Modificar los datos del elemento elegido' translated.

! !

Trait named: #TEventComputations
	uses: {}
	category: 'LaBook-Model'!

!TEventComputations commentStamp: '<historical>' prior: 0!
Computations related to an event 
!

!TEventComputations methodsFor: 'accessing' stamp: 'CLom 12/27/2014 16:25'!
detailAmount
	"the total amount for the details of this event"

	^(self details ifEmpty: [ 0 ] ifNotEmpty: [ :theDetails | theDetails sum: #totalAmount ]) round: 2.
! !

!TEventComputations methodsFor: 'accessing' stamp: 'CLom 12/27/2014 16:26'!
totalAmount
	"the total amount for this event"

	^(self extraAmount + self detailAmount) round: 2! !

Trait named: #TEventDetailComputations
	uses: {}
	category: 'LaBook-Model'!

!TEventDetailComputations commentStamp: '<historical>' prior: 0!
Computations related to event details
!

!TEventDetailComputations methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2014 00:12'!
totalAmount
	"the total amount corresponding to this detail"

	^(self unitPrice * self quantity) round: 2! !

Trait named: #TEventDetailInitialization
	uses: {}
	category: 'LaBook-Model'!

!TEventDetailInitialization commentStamp: '<historical>' prior: 0!
Initialization actions for event details
!

!TEventDetailInitialization methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/15/2014 16:47'!
initialize
	"preparation for life"

	self quantity: 0 ; unitPrice: 0! !

Trait named: #TExampleLabBuild
	uses: {}
	category: 'LaBook-Model-Tests'!

!TExampleLabBuild commentStamp: '<historical>' prior: 0!
The behavior of building laboratories for testing purposes

!

!TExampleLabBuild methodsFor: 'example building' stamp: 'CLom 11/22/2014 11:51'!
addABuyingRequirementTo: aLab
	"adds a buying requirement to aLab"

	| newReq |
	newReq := BuyingRequirement new
		date: (Date newDay: 15 month: 2 year: 2014);
		lab: aLab.
	self
		addDetailsFrom:
			{aLab reagentByCasNumber: self aperolCasNumber. 20. 100.
			 aLab reagentByCasNumber: self albuminCasNumber. 30. 20.
			 aLab 
				consumableHavingId: self halfMmTubeSigmaId  
				forProvider: (self sigmaForLab: aLab). 
			8. 0.35. }
		toBuyingRequirement: newReq.
	aLab addToEvents: newReq.
! !

!TExampleLabBuild methodsFor: 'example building' stamp: 'CarlosLombardi 10/19/2014 11:25'!
addACinzanoBuyingEventTo: aLab
	"adds a buying event corresponding to the provider named 'Cinzano' "

	| newBuying |
	newBuying := ReagentBuyingEvent new
		date: (Date newDay: 3 month: 10 year: 2013);
		provider: (aLab providerNamed: 'Cinzano');
		lab: aLab.
	self
		addDetailsFrom:
			{aLab reagentByCasNumber: self aperolCasNumber. 7. 82.
			(aLab reagentByCasNumber: self albuminCasNumber). 10. 17}
		toBuyingEvent: newBuying.
	aLab addToEvents: newBuying.
! !

!TExampleLabBuild methodsFor: 'example building' stamp: 'CLom 11/25/2014 19:09'!
addASatisfiedRequirementTo: aLab
	"adds a buying requirement, and a BuyingEvent satisfying it, to aLab"

	| req buying satisfaction |
	req := BuyingRequirement new.
	req date: (Date newDay: 25 month: 10 year: 2014) ; lab: aLab.
	self 
		addDetailsFrom: 
			{aLab reagentByCasNumber: self aperolCasNumber. 10. 100.
			 aLab reagentByCasNumber: self albuminCasNumber. 15. 40.
 			 aLab reagentByCasNumber: self saltGrainsCasNumber. 400. (0.3) }
		toBuyingRequirement: req.
	buying := ReagentBuyingEvent new.
	buying date: (Date newDay: 30 month: 10 year: 2014) ; lab: aLab ; provider: (self sigmaForLab: aLab).
	self 
		addDetailsFrom: 
			{aLab reagentByCasNumber: self aperolCasNumber. 25. 90.
			 aLab reagentByCasNumber: self albuminCasNumber. 12. 35.
 			 aLab reagentByCasNumber: self bullBloodCasNumber. 5. 350 }
		toBuyingEvent: buying.
	satisfaction := buying generateSatisfactionForRequirement: req.

	aLab 
		addToEvents: req ; addToEvents: buying ; addToEvents: satisfaction .
! !

!TExampleLabBuild methodsFor: 'example building' stamp: 'CLom 11/22/2014 11:30'!
addDetailsFrom: aList toBuyingEvent: aBuyingEvent 
	"add some details, codified in aList, to aBuyingEvent.
	 The list is codified as follows: reagent / quantity / unitPrice / next reagent ... 
	 To be merged with addDetailsFrom:toBuyingRequirement:"
	
	| dataStream newDetail |
	(aList size rem: 3) = 0 ifFalse: [ self error: 'bad-built detail list' ].
	
	dataStream := aList readStream.
	[dataStream atEnd] whileFalse: 	[ 
		newDetail := StockEventDetail new 
			event: aBuyingEvent ;
			element: dataStream next ;
			quantity: dataStream next ;
			unitPrice: dataStream next.
		aBuyingEvent addToDetails: newDetail.
	] .

	! !

!TExampleLabBuild methodsFor: 'example building' stamp: 'CLom 11/22/2014 11:35'!
addDetailsFrom: aList toBuyingRequirement: aBuyingReq 
	"add some details, codified in aList, to aBuyingReq.
	 The list is codified as follows: reagent / quantity / unitPrice / next reagent ... .
	 To be merged with addDetailsFrom:toBuyingEvent:"
	
	| dataStream newDetail priceCalc explicitPrice |
	(aList size rem: 3) = 0 ifFalse: [ self error: 'bad-built detail list' ].
	priceCalc := PriceCalculator new defaultPrice: nil ; yourself.
	
	dataStream := aList readStream.
	[dataStream atEnd] whileFalse: 	[ 
		newDetail := StockEventDetail new 
			event: aBuyingReq ;
			element: dataStream next ;
			quantity: dataStream next.
		priceCalc stockElement: newDetail element.
		explicitPrice := dataStream next.
		newDetail unitPrice: (priceCalc lastPrice ifNil: [explicitPrice]).
		aBuyingReq addToDetails: newDetail.
	] .

	! !

!TExampleLabBuild methodsFor: 'example building' stamp: 'CLom 11/25/2014 19:05'!
addSomeBuyingEventsTo: aLab

	| newBuying albumin aperol catNail saltGrains |
	albumin := aLab reagentByCasNumber: self albuminCasNumber.
	aperol := aLab reagentByCasNumber: self aperolCasNumber.
	catNail := aLab reagentByCasNumber: self catNailCasNumber.
	saltGrains := aLab reagentByCasNumber: self saltGrainsCasNumber.
	
	newBuying := ReagentBuyingEvent new
		date: (Date newDay: 12 month: 9 year: 2013) ;
		provider: (aLab providerNamed: 'SIGMA') ; lab: aLab.
	self 
		addDetailsFrom: { albumin . 8 . 15.20 . aperol . 20 . 85 . catNail . 3 . 380 } 
		toBuyingEvent: newBuying.
	aLab addToEvents: newBuying.

	newBuying := ReagentBuyingEvent new
		date: (Date newDay: 10 month: 8 year: 2013) ;
		provider: (aLab providerNamed: 'SIGMA')  ; extraAmount: 100 ; lab: aLab.
	self 
		addDetailsFrom: { aperol . 8 . 78 . catNail . 4 . 400 . saltGrains . 1000 . 0.12 } 
		toBuyingEvent: newBuying.
	aLab addToEvents: newBuying.

	newBuying := ReagentBuyingEvent new
		date: (Date newDay: 21 month: 10 year: 2013) ;
		provider: (aLab providerNamed: 'Coto')  ; lab: aLab.
	self 
		addDetailsFrom: { aperol . 10 . 80 . saltGrains . 2200 . 0.15 } 
		toBuyingEvent: newBuying.
	aLab addToEvents: newBuying.
! !

!TExampleLabBuild methodsFor: 'example building' stamp: 'CarlosLombardi 3/24/2015 18:51'!
addSomeSolutionsTo: aLab
	"adds two solutions to the given lab"

	|  aperol albumin bullBlood   strongDrink softDrink millimolar percmv |
	aperol := aLab reagentByCasNumber: self aperolCasNumber .
	albumin := aLab reagentByCasNumber: self albuminCasNumber .
	bullBlood := aLab reagentByCasNumber: self bullBloodCasNumber .
	millimolar := LabApplication current 
		reagentInSolutionConcentrationUnits 
		detect: [ :unit | unit abbreviation = 'mM' ].
	percmv := LabApplication current 
		reagentInSolutionConcentrationUnits 
		detect: [ :unit | unit abbreviation = '%(m:v)' ].
	
	strongDrink  := Solution new.
	strongDrink name: 'Trago fuerte' ;
		addToComponents: ( ReagentInSolutionByConcentrationUnitFormula new 
			reagent: aperol ; concentration: (8 units: millimolar) ) ;
		addToComponents: ( ReagentInSolutionByConcentrationUnitFormula new 
			reagent: bullBlood ; concentration: (6 units: millimolar) ) .
	aLab addToSolutions: strongDrink .
	
	softDrink := Solution new.	
	softDrink name: 'Trago suave' ;
		addToComponents: ( ReagentInSolutionByConcentrationUnitFormula new 
			reagent: aperol ; concentration: (4 units: millimolar) ) ;
		addToComponents: ( ReagentInSolutionByConcentrationUnitFormula new 
			reagent: bullBlood ; concentration: (2 units: millimolar) ) ;
		addToComponents: ( ReagentInSolutionByConcentrationUnitFormula new 
			reagent: albumin ; concentration: (3 units: percmv) ) .
	aLab addToSolutions: softDrink .
! !

!TExampleLabBuild methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 23:04'!
albuminCasNumber
	"the SIGMA reference to obtain the 'albumin' reagent "

	^'BT552'! !

!TExampleLabBuild methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 23:09'!
aperolCasNumber
	"the CAS number to obtain the 'aperol' reagent "

	^'AZ072'! !

!TExampleLabBuild methodsFor: 'example building' stamp: 'CarlosLombardi 10/19/2014 13:09'!
buildCopyOfLab: aLab
	"builds and answers a copy of the given lab, not including events"

	| newLab |
	newLab := Lab new.
	aLab stockUnits do: [ :unit | newLab addToStockUnits: unit ].
	aLab consumables do: [ :consu | newLab addToConsumables: consu ].
	aLab reagents do: [ :reag | newLab addToReagents: reag ].
	aLab providers do: [ :prov | newLab addToReferenceAuthorities: prov ].
	LabApplication current registerLab: newLab.
	^newLab
! !

!TExampleLabBuild methodsFor: 'example building' stamp: 'CarlosLombardi 3/24/2015 18:44'!
buildSimpleLab
	"builds and answers a simple lab including five reagents"

	| newLab litro tresCuartos gramo diezGramos mwunit |
	newLab := Lab new.
	litro := StockUnit new name: 'l.' ; prependX: false.
	tresCuartos := StockUnit new name: '0.75 l.' ; prependX: true.
	gramo := StockUnit new name: 'g.' ; prependX: false.
	diezGramos := StockUnit new name: '10 g.' ; prependX: true.
	mwunit := LabApplication current molecularWeightUnit .
	newLab 
		addToStockUnits: litro ; addToStockUnits: tresCuartos ; 
		addToStockUnits: gramo ; addToStockUnits: diezGramos.
	newLab 
		addProviderNamed: 'Invitrogen' ; addProviderNamed: 'Bio-Rad' ; 
		addProviderNamed: 'SIGMA' ;
		addProviderNamed: 'Coto' ; addProviderNamed: 'Cinzano'.
	newLab addToReagents: (
		Reagent new
			name: 'Sangre de toro' ; molecularWeight: (2 units: mwunit) ; casNumber: self bullBloodCasNumber ;
			stockUnit: litro ; 
			referenceId: 'AX32Q' forAuthority: (newLab providerNamed: 'Bio-Rad') ;
			yourself
	).
	newLab addToReagents: (
		Reagent new
			name: 'Aperol' ; molecularWeight: (3 units: mwunit) ; casNumber: self aperolCasNumber ;
			stockUnit: tresCuartos ; 
			referenceId: 'Ape01' forAuthority: (newLab providerNamed: 'Cinzano')	;
			yourself
	).
	newLab addToReagents: (
		Reagent new
			name: 'Granos de sal' ; molecularWeight: (10 units: mwunit) ; casNumber: self saltGrainsCasNumber ;
			stockUnit: gramo ; 
			referenceId: 'CELU' forAuthority: (newLab providerNamed: 'Coto') ;
			yourself
	).
	newLab addToReagents: (
		Reagent new
			name: 'Albumina' ; molecularWeight: (3 units: mwunit) ; casNumber: self albuminCasNumber ;
			stockUnit: diezGramos ; 
			referenceId: 'TT001' forAuthority: (newLab providerNamed: 'Bio-Rad') ;
			referenceId: 'FXA31' forAuthority: (newLab providerNamed: 'Invitrogen') ;
			yourself
	).
	newLab addToReagents: (
		Reagent new
			name: 'Uña de gato' ; molecularWeight: (6 units: mwunit) ; casNumber: self catNailCasNumber ;
			stockUnit: LabApplication unitStockUnit ; 
			referenceId: 'FXB12' forAuthority: (newLab providerNamed: 'Invitrogen') ;
			yourself
	).
	newLab addToConsumables: (
		Consumable new
			name: 'Tubo Eppendorf de 1.5 ml' ;
			referenceId: 'TE150' forAuthority: (newLab providerNamed: 'SIGMA') ;
			yourself
	).
	newLab addToConsumables: (
		Consumable new
			name: 'Tubo Eppendorf de 0.5 ml' ;
			referenceId: 'TE050' forAuthority: (newLab providerNamed: 'SIGMA') ;
			yourself
	).
	newLab addToConsumables: (
		Consumable new
			name: 'Pipeta automática' ;
			referenceId: 'PIPET' forAuthority: (newLab providerNamed: 'SIGMA') ;
			referenceId: 'AJPI92' forAuthority: (newLab providerNamed: 'Invitrogen') ;
			yourself
	).
	self addSomeSolutionsTo: newLab.
	LabApplication current registerLab: newLab.
	^newLab! !

!TExampleLabBuild methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 23:09'!
bullBloodCasNumber
	"the CAS number to obtain the 'bull blood' reagent "

	^'JJ444'! !

!TExampleLabBuild methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 23:10'!
catNailCasNumber
	"the CAS number to obtain the 'cat nail' reagent "

	^'MO901'! !

!TExampleLabBuild methodsFor: 'accessing' stamp: 'CLom 11/22/2014 11:50'!
halfMmTubeSigmaId
	"the SIGMA id to obtain the '0.5 mm Eppendorf tube' consumable "

	^'TE050'! !

!TExampleLabBuild methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 23:11'!
saltGrainsCasNumber
	"the CAS number to obtain the 'salt grains' reagent "

	^'AQ861'! !

!TExampleLabBuild methodsFor: 'accessing' stamp: 'CLom 11/22/2014 11:41'!
sigmaForLab: aLab
	"the SIGMA provider for the given lab"

	^aLab providerNamed: 'SIGMA'! !

Trait named: #TLabProvider
	uses: {}
	category: 'LaBook-Model'!

!TLabProvider commentStamp: 'CarlosLombardi 3/20/2015 19:02' prior: 0!
A TLabProvider is any object which knows how to provide a lab upon request.
!

!TLabProvider methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:03'!
lab
	"the reference lab corresponding to myself"

	self shouldBeImplemented! !

Trait named: #TListPane
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TListPane commentStamp: 'CarlosLombardi 3/26/2015 01:37' prior: 0!
Construction of a pane including the elements which could be present in the UI building of a list editor.
!

!TListPane methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 17:44'!
buildPane
	"builds a pane including all the elements to show"

	| rows |
	rows := { #buildUpperTitleBox . #buildTitleBox . #buildList . #buildTotalsRow . #buildButtonBar }
		select: [ :sym | self respondsTo: sym ] thenCollect: [ :sym | sym value: self ].
	^(self uiBuilder 	newColumn: rows ) 
		cellInset: 0 ; yourself.
! !

Trait named: #TOrderOfLogEntries
	uses: {}
	category: 'LaBook-Model-Log'!

!TOrderOfLogEntries commentStamp: 'CarlosLombardi 3/5/2015 15:10' prior: 0!
I provide different ways to order a list of LabProjectLogEntries.
!

!TOrderOfLogEntries methodsFor: 'ordered log entries' stamp: 'CarlosLombardi 3/9/2015 00:42'!
logEntriesHierarchicallyWithDepth
	"a list including an Association (depth, element) for each of my logEntries, 
	  such that each element precedes all its descendants, 
	  and the order of the children of a given element is respected. 
	  A fake root, associated with nil, is appended at depth 0. 
	 The root entries are at depth 1.
	 Efficiency is somewhat considered. "

	| fakeRoot result |
	fakeRoot := LabProjectLogEntry new.
	self rootLogEntriesOrderedByDate do: [ :entry | entry parent: fakeRoot ].
	result := fakeRoot flattenDescendantsWithDepth.
	fakeRoot children copy do: [ :entry | entry parent: nil ].
			"Why the copy here: because sending parent: to each child of the fakeRoot
			  affects the children collection of the latter, implying an unexpected behaviour 
			  of the do:  message"
	result at: 1 put: (0 -> nil).
	^result select: [ :assoc | assoc value isNil | (self logEntries includes: assoc value) ]









! !

!TOrderOfLogEntries methodsFor: 'ordered log entries' stamp: 'CarlosLombardi 3/5/2015 15:11'!
logEntriesOrderedByDate
	"my collection of logEntries, ordered by date"

	^self orderedByDate: self logEntries ! !

!TOrderOfLogEntries methodsFor: 'ordered log entries' stamp: 'CarlosLombardi 3/5/2015 15:11'!
orderedByDate: logEntries
	"the given collection of logEntries, ordered by date"

	^logEntries asSortedCollection: [ :le1 :le2 | le1 date <= le2 date ]! !

!TOrderOfLogEntries methodsFor: 'selected log entries' stamp: 'CarlosLombardi 3/5/2015 15:14'!
rootAmong: logEntries
	"the root among the given collection of logEntries"

	^logEntries select: [ :entry | entry parent isNil ]! !

!TOrderOfLogEntries methodsFor: 'ordered log entries' stamp: 'CarlosLombardi 3/5/2015 15:15'!
rootLogEntriesOrderedByDate
	"the root among my collection of logEntries, ordered by date"

	^self rootOrderedByDate: self logEntries! !

!TOrderOfLogEntries methodsFor: 'ordered log entries' stamp: 'CarlosLombardi 3/5/2015 15:16'!
rootOrderedByDate: logEntries
	"the root among the given collection of logEntries, ordered by date"

	^self orderedByDate: (self rootAmong: logEntries )! !

Trait named: #TProposalCalculations
	uses: {}
	category: 'LaBook-Model'!

!TProposalCalculations methodsFor: 'proposal' stamp: 'CLom 12/6/2014 16:24'!
buyingProposalForProvider: aProvider
	"a new BuyingProposal including the part of this requirement which can be satisfied 
	  by the given provider.
	  Returns nil if the provider cannot satisfy any of the elements included in this requirement "

	| newProposal detailsToInclude |
	newProposal := BuyingProposal new.
	newProposal provider: aProvider ;
		lab: self lab ; 
		originalRequirement: self.
	detailsToInclude := self detailsSatisfiableByProvider: aProvider.
	detailsToInclude ifEmpty: [ ^nil ].
	
	detailsToInclude do: [ :detail | 
		(detail copierTo: newProposal) 
			forWithoutPrice ; forLinkToOriginalDetail ;
			newDetailClass: BuyingProposalDetail ;
		proceed 
	].
	
	^newProposal! !

!TProposalCalculations methodsFor: 'fulfillment' stamp: 'CLom 11/25/2014 19:23'!
detailsSatisfiableByProvider: aProvider
	"the subset of my details which can be satisfied by the given provider"

	| providerInLab |
	providerInLab := ProviderInLab for: aProvider inLab: self lab.
	^self details select: [ :det | providerInLab providesStockElement: det element ]
! !

!TProposalCalculations methodsFor: 'fulfillment' stamp: 'CLom 11/25/2014 19:23'!
possibleProviders
	"the providers which can provide all my elements"
	| providerIsOK |

	providerIsOK := [:prov | self stockElements allSatisfy: [ :stockElem | prov providesStockElement: stockElem ] ].
	^(self providersForLab: self lab) 
		select: [ :prov | providerIsOK value: prov ]
		thenCollect: [ :prov | prov provider ]! !

Trait named: #TProviderInLabHome
	uses: {}
	category: 'LaBook-Model'!

!TProviderInLabHome commentStamp: '<historical>' prior: 0!
A Home for instances of ProviderInLab
!

!TProviderInLabHome methodsFor: 'providers' stamp: 'CarlosLombardi 10/14/2014 02:13'!
providersForLab: aLab
	"a set containing the providers known by the given lab"

	^aLab providers collect: [ :prov | ProviderInLab for: prov inLab: aLab ] into: Set new! !

Trait named: #TReagentListEdition
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TReagentListEdition commentStamp: 'CarlosLombardi 4/6/2015 20:07' prior: 0!
The common behavior of the objects that show the list of reagents of a Lab.
!

!TReagentListEdition methodsFor: 'list' stamp: 'CarlosLombardi 4/6/2015 20:08'!
objectsToShow
	"the list of objects to be rendered, in the proper order"

	^self model reagents asSortedCollection: [ :r1 :r2 | r1 name asUppercase <= r2 name asUppercase ]! !

Trait named: #TReagentListEditorActions
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TReagentListEditorActions commentStamp: '<historical>' prior: 0!
the behavior corresponding to add/edit/delete actions in the edition of a list of reagents
Provides an Implementation of the behaviour expected in TBusinessObjectEditionInList
!

!TReagentListEditorActions methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 09:29'!
addNewBusinessObject: aReagent
	"..."

	self model addToReagents: aReagent! !

!TReagentListEditorActions methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 09:28'!
createBusinessObjectEditorFor: aReagent
	"..."

	^ReagentEditor for: aReagent inLab: self model! !

!TReagentListEditorActions methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 09:28'!
createNewBusinessObject
	"..."

	| newReagent |
	newReagent := Reagent new.
	"set default values for the new reagent"
	newReagent stockUnit: self model defaultStockUnit.
	^newReagent
! !

!TReagentListEditorActions methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 09:29'!
removeBusinessObject: aReagent
	"..."

	self model removeFromReagents: aReagent! !

!TReagentListEditorActions methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 10:20'!
textForRemoveBusinessObjectConfirmation: aReagent
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	textBuilder 
		nextPutAll: 'Confirmar eliminación del ' ; 
		nextPutAll: 'siguiente reactivo' ; cr ; 
		nextPutAll: 'Nombre : ' ; nextPutAll: aReagent name ; cr ; 
		nextPutAll: 'CAS number : ' ; nextPutAll: aReagent casNumber.
	^textBuilder contents
! !

Trait named: #TRowDecorator
	uses: {}
	category: 'LaBook-View-Addons'!

!TRowDecorator commentStamp: 'CarlosLombardi 5/24/2015 21:31' prior: 0!
An object used by morph list editors to apply a graphic decoration to each row.
!

!TRowDecorator methodsFor: 'decorating' stamp: 'CarlosLombardi 5/24/2015 21:31'!
decoratedRowFor: aRowMorph inOrder: aNumber
	"returns the decorated row corresponding to the given parameters."
	
	self requirement! !

Trait named: #TSolutionPreparationEditorCreator
	uses: {}
	category: 'LaBook-View-Solutions'!

!TSolutionPreparationEditorCreator commentStamp: 'CarlosLombardi 3/20/2015 22:49' prior: 0!
Behavior of the objects which know how to create SolutionPreparationEditors for given or new SolutionPreparationActivities.

This behavior needs the object to respond to the #logEntry message (this is to create properly a SolutionPreparationActivity).!

!TSolutionPreparationEditorCreator methodsFor: 'editor creation' stamp: 'CarlosLombardi 3/20/2015 22:47'!
buildPreparationEditorFor: aPreparationActivity
	"Creates a new editor corresponding to the given preparation activity"
	^ (SolutionPreparationEditor for: aPreparationActivity)
			labProvider: self; yourself ! !

!TSolutionPreparationEditorCreator methodsFor: 'editor creation' stamp: 'CarlosLombardi 3/20/2015 22:47'!
buildPreparationEditorForNewActivity
	"Creates a new editor corresponding to a new preparation activity"
	^ self buildPreparationEditorFor: (SolutionPreparationActivity forLogEntry: self logEntry)! !

Trait named: #TSortByName
	uses: {}
	category: 'LaBook-Model'!

!TSortByName commentStamp: 'CarlosLombardi 5/24/2015 20:13' prior: 0!
The ability to sort a collection by the name of each element.
!

Trait named: #TListOfNames
	uses: TSortByName
	category: 'LaBook-View-Polymorph'!

!TListOfNames commentStamp: '<historical>' prior: 0!
The behaviour, for a StringListEditor, of rendering each object to show through its name!

TListOfNames classTrait
	uses: TSortByName classTrait!

!TListOfNames methodsFor: 'list' stamp: 'CarlosLombardi 5/2/2014 14:05'!
stringList
	"the list of strings to show"

	^self objectList collect: [ :obj | obj name ]! !

Trait named: #TSolutionListEdition
	uses: TListOfNames - {#stringList}
	category: 'LaBook-View-Solutions'!

!TSolutionListEdition commentStamp: 'CarlosLombardi 4/14/2015 16:22' prior: 0!
The common behavior of the objects that show the list of solutions of a Lab.
!

TSolutionListEdition classTrait
	uses: TListOfNames classTrait!

!TSolutionListEdition methodsFor: 'list' stamp: 'CarlosLombardi 4/14/2015 16:32'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self sortByUppercaseName: self model solutions! !

!TSortByName methodsFor: 'sorting' stamp: 'CarlosLombardi 5/24/2015 20:13'!
sortByUppercaseName: aCollection
	"a collection having the same elements as aCollection, sorted by their uppercase name"

	^aCollection asSortedCollection: self uppercaseNameSortBlock .! !

!TSortByName methodsFor: 'sorting' stamp: 'CarlosLombardi 5/24/2015 20:13'!
uppercaseNameSortBlock
	"a block to build a collection sorted by the uppercase name of its elements"

	^[ :obj1 :obj2 | obj1 name asUppercase < obj2 name asUppercase ]! !

Trait named: #TTotalAmountField
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TTotalAmountField commentStamp: '<historical>' prior: 0!
The behaviour of building a field to show the total amount of something
!

!TTotalAmountField methodsFor: 'ui building' stamp: 'CLom 11/24/2014 00:09'!
buildTotalAmountField
	"creates and answer a UI component to show the total amount of the event being edited"

	| newField |
	newField := DynamicTextMorph 
		newTransparentFor: self model
		get: #totalAmount
		class: Float.
	newField 
		width: 120 ; height: newField font height ;
		hResizing: #rigid ;
		vResizing: #rigid ;
		cellPositioning: #leftCenter.
	^newField

! !

Trait named: #TUIGoodies
	uses: {}
	category: 'LaBook-View-Polymorph'!

!TUIGoodies commentStamp: 'CarlosLombardi 2/12/2015 01:22' prior: 0!
A Trait reuniting some facility methods to build UI components.
!

Trait named: #TLogEntryCollectionEdition
	uses: TUIGoodies
	category: 'LaBook-View-Log'!

!TLogEntryCollectionEdition commentStamp: 'CarlosLombardi 3/5/2015 15:23' prior: 0!
I reunite the functionality related to the edition of a collections of instances of LabProjectLogEntry.
I am useful for the different views of such collections, i.e., as a tree or as a list.

!

TLogEntryCollectionEdition classTrait
	uses: TUIGoodies classTrait!

!TLogEntryCollectionEdition methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/5/2015 15:23'!
addNewBusinessObject: aLogEntry
	"..."

	self logEntries addLast: aLogEntry! !

!TLogEntryCollectionEdition methodsFor: 'data morphs' stamp: 'EstebanTolaba 6/3/2015 18:40'!
buildCompletionDateField
	"creates and answer a UI component to edit a date for the #date attribute of the model"

	| completionDateField |
	completionDateField := self uiBuilder
		newTextEntryFor: self model
		get: #completionDate
		set: #completionDate:  
		class: nil
		getEnabled: nil 
		help: 'Fecha de terminacion'.
	completionDateField 
		converter: self dateConverter ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	"to initialize contents soundly"
	completionDateField setText: completionDateField getText.
	^completionDateField
! !

!TLogEntryCollectionEdition methodsFor: 'data morphs' stamp: 'EstebanTolaba 5/29/2015 21:32'!
buildDateField
	"creates and answer a UI component to edit a date for the #date attribute of the model"

	| loadDateField |
	loadDateField := self uiBuilder
		newTextEntryFor: self model
		get: #loadDate
		set: #loadDate:  
		class: nil
		getEnabled: nil 
		help: 'Fecha del evento'.
	loadDateField 
		converter: self dateConverter ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	"to initialize contents soundly"
	loadDateField setText: loadDateField getText.
	^loadDateField
! !

!TLogEntryCollectionEdition methodsFor: 'data morphs' stamp: 'EstebanTolaba 6/3/2015 18:38'!
buildToDoDateField
	"creates and answer a UI component to edit a date for the #date attribute of the model"

	| toDoDateField |
	toDoDateField := self uiBuilder
		newTextEntryFor: self model
		get: #toDoDate
		set: #toDoDate:  
		class: nil
		getEnabled: nil 
		help: 'Fecha estimada'.
	toDoDateField 
		converter: self dateConverter ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	"to initialize contents soundly"
	toDoDateField setText: toDoDateField getText.
	^toDoDateField
! !

!TLogEntryCollectionEdition methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/20/2015 23:02'!
createBusinessObjectEditorFor: aLogEntry
	"..."

	^ (LabProjectLogEntryEditor for: aLogEntry inLab: self lab)
			possibleParents: ( self logEntries reject: [:entry | 
				(entry = aLogEntry) | (entry ancestors includes: aLogEntry) ] ) ; 
			yourself! !

!TLogEntryCollectionEdition methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/9/2015 14:04'!
createNewBusinessObject
	"..."

	| result newLogEntry |
	newLogEntry := LabProjectLogEntry new.
	result := LabProjectLogEntryEditController for: newLogEntry.
	"set default values for the new log entry"
	result selectedParent: self selectedObject.
	^ result
! !

!TLogEntryCollectionEdition methodsFor: 'ui building' stamp: 'CarlosLombardi 3/14/2015 18:52'!
helpText
	"the help text to be shown in the pane showing the log entries"

	^'Se pueden agregar, eliminar y editar actividades. Cada actividad está vinculada a una lista de archivos externos.'! !

!TLogEntryCollectionEdition methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/9/2015 13:48'!
removeBusinessObject: aLogEntry
	"..."

	aLogEntry parent: nil.
	self logEntries remove: aLogEntry! !

!TLogEntryCollectionEdition methodsFor: 'bo edition' stamp: 'EstebanTolaba 5/29/2015 21:23'!
textForRemoveBusinessObjectConfirmation: aLogEntry
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	textBuilder 
		nextPutAll: 'Confirmar eliminación de la ' ; 
		nextPutAll: 'siguiente actividad' ; cr ; 
		nextPutAll: 'Fecha : ' ; nextPutAll: (self dateConverter objectAsString: aLogEntry loadDate) ; cr ; 
		nextPutAll: 'Descripción : ' ; nextPutAll: aLogEntry description.
	^textBuilder contents
! !

!TLogEntryCollectionEdition methodsFor: 'ui building' stamp: 'CarlosLombardi 3/14/2015 18:52'!
windowTitle
	"..."

	^'Actividades de Laboratorio'! !

!TUIGoodies methodsFor: 'scaffolding morphs' stamp: 'CLom 12/5/2014 09:35'!
buildColumnSpacer: desiredHeight
	"a Morph separating rows in a column"

	^BorderedMorph new
		color: Color transparent ;
		borderWidth: 0 ;
		hResizing: #rigid ;
		vResizing: #rigid ;
		width: 1 ;
		height: desiredHeight! !

!TUIGoodies methodsFor: 'data morphs' stamp: 'EstebanTolaba 6/3/2015 19:06'!
buildCompletionDateField
	"creates and answer a UI component to edit a date for the #date attribute of the model"

	| newField |
	newField := self uiBuilder
		newTextEntryFor: self model
		get: #completionDate
		set: #completionDate:  
		class: nil
		getEnabled: nil 
		help: 'Fecha de terminacion'.
	newField 
		converter: self dateConverter ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	"to initialize contents soundly"
	newField setText: newField getText.
	^newField
! !

!TUIGoodies methodsFor: 'data morphs' stamp: 'EstebanTolaba 6/3/2015 19:12'!
buildDateField
	"creates and answer a UI component to edit a date for the #date attribute of the model"

	| newField |
	newField := self uiBuilder
		newTextEntryFor: self model
		get: #loadDate
		set: #loadDate:  
		class: nil
		getEnabled: nil 
		help: 'Fecha del evento'.
	newField 
		converter: self dateConverter ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	"to initialize contents soundly"
	newField setText: newField getText.
	^newField
! !

!TUIGoodies methodsFor: 'data morphs' stamp: 'CLom 12/13/2014 21:05'!
buildDynamicTextFor: model get: selectorOrBlock class: aClass width: desiredWidth
	"a DynamicTextMorph showing model>>selectorOrBlock"

	| newField |
	newField := DynamicTextMorph 
		newTransparentFor: model
		get: selectorOrBlock 
		class: aClass.
	newField 
		width: desiredWidth ; height: newField font height ;
		hResizing: #rigid ;
		vResizing: #rigid ;
		cellPositioning: #leftCenter.
	^newField
! !

!TUIGoodies methodsFor: 'scaffolding morphs' stamp: 'CLom 12/15/2014 00:16'!
buildEmptyColumn
	"a Morph to build a nice column on it. 
	  It has no border, it is transparent, its size depend upon that of its future submorphs. 
	  Of course, any of these features can be changed at will."

	^self buildEmptyRow 
		listDirection: #topToBottom ;
		yourself
! !

!TUIGoodies methodsFor: 'scaffolding morphs' stamp: 'CLom 12/15/2014 00:46'!
buildEmptyRow
	"a Morph to build a nice row on it. 
	  It has no border, it is transparent, its size depend upon that of its future submorphs. 
	  Of course, any of these features can be changed at will."

	^PanelMorph new 
		fillStyle: Color transparent;
		borderWidth: 0 ;
		changeTableLayout ; 
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		cellPositioning: #leftCenter ;
		listDirection: #leftToRight ;
		layoutInset: 2 ; 
		cellInset: 8 ;
		yourself
! !

!TUIGoodies methodsFor: 'data morphs' stamp: 'CarlosLombardi 3/20/2015 11:11'!
buildRightAlignedMorphFor: aString width: desiredWidth
	"creates and answers a morph right-aligned to the indicated width, 
	  having as contents the given String"

	| newField |
	newField := self newRowFor: aString.
	newField width: desiredWidth ; hResizing: #rigid.
	newField
		addMorphBack: self buildRowFillSpacer ; 
		addMorphBack: aString asMorph .
	^newField
! !

!TUIGoodies methodsFor: 'scaffolding morphs' stamp: 'CarlosLombardi 4/28/2014 20:40'!
buildRowFillSpacer
	"a Morph to take space in a row with the #spaceFill logic"

	^BorderedMorph new
		color: Color transparent ;
		borderWidth: 0 ;
		hResizing: #spaceFill ;
		vResizing: #rigid ;
		width: 1 ;
		height: 1! !

!TUIGoodies methodsFor: 'scaffolding morphs' stamp: 'CarlosLombardi 4/28/2014 20:40'!
buildRowSpacer: desiredWidth
	"a Morph separating fields in a row"

	^BorderedMorph new
		color: Color transparent ;
		borderWidth: 0 ;
		hResizing: #rigid ;
		vResizing: #rigid ;
		width: desiredWidth ;
		height: 1! !

!TUIGoodies methodsFor: 'data morphs' stamp: 'EstebanTolaba 6/3/2015 19:06'!
buildToDoDateField
	"creates and answer a UI component to edit a date for the #date attribute of the model"

	| newField |
	newField := self uiBuilder
		newTextEntryFor: self model
		get: #toDoDate
		set: #toDoDate:  
		class: nil
		getEnabled: nil 
		help: 'Fecha estimada'.
	newField 
		converter: self dateConverter ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	"to initialize contents soundly"
	newField setText: newField getText.
	^newField
! !

!TUIGoodies methodsFor: 'converting' stamp: 'CarlosLombardi 5/22/2015 12:13'!
dateConverter
	"the object-string converter for dates to use"

	^LabApplication current converters dateConverter! !

!TUIGoodies methodsFor: 'data morphs' stamp: 'CLom 12/27/2014 11:31'!
morph: aMorph centeredInWidth: aNumber
	"aMorph centered wrt the given width. 
 	 It is fit to insert into a #shrinkWrap outer morph."

	| outerMorph |
	outerMorph := PanelMorph new
		fillStyle: Color transparent ; borderWidth: 0;
		changeTableLayout;
		height: aMorph height + 4; width: aNumber; hResizing: #rigid; vResizing: #rigid;
		cellPositioning: #center;
		listDirection: #leftToRight;
		layoutInset: 2; cellInset: 8;
		yourself.
	outerMorph 
		addMorphBack: self buildRowFillSpacer ;
		addMorphBack: aMorph ;
		addMorphBack: self buildRowFillSpacer .
	^outerMorph 
! !

!TUIGoodies methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 00:17'!
newColumnFor: anObject
	"creates a new morph, having anObject as model, which can be used as a column"

	| answer |
	answer := ModelPanelMorph new
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #topToBottom;
		cellInset: 12;
		cellPositioning: #leftCenter.
	answer model: anObject.
	^answer
! !

!TUIGoodies methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 00:17'!
newRowFor: anObject
	"creates a new morph, having anObject as model, which can be used as a row"

	| answer |
	answer := ModelPanelMorph new
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		cellPositioning: #leftCenter.
	answer model: anObject.
	^answer
! !

!TUIGoodies methodsFor: 'data morphs' stamp: 'CLom 12/15/2014 00:22'!
stringMorphFor: aString 
	"a morph to represent aString, fit to insert into a #shrinkWrap outer morph. 
	 Considers multiline Strings, having $\ as line separator."

	| columnTitleMorph internalTextMorph |
	(aString includes: $\) ifTrue: [ 
		internalTextMorph := TextMorph new.
		internalTextMorph contents: aString withCRs.
		columnTitleMorph := BorderedMorph new.
		columnTitleMorph 
			color: Color transparent ;
			borderWidth: 0 ; height: internalTextMorph height ; width: internalTextMorph width ;
			hResizing: #rigid ; vResizing: #rigid.
		columnTitleMorph addMorphBack: internalTextMorph.
		^columnTitleMorph
	] ifFalse: [ 
		^aString asMorph .
	].
! !

!TUIGoodies methodsFor: 'data morphs' stamp: 'CLom 12/27/2014 11:32'!
stringMorphFor: aString centeredInWidth: aNumber
	"a nice morph representing aString, centered wrt the given width. 
 	 It is fit to insert into a #shrinkWrap outer morph. Multiline Strings accepted, having $\ as line separator.
	 See >>stringMorphFor:"

	^self morph: (self stringMorphFor: aString) centeredInWidth: aNumber .
! !

!TUIGoodies methodsFor: 'scaffolding morphs' stamp: 'CarlosLombardi 3/20/2015 19:43'!
surround: aMorph withBorderColor: aColor width: aNumber
	"builds and returns a morph containing the given morph, surrounded by a border 
	 having the specified color and width "

	| outerPane |
	outerPane := self buildEmptyColumn.
	outerPane 
		borderWidth: aNumber ; 
		borderColor: aColor ;
		addMorphBack: aMorph.
	^outerPane
! !

!TUIGoodies methodsFor: 'ui building goodies' stamp: 'CarlosLombardi 4/28/2014 20:40'!
uiBuilder
	"the object who knows how to build UI components"

	^UITheme builder! !

Trait named: #TWithComponentsForReagents
	uses: {}
	category: 'LaBook-Model-Solutions'!

!TWithComponentsForReagents commentStamp: 'CarlosLombardi 3/17/2015 22:12' prior: 0!
An object including a collection of components, where each component corresponds to a Reagent.
!

!TWithComponentsForReagents methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2015 00:00'!
componentForReagent: aReagent
	"The component of this solution corresponding to aReagent. 
	  Nil if aReagent is not needed to produce me"
	^ self components detect: [ :comp | comp reagent = aReagent ] ifNone: [ nil ] .! !

Trait named: #TWithReferences
	uses: {}
	category: 'LaBook-Model'!

!TWithReferences methodsFor: 'references' stamp: 'CarlosLombardi 4/27/2014 19:36'!
authorities
	"the authorities for which a reference ID for me exists"
	
	^self references keys! !

!TWithReferences methodsFor: 'references' stamp: 'CarlosLombardi 4/27/2014 19:36'!
referenceId: anId forAuthority: anAuthority
	"sets my reference ID for the given authority. 
	 A value for anId of nil or empty string means that I have no reference wrt anAuthority.
	 If I already have a reference for this authority, then I just change 
	 the corresponding reference ID"
	
	(anId isNil or: [ anId isEmpty ])
		ifTrue: [ (self privateReferences includesKey: anAuthority) ifTrue: [ self privateReferences removeKey: anAuthority ] ]
		ifFalse: [ self privateReferences at: anAuthority put: anId ]
	
! !

!TWithReferences methodsFor: 'references' stamp: 'CarlosLombardi 4/27/2014 19:36'!
referenceIdForAuthority: anAuthority
	"the set reference ID for the given authority, nil if i have no reference registered for that authority."
	
	^self references at: anAuthority ifAbsent: [nil]! !

!TWithReferences methodsFor: 'references' stamp: 'CarlosLombardi 4/27/2014 19:36'!
references
	"a Dictionary authority/referenceID for my references"
	
	^self privateReferences! !

!ComposableMorph methodsFor: '*LaBook' stamp: 'FernandoDiMeglio 11/3/2015 23:38'!
newLogEntryDialogWindowIn: title for: contentMorph
    "Answer a new pluggable dialog with the given content."

    ^self theme
        newLogEntryDialogWindowIn: self
        title: title
        for: contentMorph! !

!Locale methodsFor: '*LaBook-cambios' stamp: 'CarlosLombardi 3/11/2014 02:31'!
determineLocaleID
	"Locale current determineLocaleID"
	| langCode isoLang countryCode isoCountry |
	langCode := self fetchISO2Language copyWithout: Character null.
	isoLang := langCode
		ifNil: [^self localeID]
		ifNotNil: [langCode].
	countryCode := self primCountry copyWithout: Character null.
	isoCountry := countryCode
		ifNil: [^LocaleID isoLanguage: isoLang]
		ifNotNil: [countryCode].
	^LocaleID isoLanguage: isoLang isoCountry: isoCountry! !

MorphTreeModel subclass: #LabProjectLogEntryTreeModel
	uses: TOrderOfLogEntries
	instanceVariableNames: 'model treeMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectLogEntryTreeModel commentStamp: 'CarlosLombardi 3/28/2015 11:00' prior: 0!
The model for a tree morph showing the log entries in a LabProject, in a hierarchical fashion.
My model is the LabProject.!

LabProjectLogEntryTreeModel class
	uses: TOrderOfLogEntries classTrait
	instanceVariableNames: ''!

!LabProjectLogEntryTreeModel methodsFor: 'view' stamp: 'EstebanTolaba 7/27/2015 18:02'!
defaultTreeMorph
	| newTreeMorph |
	newTreeMorph := super defaultTreeMorph.
	(newTreeMorph columns at: 1) itemMorphGetter: [ :entry | entry description asMorph fillStyle: (entry completionState colorState) ].
	newTreeMorph setNameTo: 'logEntryTree'.
	^ newTreeMorph! !

!LabProjectLogEntryTreeModel methodsFor: 'list edition adaptor' stamp: 'CarlosLombardi 3/5/2015 15:56'!
invalidateList
	"rebuild the list"

	self treeMorph buildContents! !

!LabProjectLogEntryTreeModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2015 11:01'!
logEntries
	"the raw list of raw entries I am editing"

	^self model logEntries! !

!LabProjectLogEntryTreeModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 12:17'!
model
	^ model! !

!LabProjectLogEntryTreeModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 12:17'!
model: anObject
	model := anObject! !

!LabProjectLogEntryTreeModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2015 11:01'!
rootItems
	"the log entries being the top-level items in the tree "

	^self model children! !

!LabProjectLogEntryTreeModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 12:28'!
rootNodeClassFromItem: anItem
	"the adequate class to handle the given root item"

	^LabProjectLogEntryNode! !

!LabProjectLogEntryTreeModel methodsFor: 'list edition adaptor' stamp: 'CarlosLombardi 3/5/2015 15:39'!
selectedObject
	"the model object, i.e. a LogEntry, selected"

	^self selectedItem! !

!LabProjectLogEntryTreeModel methodsFor: 'list edition adaptor' stamp: 'EstebanTolaba 8/4/2015 12:27'!
selectedObject: aLogEntry
	"set the model object, i.e. a LogEntry, selected"

	"if I am asked to select nil, then I select nothing"
	"In this case, we have to explicitly affect both the MorphTreeMorph, via self selectItems: , and also
	  my selection mechanism, via self selection: nil . self selectionChanged .
	 This is due to the duality of selection management between morph and model, which seems to be 
	  inconsistent if no items are selected.
	  We tried also with self selectItems: nil . instead of self selectItems: {  } . it does not work neither.
	  Perhaps an issue should be raised."
	aLogEntry ifNil: [ 
		self selectItems: {  } . self selection: nil . self selectionChanged .
		^self 
	].
	
	"enforce that the entry to select is shown"
	self treeMorph expandAllSuchThat: [:node | 
		aLogEntry ancestors includes: node item 
	].
	"now the selection will take effect in any case"
	^self selectItems: { aLogEntry }
	! !

!LabProjectLogEntryTreeModel methodsFor: 'selecting' stamp: 'CarlosLombardi 3/14/2015 19:20'!
selectionChanged
	"detect and handle the event"

	self changed: #thereIsSomethingSelected.
	super selectionChanged.! !

!LabProjectLogEntryTreeModel methodsFor: 'list edition adaptor' stamp: 'CarlosLombardi 3/14/2015 19:14'!
thereIsSomethingSelected
	"a Boolean having the expected meaning"

	^self selectedItems notEmpty ! !

!LabProjectLogEntryTreeModel methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/14/2015 18:38'!
treeMorph
	^treeMorph! !

!LabProjectLogEntryTreeModel methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/14/2015 18:39'!
treeMorph: aMorph
	treeMorph:= aMorph! !

MorphTreeModel subclass: #LabProjectLogEntryTreeModel2
	uses: TBusinessObjectEditionInList + TOrderOfLogEntries + TLogEntryCollectionEdition
	instanceVariableNames: 'model window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectLogEntryTreeModel2 commentStamp: 'CarlosLombardi 3/14/2015 19:33' prior: 0!
An old version of LabProjectLogEntryTreeModel.
Deprecated.!

LabProjectLogEntryTreeModel2 class
	uses: TBusinessObjectEditionInList classTrait + TOrderOfLogEntries classTrait + TLogEntryCollectionEdition classTrait
	instanceVariableNames: ''!

!LabProjectLogEntryTreeModel2 methodsFor: 'actions' stamp: ''!
addElement
	"opens a window to add a new reagent"

	| boEditor editResult newBO oldSelectedBO |
	oldSelectedBO := self selectedObject.
	newBO := self createNewBusinessObject.
	
	boEditor := self createBusinessObjectEditorFor: newBO.
	boEditor uiParent: self window.
	editResult := boEditor edit.
	editResult ifTrue: [ 
		self addNewBusinessObject: boEditor businessObject.
	].
	self invalidateList.
	self selectedObject: (editResult ifTrue: [ boEditor businessObject ] ifFalse: [ oldSelectedBO ])
! !

!LabProjectLogEntryTreeModel2 methodsFor: 'bo edition' stamp: ''!
addNewBusinessObject: aLogEntry
	"..."

	self logEntries addLast: aLogEntry! !

!LabProjectLogEntryTreeModel2 methodsFor: 'data morphs' stamp: 'EstebanTolaba 5/29/2015 21:32'!
buildDateField
	"creates and answer a UI component to edit a date for the #date attribute of the model"

	| loadDateField |
	loadDateField := self uiBuilder
		newTextEntryFor: self model
		get: #loadDate
		set: #loadDate:  
		class: nil
		getEnabled: nil 
		help: 'Fechas del evento'.
	loadDateField 
		converter: self dateConverter ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	"to initialize contents soundly"
	loadDateField setText: loadDateField getText.
	^loadDateField
! !

!LabProjectLogEntryTreeModel2 methodsFor: 'bo edition' stamp: ''!
createBusinessObjectEditorFor: aLogEntry
	"..."

	^ (LabProjectLogEntryEditor for: aLogEntry)
			possibleParents: ( self logEntries reject: [:entry | 
				(entry = aLogEntry) | (entry ancestors includes: aLogEntry) ] ) ; 
			yourself! !

!LabProjectLogEntryTreeModel2 methodsFor: 'bo edition' stamp: ''!
createNewBusinessObject
	"..."

	| result newLogEntry |
	newLogEntry := LabProjectLogEntry new.
	result := LabProjectLogEntryEditController for: newLogEntry.
	"set default values for the new log entry"
	result selectedParent: self selectedObject.
	^ result
! !

!LabProjectLogEntryTreeModel2 methodsFor: 'view' stamp: 'CarlosLombardi 3/5/2015 15:54'!
defaultTreeMorph
	^ super defaultTreeMorph
			itemStringGetter: #description ;
			doubleClickSelector: #editSelected ;
			setNameTo: 'logEntryTree'
			yourself
! !

!LabProjectLogEntryTreeModel2 methodsFor: 'actions' stamp: ''!
deleteSelected
	"delete action"

	(self window
		proceed: (self textForRemoveBusinessObjectConfirmation: self selectedObject)
		title: 'Confirmación requerida')
	ifTrue: [ 
		self removeBusinessObject: self selectedObject.
		self invalidateList.
	]
! !

!LabProjectLogEntryTreeModel2 methodsFor: 'actions' stamp: 'CarlosLombardi 3/8/2015 02:48'!
editSelected
	"edit action"

	| boEditor oldSelectedBO oldParent oldDescription |
	oldSelectedBO := self selectedObject.
	oldParent := self selectedObject parent.
	oldDescription := self selectedObject description.
	boEditor := self createBusinessObjectEditorFor: self selectedObject.
	boEditor uiParent: self window.
	boEditor edit.
	(self selectedObject parent = oldParent) & (self selectedObject description = oldDescription) 
	ifFalse: [ 
		self invalidateList.
		self selectedObject: oldSelectedBO
	] .
! !

!LabProjectLogEntryTreeModel2 methodsFor: 'list edition adaptor' stamp: 'CarlosLombardi 3/5/2015 15:56'!
invalidateList
	"rebuild the list"

	self treeMorph buildContents! !

!LabProjectLogEntryTreeModel2 methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 15:08'!
logEntries
	"the raw list of raw entries I am editing"

	^self model! !

!LabProjectLogEntryTreeModel2 methodsFor: 'ordered log entries' stamp: ''!
logEntriesHierarchicallyWithDepth
	"a list including an Association (depth, element) for each of my logEntries, 
	  such that each element precedes all its descendants, 
	  and the order of the children of a given element is respected. 
	  A fake root, associated with nil, is appended at depth 0. 
	 The root entries are at depth 1.
	 Efficiency is somewhat considered. "

	| fakeRoot result |
	fakeRoot := LabProjectLogEntry new.
	self rootLogEntriesOrderedByDate do: [ :entry | entry parent: fakeRoot ].
	result := fakeRoot flattenDescendantsWithDepth.
	fakeRoot children copy do: [ :entry | entry parent: nil ].
			"Why the copy here: because sending parent: to each child of the fakeRoot
			  affects the children collection of the latter, implying an unexpected behaviour 
			  of the do:  message"
	result at: 1 put: (0 -> nil).
	^result select: [ :assoc | assoc value isNil | (self logEntries includes: assoc value) ]









! !

!LabProjectLogEntryTreeModel2 methodsFor: 'ordered log entries' stamp: ''!
logEntriesOrderedByDate
	"my collection of logEntries, ordered by date"

	^self orderedByDate: self logEntries ! !

!LabProjectLogEntryTreeModel2 methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 12:17'!
model
	^ model! !

!LabProjectLogEntryTreeModel2 methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 12:17'!
model: anObject
	model := anObject! !

!LabProjectLogEntryTreeModel2 methodsFor: 'ordered log entries' stamp: ''!
orderedByDate: logEntries
	"the given collection of logEntries, ordered by date"

	^logEntries asSortedCollection: [ :le1 :le2 | le1 date <= le2 date ]! !

!LabProjectLogEntryTreeModel2 methodsFor: 'bo edition' stamp: ''!
removeBusinessObject: aLogEntry
	"..."

	aLogEntry parent: nil.
	self logEntries remove: aLogEntry! !

!LabProjectLogEntryTreeModel2 methodsFor: 'selected log entries' stamp: ''!
rootAmong: logEntries
	"the root among the given collection of logEntries"

	^logEntries select: [ :entry | entry parent isNil ]! !

!LabProjectLogEntryTreeModel2 methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 15:16'!
rootItems
	"the log entries being the top-level items in the tree "

	^self rootLogEntriesOrderedByDate ! !

!LabProjectLogEntryTreeModel2 methodsFor: 'ordered log entries' stamp: ''!
rootLogEntriesOrderedByDate
	"the root among my collection of logEntries, ordered by date"

	^self rootOrderedByDate: self logEntries! !

!LabProjectLogEntryTreeModel2 methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 12:28'!
rootNodeClassFromItem: anItem
	"the adequate class to handle the given root item"

	^LabProjectLogEntryNode! !

!LabProjectLogEntryTreeModel2 methodsFor: 'ordered log entries' stamp: ''!
rootOrderedByDate: logEntries
	"the root among the given collection of logEntries, ordered by date"

	^self orderedByDate: (self rootAmong: logEntries )! !

!LabProjectLogEntryTreeModel2 methodsFor: 'list edition adaptor' stamp: 'CarlosLombardi 3/5/2015 15:39'!
selectedObject
	"the model object, i.e. a LogEntry, selected"

	^self selectedItem! !

!LabProjectLogEntryTreeModel2 methodsFor: 'list edition adaptor' stamp: 'CarlosLombardi 3/8/2015 02:08'!
selectedObject: aLogEntry
	"set the model object, i.e. a LogEntry, selected"

	"enforce that the entry to select is shown"
	self treeMorph expandAllSuchThat: [:node | 
		aLogEntry ancestors includes: node item 
	].
	"now the selection will take effect in any case"
	^self selectItems: { aLogEntry }! !

!LabProjectLogEntryTreeModel2 methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/5/2015 15:56'!
treeMorph
	^ window submorphNamed: 'logEntryTree'! !

!LabProjectLogEntryTreeModel2 methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/5/2015 15:46'!
window
	^ window! !

!LabProjectLogEntryTreeModel2 methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/5/2015 15:46'!
window: anObject
	window := anObject! !

!SequenceableCollection methodsFor: '*LaBook' stamp: 'CLom 12/17/2014 12:13'!
mkString: separator
	"a string built by concatenating my elements, inserting the given separator between any pair of consecutive
	 element descriptions."

	^self isEmpty ifTrue: [ '' ] ifFalse: [ 
		(self allButLast inject: '' into: [ :desc :elem | desc , elem asString, separator ]) , 
		(self last asString) ] ! !

PluggableDialogWindow subclass: #LogEntryDialogWindow
	instanceVariableNames: 'errors logEntryEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LogEntryDialogWindow commentStamp: '<historical>' prior: 0!
A LogEntryDialogWindow is xxxxxxxxx.

Instance Variables
	errors:		<Object>
	logEntryEditor:		<Object>

errors
	- xxxxx

logEntryEditor
	- xxxxx
!

!LogEntryDialogWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/3/2015 16:23'!
errors
	^ errors! !

!LogEntryDialogWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/3/2015 16:23'!
errors: anObject
	errors := anObject! !

!LogEntryDialogWindow methodsFor: 'accessing' stamp: 'FernandoDiMeglio 11/3/2015 23:52'!
logEntryEditor
	^ logEntryEditor! !

!LogEntryDialogWindow methodsFor: 'accessing' stamp: 'FernandoDiMeglio 11/3/2015 23:52'!
logEntryEditor: anObject
	logEntryEditor := anObject! !

!LogEntryDialogWindow methodsFor: 'as yet unclassified' stamp: 'EstebanTolaba 11/4/2015 17:43'!
ok

	"Ok button action in case of an error when creating/editing a log entry"

	(self errors isNil) ifTrue:[super ok]
				  ifFalse: [(LabProjectLogEntryErrorWindow  for: (self errors)) openModal.	
							self errors: nil.
							self logEntryEditor openModal.
							self logEntryEditor updateModelIfCompletedForm].! !

!Morph methodsFor: '*LaBook-cambios' stamp: 'CarlosLombardi 3/16/2014 21:20'!
submorphNamed: aName ifNone: aBlock 
	"Find the first submorph with this name, or a button with an action selector of that name"

	
	self submorphs do: 
			[:button | | sub args | 
			(button respondsTo: #actionSelector) 
				ifTrue: [button actionSelector == aName ifTrue: [^button]].
			(button respondsTo: #getTextSelector) 
				ifTrue: [button getTextSelector == aName ifTrue: [^button]].
			(button respondsTo: #getSelector) 
				ifTrue: [button getSelector == aName ifTrue: [^button]].
			(button externalName = aName) ifTrue: [^button].
			((button respondsTo: #arguments) and: [(args := button arguments) notNil]) 
				ifTrue: [(args at: 2 ifAbsent: [nil]) == aName ifTrue: [^button]].
"			(button isAlignmentMorph) 
				ifTrue: [(sub := button submorphNamed: aName ifNone: [nil]) ifNotNil: [^sub]]].
"			(sub := button submorphNamed: aName ifNone: [nil]) ifNotNil: [^sub]].
	^aBlock value! !

TestCase subclass: #BlockChainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Basics-Tests'!

!BlockChainTest methodsFor: 'as yet unclassified' stamp: 'CarlosLombardi 10/19/2014 02:56'!
testSimpleBlockChains
	"comment stating purpose of message"

	| chain1 chain2 chain3 |
	chain1 := BlockChain new.
	chain1 addBlock: [ nil ] ; addBlock: [ 7 ].
	chain1 defaultValue: 0.
	self assert: (chain1 value = 7).
	
	
	! !

TestCase subclass: #FilteredReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Basics-Tests'!

!FilteredReadStreamTest methodsFor: 'as yet unclassified' stamp: 'CLom 11/25/2014 13:27'!
testFilteredStreamOnEven
	"..."

	| aStream |
	aStream := FilteredReadStream on: (1 to: 7) filterBy: [ :n | n even ].
	self 
		assert: ( aStream next = 2 ) ;
		assert: ( aStream next = 4 ) ;		
		assert: ( aStream next = 6 ) ;
		assert: ( aStream atEnd ).! !

!FilteredReadStreamTest methodsFor: 'as yet unclassified' stamp: 'CLom 11/25/2014 13:27'!
testFilteredStreamOnOdd
	"..."

	| aStream |
	aStream := FilteredReadStream on: (1 to: 7) filterBy: [ :n | n odd ].
	self 
		assert: ( aStream next = 1 ) ;
		assert: ( aStream next = 3 ) ;		
		assert: ( aStream next = 5 ) ;
		assert: ( aStream next = 7 ) ;
		assert: ( aStream atEnd ).! !

TestCase subclass: #LabApplicationTestCase
	instanceVariableNames: 'savedLabApplication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

LabApplicationTestCase subclass: #BuyingRequirementTest
	uses: TExampleLabBuild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

BuyingRequirementTest class
	uses: TExampleLabBuild classTrait
	instanceVariableNames: ''!

!BuyingRequirementTest methodsFor: 'example building' stamp: 'CLom 11/25/2014 16:54'!
buildBuyingEventToSatisfyInLab: myLab
	"a BuyingEvent for the satisfaction and pending tests"

	| buying |
	buying := ReagentBuyingEvent new.
	buying date: (Date newDay: 30 month: 10 year: 2014) ; lab: myLab ; provider: (self sigmaForLab: myLab).
	self 
		addDetailsFrom: 
			{myLab reagentByCasNumber: self aperolCasNumber. 25. 90.
			 myLab reagentByCasNumber: self albuminCasNumber. 12. 35.
 			 myLab reagentByCasNumber: self bullBloodCasNumber. 5. 350 }
		toBuyingEvent: buying.
	^buying
	

	
	
	
	
	




! !

!BuyingRequirementTest methodsFor: 'example building' stamp: 'CLom 11/25/2014 16:53'!
buildRequirementToSatisfyInLab: myLab
	"a BuyingRequirement for the satisfaction and pending tests"

	| req |
	req := BuyingRequirement new.
	req date: (Date newDay: 25 month: 10 year: 2014) ; lab: myLab.
	self 
		addDetailsFrom: 
			{myLab reagentByCasNumber: self aperolCasNumber. 10. 100.
			 myLab reagentByCasNumber: self albuminCasNumber. 15. 40.
 			 myLab reagentByCasNumber: self saltGrainsCasNumber. 400. (0.3) }
		toBuyingRequirement: req.
	^req
	
	
	
	
	
	




! !

!BuyingRequirementTest methodsFor: 'testing' stamp: 'CLom 11/17/2014 00:36'!
testProposalsForARequirement
	"tests the generation of proposals given a BusinessRequirement, for different providers"

	| myLab req proposal propDetail |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.
	self addACinzanoBuyingEventTo: myLab.
	
	req := BuyingRequirement new.
	req date: (Date newDay: 25 month: 10 year: 2014) ; lab: myLab.
	self 
		addDetailsFrom: 
			{myLab reagentByCasNumber: self aperolCasNumber. 1. 0.
			 myLab reagentByCasNumber: self albuminCasNumber. 2. 0.
			 myLab reagentByCasNumber: self catNailCasNumber. 3. 0.
 			 myLab reagentByCasNumber: self saltGrainsCasNumber. 400. 0}
		toBuyingEvent: req.

	proposal := req buyingProposalForProvider: (myLab providerNamed: 'SIGMA').
	self 
		assert: (proposal details size = 4) ;
		assert: (proposal totalAmount = (85 + 30.40 + 1140 + 48)) ;
		assert: (proposal normalisedTotalAmount = (80 + 34 + 1140 + 60)) .
	propDetail := proposal details detect: [ :detail | detail element casNumber = self saltGrainsCasNumber ].
	self 
		assert: (propDetail quantity = 400) ;
		assert: (propDetail unitPrice = 0.12) ;
		assert: (propDetail normalisedUnitPrice = 0.15).

	proposal := req buyingProposalForProvider: (myLab providerNamed: 'Coto').
	self 
		assert: (proposal details size = 2) ;
		assert: (proposal totalAmount = 140) ;
		assert: (proposal normalisedTotalAmount = 140) .
	propDetail := proposal details detect: [ :detail | detail element casNumber = self aperolCasNumber ].
	self 
		assert: (propDetail quantity = 1) ;
		assert: (propDetail unitPrice = 80) ;
		assert: (propDetail normalisedUnitPrice = 80).

	proposal := req buyingProposalForProvider: (myLab providerNamed: 'Cinzano').
	self 
		assert: (proposal details size = 2) ;
		assert: (proposal totalAmount = (82+34)) ;
		assert: (proposal normalisedTotalAmount = (80+34)) .
	propDetail := proposal details detect: [ :detail | detail element casNumber = self aperolCasNumber ].
	self 
		assert: (propDetail quantity = 1) ;
		assert: (propDetail unitPrice = 82) ;
		assert: (propDetail normalisedUnitPrice = 80).

! !

!BuyingRequirementTest methodsFor: 'testing' stamp: 'CLom 11/25/2014 18:44'!
testRequirementPendingStateAfterSatisfaction
	"tests the pending state of a BuyingRequirement,after it is satisfied by a BuyingEvent"

	| myLab req  buying satisfaction pending someDetail |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.
	self addACinzanoBuyingEventTo: myLab.
	
	req := self buildRequirementToSatisfyInLab: myLab.
	buying := self buildBuyingEventToSatisfyInLab: myLab.
	satisfaction := buying generateSatisfactionForRequirement: req.
	myLab 
		addToEvents: req ; addToEvents: buying ; addToEvents: satisfaction .

	pending := req pendingState.
	
	self assert: (pending details size = 2).
	someDetail := pending details 
		detect: [ :det | det element = (myLab reagentByCasNumber: self albuminCasNumber) ]
		ifNone: [ nil ].
	self assert: ( someDetail notNil ); assert: ( someDetail quantity = 3).
	someDetail := pending details 
		detect: [ :det | det element = (myLab reagentByCasNumber: self saltGrainsCasNumber ) ]
		ifNone: [ nil ].
	self assert: ( someDetail notNil ); assert: ( someDetail quantity = 400).
		
	
	




! !

!BuyingRequirementTest methodsFor: 'testing' stamp: 'CLom 11/25/2014 17:00'!
testRequirementPendingStateBeforeSatisfaction
	"tests the pending state of a BuyingRequirement, before it is satisfied by a BuyingEvent"

	| myLab req  pending someDetail |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.
	self addACinzanoBuyingEventTo: myLab.
	
	req := self buildRequirementToSatisfyInLab: myLab.
	pending := req pendingState.
	
	self assert: (pending details size = 3).
	someDetail := pending details 
		detect: [ :det | det element = (myLab reagentByCasNumber: self aperolCasNumber) ]
		ifNone: [ nil ].
	self assert: ( someDetail notNil ); assert: ( someDetail quantity = 10).
	someDetail := pending details 
		detect: [ :det | det element = (myLab reagentByCasNumber: self albuminCasNumber) ]
		ifNone: [ nil ].
	self assert: ( someDetail notNil ); assert: ( someDetail quantity = 15).
	someDetail := pending details 
		detect: [ :det | det element = (myLab reagentByCasNumber: self saltGrainsCasNumber ) ]
		ifNone: [ nil ].
	self assert: ( someDetail notNil ); assert: ( someDetail quantity = 400).

	

	
	
	
	
	




! !

!BuyingRequirementTest methodsFor: 'testing' stamp: 'CLom 11/25/2014 16:55'!
testRequirementSatisfaction
	"tests the generation of the satisfaction of a BuyingRequirement by a BuyingEvent"

	| myLab req  buying satisfaction someDetail |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.
	self addACinzanoBuyingEventTo: myLab.
	
	req := self buildRequirementToSatisfyInLab: myLab.
	buying := self buildBuyingEventToSatisfyInLab: myLab.
	
	satisfaction := buying generateSatisfactionForRequirement: req.
	self assert: (satisfaction details size = 2).
	someDetail := satisfaction details 
		detect: [ :det | det element = (myLab reagentByCasNumber: self aperolCasNumber) ]
		ifNone: [ nil ].
	self 
		assert: ( someDetail notNil );
		assert: ( someDetail quantity = 10);
		assert: ( someDetail unitPrice = 90).
	someDetail := satisfaction details 
		detect: [ :det | det element = (myLab reagentByCasNumber: self albuminCasNumber ) ]
		ifNone: [ nil ].
	self 
		assert: ( someDetail notNil );
		assert: ( someDetail quantity = 12);
		assert: ( someDetail unitPrice = 35).

	
	
	
	
	




! !

LabApplicationTestCase subclass: #EditingStockDetailEventTest
	uses: TExampleLabBuild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

EditingStockDetailEventTest class
	uses: TExampleLabBuild classTrait
	instanceVariableNames: ''!

!EditingStockDetailEventTest methodsFor: 'testing' stamp: 'CarlosLombardi 10/4/2014 11:15'!
testComputations
	"test that an EditingStockDetailEvent performs its computations properly"

	| myLab aperol catNail editingDetail |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.
	aperol := myLab reagentByCasNumber: self aperolCasNumber .
	catNail := myLab reagentByCasNumber: self catNailCasNumber .
	
	editingDetail := StockEventDetailEditController  forNewDetailInLab: myLab.
	editingDetail provider: (myLab providerNamed: 'SIGMA').
	"nothing set - totalAmount should be zero"
	self assert: (editingDetail totalAmount = 0).
	
	"set aperol, should update the unit price "
	editingDetail element: aperol.
	self assert: (editingDetail unitPrice = 85).
	
	"set a quantity, should update total amount"
	editingDetail quantity: 20.
	self assert: (editingDetail totalAmount = 1700).
	
	"change reagent, should update both unit price and total amount"
	editingDetail element: catNail .
	self assert: (editingDetail unitPrice = 380).
	self assert: (editingDetail totalAmount = 7600).
	
	"change unit price, should update total amount"
	editingDetail unitPrice: 300.
	self assert: (editingDetail totalAmount = 6000).

	"change quantity"
	editingDetail quantity: 15.
	self assert: (editingDetail totalAmount = 4500).
	
	"clear reagent"
	editingDetail element: nil .
	self assert: (editingDetail quantity = 15).
	self assert: (editingDetail unitPrice = 0).
	self assert: (editingDetail totalAmount = 0).
! !

!EditingStockDetailEventTest methodsFor: 'testing' stamp: 'CarlosLombardi 10/4/2014 11:15'!
testReagentPriceObtention
	"... in different conditions"

	| myLab editingDetail  |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.
	
	editingDetail := StockEventDetailEditController  forNewDetailInLab: myLab.
	editingDetail provider: (myLab providerNamed: 'Coto').
	
	"aperol: has Coto price"
	editingDetail element: (myLab reagentByCasNumber: self aperolCasNumber ).
	self assert: (editingDetail unitPrice = 80).
	
	"albumin: has price for other providers only"
	editingDetail element: (myLab reagentByCasNumber: self albuminCasNumber).
	self assert: (editingDetail unitPrice = 15.20).
	
	"bull blood: no price at all"
	editingDetail element: (myLab reagentByCasNumber: self bullBloodCasNumber).
	self assert: (editingDetail unitPrice = 0).
	
	
! !

LabApplicationTestCase subclass: #EventDetailCopierTest
	uses: TExampleLabBuild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

EventDetailCopierTest class
	uses: TExampleLabBuild classTrait
	instanceVariableNames: ''!

!EventDetailCopierTest methodsFor: 'testing' stamp: 'CarlosLombardi 2/11/2015 18:13'!
testEventDetailCopy
	"a simple test"

	| myLab sourceDetail newEvent newDetail detailsInZero |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.

	sourceDetail := myLab events anyOne details anyOne.
	
	newEvent := ReagentBuyingEvent new
		date: (Date newDay: 25 month: 2 year: 2014);
		provider: (myLab providerNamed: 'Cinzano');
		lab: myLab.
	self assert: (newEvent details isEmpty).

	(sourceDetail copierTo: newEvent) proceed.
	self assert: (newEvent details size = 1).
	newDetail := newEvent details anyOne. "there is just one"
	self assert: (newDetail event = newEvent).
	self assert: (newDetail element = sourceDetail element).
	self assert: (newDetail quantity = sourceDetail quantity).
	self assert: (newDetail unitPrice = sourceDetail unitPrice).
	
	(sourceDetail copierTo: newEvent) 
		forWithoutPrice ;
		newDetailClass: StockEventDetail ;
	proceed.	
	self assert: (newEvent details size = 2).
	detailsInZero := newEvent details select: [ :det | det unitPrice = 0 ].
	self assert: (detailsInZero size = 1).
	newDetail := detailsInZero anyOne. "there is just one"
	self assert: (newDetail event = newEvent).
	self assert: (newDetail element = sourceDetail element).
	self assert: (newDetail quantity = sourceDetail quantity).
	self assert: (newDetail unitPrice = 0).
	! !

LabApplicationTestCase subclass: #EventQueryTest
	uses: TExampleLabBuild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

EventQueryTest class
	uses: TExampleLabBuild classTrait
	instanceVariableNames: ''!

!EventQueryTest methodsFor: 'example building' stamp: ''!
addACinzanoBuyingEventTo: aLab
	"adds a buying event corresponding to the provider named 'Cinzano' "

	| newBuying |
	newBuying := ReagentBuyingEvent new
		date: (Date newDay: 3 month: 10 year: 2013);
		provider: (aLab providerNamed: 'Cinzano');
		lab: aLab.
	self
		addDetailsFrom:
			{aLab reagentByCasNumber: self aperolCasNumber. 7. 82.
			(aLab reagentByCasNumber: self albuminCasNumber). 10. 17}
		toBuyingEvent: newBuying.
	aLab addToEvents: newBuying.
! !

!EventQueryTest methodsFor: 'example building' stamp: ''!
addDetailsFrom: aList toBuyingEvent: aBuyingEvent 
	"add some details, codified in aList, to aBuyingEvent.
	 The list is codified as follows: reagent / quantity / unitPrice / next reagent ... "
	
	| dataStream newDetail |
	(aList size rem: 3) = 0 ifFalse: [ self error: 'bad-built detail list' ].
	
	dataStream := aList readStream.
	[dataStream atEnd] whileFalse: 	[ 
		newDetail := StockEventDetail new 
			event: aBuyingEvent ;
			element: dataStream next ;
			quantity: dataStream next ;
			unitPrice: dataStream next.
		aBuyingEvent addToDetails: newDetail.
	] .

	! !

!EventQueryTest methodsFor: 'example building' stamp: ''!
addSomeBuyingEventsTo: aLab

	| newBuying albumin aperol catNail saltGrains |
	albumin := aLab reagentByCasNumber: self albuminCasNumber.
	aperol := aLab reagentByCasNumber: self aperolCasNumber.
	catNail := aLab reagentByCasNumber: self catNailCasNumber.
	saltGrains := aLab reagentByCasNumber: self saltGrainsCasNumber.
	
	newBuying := ReagentBuyingEvent new
		date: (Date newDay: 12 month: 9 year: 2013) ;
		provider: (aLab providerNamed: 'SIGMA') ; lab: aLab.
	self 
		addDetailsFrom: { albumin . 8 . 15.20 . aperol . 20 . 85 . catNail . 3 . 380 } 
		toBuyingEvent: newBuying.
	aLab addToEvents: newBuying.

	newBuying := ReagentBuyingEvent new
		date: (Date newDay: 10 month: 8 year: 2013) ;
		provider: (aLab providerNamed: 'SIGMA')  ; extraAmount: 100 ; lab: aLab.
	self 
		addDetailsFrom: { aperol . 8 . 78 . catNail . 4 . 400 . saltGrains . 1000 . 0.12 } 
		toBuyingEvent: newBuying.
	aLab addToEvents: newBuying.

	newBuying := ReagentBuyingEvent new
		date: (Date newDay: 21 month: 10 year: 2013) ;
		provider: (aLab providerNamed: 'Coto')  ; lab: aLab.
	self 
		addDetailsFrom: { aperol . 10 . 80 . saltGrains . 2200 . 0.15 } 
		toBuyingEvent: newBuying.
	aLab addToEvents: newBuying.
! !

!EventQueryTest methodsFor: 'accessing' stamp: ''!
albuminCasNumber
	"the SIGMA reference to obtain the 'albumin' reagent "

	^'BT552'! !

!EventQueryTest methodsFor: 'accessing' stamp: ''!
aperolCasNumber
	"the CAS number to obtain the 'aperol' reagent "

	^'AZ072'! !

!EventQueryTest methodsFor: 'example building' stamp: ''!
buildCopyOfLab: aLab
	"builds and answers a copy of the given lab, not including events"

	| newLab |
	newLab := Lab new.
	aLab stockUnits do: [ :unit | newLab addToStockUnits: unit ].
	aLab consumables do: [ :consu | newLab addToConsumables: consu ].
	aLab reagents do: [ :reag | newLab addToReagents: reag ].
	aLab providers do: [ :prov | newLab addToReferenceAuthorities: prov ].
	LabApplication current registerLab: newLab.
	^newLab
! !

!EventQueryTest methodsFor: 'example building' stamp: ''!
buildSimpleLab
	"builds and answers a simple lab including five reagents"

	| newLab litro tresCuartos gramo diezGramos |
	newLab := Lab new.
	litro := StockUnit new name: 'l.' ; prependX: false.
	tresCuartos := StockUnit new name: '0.75 l.' ; prependX: true.
	gramo := StockUnit new name: 'g.' ; prependX: false.
	diezGramos := StockUnit new name: '10 g.' ; prependX: true.
	newLab 
		addToStockUnits: litro ; addToStockUnits: tresCuartos ; 
		addToStockUnits: gramo ; addToStockUnits: diezGramos.
	newLab 
		addProviderNamed: 'Invitrogen' ; addProviderNamed: 'Bio-Rad' ; 
		addProviderNamed: 'SIGMA' ;
		addProviderNamed: 'Coto' ; addProviderNamed: 'Cinzano'.
	newLab addToReagents: (
		Reagent new
			name: 'Sangre de toro' ; molecularWeight: 2.04 ; casNumber: self bullBloodCasNumber ;
			stockUnit: litro ; 
			referenceId: 'AX32Q' forAuthority: (newLab providerNamed: 'Bio-Rad') ;
			yourself
	).
	newLab addToReagents: (
		Reagent new
			name: 'Aperol' ; molecularWeight: 1.22 ; casNumber: self aperolCasNumber ;
			stockUnit: tresCuartos ; 
			referenceId: 'Ape01' forAuthority: (newLab providerNamed: 'Cinzano')	;
			yourself
	).
	newLab addToReagents: (
		Reagent new
			name: 'Granos de sal' ; molecularWeight: 8.7 ; casNumber: self saltGrainsCasNumber ;
			stockUnit: gramo ; 
			referenceId: 'CELU' forAuthority: (newLab providerNamed: 'Coto') ;
			yourself
	).
	newLab addToReagents: (
		Reagent new
			name: 'Albumina' ; molecularWeight: 3.15 ; casNumber: self albuminCasNumber ;
			stockUnit: diezGramos ; 
			referenceId: 'TT001' forAuthority: (newLab providerNamed: 'Bio-Rad') ;
			referenceId: 'FXA31' forAuthority: (newLab providerNamed: 'Invitrogen') ;
			yourself
	).
	newLab addToReagents: (
		Reagent new
			name: 'Uña de gato' ; molecularWeight: 6.45 ; casNumber: self catNailCasNumber ;
			stockUnit: LabApplication unitStockUnit ; 
			referenceId: 'FXB12' forAuthority: (newLab providerNamed: 'Invitrogen') ;
			yourself
	).
	newLab addToConsumables: (
		Consumable new
			name: 'Tubo appendorf de 1.5 ml' ;
			referenceId: 'TA150' forAuthority: (newLab providerNamed: 'SIGMA') ;
			yourself
	).
	newLab addToConsumables: (
		Consumable new
			name: 'Tubo appendorf de 0.5 ml' ;
			referenceId: 'TA050' forAuthority: (newLab providerNamed: 'SIGMA') ;
			yourself
	).
	newLab addToConsumables: (
		Consumable new
			name: 'Pipeta automática' ;
			referenceId: 'PIPET' forAuthority: (newLab providerNamed: 'SIGMA') ;
			referenceId: 'AJPI92' forAuthority: (newLab providerNamed: 'Invitrogen') ;
			yourself
	).
	LabApplication current registerLab: newLab.
	^newLab! !

!EventQueryTest methodsFor: 'accessing' stamp: ''!
bullBloodCasNumber
	"the CAS number to obtain the 'bull blood' reagent "

	^'JJ444'! !

!EventQueryTest methodsFor: 'accessing' stamp: ''!
catNailCasNumber
	"the CAS number to obtain the 'cat nail' reagent "

	^'MO901'! !

!EventQueryTest methodsFor: 'accessing' stamp: ''!
saltGrainsCasNumber
	"the CAS number to obtain the 'salt grains' reagent "

	^'AQ861'! !

!EventQueryTest methodsFor: 'query tests' stamp: 'CarlosLombardi 10/19/2014 11:02'!
testLastPriceCalculationOneLab

	| myLab aPriceCalculator |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.

	aPriceCalculator := PriceCalculator new.
	aPriceCalculator lab: myLab.	

	aPriceCalculator stockElement: (myLab reagentByCasNumber: self aperolCasNumber).
	self assert: (aPriceCalculator lastPrice = 80).
	aPriceCalculator provider: (myLab providerNamed: 'SIGMA').
	self assert: (aPriceCalculator lastPrice = 85).
	aPriceCalculator provider: (myLab providerNamed: 'Coto').
	self assert: (aPriceCalculator lastPrice = 80).
	aPriceCalculator provider: (myLab providerNamed: 'Cinzano').
	self assert: (aPriceCalculator lastPrice = 80).
	aPriceCalculator forOnlySpecifiedProvider.
	self assert: (aPriceCalculator lastPrice = 0).


"	allDetails := aQuery details.
	self assert: (allDetails size = 8).
	self assert: ((allDetails collect: [:det | det quantity ] ) sum = 3253).
	
	aQuery stockElement: (myLab reagentByCasNumber: self aperolCasNumber).
	aperolDetails := aQuery details.
	self assert: (aperolDetails size = 3).
	self assert: ((aperolDetails collect: [:det | det quantity ] ) sum = 38).

	aQuery provider: (myLab providerNamed: 'SIGMA').
	aperolSigmaDetails := aQuery details.
	self assert: (aperolSigmaDetails size = 2).
	self assert: ((aperolSigmaDetails collect: [:det | det quantity ] ) sum = 28).
"! !

!EventQueryTest methodsFor: 'query tests' stamp: 'CarlosLombardi 10/19/2014 13:06'!
testLastPriceCalculationTwoLabs
	| myLab secondLab aPriceCalculator |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.	
		
	"copy stock units and stock elements from myLab to secondLab"
	secondLab := self buildCopyOfLab: myLab.
		
	"add a buying event to second lab"
	self addACinzanoBuyingEventTo: secondLab.
	
	aPriceCalculator := PriceCalculator new.
	aPriceCalculator lab: myLab.
	aPriceCalculator stockElement: (secondLab reagentByCasNumber: self aperolCasNumber).
	self assert: aPriceCalculator lastPrice = 80.
	aPriceCalculator forOnlySpecifiedProvider.
	aPriceCalculator provider: (myLab providerNamed: 'Cinzano').
	self assert: aPriceCalculator lastPrice = 82.
	aPriceCalculator provider: (myLab providerNamed: 'Invitrogen').
	self assert: aPriceCalculator lastPrice = 0.
	! !

!EventQueryTest methodsFor: 'query tests' stamp: 'CarlosLombardi 10/19/2014 10:51'!
testQueryDetails

	| myLab aQuery aperolDetails allDetails aperolSigmaDetails |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.

	aQuery := EventQuery new.
	aQuery lab: myLab.

	allDetails := aQuery details.
	self assert: (allDetails size = 8).
	self assert: ((allDetails collect: [:det | det quantity ] ) sum = 3253).
	
	aQuery stockElement: (myLab reagentByCasNumber: self aperolCasNumber).
	aperolDetails := aQuery details.
	self assert: (aperolDetails size = 3).
	self assert: ((aperolDetails collect: [:det | det quantity ] ) sum = 38).

	aQuery provider: (myLab providerNamed: 'SIGMA').
	aperolSigmaDetails := aQuery details.
	self assert: (aperolSigmaDetails size = 2).
	self assert: ((aperolSigmaDetails collect: [:det | det quantity ] ) sum = 28).
! !

!EventQueryTest methodsFor: 'query tests' stamp: 'CarlosLombardi 10/19/2014 13:05'!
testQueryDetailsTwoLabs

	| myLab secondLab aQuery aperolDetails allDetails aperolSigmaDetails |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.

	secondLab := self buildCopyOfLab: myLab.
	self addACinzanoBuyingEventTo: secondLab.

	aQuery := EventQuery new.

	allDetails := aQuery details.
	self assert: (allDetails size = 10).
	self assert: ((allDetails collect: [:det | det quantity ] ) sum = 3270).
	
	aQuery stockElement: (myLab reagentByCasNumber: self aperolCasNumber).
	aperolDetails := aQuery details.
	self assert: (aperolDetails size = 4).
	self assert: ((aperolDetails collect: [:det | det quantity ] ) sum = 45).

	aQuery provider: (myLab providerNamed: 'SIGMA').
	aperolSigmaDetails := aQuery details.
	self assert: (aperolSigmaDetails size = 2).
	self assert: ((aperolSigmaDetails collect: [:det | det quantity ] ) sum = 28).
! !

!EventQueryTest methodsFor: 'query tests' stamp: 'CarlosLombardi 10/19/2014 13:04'!
xtestLastPriceCalculationTwoLabs
	| myLab secondLab aPriceCalculator |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.	
		
	"copy stock units and stock elements from myLab to secondLab"
	secondLab := self buildCopyOfLab: myLab.
		
	"add a buying event to second lab"
	self addACinzanoBuyingEventTo: secondLab.
	
	aPriceCalculator := PriceCalculator new.
	aPriceCalculator lab: myLab.
	aPriceCalculator stockElement: (secondLab reagentByCasNumber: self aperolCasNumber).
	self assert: aPriceCalculator lastPrice = 80.
	aPriceCalculator forOnlySpecifiedProvider.
	aPriceCalculator provider: (myLab providerNamed: 'Cinzano').
	self assert: aPriceCalculator lastPrice = 82.
	aPriceCalculator provider: (myLab providerNamed: 'Invitrogen').
	self assert: aPriceCalculator lastPrice = 0.
	! !

!LabApplicationTestCase methodsFor: 'running' stamp: 'CarlosLombardi 10/19/2014 11:51'!
setUp
	"code to be run before each test"

	| newLabApplication |
	savedLabApplication := LabApplication current.
	newLabApplication := LabApplication new.
	LabApplication forceCurrentTo: newLabApplication.! !

!LabApplicationTestCase methodsFor: 'running' stamp: 'CarlosLombardi 10/19/2014 11:41'!
tearDown
	"code to be run after each test"

	LabApplication forceCurrentTo: savedLabApplication.! !

LabApplicationTestCase subclass: #LabStockTest
	uses: TExampleLabBuild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

LabStockTest class
	uses: TExampleLabBuild classTrait
	instanceVariableNames: ''!

!LabStockTest methodsFor: 'reagent base tests' stamp: 'CarlosLombardi 4/28/2014 23:01'!
testBuyingEvent

	| myLab buying1 buying2 aperol catNail |
	myLab := self buildSimpleLab.
	aperol := myLab reagentByCasNumber: self aperolCasNumber .
	catNail := myLab reagentByCasNumber: self catNailCasNumber .
	self addSomeBuyingEventsTo: myLab.
	buying1 := myLab events 
		detect: [ :event | event date = (Date newDay: 10 month: 8 year: 2013 ) ] ifNone: [ nil ].
	buying2 := myLab events 
		detect: [ :event | event date = (Date newDay: 21 month: 10 year: 2013 ) ] ifNone: [ nil ].
	self 
		assert: (buying1 involvesElement: aperol) ;
		assert: (buying1 involvesElement: catNail) ;
		deny: (buying1 involvesElement: (myLab reagentByCasNumber: self albuminCasNumber )) ;
		assert: (buying2 involvesElement: aperol) ;
		deny: (buying2 involvesElement: catNail).
	self 
		assert: (buying1 totalAmount =  2444) ;
		assert: (buying2 totalAmount =  1130) .
		
		
! !

!LabStockTest methodsFor: 'reagent base tests' stamp: 'CarlosLombardi 3/27/2014 23:04'!
testRetrieveBySigmaReference

	| myLab albumin |
	myLab := self buildSimpleLab.
	albumin := myLab reagentByCasNumber: self albuminCasNumber.
	self 
		assert: albumin notNil ;
		assert: albumin name = 'Albumina'.
	self assert: (myLab reagentByCasNumber: 'NOHAY') isNil.! !

!LabStockTest methodsFor: 'reagent base tests' stamp: 'CarlosLombardi 10/20/2014 10:50'!
testStockAndLatestPrice

	| myLab assertBlock reagentInLab |
	myLab := self buildSimpleLab.
	self addSomeBuyingEventsTo: myLab.
	"aperol := myLab reagentBySigmaReference: self aperolSigmaRef .
""	catNail := myLab reagentBySigmaReference: self catNailSigmaRef ."

	"dataPack is: sigmaRef / expected stock / expected last buying price / for SIGMA / for Coto"
	"(fourth and fifth optional) "
	assertBlock := [ :dataPack | | priceCalculator |
		reagentInLab := StockElementInLab for: (myLab reagentByCasNumber: dataPack first) inLab: myLab.
		priceCalculator := reagentInLab priceCalculator.
		priceCalculator defaultPrice: nil.
		self 
			assert: (reagentInLab currentStock = dataPack second) ;
			assert: (priceCalculator lastPrice = dataPack third).
		(dataPack size > 3) ifTrue: [ 
			priceCalculator forOnlySpecifiedProvider.
			priceCalculator provider: (myLab providerNamed: 'SIGMA').
			self assert: ( priceCalculator lastPrice = dataPack fourth).
			priceCalculator provider: (myLab providerNamed: 'Coto').
			self assert: ( priceCalculator lastPrice = dataPack fifth).
		]
	].

	assertBlock 
		value: { self albuminCasNumber . 8 . 15.20 } ;
		value: { self aperolCasNumber . 38 . 80 . 85 . 80 } ;
		value: { self catNailCasNumber . 7 . 380 . 380 . nil } ;
		value: { self saltGrainsCasNumber . 3200 . 0.15 } ;
		value: { self bullBloodCasNumber . 0 . nil } .
		
! !

LabApplicationTestCase subclass: #SolutionPreparationTest
	uses: TExampleLabBuild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

SolutionPreparationTest class
	uses: TExampleLabBuild classTrait
	instanceVariableNames: ''!

!SolutionPreparationTest methodsFor: 'testing' stamp: 'CarlosLombardi 3/24/2015 19:00'!
testReagentQuantities
	"a simple test for the quantities of reagent in a solution preparation"

	| theLab aperol albumin sal form1 form2 aperolmw  bullBlood salprep |
	theLab := self buildSimpleLab.
	aperol := theLab reagentByCasNumber: self aperolCasNumber .
	albumin := theLab reagentByCasNumber: self albuminCasNumber .
	bullBlood := theLab reagentByCasNumber: self bullBloodCasNumber .
	form1 := [ :comp :quant | quant / (comp concentration * comp molecularWeight)  ].
	form2 := [ :comp :quant | (quant * 3) / comp concentration ].
	aperolmw := aperol molecularWeight .
	
	sal  := Solution new.
	sal name: 'Cloruro de sodio' ;
		addToComponents: ( ReagentInSolutionByExplicitFormula new 
			reagent: aperol ; concentration: 4 ; formula: form1 ) ;
		addToComponents: ( ReagentInSolutionByExplicitFormula new 
			reagent: albumin ; concentration: 2 ; formula: form2 ) .

	self assert: ( (sal componentForReagent: aperol ) isNotNil ) .
	self assert: ( (sal componentForReagent: bullBlood ) isNil ) .
	self assert: (( (sal componentForReagent: aperol ) quantityNeededFor: 10 ) asFloat =  (2.5 / aperolmw) asFloat ) .
	
	salprep := SolutionPreparationActivity new .
	salprep solution: sal ; solutionQuantity: 20 .
	self assert: ( (salprep reagentQuantityFor: aperol) asFloat = (5 / aperolmw) asFloat ).
	self assert: ( (salprep reagentQuantityFor: albumin) = 30 ).
	! !

LabApplicationTestCase subclass: #StockUnitTest
	uses: TExampleLabBuild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

StockUnitTest class
	uses: TExampleLabBuild classTrait
	instanceVariableNames: ''!

!StockUnitTest methodsFor: 'testing' stamp: 'CarlosLombardi 3/27/2014 23:13'!
testAsString
	"verify that the result of >>asString is as expected"

	| diezMl porCaja |
	diezMl := StockUnit new.
	diezMl name: '10 ml.' ; prependX: true.
	self assert: (diezMl asString = 'x 10 ml.').

	porCaja := StockUnit new.
	porCaja name: 'caja' ; prependX: false. 
	self assert: (porCaja asString = 'caja').
! !

TestCase subclass: #LabProjectLogEntryTest
	instanceVariableNames: 'logEntry logEntryPremoted logEntryDemoted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/14/2015 02:11'!
setUp

	| solutionPreparationActivity child |
	
	logEntry := LabProjectLogEntry new.
	
	child := LabProjectLogEntry new.
	child parent: logEntry.
	
	logEntry loadDate: (Date newDay: 11 month: 11 year: 2015).
	logEntry toDoDate: (Date newDay: 12 month: 11 year: 2015).
	logEntry completionDate: (Date newDay: 14 month: 11 year: 2015).
	logEntry notes: (Text fromString: 'Importante: No olvidar').
	logEntry description: 'Lectura de placas'.
	logEntry attachFileNamed: 'Mi Ejemplo'.
	logEntry attachFileNamed: 'Prueba'.
	logEntry parentSetter: LabProject new.
	logEntry children add: child.
	
	solutionPreparationActivity := SolutionPreparationActivity new.
	solutionPreparationActivity solution: Solution new.
	solutionPreparationActivity solutionQuantity: (15 units: (Unit millimetre)).
	
	logEntry addToSolutionPreparationActivities: solutionPreparationActivity.
	
	logEntry completionDate: EstimatedState new.
	logEntry rootDirectoryPath:'C:\Archivos de programa\MiArchivo.pdf'.
	logEntry noteEditor: PluggableTextMorph new.! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/14/2015 03:06'!
testAmendParentInDescendantsForCopy

	| aLogEntry |
	
	aLogEntry := LabProjectLogEntry new.
	
	aLogEntry children add: LabProjectLogEntry new; 
					     add: LabProjectLogEntry new; 
					     add: LabProjectLogEntry new.
	
	aLogEntry amendParentInDescendantsForCopy.
	
	self assert: (aLogEntry children allSatisfy: [:child | child parent == aLogEntry]).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/14/2015 02:12'!
testIsCanBeDemotedFalse

	| parent |
	
	parent := logEntry parent.
	
	parent privateAddLastChild: LabProjectLogEntry new.
	parent privateAddLastChild: LabProjectLogEntry new.
	parent privateAddLastChild: logEntry.
	
	self deny: logEntry canBeDemoted.! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/14/2015 02:13'!
testIsCanBeDemotedTrue

	| parent |

	parent := logEntry parent.
	
	parent privateAddLastChild: logEntry.
	parent privateAddLastChild: LabProjectLogEntry new.
	parent privateAddLastChild: LabProjectLogEntry new.
	
	self assert: logEntry canBeDemoted.! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:36'!
testIsReplicableOneDigitFalse

	logEntry description: 'Mi ejemplo (1 de 10)'.
	
	self deny: (logEntry isReplicableOneDigit).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:35'!
testIsReplicableOneDigitTrue

	logEntry description: 'Mi ejemplo (1 de 9)'.
	
	self assert: (logEntry isReplicableOneDigit).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:37'!
testIsReplicableTwoDigitFalse

	logEntry description: 'Mi ejemplo (1 de 4)'.
	
	self deny: (logEntry isReplicableTwoDigits).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:37'!
testIsReplicableTwoDigitTrue

	logEntry description: 'Mi ejemplo (1 de 11)'.
	
	self assert: (logEntry isReplicableTwoDigits).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/14/2015 02:13'!
testIscanBePromotedFalse

	| parent |
	
	parent := logEntry parent.
	
	parent privateAddLastChild: logEntry.
	parent privateAddLastChild: LabProjectLogEntry new.
	
	self deny: logEntry canBePromoted.! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/14/2015 02:18'!
testIscanBePromotedTrue

	| parent |

	parent := logEntry parent.
	
	parent privateAddLastChild: LabProjectLogEntry new.
	parent privateAddLastChild: logEntry.
	parent privateAddLastChild: LabProjectLogEntry new.
	
	self assert: logEntry canBePromoted.! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:40'!
testNumberToReplicateOneDigit

	logEntry description: 'Mi ejemplo (1 de 2)'.
	
	self assert: (logEntry numberToReplicate = 2).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:40'!
testNumberToReplicateTwoDigit

	logEntry description: 'Mi ejemplo (1 de 14)'.
	
	self assert: (logEntry numberToReplicate = 14).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:49'!
testNumberToReplicateWithoutDigits

	logEntry description: 'Mi ejemplo'.
	
	self assert: (logEntry numberToReplicate = 0).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:21'!
testReplicateFromLogEntry

	| aLogEntry solutionActivityAlogEntry solutionActivityLogEntry |
	
	aLogEntry := LabProjectLogEntry new.
	
	aLogEntry replicateFromLogEntry: logEntry.
	
	self deny: (aLogEntry description == logEntry description).
	self deny: (aLogEntry loadDate == logEntry loadDate).
	self deny: (aLogEntry toDoDate == logEntry toDoDate).
	self deny: (aLogEntry completionDate == logEntry completionDate).
	self deny: (aLogEntry notes == logEntry notes).
	self deny: (aLogEntry attachedFiles first == logEntry attachedFiles first).
	self deny: (aLogEntry attachedFiles last == logEntry attachedFiles last).
	self assert: (aLogEntry parent == logEntry parent).
	self deny: (aLogEntry children first == logEntry children first).
	
	solutionActivityAlogEntry := aLogEntry solutionPreparationActivities first.
	solutionActivityLogEntry := logEntry solutionPreparationActivities first.
	self assert: (solutionActivityAlogEntry solution == solutionActivityLogEntry solution).
	self deny: (solutionActivityAlogEntry solutionQuantity == solutionActivityLogEntry solutionQuantity).
	
	self deny: (aLogEntry completionDate == logEntry completionDate).
	self deny: (aLogEntry rootDirectoryPath == logEntry rootDirectoryPath).
	self deny: (aLogEntry noteEditor == logEntry noteEditor).
	
	self assert: (aLogEntry children first parent description = 'Lectura de placas').
	self deny: (aLogEntry children first parent == logEntry children first parent).! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:42'!
testcanBeReplicatedFalse

	logEntry description: 'Mi ejemplo'.
	
	self deny: logEntry canBeReplicated .! !

!LabProjectLogEntryTest methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 11/13/2015 01:42'!
testcanBeReplicatedTrue

	logEntry description: 'Mi ejemplo (1 de 2)'.
	
	self assert: logEntry canBeReplicated .! !

TestCase subclass: #ReportGeneratorTest
	instanceVariableNames: 'reportGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Tests'!

!ReportGeneratorTest methodsFor: 'as yet unclassified' stamp: 'EstebanTolaba 11/13/2015 18:15'!
setUp! !

!MulticolumnLazyListMorph methodsFor: '*LaBook-cambios' stamp: 'CarlosLombardi 3/12/2014 18:14'!
setColumnWidthsFor: aCanvas
        | row topRow bottomRow |
        "set columnWidths for drawing on the specified canvas"
		columnWidths ifNil: [
		columnWidths := (self item: 1) collect: [ :ignored | 0 ]. ].
	topRow := (self topVisibleRowForCanvas: aCanvas) max: 1.
	bottomRow :=  (self bottomVisibleRowForCanvas: aCanvas) max: 1.
	topRow > bottomRow ifTrue: [ ^ self ].
	topRow to: bottomRow do: [ :rowIndex |
                row := self item: rowIndex.
                columnWidths := columnWidths with: row collect: [ :currentWidth :item |
				| widthOfItem |
"				widthOfItem := (font widthOfStringOrText: item).
"
				widthOfItem := item asMorph width.	
				widthOfItem > currentWidth
					ifTrue: [ self changed.  widthOfItem ]
					ifFalse: [ currentWidth ] ] ]! !

Stream subclass: #FilteredReadStream
	instanceVariableNames: 'baseStream filter isFinished peekedElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Basics'!

!FilteredReadStream commentStamp: '<historical>' prior: 0!
A Stream which filters the given elements upon a boolean block.
I am not positionable; I am only fit for the standard use of next / atEnd.

filter: the block.!

!FilteredReadStream class methodsFor: 'instance creation' stamp: 'CLom 11/25/2014 13:25'!
on: anObject filterBy: aBlock
	"a new instance traversing anObject and filtering by aBlock"

	^self basicNew 
		baseStream: anObject readStream filter: aBlock ;
		yourself! !

!FilteredReadStream methodsFor: 'private' stamp: 'CLom 11/25/2014 13:13'!
advance
	"private - advance my inner state"

	| found |
	found := false.
	baseStream atEnd ifFalse: [ 
		[ peekedElement := baseStream next. 
		  found := filter value: peekedElement. ]
		doWhileFalse: [ baseStream atEnd | found ].
		isFinished := baseStream atEnd & found not.
	]
	ifTrue: [ self isFinished: true ].! !

!FilteredReadStream methodsFor: 'testing' stamp: 'CLom 11/25/2014 13:13'!
atEnd
	"Answer whether the receiver can access any more objects."

	^self isFinished! !

!FilteredReadStream methodsFor: 'accessing' stamp: 'CLom 11/25/2014 13:04'!
baseStream
	"A non-filtered stream upon which I proceed"
	^ baseStream
	! !

!FilteredReadStream methodsFor: 'accessing - private' stamp: 'CLom 11/25/2014 13:17'!
baseStream: aStream filter: aBlock
	"I prepare myself to life given my basic parameters"
	
	baseStream := aStream.
	filter := aBlock.
	self advance.! !

!FilteredReadStream methodsFor: 'accessing' stamp: 'CLom 11/25/2014 13:06'!
contents
	"Answer all of the contents of the receiver."

	self shouldNotImplement! !

!FilteredReadStream methodsFor: 'accessing' stamp: 'CLom 11/25/2014 13:04'!
filter
	"the boolean block being the criteria to filter the base elements"
	^ filter! !

!FilteredReadStream methodsFor: 'accessing - private' stamp: 'CLom 11/25/2014 13:03'!
isFinished
	^ isFinished! !

!FilteredReadStream methodsFor: 'accessing - private' stamp: 'CLom 11/25/2014 13:03'!
isFinished: anObject
	isFinished := anObject! !

!FilteredReadStream methodsFor: 'accessing' stamp: 'CLom 11/25/2014 13:14'!
next
	"Answer the next object accessible by the receiver."

	| result |
	self atEnd ifTrue: [ ^self error: 'Stream access past its end attempted.' ].
	result := self peekedElement.
	self advance.
	^result! !

!FilteredReadStream methodsFor: 'accessing' stamp: 'CLom 11/25/2014 13:06'!
nextPut: anObject
	"Insert the argument, anObject, as the next object accessible by the 
	receiver. Answer anObject."

	self shouldNotImplement! !

!FilteredReadStream methodsFor: 'accessing - private' stamp: 'CLom 11/25/2014 13:03'!
peekedElement
	^ peekedElement! !

!FilteredReadStream methodsFor: 'accessing - private' stamp: 'CLom 11/25/2014 13:03'!
peekedElement: anObject
	peekedElement := anObject! !

!PluggableTextFieldMorph methodsFor: '*LaBook' stamp: 'CarlosLombardi 3/12/2014 14:59'!
initializeShortcuts: aKMDispatcher
	super initializeShortcuts: aKMDispatcher.
	aKMDispatcher attachCategory: #MorphFocusNavigation ! !

PluggableTextFieldMorph subclass: #PluggableTextSingleLineFieldMorph
	instanceVariableNames: 'colorIsExplicitlySet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Morphic-Addons'!

!PluggableTextSingleLineFieldMorph methodsFor: 'visual properties' stamp: 'CarlosLombardi 2/28/2015 01:05'!
fillStyle: aFillStyle
	"Set the current fillStyle of the receiver."
	
	colorIsExplicitlySet ifFalse: [ super fillStyle: aFillStyle ]! !

!PluggableTextSingleLineFieldMorph methodsFor: 'initialization-release' stamp: 'CarlosLombardi 2/28/2015 01:02'!
initialize
	"preparation for life"

	super initialize.
	colorIsExplicitlySet := false.! !

!PluggableTextSingleLineFieldMorph methodsFor: 'event handling' stamp: 'CarlosLombardi 2/28/2015 00:58'!
keystrokeFromTextMorph: anEvent
	( (anEvent keyCharacter = Character cr) and: [ self textMorph acceptOnCR not ] )
		ifTrue: [^true].
	^super keystrokeFromTextMorph: anEvent
			! !

!PluggableTextSingleLineFieldMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 2/28/2015 01:04'!
setExplicitColor: aColor
	"set my color. The set color will not be affected by calls to fillStyle:"

	colorIsExplicitlySet := true.
	super color: aColor 
	! !

PluggableTextFieldMorph subclass: #TextMorphKeyStrokeSignal
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!TextMorphKeyStrokeSignal commentStamp: '<historical>' prior: 0!
A TextMorphKeyStrokeSignal is xxxxxxxxx.

Instance Variables
	context:		<Object>

context
	- xxxxx
!

!TextMorphKeyStrokeSignal methodsFor: 'accessing' stamp: 'CarlosLombardi 10/26/2015 22:36'!
context
	^ context! !

!TextMorphKeyStrokeSignal methodsFor: 'accessing' stamp: 'CarlosLombardi 10/26/2015 22:36'!
context: anObject
	context := anObject! !

!TextMorphKeyStrokeSignal methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 10/30/2015 03:45'!
deleteCharacterIn: aString withKey: aStringKey
	"returns a string without the last character"
	
	| sizeInput index inputCopy intervalSelection |
					
	sizeInput := (aString size).
					
	inputCopy := ''.
	index := 1.

	intervalSelection := self getSelection.

	"Verifico si se selecciono todo el texto. (intervalSelection first = 1) esto quiere dcir que la seleccion empieza en 1 (al inicio)"
		(((intervalSelection first = 1) & (intervalSelection last = sizeInput)) | 
		((intervalSelection first = 1) & (intervalSelection last = 0) & (aStringKey = '<delete>') & (sizeInput = 1))) &
		((intervalSelection first = 2) & (intervalSelection last = 1) & (aStringKey = '<delete>') & (sizeInput = 1) not)
		 ifTrue: [ 
								inputCopy := ''.
					] ifFalse: [ 
						(sizeInput - 1) timesRepeat: [
							inputCopy := inputCopy , (aString at: index) asString.
							index := index + 1			
		  				].	
		].
	
	^inputCopy! !

!TextMorphKeyStrokeSignal methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 10/30/2015 03:51'!
deleteLastCharacter: aString
	"returns a string without the last character"
	
	| size index inputCopy |
					
	size := (aString size) - 1.
					
	inputCopy := ''.
	index := 1.

	size timesRepeat: [
			inputCopy := inputCopy , (aString at: index) asString.
			index := index + 1			
		  ].
	
	^inputCopy! !

!TextMorphKeyStrokeSignal methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 10/27/2015 17:46'!
disableButton
	"Disable the button Ok"
	
	self context window buttons first disable! !

!TextMorphKeyStrokeSignal methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 12/9/2015 00:34'!
disableButtonIfEmpty: aString
	"Disable button if aString is empty or is composite of spaces"

	aString isEmpty | (aString isAllSeparators) ifTrue: [ self disableButton ].
					
					! !

!TextMorphKeyStrokeSignal methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 10/27/2015 17:46'!
enableButton
	"Enable the button Ok"

	self context window buttons first enable! !

!TextMorphKeyStrokeSignal methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 12/9/2015 00:41'!
isKeyValid: anEvent
	"Verify it had been entered an event valid it refers to be a key to which enter in the field"
	
	| stringKey valueKeyForScrollMouse|

	stringKey := anEvent keyString.
	valueKeyForScrollMouse := anEvent keyValue.

   ^ (stringKey ~= '<up>') &
	(stringKey ~= '<down>') &
	(stringKey ~= '<right>') &
	(stringKey ~= '<left>') &
	(stringKey ~= '<pageDown>') &
	(stringKey ~= '<pageUp>') &
	(stringKey ~= '<end>') &
	(stringKey ~= '<home>') &
	(stringKey ~= '<insert>') &
	(stringKey ~= '<cr>') &
	(valueKeyForScrollMouse ~= 30) &
	(valueKeyForScrollMouse ~= 31)
	! !

!TextMorphKeyStrokeSignal methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 10/27/2015 22:12'!
keystrokeFromTextMorph: anEvent

	self validateField: anEvent.
	^super keystrokeFromTextMorph: anEvent.! !

!TextMorphKeyStrokeSignal methodsFor: 'as yet unclassified' stamp: 'FernandoDiMeglio 12/9/2015 00:47'!
validateField: anEvent
	"Disable the button Ok if the field is empty and otherwise enable "
	
	| input stringKey sizeInput intervalSelection |

	stringKey := anEvent keyString.
	input := self text asString.
	sizeInput := input size.
	intervalSelection := self getSelection.

	(stringKey = '<backspace>') | (stringKey = '<delete>') ifTrue: [  
		
			"Verify if all the text is selected. (intervalSelection first = 1) it refers to the selection starts in one (at the biginning) "
			(intervalSelection first = 1) ifTrue: [ 
						(intervalSelection last = sizeInput) ifTrue: [ self disableButton ] ifFalse: [
									"verifico si quedo una letra y se apreto delete"
									(intervalSelection last = 0) & (stringKey = '<delete>') & (sizeInput = 1)  ifTrue: [ self disableButton ] 
								]
						] ifFalse:[
							| inputCopy |
							
							"Verify if only there is one letter and it is in the end"
							((intervalSelection first = 2) & (intervalSelection last = 1) & (stringKey = '<delete>') & (sizeInput = 1) not) | 
							((intervalSelection first = 2) & (intervalSelection last = 1) & (stringKey = '<backspace>') & (sizeInput = 1) ) ifTrue: [ 
								inputCopy := self deleteLastCharacter: input.
								self disableButtonIfEmpty: inputCopy.
							]
						]					
		] ifFalse: [ 
			(self isKeyValid: anEvent) ifTrue: [ 
					self enableButton.
					(input,stringKey) isAllSeparators ifTrue: [ self disableButton ]				
				]
			].! !

PanelMorph subclass: #ModelPanelMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ModelPanelMorph commentStamp: '<historical>' prior: 0!
A PanelMorph, with a model!

!ModelPanelMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 5/25/2015 21:13'!
adoptPaneColor: paneColor
	"I am asked to change my color in order to adapt to the given general color.
	 I decide to do nothing"! !

!ModelPanelMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 3/14/2014 03:18'!
model
	^ model! !

!ModelPanelMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 3/14/2014 03:18'!
model: anObject
	model := anObject! !

!DialogWindow class methodsFor: '*LaBook' stamp: 'CarlosLombardi 2/13/2015 18:34'!
initialize
	"tasks to be accomplished when installing this class in an image"

	| classesHavingNonDesiredInstVarName |
	classesHavingNonDesiredInstVarName :=
		(DialogWindow allSuperclasses , DialogWindow withAllSubclasses)
		select: [:cl | cl hasInstVarNamed: 'acceptOnCR'].
	
	classesHavingNonDesiredInstVarName 
	ifEmpty: [ 
		self addInstVarNamed: 'acceptOnCR'.
		self withAllSubclassesDo: 
			[ :cl | cl allInstancesDo: [ :window | window instVarNamed: 'acceptOnCR' put: true ] ]
	]
	ifNotEmpty: [  
		UITheme builder 
			abort: ('se detecta la variable de instancia acceptOnCR \',
			'en estas clases en la jerarquia de DialogWindow \',
			(classesHavingNonDesiredInstVarName collect: [:cl | cl name asString]) asArray asString)
			 withCRs 
			title: 'Problema al cargar cambios en DialogWindow'.
	].! !

!DialogWindow methodsFor: '*LaBook' stamp: 'CarlosLombardi 2/13/2015 18:42'!
acceptOnCR
	^ acceptOnCR! !

!DialogWindow methodsFor: '*LaBook' stamp: 'CarlosLombardi 2/13/2015 18:42'!
acceptOnCR: anObject
	acceptOnCR := anObject! !

!DialogWindow methodsFor: '*LaBook' stamp: 'CarlosLombardi 2/13/2015 18:43'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		cancelled: true;
		acceptOnCR: true;
		addInitialPanel! !

!DialogWindow methodsFor: '*LaBook' stamp: 'CarlosLombardi 2/14/2015 14:56'!
keyStroke: evt
	"Check for return and escape keys."

	super keyStroke: evt.
	(self defaultButton notNil and: [evt keyCharacter = Character cr and: [self acceptOnCR]]) ifTrue: [self returnPressed. ^true].
	evt keyCharacter = Character escape ifTrue: [self escapePressed. ^true].
	^false! !

Object subclass: #ActiveFile
	uses: TBasicBusinessObject
	instanceVariableNames: 'reference externalCommand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Log'!

!ActiveFile commentStamp: 'CarlosLombardi 2/17/2015 19:38' prior: 0!
An ActiveFile is a file reference which can be the subject of an action, modeled by an external command.
I know how to create a Morph able to edit myself.!

ActiveFile class
	uses: TBasicBusinessObject classTrait
	instanceVariableNames: ''!

!ActiveFile methodsFor: 'accessing' stamp: 'CarlosLombardi 2/17/2015 19:42'!
exists
	"the full filename corresponding to this reference"
	^reference ifNil: [ false ] ifNotNil: [ :ref | ref exists ]
! !

!ActiveFile methodsFor: 'accessing' stamp: 'CarlosLombardi 2/17/2015 19:39'!
externalCommand
	^ externalCommand! !

!ActiveFile methodsFor: 'accessing' stamp: 'CarlosLombardi 2/17/2015 19:39'!
externalCommand: anObject
	externalCommand := anObject! !

!ActiveFile methodsFor: 'accessing' stamp: 'CarlosLombardi 2/17/2015 19:41'!
fullName
	"the full filename corresponding to this reference"
	^reference ifNil: [ '' ] ifNotNil: [ :ref | ref fullName ]
! !

!ActiveFile methodsFor: 'accessing' stamp: 'CarlosLombardi 2/18/2015 01:05'!
fullName: aString
	"associate myself to the file having the given full name"

	self reference: 
		( aString isEmpty ifTrue: [ nil ]
		  ifFalse: [ 
				(FileReference 
					fileSystem: FileSystem disk 
					path: (FileSystem disk resolveString: aString))
		  ] )
! !

!ActiveFile methodsFor: 'accessing' stamp: 'CarlosLombardi 2/17/2015 19:44'!
hasAvailableAction
	"whether I can act on the file I point to"
	^(reference isNil | externalCommand isNil)
		ifTrue: [ false ]
		ifFalse: [ externalCommand acceptsFile: reference ]
! !

!ActiveFile methodsFor: 'actions' stamp: 'CarlosLombardi 2/17/2015 19:46'!
performAction
	"perform the external action I can do on the file I point to"

	externalCommand actOnFile: reference! !

!ActiveFile methodsFor: 'accessing' stamp: 'CarlosLombardi 2/17/2015 19:39'!
reference
	^ reference! !

!ActiveFile methodsFor: 'accessing' stamp: 'CarlosLombardi 2/17/2015 20:00'!
reference: anObject
	reference := anObject.
	self changed: #fileReference.! !

Object subclass: #AlternateBackgroundColorRowDecorator
	uses: TRowDecorator
	instanceVariableNames: 'oddColor evenColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Addons'!

!AlternateBackgroundColorRowDecorator commentStamp: 'CarlosLombardi 5/24/2015 21:29' prior: 0!
A row decorator assigning different background color to odd and even rows.!

AlternateBackgroundColorRowDecorator class
	uses: TRowDecorator classTrait
	instanceVariableNames: ''!

!AlternateBackgroundColorRowDecorator class methodsFor: 'instance creation' stamp: 'CarlosLombardi 5/24/2015 22:08'!
oddColor: colorO evenColor: colorE
	"Creates a new row decorator for the given colors. 
	 Setting colorO as nil implies that the odd rows will not be decorated, similarly for colorE"

	^self new
		oddColor: colorO ; evenColor: colorE ; yourself .! !

!AlternateBackgroundColorRowDecorator methodsFor: 'private' stamp: 'CarlosLombardi 5/24/2015 22:06'!
assignColor: aColor toRow: aRowMorph 
	"assign aColor as background color for aRowMorph. Modifies and returns aRowMorph"

	aColor ifNotNil: [ aRowMorph color: aColor ] .
	^aRowMorph ! !

!AlternateBackgroundColorRowDecorator methodsFor: 'decorating' stamp: 'CarlosLombardi 5/24/2015 22:22'!
decoratedRowFor: aRowMorph inOrder: aNumber
	"returns the decorated row corresponding to the given parameters."

	^self 
		assignColor: (aNumber even ifTrue: [evenColor] ifFalse: [oddColor]  )
		toRow: aRowMorph ! !

!AlternateBackgroundColorRowDecorator methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 22:20'!
evenColor
	^ evenColor! !

!AlternateBackgroundColorRowDecorator methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 22:20'!
evenColor: anObject
	evenColor := anObject! !

!AlternateBackgroundColorRowDecorator methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 22:20'!
oddColor
	^ oddColor! !

!AlternateBackgroundColorRowDecorator methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 22:20'!
oddColor: anObject
	oddColor := anObject! !

Object subclass: #BOEditorCodeSnippets
	instanceVariableNames: 'lab currentEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-CodeSnippets'!

!BOEditorCodeSnippets commentStamp: 'CarlosLombardi 2/12/2015 01:46' prior: 0!
Some code snippets to test the edition of business objects of the LaBook.!

!BOEditorCodeSnippets class methodsFor: 'instance creation' stamp: 'CarlosLombardi 2/12/2015 01:55'!
for: aLab
	"a new snippet bunch acting on the given lab"

	^self new lab: aLab ; yourself ! !

!BOEditorCodeSnippets methodsFor: 'accessing' stamp: 'CarlosLombardi 2/12/2015 01:53'!
currentEditor
	"the last launched editor"
	^ currentEditor ! !

!BOEditorCodeSnippets methodsFor: 'stock elements' stamp: 'CarlosLombardi 2/12/2015 02:06'!
editReagent: aReagent
	"edit the given reagent"

	currentEditor := ReagentEditor for: aReagent inLab: self lab.
	currentEditor edit.  
	
! !

!BOEditorCodeSnippets methodsFor: 'stock elements' stamp: 'CarlosLombardi 2/12/2015 02:14'!
editReagentListDetailedCode
	"some detailed code related to the list edition of the set of reagents"

	| listEditor window thisLab |
	thisLab := Lab exampleLab.
	listEditor := ReagentListEditor for: thisLab.
	window := listEditor buildWindow.
	window openAsIs.
	listEditor selectedIndex: 3.
	listEditor selectedObject: (thisLab reagentNamed: 'Aperol').
	window width.
	window submorphs last width.
	
! !

!BOEditorCodeSnippets methodsFor: 'stock units' stamp: 'CarlosLombardi 2/12/2015 01:53'!
editStockUnitNamed: aName
	"edit the stock unit having the given name"

	currentEditor := StockUnitEditor for: (self lab stockUnitNamed: aName).
	currentEditor edit.
! !

!BOEditorCodeSnippets methodsFor: 'events' stamp: 'CarlosLombardi 2/12/2015 02:18'!
eventDetailDetailedEdit
	"detailed code pertaining to the edition of a StockEventDetail"

	| editModel editView |
	editModel :=StockEventDetailEditController forNewDetailInLab: self lab.
	editModel provider: (self lab providerNamed: 'SIGMA').
	editView := StockEventDetailEditor for: editModel.

	editModel :=StockEventDetailEditController forNewDetailInLab: self lab.
	editModel providerIsRelevant: false ; unitPriceIsEditable: false.
	editView := StockEventDetailEditor for: editModel.

	editView buildWindow.
	editView open.
	editView model unitPrice.

	editModel provider: (self lab providerNamed: 'Coto').

	editModel totalAmount.

	editView unitPriceField acceptOnFocusChange.
	editView totalAmountField font height.
! !

!BOEditorCodeSnippets methodsFor: 'events' stamp: 'CarlosLombardi 2/12/2015 02:25'!
eventDetailedBrowse
	"detailed code pertaining to the graphical browsing of StockEvents"

	| buyingReq buyingReq2 buyingEvent proposal |
	buyingReq := 
		self lab events detect: [ :event | 
			event isABuyingRequirement &
			event date = (Date newDay: 25 month: 10 year: 2014) ].
	buyingReq2 := 
		self lab events detect: [ :event | 
			event isABuyingRequirement &
			event date = (Date newDay: 15 month: 2 year: 2014) ].
	buyingEvent := 
		self lab events detect: [ :event | 
			event isABuying &
			event date = (Date newDay: 12 month: 9 year: 2013) ].

	buyingEvent := 
	self lab events detect: [ :event | 
			event isABuying and: [ event extraAmount > 0 ] ].
	
	(BuyingRequirementPendingView for: buyingReq pendingState) open.

	(BuyingEventDetailView for: nil) open.

	(BuyingRequirementProposalsView for: buyingReq) open.

	(BuyingRequirementStateView for: buyingReq) open.

	(BuyingRequirementListView for: self lab) open.

	proposal := buyingReq buyingProposalForProvider: 
		(self lab providerNamed: 'SIGMA').
	(BuyingProposalDetailView for: proposal) open.

	(buyingReq pendingState details detect: [:det | det originalQuantity = 30])
	originalDetail unitPrice.


! !

!BOEditorCodeSnippets methodsFor: 'events' stamp: 'CarlosLombardi 2/12/2015 02:21'!
eventDetailedEdit
	"detailed code pertaining to the edition of a StockEvent"

	| beEditController beUiRenderer |
	beEditController := StockEventEditController forNewEventOfClass: BuyingRequirement.
	beEditController lab: self lab.
	beUiRenderer := BuyingRequirementEditor for: beEditController.

	beEditController := BuyingEventController forNewEvent.
	beEditController 
		lab: self lab ; 
		provider: (self lab providerNamed: 'SIGMA').
	beUiRenderer := BuyingEventEditor for: beEditController.
	beUiRenderer window position: 200@100.

	beUiRenderer open.
	beUiRenderer morphList first submorphs last submorphs first.
	beUiRenderer morphList first submorphs last textChanged.

	self lab events explore. 



	beUiRenderer morphList first submorphs first model.

	self lab dependents.

	beUiRenderer morphList first model.

	beUiRenderer class allInstances first.
	
	beUiRenderer providerField dependents.

	beUiRenderer totalAmountField textChanged.
	beUiRenderer totalAmountField text.

	beUiRenderer model.

	beUiRenderer model totalAmount model.

	(beUiRenderer window submorphNamed: #date) converter objectAsString: Date today.

	beEditController date.

! !

!BOEditorCodeSnippets methodsFor: 'accessing' stamp: 'CarlosLombardi 2/12/2015 01:47'!
lab
	^ lab! !

!BOEditorCodeSnippets methodsFor: 'accessing' stamp: 'CarlosLombardi 2/12/2015 01:47'!
lab: anObject
	lab := anObject! !

!BOEditorCodeSnippets methodsFor: 'stock units' stamp: 'CarlosLombardi 2/12/2015 02:04'!
reconnectUnitStockUnitInReagents
	"set, to all the reagents in my lab having any unit stock unit, the default unit stock unit"

	self lab reagents do: [ :reag | 
		(reag stockUnit name = 'unid.') ifTrue: [ 
			reag stockUnit: LabApplication unitStockUnit  
		]
	].
! !

!BOEditorCodeSnippets methodsFor: 'stock units' stamp: 'CarlosLombardi 2/12/2015 01:58'!
someReagentHavingStockUnitNamed: aName
	"a reagent, registered in my lab, whose stock unit has the given name. Nil if no such reagent found"

	^self lab reagents 
		detect: [ :reagent | 
			reagent stockUnit = (self lab stockUnitNamed: aName) ]
		ifNone: [ nil ].
! !

!BOEditorCodeSnippets methodsFor: 'stock units' stamp: 'CarlosLombardi 2/12/2015 02:01'!
stockUnitCopies
	"a new collection including a copy of each stock unit registered in my lab"

	^self lab stockUnits collect: [:strUnit | 
		StockUnit new name: strUnit ; yourself
	].! !

Object subclass: #BlockChain
	instanceVariableNames: 'blocks defaultValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Basics'!

!BlockChain commentStamp: '<historical>' prior: 0!
I am a chain of blocks.
My value is the value given by my first component which yields an useful value, i.e., a value different than my nilValue. If no component yields an useful value, then I return the defaultValue set to me.

Note the difference between nilValue and defaultValue. 
Currently, the former is fixed to nil.!

!BlockChain methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/17/2014 01:32'!
addBlock: aBlock
	"adds a new block at the end of this chain"

	blocks addLast: aBlock! !

!BlockChain methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/19/2014 02:59'!
blocks
	"the ordered collection of the blocks participating of this BlockChain"

	^blocks! !

!BlockChain methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/19/2014 02:55'!
defaultValue
	^ defaultValue! !

!BlockChain methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/19/2014 02:55'!
defaultValue: anObject
	defaultValue := anObject! !

!BlockChain methodsFor: 'initialize-release' stamp: 'CarlosLombardi 10/19/2014 10:42'!
initialize
	"I prepare myself for life"

	blocks := OrderedCollection new.
! !

!BlockChain methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/19/2014 10:43'!
nilValue
	"the value considered as nil when computing my value"

	^nil! !

!BlockChain methodsFor: 'value' stamp: 'CarlosLombardi 10/19/2014 10:43'!
value
	"my value, assuming that my blocks are nullary"

	| result stream |
	result := self nilValue.
	stream := self blocks readStream.
	[ stream atEnd not & (result = self nilValue) ] whileTrue: 
		[  result := stream next value ].
	(result = self nilValue) ifTrue: [ result := self defaultValue ].
	^result
	! !

Object subclass: #BuyingReferenceEditController
	instanceVariableNames: 'authority referenceId reagentEditController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

!BuyingReferenceEditController commentStamp: '<historical>' prior: 0!
A simple controller for the edition of a reference for a Reagent!

!BuyingReferenceEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 13:13'!
authoritiesToChoose
	"a list of authorities which can be chosen to explicitly assign a reference"

	| theLab |
	theLab := self reagentEditController lab.
	^theLab referenceAuthorities copyWithout: theLab casAuthority! !

!BuyingReferenceEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2014 23:37'!
authority
	^ authority! !

!BuyingReferenceEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2014 23:37'!
authority: anObject
	authority := anObject! !

!BuyingReferenceEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 12:15'!
lab
	"the reference Lab"

	^self reagentEditController lab! !

!BuyingReferenceEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2014 00:51'!
reagentEditController
	^ reagentEditController! !

!BuyingReferenceEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2014 00:51'!
reagentEditController: anObject
	reagentEditController := anObject! !

!BuyingReferenceEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2014 23:37'!
referenceId
	^ referenceId! !

!BuyingReferenceEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2014 23:37'!
referenceId: anObject
	referenceId := anObject! !

Object subclass: #BuyingReferenceSetEditController
	instanceVariableNames: 'element lab referenceEditControllers casNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

!BuyingReferenceSetEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 12:27'!
authorities
	"the explicitly selected references authorities. CAS not included"
	
	^referenceEditControllers collect: [ :controller | controller authority ]! !

!BuyingReferenceSetEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/1/2014 12:13'!
casNumber
	"the CAS number of the element"

	^casNumber
	! !

!BuyingReferenceSetEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/1/2014 12:13'!
casNumber: aString
	"the CAS number of the element"

	casNumber := aString
	! !

!BuyingReferenceSetEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/1/2014 22:29'!
element
	^ element! !

!BuyingReferenceSetEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/1/2014 22:33'!
element: anObject
	element := anObject.
	self initializeIndividualControllers.! !

!BuyingReferenceSetEditController methodsFor: 'private' stamp: 'CarlosLombardi 10/4/2014 12:21'!
initializeIndividualControllers
	"private - initialize the individual ReferenceEditControllers"

	| newReferenceEditController authorities references |
	"I need to know both my element and my lab to initialize individual controllers"
	(self element isNil | self lab isNil) ifTrue: [ ^true ].
	
	authorities := ( (self element authoritiesWithoutCas asSortedCollection: [ :a1 :a2 | a1 name <= a2 name ]) asArray 
					, #(nil nil nil) ) copyFrom: 1 to: 3.
	references := authorities
		collect: [ :auth | 
			auth isNil
				ifTrue: [ '' ]
				ifFalse: [ self element referenceIdForAuthority: auth ] ].
	casNumber := (self element referenceIdForAuthority: lab casAuthority) ifNil: ''.
	referenceEditControllers := OrderedCollection new.
	authorities with: references do: [ :auth :ref | 
		newReferenceEditController := BuyingReferenceEditController new.
		newReferenceEditController 
			authority: auth ; 
			referenceId: ref ; 
			reagentEditController: self.
		referenceEditControllers addLast: newReferenceEditController.
	]! !

!BuyingReferenceSetEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/1/2014 22:29'!
lab
	^ lab! !

!BuyingReferenceSetEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/1/2014 22:33'!
lab: anObject
	lab := anObject.
	self initializeIndividualControllers.! !

!BuyingReferenceSetEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/1/2014 12:14'!
referenceEditControllers
	^ referenceEditControllers! !

!BuyingReferenceSetEditController methodsFor: 'updating' stamp: 'CarlosLombardi 10/4/2014 13:34'!
updateModel
	"update reagent, and eventually also lab"

	"CAS number"
	self element referenceId: self casNumber forAuthority: lab casAuthority.
	
	"other references"
	"remove those not having reference anymore"
	self element authoritiesWithoutCas do: [ :auth | 
		(self authorities includes: auth) ifFalse: [self element referenceId: nil forAuthority: auth ]
	].
	"set values for the edited authorities"
	referenceEditControllers do: [ :controller |
		controller authority ifNotNil: [ :auth1 | self element referenceId: controller referenceId forAuthority: auth1 ] .
	].
	"add authorities to the lab -- we assume all created authorities to be providers"
	(self authorities select: #notNil) do: [ :auth | lab addToReferenceAuthorities: auth ].
	
	! !

Object subclass: #BuyingRequirementDescriptor
	instanceVariableNames: 'sortedDetails onlyPendingDetails model contentBlocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Queries'!

!BuyingRequirementDescriptor commentStamp: '<historical>' prior: 0!
I know how to describe a buyingRequirement, currently as a String.!

!BuyingRequirementDescriptor class methodsFor: 'instance creation' stamp: 'CLom 12/17/2014 11:15'!
for: aRequirement
	"a new instance whose model is aRequirement"

	^self new
		model: aRequirement ;
		yourself! !

!BuyingRequirementDescriptor methodsFor: 'description' stamp: 'CarlosLombardi 5/22/2015 12:09'!
addDate
	"add the date when building descriptions"

	contentBlocks addLast: 
		[:descriptor | LabApplication current converters dateConverter objectAsString: descriptor model date].! !

!BuyingRequirementDescriptor methodsFor: 'description' stamp: 'CLom 12/17/2014 12:17'!
addRelevantDetails: n
	"add the n most relevant details when building descriptions"

	| details result explicitDetailsSize |
	contentBlocks addLast: [ :descriptor | 
		details := descriptor sortedDetails.
		explicitDetailsSize := n min: details size.
		result := ( (details copyFrom: 1 to: explicitDetailsSize ) collect: [ :det |  
			det quantity asString, ' ', det element name
	 	 		, ' (de ', det originalDetail quantity asString, ')' 
		] ) mkString: ' , '.
		(details size > explicitDetailsSize) ifTrue: [ 
			result := result, ' , ',  (details size - explicitDetailsSize) asString, ' más' 
		].
		result
	]. ! !

!BuyingRequirementDescriptor methodsFor: 'description' stamp: 'CLom 12/17/2014 12:02'!
addTotalQuantity
	"add the total quantity when building descriptions"

	^contentBlocks addLast: 
		[:descriptor | 'cantidad total ', descriptor model totalQuantity asString].! !

!BuyingRequirementDescriptor methodsFor: 'private' stamp: 'CLom 12/17/2014 11:15'!
computeSortedDetails
	"Private - compute and answer the list of details to include in the description"

	| sortBlock details |
	sortBlock := [ :det1 :det2 | det1 totalAmount >= det2 totalAmount ].
	details := (self model details asSortedCollection: sortBlock) asArray.
	onlyPendingDetails ifFalse: [ 
		details := details, (self model fulfilledDetails asSortedCollection: sortBlock) asArray.
	].
	^details
! !

!BuyingRequirementDescriptor methodsFor: 'accessing' stamp: 'CLom 12/17/2014 11:05'!
forAllDetails
	"set myself to include all the details in the description. See >>forOnlyPendingDetails"

	onlyPendingDetails := false! !

!BuyingRequirementDescriptor methodsFor: 'accessing' stamp: 'CLom 12/17/2014 11:05'!
forOnlyPendingDetails
	"set myself to include only the pending details in the description"

	onlyPendingDetails := true! !

!BuyingRequirementDescriptor methodsFor: 'initialize-release' stamp: 'CLom 12/17/2014 11:22'!
initialize
	"preparation for life"

	super initialize.
	onlyPendingDetails := false.
	contentBlocks := OrderedCollection new.! !

!BuyingRequirementDescriptor methodsFor: 'accessing' stamp: 'CLom 12/17/2014 11:13'!
model
	^ model! !

!BuyingRequirementDescriptor methodsFor: 'accessing' stamp: 'CLom 12/17/2014 11:13'!
model: anEvent
	model := anEvent isAPendingState 
		ifTrue: [ anEvent ] 
		ifFalse: [ anEvent pendingState ].! !

!BuyingRequirementDescriptor methodsFor: 'accessing' stamp: 'CLom 12/17/2014 11:06'!
sortedDetails
	"the details, sorted as needed to build the description"

	sortedDetails ifNil: [ sortedDetails := self computeSortedDetails. ].
	^sortedDetails ! !

!BuyingRequirementDescriptor methodsFor: 'description' stamp: 'CLom 12/17/2014 12:14'!
stringDescription
	"the description of my model as a String, given the contents which I was asked to include"

	^(contentBlocks collect: [ :block | block value: self ]) mkString: '  --  '.
! !

Object subclass: #BuyingRequirementSatisfactionDetail
	uses: TEventDetailComputations
	instanceVariableNames: 'buyingDetail event quantity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

BuyingRequirementSatisfactionDetail class
	uses: TEventDetailComputations classTrait
	instanceVariableNames: ''!

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 15:27'!
buyingDetail
	^ buyingDetail! !

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 15:27'!
buyingDetail: anObject
	buyingDetail := anObject! !

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 15:27'!
element
	"my stock element "
	^self buyingDetail element! !

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 15:26'!
event
	^ event! !

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 15:26'!
event: anObject
	event := anObject! !

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 15:26'!
quantity
	^ quantity! !

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 15:26'!
quantity: anObject
	quantity := anObject! !

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 12/22/2014 02:35'!
stockVariation
	"for polymorphism with StockEventDetail"
	^ 0! !

!BuyingRequirementSatisfactionDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 15:28'!
unitPrice
	"the unit price for the event which satisfies the requirement"
	^self buyingDetail unitPrice! !

Object subclass: #Consumable
	uses: TBasicBusinessObject + TWithReferences
	instanceVariableNames: 'name references'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!Consumable commentStamp: '<historical>' prior: 0!
A Consumable used in laboratories!

Consumable class
	uses: TBasicBusinessObject classTrait + TWithReferences classTrait
	instanceVariableNames: ''!

!Consumable methodsFor: 'references' stamp: 'CarlosLombardi 5/2/2014 10:32'!
authoritiesWithoutCas
	"the authorities for which a reference ID for me exists, not considering CAS.
	 For me is exactly my set of authorities, since consumables do not have a CAS number"

	^self authorities! !

!Consumable methodsFor: 'initialize-release' stamp: 'CarlosLombardi 4/27/2014 19:39'!
initialize
	"I get ready for life"

	references := Dictionary new.
	^self! !

!Consumable methodsFor: 'accessing' stamp: 'CarlosLombardi 4/27/2014 19:39'!
name
	"a name which identifies me"
	^ name
! !

!Consumable methodsFor: 'accessing' stamp: 'CarlosLombardi 4/27/2014 19:39'!
name: anObject
	name := anObject! !

!Consumable methodsFor: 'references' stamp: 'CarlosLombardi 4/27/2014 19:37'!
privateReferences
	"private - a Dictionary authority/referenceID for my references.
	 For use in traits "
	
	^references ! !

!Consumable methodsFor: 'accessing' stamp: 'CarlosLombardi 4/27/2014 19:40'!
stockUnit
	"the stock unit corresponding for a consumable - it is always 'units' "
	^LabApplication unitStockUnit 
! !

Object subclass: #ConsumableEditController
	uses: TBasicBusinessObjectIsElement + TDelegateNameEditionInBasicBusinessObject
	instanceVariableNames: 'consumable lab referenceSetEditController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

ConsumableEditController class
	uses: TBasicBusinessObjectIsElement classTrait + TDelegateNameEditionInBasicBusinessObject classTrait
	instanceVariableNames: ''!

!ConsumableEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/2/2014 09:49'!
consumable
	^ consumable! !

!ConsumableEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/2/2014 09:50'!
consumable: anObject lab: aLab
	consumable := anObject.
	lab := aLab.
	self setReferenceData.! !

!ConsumableEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/2/2014 09:51'!
element
	^ self consumable! !

!ConsumableEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/2/2014 09:49'!
lab
	^ lab! !

!ConsumableEditController methodsFor: 'references' stamp: 'CarlosLombardi 5/2/2014 10:33'!
referenceEditControllers
	^ referenceSetEditController referenceEditControllers! !

!ConsumableEditController methodsFor: 'references' stamp: 'CarlosLombardi 5/2/2014 09:49'!
referenceSetEditController
	^ referenceSetEditController! !

!ConsumableEditController methodsFor: 'private' stamp: 'CarlosLombardi 5/2/2014 09:51'!
setReferenceData
	"..."

	referenceSetEditController := BuyingReferenceSetEditController new.
	referenceSetEditController
		element: self element ; 
		lab: self lab .
! !

!ConsumableEditController methodsFor: 'actions' stamp: 'CarlosLombardi 5/2/2014 09:59'!
updateModel
	"update reagent, and eventually also lab"

	"name is automatically updated, cfr method name: in this class."
	
	"references delegated to referenceSetEditController"
	referenceSetEditController updateModel.
	
! !

Object subclass: #EventDetailCopier
	instanceVariableNames: 'source targetEvent newDetailClass copyPrice linkToOriginalDetail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Queries'!

!EventDetailCopier commentStamp: '<historical>' prior: 0!
I know how to add a new detail into a given StockEvent (my targetEvent), which is a copy of an existing detail (my source).
A user can configure me indicating 
- newDetailClass, i.e. the class of which the detail I create is an instance. Defaults to StockEventDetail
- copyPrice, i.e., whether price must be copied from source to the new detail. Defaults to yes.

Once I am configured, you just tell me to proceed.!

!EventDetailCopier methodsFor: 'accessing - signals' stamp: 'CarlosLombardi 11/16/2014 00:30'!
copyPrice
	^ copyPrice! !

!EventDetailCopier methodsFor: 'accessing - signals' stamp: 'CLom 12/6/2014 16:19'!
forLinkToOriginalDetail
	linkToOriginalDetail  := true! !

!EventDetailCopier methodsFor: 'accessing - signals' stamp: 'CLom 12/6/2014 16:20'!
forNotLinkToOriginalDetail
	linkToOriginalDetail  := false! !

!EventDetailCopier methodsFor: 'accessing - signals' stamp: 'CarlosLombardi 11/16/2014 00:30'!
forWithPrice
	copyPrice := true! !

!EventDetailCopier methodsFor: 'accessing - signals' stamp: 'CarlosLombardi 11/16/2014 00:30'!
forWithoutPrice
	copyPrice := false! !

!EventDetailCopier methodsFor: 'initialize-release' stamp: 'CLom 12/6/2014 16:20'!
initialize
	"I prepare myself for life"

	self forWithPrice ; forNotLinkToOriginalDetail ;
		newDetailClass: StockEventDetail.! !

!EventDetailCopier methodsFor: 'accessing - signals' stamp: 'CLom 12/6/2014 16:21'!
linkToOriginalDetail
	^ linkToOriginalDetail ! !

!EventDetailCopier methodsFor: 'accessing' stamp: 'CarlosLombardi 11/16/2014 00:30'!
newDetailClass
	^ newDetailClass! !

!EventDetailCopier methodsFor: 'accessing' stamp: 'CarlosLombardi 11/16/2014 00:30'!
newDetailClass: anObject
	newDetailClass := anObject! !

!EventDetailCopier methodsFor: 'actions' stamp: 'CLom 12/6/2014 16:22'!
proceed
	"produce a new detail and add it to the targetEvent"

	| newDetail |
	newDetail := self newDetailClass new.
	newDetail 
		event: self targetEvent ;
		element: self source element ;
		quantity: self source quantity.
	self copyPrice ifTrue: [ newDetail unitPrice: self source unitPrice ].	
	self linkToOriginalDetail ifTrue: [ newDetail originalDetail: self source ].
	self targetEvent addToDetails: newDetail.
	^newDetail ! !

!EventDetailCopier methodsFor: 'accessing' stamp: 'CarlosLombardi 11/16/2014 00:30'!
source
	^ source! !

!EventDetailCopier methodsFor: 'accessing' stamp: 'CarlosLombardi 11/16/2014 00:30'!
source: anObject
	source := anObject! !

!EventDetailCopier methodsFor: 'accessing' stamp: 'CarlosLombardi 11/16/2014 00:30'!
targetEvent
	^ targetEvent! !

!EventDetailCopier methodsFor: 'accessing' stamp: 'CarlosLombardi 11/16/2014 00:30'!
targetEvent: anObject
	targetEvent := anObject! !

Object subclass: #EventQuery
	instanceVariableNames: 'lab provider stockElement onlyBuyingEvents eventsSortBlock explicitConditions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Queries'!

!EventQuery commentStamp: '<historical>' prior: 0!
An object which knows how to extract events or event details given a series of restrictions!

!EventQuery methodsFor: 'conditions - internal' stamp: 'CarlosLombardi 10/19/2014 04:27'!
addEventTypeConditionTo: eventConditionList
	"add the corresponding condition about the event type to the given list of conditions"
	self onlyBuyingEvents ifTrue: [ eventConditionList addLast: [ :event | event isABuying ] ].! !

!EventQuery methodsFor: 'conditions - internal' stamp: 'CarlosLombardi 10/19/2014 04:24'!
addProviderConditionTo: eventConditionList
	"add the corresponding condition about providers to the given list of conditions"
	self provider ifNotNil: [ :prov | eventConditionList addLast: [ :event | event provider = prov ] ]! !

!EventQuery methodsFor: 'conditions - internal' stamp: 'CarlosLombardi 10/19/2014 04:25'!
addStockElementEventConditionTo: eventConditionList
	"add the corresponding condition about the stock element/s involved to the given list of conditions"
	self stockElement ifNotNil: [ :elem | eventConditionList addLast: [ :event | event involvesElement: elem ] ]! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:12'!
addToExplicitConditions: anUnaryBlock
	"anUnaryBlock is added as a condition for this query"
	explicitConditions addLast: anUnaryBlock ! !

!EventQuery methodsFor: 'details' stamp: 'CarlosLombardi 10/19/2014 04:42'!
details
	"the details that must be taken into account by this query"

	^self events
		inject: OrderedCollection new
		into: [ :details :event | details addAll: (self detailsForEvent: event) ; yourself ]
		! !

!EventQuery methodsFor: 'details' stamp: 'CarlosLombardi 10/19/2014 04:41'!
detailsForEvent: aStockEvent
	"the details in aStockEvent that must be taken into account by this query"

	^self stockElement 
		ifNil: [ aStockEvent details ]
		ifNotNil: [ :elem | aStockEvent detailsForElement: elem ]
		! !

!EventQuery methodsFor: 'conditions - internal' stamp: 'CLom 11/22/2014 21:14'!
eventConditions
	"the conditions to be checked on events"
	| conds |
	conds := OrderedCollection new.
	self addEventTypeConditionTo: conds ;
		addStockElementEventConditionTo: conds ; 
		addProviderConditionTo: conds.
	conds addAll: self explicitConditions.
	^conds! !

!EventQuery methodsFor: 'events' stamp: 'CarlosLombardi 10/19/2014 04:44'!
events
	"the events satisfying the conditions in this query, eventually sorted by the given sort criteria"
	| matchingEvents |
	matchingEvents := self lab
		ifNotNil: [ :theLab | self eventsInLab: theLab ]
		ifNil: [ LabApplication current labs 
				inject: Set new
				into: [ :events :theLab | events addAll: (self eventsInLab: theLab) ; yourself  ]
			].
	^self mustSortEvents 
		ifTrue: [ matchingEvents asSortedCollection: self eventsSortBlock ]
		ifFalse: [ matchingEvents ]! !

!EventQuery methodsFor: 'events' stamp: 'CarlosLombardi 10/19/2014 11:01'!
eventsInLab: aLab
	"private -- the events to consider in the given Lab"

	^aLab events select: [ :event | 
		self eventConditions allSatisfy: [ :cond | cond value: event ] ]! !

!EventQuery methodsFor: 'sort criteria' stamp: 'CarlosLombardi 10/19/2014 04:09'!
eventsSortBlock
	^ eventsSortBlock! !

!EventQuery methodsFor: 'sort criteria' stamp: 'CarlosLombardi 10/19/2014 04:09'!
eventsSortBlock: anObject
	eventsSortBlock := anObject! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:21'!
explicitConditions
	"the conditions explicitly set as unary blocks"
	^ explicitConditions! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 10:14'!
forOnlyBuyingEvents
	"restricts the query to buying events"
	onlyBuyingEvents := true! !

!EventQuery methodsFor: 'sort criteria' stamp: 'CarlosLombardi 10/19/2014 04:13'!
forSortEventsByDate
	"set date as sort criteria for events in this query"
	eventsSortBlock := [ :e1 :e2 | e1 date < e2 date ]! !

!EventQuery methodsFor: 'sort criteria' stamp: 'CLom 12/17/2014 02:45'!
forSortEventsByReversedDate
	"set date as sort criteria for events in this query, putting the most recent at the top"
	eventsSortBlock := [ :e1 :e2 | e1 date > e2 date ]! !

!EventQuery methodsFor: 'initialize-release' stamp: 'CarlosLombardi 10/19/2014 04:50'!
initialize
	"I prepare myself for life"

	super initialize.
	explicitConditions := OrderedCollection new.
	onlyBuyingEvents := false.! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:09'!
lab
	^ lab! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:09'!
lab: anObject
	lab := anObject! !

!EventQuery methodsFor: 'sort criteria' stamp: 'CarlosLombardi 10/19/2014 04:14'!
mustSortEvents
	"true iff some sort criteria for events must be considered"
	^eventsSortBlock isNil not! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:09'!
onlyBuyingEvents
	^ onlyBuyingEvents! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:09'!
provider
	^ provider! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:09'!
provider: anObject
	provider := anObject! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:09'!
stockElement
	^ stockElement! !

!EventQuery methodsFor: 'conditions - basic accessing' stamp: 'CarlosLombardi 10/19/2014 04:09'!
stockElement: anObject
	stockElement := anObject! !

Object subclass: #ExternalCommand
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-ExternalCommands'!

!ExternalCommand commentStamp: 'CarlosLombardi 2/15/2015 21:11' prior: 0!
An external command which can act on a file.
This is an abstract class.!

ExternalCommand subclass: #CompositeExternalCommand
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-ExternalCommands'!

!CompositeExternalCommand commentStamp: 'CarlosLombardi 2/15/2015 21:21' prior: 0!
An ExternalCommand which delegates to a number of other commands.!

!CompositeExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 21:23'!
acceptsFile: aFileReference
	"true iff I can act on the file being modeled by aFileReference"

	^(self feasibleCommandsFor: aFileReference) notEmpty ! !

!CompositeExternalCommand methodsFor: 'accessing' stamp: 'CarlosLombardi 2/15/2015 21:20'!
addToCommands: anExternalCommand
	"adds a new command to my suite"

	commands addLast: anExternalCommand.
	^self! !

!CompositeExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 21:33'!
doActOnFile: aFileReference
	"execute the action described in my command script"

	(self feasibleCommandsFor: aFileReference) anyOne doActOnFile: aFileReference! !

!CompositeExternalCommand methodsFor: 'accessing' stamp: 'CarlosLombardi 2/15/2015 21:23'!
feasibleCommandsFor: aFileReference
	"the commands in my suite which can act on the given reference"

	^commands select: [ :comm | comm acceptsFile: aFileReference ]! !

!CompositeExternalCommand methodsFor: 'initialization-release' stamp: 'CarlosLombardi 2/15/2015 21:31'!
initialize
	"preparation for life"

	super initialize.
	commands := OrderedCollection new.! !

!ExternalCommand class methodsFor: 'as yet unclassified' stamp: 'CarlosLombardi 2/15/2015 21:12'!
fileReferenceFromFilename: aFilename
	"the file reference corresponding to the given filename, in the context of the current file system"

	^FileReference 
		fileSystem: FileSystem disk 
		path: (FileSystem disk resolveString: aFilename)! !

!ExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 21:13'!
acceptsFile: aFileReference
	"true iff I can act on the file being modeled by aFileReference"

	^self subclassResponsibility 
! !

!ExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 21:13'!
acceptsFileNamed: aFilename
	"true iff I can act on the file having the given name"

	^self acceptsFile: (self class fileReferenceFromFilename: aFilename)
! !

!ExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 21:29'!
actOnFile: aFileReference
	"execute the action described in my command script"

	(self checkFile: aFileReference) ifFalse: [ ^ self ].
	self doActOnFile: aFileReference! !

!ExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 21:13'!
actOnFileNamed: aFilename
	"execute the action described in my command script"

	self actOnFile: (self class fileReferenceFromFilename: aFilename)
! !

!ExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/16/2015 00:56'!
checkFile: aFileReference
	| result |
	result := self acceptsFile: aFileReference.
	result ifFalse: [ 
			UITheme builder
				abort: 'El archivo \' withCRs , aFileReference fullName, '\ no existe, o no puede ser procesado adecuadamente' withCRs 
				title: 'No se puede ejecutar el comando', (self name ifNil: [''] ifNotNil: [ :str | ' ', str ] ). ].
	^result! !

!ExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 21:28'!
doActOnFile: aFileReference
	"execute the action described in my command script"

	^self subclassResponsibility 
! !

!ExternalCommand methodsFor: 'accessing' stamp: 'CarlosLombardi 2/16/2015 00:52'!
name
	^ name! !

!ExternalCommand methodsFor: 'accessing' stamp: 'CarlosLombardi 2/16/2015 00:52'!
name: anObject
	name := anObject! !

ExternalCommand subclass: #SimpleOSProcessExternalCommand
	instanceVariableNames: 'acceptedExtensions commandString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-ExternalCommands'!

!SimpleOSProcessExternalCommand commentStamp: 'CarlosLombardi 2/15/2015 21:11' prior: 0!
An external command which can act on a file, whose implementation is based on the OSProcess package.!

!SimpleOSProcessExternalCommand methodsFor: 'accessing' stamp: 'CarlosLombardi 2/15/2015 19:44'!
acceptedExtensions
	^ acceptedExtensions! !

!SimpleOSProcessExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 19:43'!
acceptsFile: aFileReference
	"true iff I can act on the file modeled by the given reference"

	^aFileReference exists and: [ self acceptedExtensions includes: aFileReference extension ]! !

!SimpleOSProcessExternalCommand methodsFor: 'accessing' stamp: 'CarlosLombardi 2/15/2015 19:47'!
addToAcceptedExtensions: aString
	"set myself to accept files having the "
	acceptedExtensions addLast: aString! !

!SimpleOSProcessExternalCommand methodsFor: 'accessing' stamp: 'CarlosLombardi 2/15/2015 20:16'!
commandString
	^ commandString ifNil: [ '' ]! !

!SimpleOSProcessExternalCommand methodsFor: 'accessing' stamp: 'CarlosLombardi 2/15/2015 20:17'!
commandString: anObject
	commandString := anObject! !

!SimpleOSProcessExternalCommand methodsFor: 'actions' stamp: 'CarlosLombardi 2/15/2015 21:27'!
doActOnFile: aFileReference
	OSProcess command: (self specializedScriptFor: aFileReference)! !

!SimpleOSProcessExternalCommand methodsFor: 'initialize - release' stamp: 'CarlosLombardi 2/15/2015 19:48'!
initialize
	"preparation for life"

	super initialize.
	acceptedExtensions := OrderedCollection new.! !

!SimpleOSProcessExternalCommand methodsFor: 'accessing' stamp: 'FernandoDiMeglio 10/20/2015 02:19'!
specializedScriptFor: aFileReference
	| replacementRanges specializedScript |
	specializedScript := self commandString.
	[ (replacementRanges := specializedScript allRangesOfSubString: '<1>') isEmpty ]
		whileFalse: [ 
			specializedScript := 
				(specializedScript first:	 replacementRanges first first - 1) , 
				aFileReference fullName , 
				(specializedScript allButFirst: replacementRanges first last) 
		].
	^ specializedScript! !

Object subclass: #Lab
	uses: TLabProvider
	instanceVariableNames: 'reagents consumables referenceAuthorities solutions projects events stockUnits'
	classVariableNames: 'CasAuthority'
	poolDictionaries: ''
	category: 'LaBook-Model'!

!Lab commentStamp: '<historical>' prior: 0!
A Lab where reagents are handled!

Lab class
	uses: TLabProvider classTrait
	instanceVariableNames: ''!

!Lab class methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 11:08'!
casAuthority
	"the reference authority corresponding to CAS"

	CasAuthority isNil ifTrue: [ CasAuthority := ReferenceAuthority newNamed: 'CAS' ].
	^CasAuthority! !

!Lab class methodsFor: 'examples' stamp: 'CarlosLombardi 3/25/2014 23:41'!
exampleLab
	"a lab to be used in tests and proofs"

	| newLab |
	newLab := Lab new.
	newLab addToReagents: (Reagent exampleReagent).
	newLab addToReagents: 
		(Reagent new
			name: 'Sangre de toro espesa';
			casNumber: 'D3142';
			molecularWeight: 9.3).
	newLab addToReagents: 
		(Reagent new
			name: 'Aperol';
			casNumber: 'H1234';
			molecularWeight: 0.28).			
	newLab addToReagents: 
		(Reagent new
			name: 'T-5-permatol';
			casNumber: 'J8642';
			molecularWeight: 1.23).
	newLab addToReagents: 
		(Reagent new
			name: 'T-8-menganol';
			casNumber: 'J3579';
			molecularWeight: 0.87).
	newLab addToReagents: 
		(Reagent new
			name: 'Sarabun';
			casNumber: 'J9182';
			molecularWeight: 0.341).
	^newLab			
	
! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 10/4/2014 11:12'!
addProviderNamed: name
	"adds a new provider having the given name, does nothing if such a provider already exists"

	(self providerNamed: name) ifNil: [ 
		self addToReferenceAuthorities: (Provider newNamed: name)
	]

! !

!Lab methodsFor: 'consumables' stamp: 'CarlosLombardi 4/27/2014 19:29'!
addToConsumables: aConsumable
	"aConsumable is used by me"

	consumables add: aConsumable.
	self changed: #labConsumableList.! !

!Lab methodsFor: 'events' stamp: 'CarlosLombardi 3/13/2014 09:14'!
addToEvents: anEvent
	"the events registered for this lab"

	events addLast: anEvent
	! !

!Lab methodsFor: 'projects' stamp: 'CarlosLombardi 3/29/2015 11:25'!
addToProjects: aProject
	"the LabProjects performed in this Lab"

	projects addLast: aProject! !

!Lab methodsFor: 'reagents' stamp: 'CarlosLombardi 3/25/2014 00:00'!
addToReagents: aReagent
	"register that aReagent is used by me"

	reagents add: aReagent.
	self changed: #labReagentList.! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 3/11/2014 12:51'!
addToReferenceAuthorities: aReferenceAuthority
	"adds a new reference authority. Does nothing if it is already included"

	referenceAuthorities add: aReferenceAuthority ! !

!Lab methodsFor: 'solutions' stamp: 'CarlosLombardi 3/31/2015 22:36'!
addToSolutions: aSolution
	"cfr. >>solutions"

	solutions addLast: aSolution .
	self changed: #labSolutionList.! !

!Lab methodsFor: 'stock units' stamp: 'CarlosLombardi 3/28/2014 02:11'!
addToStockUnits: aStockUnit
	"adds a new stock unit. Does nothing if it is already included"

	stockUnits add: aStockUnit ! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 3/26/2014 00:00'!
casAuthority
	"the reference authority corresponding to CAS"

	^self class casAuthority ! !

!Lab methodsFor: 'private' stamp: 'CarlosLombardi 3/27/2014 23:19'!
clearStockUnits
	"private - clear all the units"
	stockUnits := Set new! !

!Lab methodsFor: 'consumables' stamp: 'CLom 11/22/2014 11:43'!
consumableHavingId: anId forProvider: aProvider
	"the consumable named aName, nil if there is none"

	^consumables
		detect: [ :consumable | (consumable referenceIdForAuthority: aProvider) = anId ]
		ifNone: [ nil ]! !

!Lab methodsFor: 'consumables' stamp: 'CarlosLombardi 4/27/2014 19:31'!
consumableNamed: aName
	"the consumable named aName, nil if there is none"

	^consumables
		detect: [ :consumable | consumable name = aName ]
		ifNone: [ nil ]! !

!Lab methodsFor: 'consumables' stamp: 'CarlosLombardi 4/27/2014 19:30'!
consumables
	"a collection with the consumables used by me"

	^consumables! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 10/4/2014 11:09'!
defaultProvider
	"the default provider for this lab"

	^self providerNamed: 'SIGMA'! !

!Lab methodsFor: 'stock units' stamp: 'CarlosLombardi 3/28/2014 00:20'!
defaultStockUnit
	"the stock unit to assign e.g. to a new reagent by default"
	^ LabApplication unitStockUnit ! !

!Lab methodsFor: 'events' stamp: 'CarlosLombardi 3/12/2014 23:47'!
events
	"the events registered for this lab"

	^events
	! !

!Lab methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/29/2015 11:23'!
initialize
	"I get ready for life"

	super initialize.
	reagents := OrderedCollection new.
	consumables := OrderedCollection new.
	referenceAuthorities := Set with: self casAuthority.
	solutions := OrderedCollection new.
	projects := OrderedCollection new.
	events := OrderedCollection new.
	stockUnits := Set with: LabApplication unitStockUnit.! !

!Lab methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:03'!
lab
	"the reference lab corresponding to myself"

	^self ! !

!Lab methodsFor: 'projects' stamp: 'CarlosLombardi 3/29/2015 11:25'!
projects
	"the LabProjects performed in this Lab"

	^projects ! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 10/3/2014 23:55'!
providerNamed: theName
	"the provider known by this lab, having the given name. 
	 Nil iff there is no such authority"

	^self referenceAuthorities 
		detect: [ :auth |  (auth name = theName) & (auth isProvider) ]
		ifNone: [ nil ]! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 10/3/2014 23:31'!
providers
	"the providers known by this lab. 
	 CAS is a reference authority, it is not a provider"

	^referenceAuthorities copyWithout: Lab casAuthority
	
! !

!Lab methodsFor: 'reagents' stamp: 'CarlosLombardi 3/27/2014 23:01'!
reagentByCasNumber: aReference
	"the reagent having the specified SIGMA reference, nil if there is none"

	^reagents
		detect: [ :reagent | reagent casNumber = aReference ]
		ifNone: [ nil ]! !

!Lab methodsFor: 'reagents' stamp: 'CarlosLombardi 3/10/2014 18:01'!
reagentNamed: aName
	"the reagent named aName, nil if there is none"

	^reagents
		detect: [ :reagent | reagent name = aName ]
		ifNone: [ nil ]! !

!Lab methodsFor: 'reagents' stamp: 'Clom 2/9/2013 14:44'!
reagents
	"a collection with the reagents used by me"

	^reagents! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 3/11/2014 10:57'!
referenceAuthorities
	"the reference authorities known by this lab"

	^referenceAuthorities! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 10/3/2014 23:38'!
referenceAuthorityNamed: theName
	"the reference authority known by this lab, having the given name. 
	 Nil iff there is no such authority"

	^self referenceAuthorities 
		detect: [ :auth |  auth name = theName  ]
		ifNone: [ nil ]! !

!Lab methodsFor: 'consumables' stamp: 'CarlosLombardi 4/27/2014 19:31'!
removeFromConsumables: aConsumable
	"register that aConsumable is no longer used by me"

	consumables remove: aConsumable.
	self changed: #labConsumableList.! !

!Lab methodsFor: 'projects' stamp: 'CarlosLombardi 3/29/2015 11:25'!
removeFromProjects: aProject
	"the LabProjects performed in this Lab"

	projects remove: aProject! !

!Lab methodsFor: 'reagents' stamp: 'CarlosLombardi 3/25/2014 00:00'!
removeFromReagents: aReagent
	"register that aReagent is no longer used by me"

	reagents remove: aReagent.
	self changed: #labReagentList.! !

!Lab methodsFor: 'reference authorities and providers' stamp: 'CarlosLombardi 3/11/2014 10:41'!
removeFromReferenceAuthorities: aReferenceAuthority
	"the given reference is not anymore known by this lab. 
	 Error if is associated to any reagent, or else I do not know it"

	(self referenceAuthorities includes: aReferenceAuthority)
		ifFalse: [ self error: 'The reference authority ' , aReferenceAuthority asString , ' is unknown to this lab' ].
	( reagents 
		detect: [ :reagent | reagent authorities includes: aReferenceAuthority ] 
		ifNone: [ nil ] )
			ifNotNil: [ :reagent | self error: 
				'The reference authority ' , aReferenceAuthority asString , ' is associated to the reagent ' , reagent name ].
	referenceAuthorities remove: aReferenceAuthority! !

!Lab methodsFor: 'solutions' stamp: 'CarlosLombardi 3/31/2015 22:36'!
removeFromSolutions: aSolution
	"cfr. >>solutions"

	solutions remove: aSolution .
	self changed: #labSolutionList.! !

!Lab methodsFor: 'stock units' stamp: 'CLom 12/28/2014 01:44'!
removeFromStockUnits: aStockUnit
	"the given reference is not anymore known by this lab. 
	 Error if is associated to any reagent, or else I do not know it"

	(self stockUnits includes: aStockUnit)
		ifFalse: [ self error: 'La unidad ' , aStockUnit asString , ' no está registrada en este laboratorio' ].
	( reagents 
		detect: [ :reagent | reagent stockUnit = aStockUnit ] 
		ifNone: [ nil ] )
			ifNotNil: [ :reagent | self error: 
				'La unidad ' , aStockUnit asString , ' está asociada al reactivo ' , reagent name ].
	stockUnits remove: aStockUnit! !

!Lab methodsFor: 'solutions' stamp: 'CarlosLombardi 3/20/2015 00:45'!
solutionNamed: aString
	"the solution I produce having the given name, nil if I know of no such solution."

	^solutions detect: [ :solu | solu name = aString ] ifNone: [ nil ]! !

!Lab methodsFor: 'solutions' stamp: 'CarlosLombardi 3/20/2015 00:42'!
solutions
	"the set of solutions which are produced in this lab"

	^solutions! !

!Lab methodsFor: 'stock elements' stamp: 'CarlosLombardi 5/2/2014 14:02'!
stockElements
	"a Collection including all my stock elements, reagents and consumables"

	^self reagents, self consumables! !

!Lab methodsFor: 'stock units' stamp: 'CarlosLombardi 3/27/2014 23:21'!
stockUnitNamed: aName
	"the stock unit named aName, nil if there is none"

	^stockUnits
		detect: [ :stockUnit | stockUnit name = aName ]
		ifNone: [ nil ]! !

!Lab methodsFor: 'stock units' stamp: 'CarlosLombardi 3/28/2014 02:12'!
stockUnits
	^ stockUnits copy! !

Object subclass: #LabApplication
	instanceVariableNames: 'labs externalCommandSuite units formulas defaultPathForAttachedFiles'
	classVariableNames: 'CurrentApp UnitStockUnit'
	poolDictionaries: ''
	category: 'LaBook-Model'!

!LabApplication commentStamp: 'CarlosLombardi 2/16/2015 01:05' prior: 0!
The lab info management application!

!LabApplication class methodsFor: 'as yet unclassified' stamp: 'CarlosLombardi 10/13/2014 10:57'!
current
	"the current app"
	
	CurrentApp ifNil: [ 
		CurrentApp := LabApplication new.
	].
	^CurrentApp ! !

!LabApplication class methodsFor: 'as yet unclassified' stamp: 'CarlosLombardi 10/19/2014 11:34'!
forceCurrentTo: aLabApplication
	"for test - force LabApplication current to the given value"
	
	CurrentApp := aLabApplication 
! !

!LabApplication class methodsFor: 'as yet unclassified' stamp: 'CarlosLombardi 2/11/2015 15:47'!
initializeLocalization
	"Sets the translation for the language-specific messages and texts.
	 2015.02.11 - anulo porque cambio en Pharo3 no existe la clase NaturalLanguageFormTranslator"
	
"	| translator |
	translator := NaturalLanguageFormTranslator localeID: (LocaleID isoString: 'es-AR').
	translator 
		name: 'OK' form: 'Aceptar';
		name: 'Cancel' form: 'Cancelar'; 
		name: 'Apply changes and close the window' form: 'Confirmar cambios y cerrar' ;
		name: 'Cancel changes and close the window' form: 'Cancelar cambios y cerrar'.

	translator := NaturalLanguageFormTranslator localeID: (LocaleID isoString: 'en-US').
	translator 
		name: 'Agregar' form: 'Add';
		name: 'Modificar' form: 'Edit'; 
		name: 'Eliminar' form: 'Delete'."
! !

!LabApplication class methodsFor: 'as yet unclassified' stamp: 'CarlosLombardi 3/28/2014 00:18'!
unitStockUnit
	"the stock unit corresponding to 'units' "
	
	UnitStockUnit ifNil: [ 
		UnitStockUnit := StockUnit new name: 'unid.' ; prependX: false ; yourself 
	].
	^UnitStockUnit ! !

!LabApplication methodsFor: 'labs' stamp: 'CarlosLombardi 10/13/2014 11:00'!
clearLabs
	"I forget about all the labs I was registered with"

	labs := Set new.
! !

!LabApplication methodsFor: 'converting' stamp: 'CarlosLombardi 5/22/2015 11:39'!
converters
	"an object which provides converters"

	^UIConverters ! !

!LabApplication methodsFor: 'defaults' stamp: 'CarlosLombardi 4/1/2015 12:23'!
defaultPathForAttachedFiles
	^ defaultPathForAttachedFiles! !

!LabApplication methodsFor: 'defaults' stamp: 'CarlosLombardi 4/1/2015 12:23'!
defaultPathForAttachedFiles: anObject
	defaultPathForAttachedFiles := anObject! !

!LabApplication methodsFor: 'accessing' stamp: 'CarlosLombardi 2/16/2015 01:06'!
externalCommandSuite
	^ externalCommandSuite! !

!LabApplication methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/24/2015 00:23'!
initialize
	"I prepare myself for life"

	super initialize .
	self clearLabs.
	self initializeExternalCommands.
	self initializeUnits.
	self initializeFormulas.   "beware - initializeFormulas needs the Units to have been initialized previously"
! !

!LabApplication methodsFor: 'initialize-release' stamp: 'EstebanTolaba 8/2/2015 22:01'!
initializeExternalCommands
	"setup of the suite of external commands for this application"

	| openExcel openTxt openWord openPdf externalCommandsFile externalCommandsString|
	openExcel := SimpleOSProcessExternalCommand new.
	
	
	externalCommandsFile := FileStream fileNamed: 'ExternalCommands.txt'. 
	externalCommandsString  := externalCommandsFile contentsOfEntireFile.
	
	openExcel 
		name: 'Excel' ;
		addToAcceptedExtensions: 'xls' ;
		addToAcceptedExtensions: 'xlsx' ;
		commandString:  (externalCommandsString lineNumber: 1).

	openWord := SimpleOSProcessExternalCommand new.
	openWord
		name: 'Word' ;
		addToAcceptedExtensions: 'docx' ;
		addToAcceptedExtensions: 'doc' ;
		commandString: (externalCommandsString lineNumber: 2).
		
	openTxt := SimpleOSProcessExternalCommand new.
	openTxt 
		name: 'Archivo de texto' ;
		addToAcceptedExtensions: 'txt';
		commandString: (externalCommandsString lineNumber: 3).

	openPdf := SimpleOSProcessExternalCommand new.
	openPdf 
		name: 'Archivo .PDF' ;
		addToAcceptedExtensions: 'pdf';
		commandString: (externalCommandsString lineNumber: 4).

	externalCommandSuite := CompositeExternalCommand new.
	externalCommandSuite 
		addToCommands: openExcel ; addToCommands: openWord ; 
		addToCommands: openTxt ; addToCommands: openPdf.


! !

!LabApplication methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/25/2015 10:16'!
initializeFormulas
	"setup of the formulas used in this application"

	| millimolar percwv reagentInSolutionFormulas |
	formulas := Dictionary new.
	
	millimolar := self reagentInSolutionConcentrationUnits detect: [:unit | unit abbreviation = 'mM'].
	percwv := self reagentInSolutionConcentrationUnits detect: [:unit | unit abbreviation = '%(m:v)'].
	reagentInSolutionFormulas := Dictionary new.
	reagentInSolutionFormulas at: millimolar put: [ :reagentInSolution :solutionQuantity |
		(reagentInSolution molecularWeight * reagentInSolution concentration * solutionQuantity) 
			convertTo: self reagentInSolutionQuantityUnit
	].
	reagentInSolutionFormulas at: percwv put: [ :reagentInSolution :solutionQuantity |
		(reagentInSolution concentration * solutionQuantity) convertTo: self reagentInSolutionQuantityUnit
	].
	
	formulas at: #reagentInSolution put: reagentInSolutionFormulas.
! !

!LabApplication methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/24/2015 00:16'!
initializeUnits
	"setup of the units used in this application"

	| millimol millimolar percwv millilitre |
	units := Dictionary new.
	
	millimol := Unit moles prefixedBy: 'milli'.
	millimolar := millimol per: Unit litre.
	millimolar abbreviation: 'mM'.
	percwv := Unit grams per: (Unit liter prefixedBy: 'deci').
	percwv abbreviation: '%(m:v)'.
	millilitre := Unit litre prefixedBy: 'milli'.

	units at: #reagentInSolutionConcentration put: (Array with: millimolar with: percwv).
	units at: #solutionQuantity put: millilitre.
	units at: #reagentInSolutionQuantity put: Unit grams.
	units at: #molecularWeight put: Unit gramsPerMole.
! !

!LabApplication methodsFor: 'labs' stamp: 'CarlosLombardi 10/13/2014 10:57'!
labs
	"my current labs"

	^labs! !

!LabApplication methodsFor: 'units and formulas' stamp: 'CarlosLombardi 3/24/2015 00:28'!
molecularWeightUnit
	"the unit used to define the molecular weight of a reagent "

	^units at: #molecularWeight! !

!LabApplication methodsFor: 'units and formulas' stamp: 'CarlosLombardi 3/24/2015 00:24'!
reagentInSolutionConcentrationUnits
	"the units which can be used to define the concentration for a ReagentInSolution"

	^units at: #reagentInSolutionConcentration! !

!LabApplication methodsFor: 'units and formulas' stamp: 'CarlosLombardi 3/24/2015 00:31'!
reagentInSolutionFormulas
	"the formulas (one for each possible concentration unit) 
	  to be used to calculate the quantity of reagent needed in a SolutionPreparationActivity.
	  Cfr. >>reagentInSolutionConcentrationUnits.
	  Returns a map unit -> formula."

	^formulas at: #reagentInSolution! !

!LabApplication methodsFor: 'units and formulas' stamp: 'CarlosLombardi 3/24/2015 00:28'!
reagentInSolutionQuantityUnit
	"the unit used to define the quantity of each reagent used in a SolutionPreparationActivity"

	^units at: #reagentInSolutionQuantity! !

!LabApplication methodsFor: 'labs' stamp: 'CarlosLombardi 10/13/2014 10:58'!
registerLab: aLab
	"register a new lab"

	self labs add: aLab! !

!LabApplication methodsFor: 'units and formulas' stamp: 'CarlosLombardi 3/24/2015 00:25'!
solutionQuantityUnit
	"the units used to define the quantity of solution to be prepared in a SolutionPreparationActivity"

	^units at: #solutionQuantity! !

Object subclass: #LabProject
	uses: TBasicBusinessObject + TCompositeTree + TChildrenLogEntries
	instanceVariableNames: 'logEntries description children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Log'!

!LabProject commentStamp: 'CarlosLombardi 3/28/2015 01:17' prior: 0!
I represent a project whose activity is registered in an application.
I am the root of a tree of LabProjectLogEntries.!

LabProject class
	uses: TBasicBusinessObject classTrait + TCompositeTree classTrait + TChildrenLogEntries classTrait
	instanceVariableNames: ''!

!LabProject methodsFor: 'log entries' stamp: 'CarlosLombardi 3/28/2015 00:49'!
addToLogEntries: aLogEntry
	logEntries addLast: aLogEntry! !

!LabProject methodsFor: 'log entries' stamp: 'FernandoDiMeglio 8/23/2015 00:36'!
addToLogEntriesRecursively: aLogEntry
	"add to logEntries the aLogEntry parameter and all their descendants (children, children of children, etc)"
	
	logEntries addLast: aLogEntry.
	(aLogEntry children) do:[:child | self addToLogEntriesRecursively: child].! !

!LabProject methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/28/2015 11:05'!
children
	^ children! !

!LabProject methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2015 00:48'!
description
	^ description! !

!LabProject methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2015 00:48'!
description: anObject
	description := anObject! !

!LabProject methodsFor: 'report' stamp: 'FernandoDiMeglio 10/16/2015 03:31'!
generateReport
	"Generate the report for the selected activity"
	
	| reportGenerator |
	
	reportGenerator := ReportGenerator new.
	reportGenerator labProject: self.
	^reportGenerator generate.! !

!LabProject methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/28/2015 01:13'!
initialize
	"preparation for life"

	super initialize.
	logEntries := OrderedCollection new.
	children := OrderedCollection new.! !

!LabProject methodsFor: 'log entries' stamp: 'CarlosLombardi 3/28/2015 00:48'!
logEntries
	^ logEntries! !

!LabProject methodsFor: 'accessing' stamp: 'EstebanTolaba 7/8/2015 02:21'!
logEntries: anObject
	logEntries := anObject! !

!LabProject methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/28/2015 11:11'!
parent
	"I am the root, hence I have no parent. Cfr. >>ancestors"
	^ nil! !

!LabProject methodsFor: 'log entries' stamp: 'CarlosLombardi 3/28/2015 01:14'!
removeFromLogEntries: aLogEntry
	logEntries remove: aLogEntry .
	aLogEntry parent: nil .! !

Object subclass: #LabProjectLogEntry
	uses: TBasicBusinessObject + TCompositeTree + TChildrenLogEntries
	instanceVariableNames: 'loadDate toDoDate completionDate notes attachedFiles usedMaterial description parent children solutionPreparationActivities completionState rootDirectoryPath noteEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Log'!

!LabProjectLogEntry commentStamp: 'CarlosLombardi 3/5/2015 11:41' prior: 0!
A log entry describing some activity performed for a lab project.
The set of log entries for a project are organised as a tree.!

LabProjectLogEntry class
	uses: TBasicBusinessObject classTrait + TCompositeTree classTrait + TChildrenLogEntries classTrait
	instanceVariableNames: ''!

!LabProjectLogEntry methodsFor: 'attached files' stamp: 'CarlosLombardi 2/28/2015 23:07'!
addAllToAttachedFiles: aCollection
	"exactly that"
	attachedFiles addAll: aCollection! !

!LabProjectLogEntry methodsFor: 'solution preparation activities' stamp: 'CarlosLombardi 3/20/2015 22:19'!
addAllToSolutionPreparationActivities: aCollectionOfSolutionPAs
	"the activities of preparation of solutions which are part of this log entry"

	aCollectionOfSolutionPAs do: [ :solPA | self addToSolutionPreparationActivities: solPA ]! !

!LabProjectLogEntry methodsFor: 'solution preparation activities' stamp: 'CarlosLombardi 3/20/2015 22:16'!
addToSolutionPreparationActivities: aSolutionPA
	"the activities of preparation of solutions which are part of this log entry"

	solutionPreparationActivities addLast: aSolutionPA ! !

!LabProjectLogEntry methodsFor: 'replication' stamp: 'FernandoDiMeglio 11/14/2015 02:11'!
amendParentInDescendantsForCopy
	"Private - set the parent of all my descendants 
	 to be coherent with the information in the collections of children.
	 To be used only inside postCopy"
	 
	self children do: [:ch |
		ch parentSetter: self.
		ch amendParentInDescendantsForCopy.
	]! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: ''!
asBasicBusinessObject
	"the basic business object corresponding to me.
	 In this case it is exactly me, as I am a basic business object "

	^self! !

!LabProjectLogEntry methodsFor: 'attached files' stamp: 'CarlosLombardi 2/28/2015 22:50'!
attachFileNamed: aFileName
	"register that the file named aFileNamed is related to this log entry"

	attachedFiles addLast: (
		ActiveFile new
			externalCommand: LabApplication current externalCommandSuite ;
			fullName: aFileName ;
			yourself
	)! !

!LabProjectLogEntry methodsFor: 'attached files' stamp: 'CarlosLombardi 2/11/2015 17:58'!
attachedFiles
	^ attachedFiles! !

!LabProjectLogEntry methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/31/2015 21:15'!
canBeDemoted
	"true iff I can be demoted among my parent children "
	
	^self parent children last ~= self! !

!LabProjectLogEntry methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/31/2015 21:15'!
canBePromoted
	"true iff I can be promoted among my parent children "
	
	^self parent children first ~= self! !

!LabProjectLogEntry methodsFor: 'replication' stamp: 'EstebanTolaba 8/23/2015 22:16'!
canBeReplicated
	"true iff I can be replicated based on my name "


	^ self isReplicableOneDigit  | self isReplicableTwoDigits.
		
! !

!LabProjectLogEntry methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/5/2015 11:42'!
children
	^ children! !

!LabProjectLogEntry methodsFor: 'solution preparation activities' stamp: 'CarlosLombardi 3/20/2015 22:18'!
clearSolutionPreparationActivities
	"the activities of preparation of solutions which are part of this log entry"

	solutionPreparationActivities removeAll! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:59'!
completionDate
	^ completionDate! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:59'!
completionDate: anObject
	completionDate := anObject! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 8/24/2015 13:03'!
completionState

	"My completion state based on the input of my date fields"
	
	| state  |
	
	state := OnlyLoadedState new.
	self toDoDate notNil & self completionDate isNil
	ifTrue: [ state := EstimatedState new ].
	self toDoDate notNil & self completionDate notNil
	ifTrue: [ state := CompletedState new ].
	self completionState: state.
	^ state.! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 7/27/2015 17:58'!
completionState: anObject
	completionState := anObject! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'CarlosLombardi 2/12/2015 10:40'!
description
	^ description! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'CarlosLombardi 2/12/2015 10:41'!
description: anObject
	description := anObject! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 9/14/2015 16:19'!
editor
	^ self noteEditor textMorph editor.! !

!LabProjectLogEntry methodsFor: 'initialization-release' stamp: 'EstebanTolaba 9/4/2015 17:03'!
initialize
	"preparation for life"

	super initialize.
	usedMaterial := OrderedCollection new.
	attachedFiles := OrderedCollection new.
	solutionPreparationActivities := OrderedCollection new.
	children := OrderedCollection new.
	self completionState: OnlyLoadedState new.
	"self noteEditor: LabProjectLogEntryNoteEditor new."
	
! !

!LabProjectLogEntry methodsFor: 'replication' stamp: 'FernandoDiMeglio 11/13/2015 01:33'!
isReplicableOneDigit
	"True if my description ends with (1 de X) Where X is a number from 1 to 9"

	self description size > 8
		ifTrue: [ 
			| substring |
			substring := self description last: 8.

			^ ((substring at: 1) = $( & ((substring at: 8) = $)) & ((substring at: 2) = $1) & ((substring at: 4) = $d)
				& ((substring at: 5) = $e))]
		ifFalse: [ ^ false ].
		
! !

!LabProjectLogEntry methodsFor: 'replication' stamp: 'FernandoDiMeglio 11/13/2015 01:32'!
isReplicableTwoDigits
	"True if my description ends with (1 de X) Where X is a number from 10 to 99"
	
	self description size > 9
		ifTrue: [ 
			| substring |
			substring := self description last: 9.

			^ ((substring at: 1) = $( & ((substring at: 9) = $)) & ((substring at: 2) = $1) & ((substring at: 4) = $d)
				& ((substring at: 5) = $e))]
		ifFalse: [ ^ false ].
		
! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:59'!
loadDate
	^ loadDate! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:59'!
loadDate: anObject
	loadDate := anObject! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 9/4/2015 16:54'!
noteEditor
	^ noteEditor! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 9/4/2015 16:54'!
noteEditor: anObject
	noteEditor := anObject! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'CarlosLombardi 2/11/2015 17:58'!
notes
	^ notes! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'CarlosLombardi 2/14/2015 15:21'!
notes: anObject
	notes := anObject! !

!LabProjectLogEntry methodsFor: 'replication' stamp: 'FernandoDiMeglio 10/31/2015 16:39'!
numberToReplicate	
	"The number of my description if I can be replicated"
	
	self isReplicableOneDigit ifTrue:[^(((self description last: 8) at: 7) asString) asNumber.].
	self isReplicableTwoDigits ifTrue:[^(((((self description last: 9) at: 7) asString) , (((self description last: 9) at: 8) asString)) asNumber).].
	^0.! !

!LabProjectLogEntry methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/5/2015 11:42'!
parent
	^ parent! !

!LabProjectLogEntry methodsFor: 'log entry tree' stamp: 'CarlosLombardi 3/8/2015 02:37'!
parent: aLogEntry
	"set the given LogEntry as my parent. 
	 This is the only way to update the tree other than children reorganization (promoteChild: / demoteChild:).
	 Ensures coherence of children and parent, by adding myself as the last child of my new parent."
	
	| oldParent |
	(aLogEntry ~= parent) ifTrue: [ 
		oldParent := parent.
		parent := aLogEntry.
		oldParent ifNotNil: [ oldParent privateRemoveChild: self ].
		parent ifNotNil: [ parent privateAddLastChild: self ].		
	] .
	! !

!LabProjectLogEntry methodsFor: 'log entry tree' stamp: 'FernandoDiMeglio 11/14/2015 02:11'!
parentSetter: aLogEntry
	"set the given LogEntry as my parent directly"
	
	parent := aLogEntry.
! !

!LabProjectLogEntry methodsFor: 'replication' stamp: 'FernandoDiMeglio 11/12/2015 22:12'!
postCopy

	super postCopy.
	self description: self description copy.
	self loadDate: self loadDate copy.
	self toDoDate: self toDoDate copy.
	self completionDate: self completionDate copy.
	self completionState: self completionState copy.
	self notes: self notes copy.
	self noteEditor: self noteEditor copy.
	self rootDirectoryPath: self rootDirectoryPath copy.
	solutionPreparationActivities := self solutionPreparationActivities collect:[:solu | solu copy ].
	
	attachedFiles := (self attachedFiles) collect: [:file | file copy ].
	children := (self children) collect: [:child |  child copy].
						
	"usedMaterial unimplemented "
	
	^self.! !

!LabProjectLogEntry methodsFor: 'attached files' stamp: 'CarlosLombardi 2/28/2015 23:06'!
removeAllFromAttachedFiles
	attachedFiles removeAll ! !

!LabProjectLogEntry methodsFor: 'replication' stamp: 'FernandoDiMeglio 11/12/2015 22:12'!
replicateFromLogEntry: aLogEntry
	"Creates a copy of aLogEntry and their descendants redefining the method postCopy than utilizes copy"

	| logEntryCopy |
		
	logEntryCopy := aLogEntry copy.	
	self description: logEntryCopy  description.
	self loadDate: logEntryCopy loadDate.
	self toDoDate: logEntryCopy toDoDate.
	self completionDate: logEntryCopy completionDate.
	self completionState: logEntryCopy completionState.
	self notes: logEntryCopy notes.
	self noteEditor: logEntryCopy noteEditor.
	self rootDirectoryPath: logEntryCopy rootDirectoryPath.
	solutionPreparationActivities  := logEntryCopy solutionPreparationActivities.
	attachedFiles := logEntryCopy attachedFiles.
	children := logEntryCopy children.
	self parent: aLogEntry  parent.	
	self amendParentInDescendantsForCopy.! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 8/13/2015 14:49'!
rootDirectoryPath
	^ rootDirectoryPath! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 8/13/2015 14:49'!
rootDirectoryPath: anObject
	rootDirectoryPath := anObject! !

!LabProjectLogEntry methodsFor: 'solution preparation activities' stamp: 'CarlosLombardi 3/20/2015 22:16'!
solutionPreparationActivities
	"the activities of preparation of solutions which are part of this log entry"

	^solutionPreparationActivities ! !

!LabProjectLogEntry methodsFor: 'stock' stamp: 'CarlosLombardi 2/11/2015 18:17'!
stockVariationSign
	"lab activities imply stock decrease"
	^-1! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:59'!
toDoDate
	^ toDoDate! !

!LabProjectLogEntry methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:59'!
toDoDate: anObject
	toDoDate := anObject! !

!LabProjectLogEntry methodsFor: 'stock' stamp: 'CarlosLombardi 2/11/2015 18:20'!
use: howMuch ofMaterial: aStockElement
	"register that the given quantity of aStockElement was used during the logged activity"
	usedMaterial add: (
		StockEventDetail new
			event: self ;
			element: aStockElement ;
			quantity: howMuch ;
			unitPrice: 0 ;
			yourself
	)! !

!LabProjectLogEntry methodsFor: 'stock' stamp: 'CarlosLombardi 2/11/2015 17:58'!
usedMaterial
	^ usedMaterial! !

Object subclass: #LabProjectLogEntryCompletionState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Log'!

!LabProjectLogEntryCompletionState commentStamp: '<historical>' prior: 0!
A CompletionState is xxxxxxxxx.

Instance Variables
	logEntry:		<Object>

logEntry
	- xxxxx
!

LabProjectLogEntryCompletionState subclass: #CompletedState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Log'!

!CompletedState commentStamp: '<historical>' prior: 0!
A CompletedState is xxxxxxxxx.
!

!CompletedState methodsFor: 'as yet unclassified' stamp: 'EstebanTolaba 7/9/2015 13:01'!
colorState

	^Color black.! !

LabProjectLogEntryCompletionState subclass: #EstimatedState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Log'!

!EstimatedState commentStamp: '<historical>' prior: 0!
An EstimatedState is xxxxxxxxx.
!

!EstimatedState methodsFor: 'as yet unclassified' stamp: 'EstebanTolaba 7/9/2015 13:01'!
colorState

	^Color orange.! !

!LabProjectLogEntryCompletionState class methodsFor: 'as yet unclassified' stamp: 'EstebanTolaba 7/9/2015 12:57'!
for: aLogEntry


	^self new
		logEntry: aLogEntry ;
		yourself! !

!LabProjectLogEntryCompletionState methodsFor: 'accessing' stamp: 'EstebanTolaba 7/9/2015 13:00'!
colorState

	^self subclassResponsibility.! !

LabProjectLogEntryCompletionState subclass: #OnlyLoadedState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Log'!

!OnlyLoadedState commentStamp: '<historical>' prior: 0!
An OnlyLoadedState is xxxxxxxxx.
!

!OnlyLoadedState methodsFor: 'as yet unclassified' stamp: 'EstebanTolaba 7/27/2015 18:18'!
colorState

	^Color red.! !

Object subclass: #LabProjectLogEntryEditController
	uses: TSolutionPreparationEditorCreator
	instanceVariableNames: 'model parent loadDate toDoDate completionDate description notes attachedFiles solutionPreparationActivities lab labProject defaultParent rootDirectoryPath noteEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectLogEntryEditController commentStamp: 'CarlosLombardi 3/20/2015 22:45' prior: 0!
A controller for the edition of a LabProjectLogEntry.
I must control the sets of attached files and solution preparation activities.
I handle the solution preparation activities through edit controllers (in fact editors, since a SolutionPreparationEditor acts as both editor and edit controller).!

LabProjectLogEntryEditController class
	uses: TSolutionPreparationEditorCreator classTrait
	instanceVariableNames: ''!

!LabProjectLogEntryEditController class methodsFor: 'instance creation' stamp: 'CarlosLombardi 2/28/2015 22:57'!
for: aLogEntry
	"a new editor to control the edition of the given log entry"

	^self new
		model: aLogEntry ;
		yourself! !

!LabProjectLogEntryEditController methodsFor: 'attached files' stamp: 'CarlosLombardi 2/28/2015 22:55'!
attachedFiles
	
	^ attachedFiles! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:53'!
attachedFiles: anObject
	attachedFiles := anObject! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:53'!
completionDate
	^ completionDate! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:53'!
completionDate: anObject
	completionDate := anObject! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 23:48'!
defaultParent
	^ defaultParent! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 23:48'!
defaultParent: anObject
	defaultParent := anObject! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/9/2015 12:46'!
description
	"my description"

	^description! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/9/2015 12:46'!
description: aString
	"my description is set"

	description := aString! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 11/2/2015 18:31'!
incorrectDates

	|thereIsAnError|
	thereIsAnError := false.

	(self  loadDate isNil) ifTrue:[thereIsAnError :=true].
	(self  toDoDate notNil & (self model toDoDate < self model loadDate)) ifTrue:[thereIsAnError :=true].
	(self  completionDate notNil & self model toDoDate notNil & ((self model completionDate < self model loadDate) | (self model completionDate < self model toDoDate)  )) ifTrue:[thereIsAnError :=true].
	^thereIsAnError.! !

!LabProjectLogEntryEditController methodsFor: 'initialize-release' stamp: 'CarlosLombardi 2/28/2015 22:58'!
initialize
	"preparation for life"

	super initialize .
	attachedFiles := OrderedCollection new.! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:43'!
lab
	^ lab! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 23:48'!
lab: anObject
	lab := anObject.
! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 23:37'!
labProject
	^ labProject! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 23:48'!
labProject: anObject
	labProject := anObject.
! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:53'!
loadDate
	^ loadDate! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:53'!
loadDate: anObject
	loadDate := anObject! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:50'!
logEntry
	"the LogEntry associated to me. Cfr. TSolutionPreparationEditorCreator"
	^ self model! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 2/28/2015 22:55'!
model
	
	^ model! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 9/4/2015 17:09'!
model: aLogEntry
	
	model := aLogEntry.
	self 
		parent: aLogEntry parent ; 
		loadDate: aLogEntry loadDate ; 
		toDoDate: aLogEntry toDoDate ; 
		completionDate: aLogEntry completionDate ; 
		description: aLogEntry description ;
		notes: aLogEntry notes;
		noteEditor: aLogEntry noteEditor.
	
	attachedFiles := aLogEntry attachedFiles collect: [ :afile | 
		ActiveFile new 
			externalCommand: afile externalCommand ;  
			fullName: afile fullName ;
			yourself
	] .

	solutionPreparationActivities := aLogEntry solutionPreparationActivities 
		collect: [ :solPA | self buildPreparationEditorFor: solPA ] .
		
! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 9/4/2015 17:01'!
noteEditor
	^ noteEditor! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'FernandoDiMeglio 12/8/2015 00:47'!
noteEditor: anObject
	noteEditor := anObject.
	"self model noteEditor: anObject."! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 23:32'!
notes
	"my notes"

	^notes! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 23:32'!
notes: aString
	"my notes are set"

	notes := aString! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 23:40'!
parent
	"my parent LogEntry"

	^parent! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/9/2015 12:46'!
parent: aLogEntry
	"my parent LogEntry is set"

	parent := aLogEntry! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 8/10/2015 17:57'!
rootDirectoryPath
	^ rootDirectoryPath! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 8/10/2015 17:57'!
rootDirectoryPath: anObject
	rootDirectoryPath := anObject! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 21:12'!
selectedParent: aLogEntry
	"my parent LogEntry is selected from the UI"

	| oldParent   dateCalculation |
	oldParent := self parent.
	self parent: aLogEntry .

	"set date if corresponds"
	dateCalculation := [ :logEntryOrProject | 
		logEntryOrProject ifNotNil: [ (logEntryOrProject respondsTo: #loadDate) 
				ifFalse: [ Date today ] ifTrue: [ logEntryOrProject loadDate ] 
		]
	] .
	(oldParent ~= aLogEntry) & (self loadDate = (dateCalculation value: oldParent)) ifTrue: [ 
		self loadDate: (dateCalculation value: aLogEntry)
	] .
	
	! !

!LabProjectLogEntryEditController methodsFor: 'actions' stamp: 'CarlosLombardi 3/29/2015 23:49'!
setDefaults
	"..."

	self parent ifNil: [ self selectedParent: (self defaultParent ifNil: [ self labProject ]) ] .! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:57'!
solutionPreparationActivities
	"the (editors = editControllers for) the solution preparation activities of my model "

	^solutionPreparationActivities ! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:53'!
solutionPreparationActivities: anObject
	solutionPreparationActivities := anObject! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:53'!
toDoDate
	^ toDoDate! !

!LabProjectLogEntryEditController methodsFor: 'accessing' stamp: 'EstebanTolaba 5/29/2015 20:53'!
toDoDate: anObject
	toDoDate := anObject! !

!LabProjectLogEntryEditController methodsFor: 'actions' stamp: 'FernandoDiMeglio 12/8/2015 00:48'!
updateModel
	"pour the changes I am conscious about to my model"

	| mergedFiles |
	"simple fields"
	self model
		loadDate: self loadDate ; toDoDate: self toDoDate ; completionDate: self completionDate ; description: self description ; parent: self parent ; notes: self notes; noteEditor: self noteEditor.
			
	"files"
	mergedFiles := OrderedCollection new.
	self attachedFiles 
		reject: [ :efile | efile fullName isEmpty ]
		thenDo: [ :efile | (mergedFiles anySatisfy: [:mfile | mfile fullName = efile fullName] ) ifFalse: [ 
					mergedFiles addLast: ( self model attachedFiles 
						detect: [ :ofile | ofile fullName = efile fullName ]
						ifNone: [ efile ]
					)
				 ] ].
	self model removeAllFromAttachedFiles ; addAllToAttachedFiles: mergedFiles.
	
	"solution preparation activities"
	solutionPreparationActivities do: [ :solPAeditor | solPAeditor updateModel ] .
	self model 
		clearSolutionPreparationActivities  ; 
		addAllToSolutionPreparationActivities: (solutionPreparationActivities collect: #model) .
	
! !

Object subclass: #LineRowDecorator
	uses: TRowDecorator + TUIGoodies
	instanceVariableNames: 'oddColor evenColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Addons'!

!LineRowDecorator commentStamp: 'CarlosLombardi 5/26/2015 02:04' prior: 0!
A row decorator which draws an horizontal line to separate rows.!

LineRowDecorator class
	uses: TRowDecorator classTrait + TUIGoodies classTrait
	instanceVariableNames: ''!

!LineRowDecorator methodsFor: 'decorating' stamp: 'CarlosLombardi 5/26/2015 03:20'!
decoratedRowFor: aRowMorph inOrder: aNumber
	"returns the decorated row corresponding to the given parameters."
	
	| linea decoratedMorph |
	(aNumber = 1) ifTrue: [ ^aRowMorph ] .

	"just to force computation of bounds"
	aRowMorph fullBounds.
	
	linea := LineMorph 
		from:0@0 to: (aRowMorph width) @0  
		color: (Color r: 0.1 g: 0.8 b: 0.6 ) darker width: 2. 

	decoratedMorph := ModelPanelMorph new.  "just to avoid change of colors by adoptPaneColor of the window"
	decoratedMorph model: nil .
	decoratedMorph model: aRowMorph model.
	decoratedMorph
		changeTableLayout ; 
		listDirection: #topToBottom ;
		cellInset: 0 ;
		cellPositioning: #topLeft .
	decoratedMorph borderWidth: 0.
	decoratedMorph hResizing: #shrinkWrap ; vResizing: #shrinkWrap .
	decoratedMorph 
		addMorphBack: linea ; 
		addMorphBack: (self buildColumnSpacer: 1) ; 
		addMorphBack: aRowMorph .

	^decoratedMorph

! !

Object subclass: #MultiRowMorphBuilder
	uses: TUIGoodies
	instanceVariableNames: 'mainMorphMaster completeRows currentRow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

MultiRowMorphBuilder class
	uses: TUIGoodies classTrait
	instanceVariableNames: ''!

!MultiRowMorphBuilder methodsFor: 'actions' stamp: 'CLom 12/27/2014 03:01'!
addMorph: aMorph
	"adds a new morph in the current position"

	currentRow ifNil: [ currentRow := self buildEmptyRow. ].
	currentRow addMorphBack: aMorph.! !

!MultiRowMorphBuilder methodsFor: 'accessing' stamp: 'CLom 12/27/2014 02:50'!
borderColor: aColor
	"cfr. Morph>>borderColor:"

	mainMorphMaster borderColor: aColor.! !

!MultiRowMorphBuilder methodsFor: 'accessing' stamp: 'CLom 12/27/2014 02:51'!
borderWidth: aNumber
	"cfr. Morph>>borderWidth:"

	mainMorphMaster borderWidth: aNumber.! !

!MultiRowMorphBuilder methodsFor: 'actions' stamp: 'CLom 12/27/2014 02:45'!
cr
	"jumps over a new line"

	currentRow ifNil: [ currentRow := self buildEmptyRow. currentRow addMorph: (self buildRowSpacer: 1). ].
	completeRows addLast: currentRow.
	currentRow := nil.! !

!MultiRowMorphBuilder methodsFor: 'accessing' stamp: 'CLom 12/27/2014 02:52'!
fillStyle: aStyle
	"cfr. Morph>>fillStyle:"

	mainMorphMaster fillStyle: aStyle.! !

!MultiRowMorphBuilder methodsFor: 'initialize-release' stamp: 'CLom 12/27/2014 03:21'!
initialize
	"preparation for life"

	super initialize.
	mainMorphMaster := self buildEmptyColumn layoutInset: 0 ; cellInset: 4 ; yourself.
	completeRows := OrderedCollection new.
	currentRow := nil.! !

!MultiRowMorphBuilder methodsFor: 'accessing' stamp: 'CLom 12/27/2014 02:54'!
morph
	"the built morph"

	| result |
	result := mainMorphMaster shallowCopy.
	result addAllMorphs: completeRows.
	currentRow ifNotNil: [ result addMorphBack: currentRow. ].
	^result! !

Object subclass: #ObjectEditor
	uses: TUIGoodies
	instanceVariableNames: 'model uiParent window'
	classVariableNames: 'DateConverter'
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ObjectEditor commentStamp: '<historical>' prior: 0!
A superclass for object editors.

Concrete subclasses must realize the method buildWindow, used by the template method window.!

ObjectEditor class
	uses: TUIGoodies classTrait
	instanceVariableNames: ''!

ObjectEditor subclass: #ActiveFileTestWindow
	uses: TBuildWindowFromForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Tests'!

!ActiveFileTestWindow commentStamp: 'CarlosLombardi 2/18/2015 02:40' prior: 0!
A window to test ActiveFileFieldMorph.
!

ActiveFileTestWindow class
	uses: TBuildWindowFromForm classTrait
	instanceVariableNames: ''!

!ActiveFileTestWindow methodsFor: 'ui building' stamp: 'CarlosLombardi 2/28/2015 01:21'!
buildForm
	"Build and return the form included in this window"

	| fileField newColumn |
	fileField := ActiveFileFieldMorph new
		model: self model;
		yourself.
	fileField defaultPathFullName: 'c:\data\carlos\pharo'.
	newColumn := self buildEmptyColumn .
	newColumn addMorphBack: fileField.
	^ newColumn! !

!ActiveFileTestWindow methodsFor: 'initialize-release' stamp: 'CarlosLombardi 2/18/2015 00:23'!
initialize
	"preparation for life"

	| newActiveFile |
	super initialize.
	newActiveFile := ActiveFile new
		externalCommand: LabApplication current externalCommandSuite;
		yourself.
	self model: newActiveFile.! !

!ActiveFileTestWindow methodsFor: 'accessing' stamp: 'CarlosLombardi 2/18/2015 00:34'!
model: anObject
	"model cannot change, once set"

	self model ifNil: [ super model: anObject ]! !

!ActiveFileTestWindow methodsFor: 'ui building' stamp: 'CarlosLombardi 2/18/2015 00:26'!
windowTitle
	"..."

	^'Prueba de edición de referencia a archivo'! !

ObjectEditor subclass: #BaseListEditor
	instanceVariableNames: 'selectedIndex additionalEventOnSelectionChange setObjectSelectedBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BaseListEditor commentStamp: '<historical>' prior: 0!
A superclass for editors based on a list of items!

!BaseListEditor methodsFor: 'accessing' stamp: 'CLom 11/23/2014 16:46'!
additionalEventOnSelectionChange
	"A Symbol, particular to this list editor, to be emitted as an event on selection change.
	 The general events #selectedIndex and #thereIsSomethingSelected are always emitted."
	^ additionalEventOnSelectionChange! !

!BaseListEditor methodsFor: 'accessing' stamp: 'CLom 11/23/2014 16:47'!
additionalEventOnSelectionChange: anObject
	"A Symbol, particular to this list editor, to be emitted as an event on selection change.
	 The general events #selectedIndex and #thereIsSomethingSelected are always emitted."
	additionalEventOnSelectionChange := anObject! !

!BaseListEditor methodsFor: 'objects' stamp: 'CarlosLombardi 3/16/2014 12:40'!
indexForObject: anObject
	"the index corresponding to the given object, 
	  0 if it is not included in the list of objects to render"

	^self objectList indexOf: anObject.	"0 if anObject is not in the list"
! !

!BaseListEditor methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/12/2014 09:41'!
initialize
	"get prepared for life"

	super initialize.
	^self selectedIndex: 0 ; yourself! !

!BaseListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/12/2014 09:52'!
objectList
	"the list of objects to render"
	
	^self subclassResponsibility ! !

!BaseListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/12/2014 09:40'!
selectedIndex
	^ selectedIndex! !

!BaseListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 00:27'!
selectedIndex: anIndex
	"selects the object at the given index"
	self semiSilentSelectedIndex: anIndex.
	self additionalEventOnSelectionChange ifNotNil: [ :symbol | self changed: symbol ] .
	self setObjectSelectedBlock ifNotNil: [ :block | block value: self selectedObject ] .
	
	! !

!BaseListEditor methodsFor: 'objects' stamp: 'CarlosLombardi 3/12/2014 09:44'!
selectedObject
	"the selected object, nil if there is nothing selected"

	^self thereIsSomethingSelected 
		ifTrue: [ self objectList at: self selectedIndex ]
		ifFalse: [ nil ]! !

!BaseListEditor methodsFor: 'objects' stamp: 'CarlosLombardi 3/14/2014 16:58'!
selectedObject: anObject
	"select the given object"

	self selectedIndex: (self indexForObject: anObject)! !

!BaseListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 00:28'!
semiSilentSelectedIndex: anIndex
	"select the object at the given index, firing just the events related with the view.
	 That is, the additionalEventOnSelectionChange is not fired.
	 The setObjectSelectedBlock is neither evaluated."
	selectedIndex := anIndex.
	self 
		changed: #selectedIndex;
  		changed: #thereIsSomethingSelected.
! !

!BaseListEditor methodsFor: 'objects' stamp: 'CarlosLombardi 3/9/2015 12:23'!
semiSilentSelectedObject: anObject
	"select the given object, firing just the events related with the view.
	 That is, the additionalEventOnSelectionChange is not fired."

	self semiSilentSelectedIndex: (self indexForObject: anObject)! !

!BaseListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 00:29'!
setObjectSelectedBlock
	"an unary block to be evaluated when the selected object is changed; the argument is the newly selected object."
	^ setObjectSelectedBlock! !

!BaseListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 00:29'!
setObjectSelectedBlock: anObject
	"an unary block to be evaluated when the selected object is changed; the argument is the newly selected object."
	setObjectSelectedBlock := anObject! !

!BaseListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/12/2014 09:51'!
thereIsSomethingSelected
	"a boolean"

	^self selectedIndex notNil and: [ self selectedIndex between: 1 and: self objectList size ]! !

BaseListEditor subclass: #BaseMorphListEditor
	instanceVariableNames: 'morphList rowDecorator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BaseMorphListEditor commentStamp: 'CarlosLombardi 3/26/2015 01:11' prior: 0!
A superclass for editors based on a list of Morphs. 

The corresponding list morph in a rendering of a BaseMorphListEditor must refer to #morphList to obtain its contents.
The morph list is cached.

!

BaseMorphListEditor subclass: #ActiveFileListEditor
	uses: TUIGoodies + TBuildWindowFromPane + TEditObjectInListButtons + (TBusinessObjectEditionInList - {#editSelected})
	instanceVariableNames: 'defaultPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!ActiveFileListEditor commentStamp: 'CarlosLombardi 2/27/2015 01:09' prior: 0!
I know how to edit my model, which is a list of instances of ActiveFile. 
I use an ActiveFileFieldMorph to edit each ActiveFile in the list.
!

ActiveFileListEditor class
	uses: TUIGoodies classTrait + TBuildWindowFromPane classTrait + TEditObjectInListButtons classTrait + TBusinessObjectEditionInList classTrait
	instanceVariableNames: ''!

!ActiveFileListEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 2/28/2015 01:12'!
activeFileMorphs
	"a collection including all the morphs corresponding to the edited active files"

	^self morphList collect: [ :morph | morph submorphs first ].! !

!ActiveFileListEditor methodsFor: 'actions' stamp: 'CarlosLombardi 2/27/2015 11:44'!
addElement
	"adds a new file into the list"

	| newFile |
	newFile :=  ActiveFile new.
	newFile externalCommand: LabApplication current externalCommandSuite .
	self model addLast: newFile.
	self invalidateList.
	self selectedObject: newFile.	
! !

!ActiveFileListEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 8/17/2015 21:03'!
buildButtonBar
	"build a UI component to show the buttons to appear under the list"
	
	^self uiBuilder 
		newRow: { self buildAddButton . self buildDeleteButton } .

! !

!ActiveFileListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 2/27/2015 11:30'!
buildPane
	"creates and answers the main pane to be included in a Window"

	^(self uiBuilder 
		newColumn: { self buildList . self buildButtonBar }) 
		cellInset: 0 ; yourself.
! !

!ActiveFileListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 2/28/2015 02:31'!
buildRowFor: anObject
	"creates and answers a row for my morph list, representing anObject"

	| newRow fileMorph |
	newRow := self newRowFor: anObject.
	newRow 
		height: 40 ; 
		vResizing: #rigid .
	fileMorph := ActiveFileFieldMorph new .
	fileMorph 
		model: anObject ;
		addDependent: self ;
		defaultPathFullName: defaultPath.
	newRow addMorphBack: fileMorph.	
	^ newRow! !

!ActiveFileListEditor methodsFor: 'actions' stamp: 'EstebanTolaba 8/13/2015 15:45'!
centralizeAttachedFiles

	| result |
	result := self uiBuilder theme 
		chooseFullFileNameIn: self uiBuilder 
		title: 'Elija una carpeta para guardar sus archivos' 
		extensions: nil 
		path: 'C:\'
		preview: nil.
	result ifNotNil: [ self rootDirectoryPath: 'C:\'].
	
	self model do:[:file|
		
		|fileName|
		
		fileName := (file fullName findTokens: '\') last.
		self fileSystem copy: (file fullName)  to: (self rootDirectoryPath  , fileName). 
		].
	! !

!ActiveFileListEditor methodsFor: 'updating' stamp: 'CarlosLombardi 4/1/2015 12:27'!
handleUpdate: aMorphChange
	"I am informed about a aMorphChange"

	| possiblePath |
	aMorphChange selector = #activeFile
		ifTrue: [ 
			| fileReference |
			fileReference := aMorphChange arguments reference.
			fileReference ifNotNil: [ 
				possiblePath := fileReference parent.
				(possiblePath exists and: [ possiblePath fullName notEmpty ]) ifTrue: [ 
					defaultPath := possiblePath fullName .
					self activeFileMorphs do: [ :fileMorph | fileMorph defaultPathFullName: defaultPath ] .
					LabApplication current defaultPathForAttachedFiles: defaultPath.
				] 
			]
		]! !

!ActiveFileListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 2/27/2015 01:13'!
helpText
	"the help text to be shown in the list"

	^'Ingrese los archivos a tener en cuenta'! !

!ActiveFileListEditor methodsFor: 'initialize-release' stamp: 'EstebanTolaba 8/10/2015 18:09'!
initialize
	"preparation for life"

	super initialize.
	fileSystem:= FileSystem disk.
	defaultPath := LabApplication current defaultPathForAttachedFiles .! !

!ActiveFileListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 4/1/2015 12:36'!
model: aCollectionOfFiles
	"set the collection I show"

	| existingFiles |
	super model: aCollectionOfFiles .
	existingFiles := aCollectionOfFiles select: [ :activeFile | 
		activeFile exists & activeFile reference parent fullName notEmpty 
	].
	existingFiles ifNotEmpty: [ defaultPath := existingFiles last reference parent fullName ].! !

!ActiveFileListEditor methodsFor: 'list' stamp: 'CarlosLombardi 2/27/2015 01:11'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model! !

!ActiveFileListEditor methodsFor: 'data morphs' stamp: 'EstebanTolaba 8/10/2015 18:49'!
pathToFindFiles
	"the full name of the path where my file chooser must open upon"

	self rootDirectoryPath  ifNotNil: [ :ref | ^ref parent fullName ].
	( rootDirectoryPath notNil and: [ rootDirectoryPath exists ] ) ifTrue: [ ^rootDirectoryPath fullName ].
	^nil
! !

!ActiveFileListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 2/27/2015 11:47'!
removeBusinessObject: anActiveFile
	"..."

	self model remove: anActiveFile! !

!ActiveFileListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 2/28/2015 23:47'!
textForRemoveBusinessObjectConfirmation: anActiveFile
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	anActiveFile fullName isEmpty ifTrue: [ 
		textBuilder 	nextPutAll: 'Confirmar eliminación del archivo elegido ' 
	] ifFalse: [ 
		textBuilder 
			nextPutAll: 'Confirmar eliminación del archivo ' ; cr ;
			nextPutAll: anActiveFile fullName.
	 ].
	^textBuilder contents
! !

!ActiveFileListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 2/27/2015 11:28'!
windowTitle

	^'Archivos asociados'! !

BaseMorphListEditor subclass: #BOReferencesDeletionView
	uses: TBuildWindowFromPane + TListPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Basics'!

!BOReferencesDeletionView commentStamp: 'CarlosLombardi 5/26/2015 15:38' prior: 0!
A desktop view for the list of references of a given business object, adequate to be included in the confirmation popup for the deletion of that object. 
My model is the business object whose deletion is asked.!

BOReferencesDeletionView class
	uses: TBuildWindowFromPane classTrait + TListPane classTrait
	instanceVariableNames: ''!

!BOReferencesDeletionView methodsFor: 'ui building' stamp: 'CarlosLombardi 5/26/2015 15:55'!
buildPane
	"builds a pane including all the elements to show"

	| titleMorph pane |
	self model referencesToMe isEmpty 
	ifTrue: [ ^'No registra referencias.' asMorph width: 500 ; yourself ]
	ifFalse: [ 
		titleMorph := 'Registra las siguientes referencias' asMorph width: 500 ; yourself .
		pane := self uiBuilder newColumn: { titleMorph .  self buildColumnSpacer: 10 . self buildList }.
		^pane cellInset: 0 ; yourself . 
	]
! !

!BOReferencesDeletionView methodsFor: 'ui building' stamp: 'CarlosLombardi 5/26/2015 15:47'!
buildRowFor: anObject
	"creates and answers a row for my morph list, representing anObject"

	^anObject description asMorph width: 500 ; yourself! !

!BOReferencesDeletionView methodsFor: 'ui building' stamp: 'CarlosLombardi 5/26/2015 15:39'!
helpText
	"the help text to be shown in the list"

	^'Referencias'! !

!BOReferencesDeletionView methodsFor: 'initialize-release' stamp: 'CarlosLombardi 5/26/2015 15:57'!
initialize
	"preparation for life"

	super initialize.
	self rowDecorator: LineRowDecorator new .
! !

!BOReferencesDeletionView methodsFor: 'list' stamp: 'CarlosLombardi 5/26/2015 15:39'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model referencesToMe! !

!BOReferencesDeletionView methodsFor: 'accessing' stamp: 'CarlosLombardi 5/26/2015 15:50'!
windowTitle
	"..."

	^'Referencias a ', self model name! !

!BaseMorphListEditor methodsFor: 'ui building' stamp: 'CLom 12/22/2014 02:43'!
buildList
	"build a UI component to show the list"

	| list |
	list := self uiBuilder
		newMorphListFor: self
		list: #morphList
		getSelected: #selectedIndex
		setSelected: #selectedIndex:
		help: self helpText.
	list getMenuSelector: #fillListMenu:.
	^ list! !

!BaseMorphListEditor methodsFor: 'list' stamp: 'CarlosLombardi 5/25/2015 21:13'!
buildMorphList
	"build the list of morphs to show, invoked whenever this list is needed"
	
	| rawRow |
	^self objectsToShow withIndexCollect: [ :objToShow :ix | 
		rawRow := self buildRowFor: objToShow .
		self rowDecorator decoratedRowFor: rawRow inOrder: ix .
	]
! !

!BaseMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 4/28/2014 00:37'!
buildRowFor: anObject
	"creates and answers a row for my morph list, representing anObject"
	
	self subclassResponsibility 
! !

!BaseMorphListEditor methodsFor: 'ui building' stamp: 'CLom 12/22/2014 02:46'!
fillListMenu: aMenu
	"fills the right-button menu corresponding to my list. Do nothing by default"

	^aMenu! !

!BaseMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 4/28/2014 00:07'!
helpText
	"the help text to be shown in the list"

	self subclassResponsibility ! !

!BaseMorphListEditor methodsFor: 'initialize-release' stamp: 'CarlosLombardi 5/24/2015 21:27'!
initialize
	"preparation for life"

	super initialize.
	rowDecorator := TrivialRowDecorator new .! !

!BaseMorphListEditor methodsFor: 'list' stamp: 'CLom 12/22/2014 02:31'!
invalidateList
	"the list must be rebuilt"
	morphList := nil.
	self selectedIndex: 0.
	self changed: #morphList! !

!BaseMorphListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/13/2014 14:37'!
morphList
	"the list of morphs to show"
	
	morphList isNil ifTrue: [ morphList := self buildMorphList ].
	^morphList! !

!BaseMorphListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/13/2014 14:17'!
objectList
	"the list of objects to render"

	^self morphList collect: [ :morph | morph model ]! !

!BaseMorphListEditor methodsFor: 'list' stamp: 'CLom 11/22/2014 12:15'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	self subclassResponsibility! !

!BaseMorphListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 21:19'!
rowDecorator
	"the object which applies a decoration on each row"

	^rowDecorator ! !

!BaseMorphListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 22:18'!
rowDecorator: anObject
	rowDecorator := anObject! !

BaseMorphListEditor subclass: #BuyingEventDetailView
	uses: TBuildWindowFromPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingEventDetailView commentStamp: '<historical>' prior: 0!
I am a view of a BuyingEvent.

Model: the BuyingEvent.
Objects to show in the list: my model details.!

BuyingEventDetailView class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!BuyingEventDetailView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 16:29'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildUpperTitleBox . self buildTitleBox . self buildList . self buildTotalsRow }) 
		cellInset: 0 ; yourself.
! !

!BuyingEventDetailView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 03:43'!
buildRowFor: aDetail
	"creates and answers a row for my morph list, representing aDetail"

	| newRow |
	newRow := self newRowFor: aDetail.
	newRow 
		addMorphBack: 
			( aDetail element name asMorph width: 200 ; yourself ) ; 
		addMorphBack: 
			( aDetail quantity asString asMorph width: 60 ; yourself ) ; 
		addMorphBack: 
			( aDetail element stockUnit asString asMorph width: 80 ; yourself ) ; 
		addMorphBack: 
			( aDetail unitPrice asString asMorph width: 80 ; yourself ) ;
		addMorphBack: 
			( aDetail totalAmount asString asMorph width: 100 ; yourself ) .
	^newRow 
! !

!BuyingEventDetailView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 03:44'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Reactivo o consumible' width: 200 ;
		addString: 'Cantidad ' width: 148 ; 
		addString: 'Precio\unitario' width: 80 ;
		addString: 'Importe' width: 100.
	^titleBuilder titleBox
! !

!BuyingEventDetailView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 16:39'!
buildTotalsRow
	"build a row with totals to show below the detail list"

	| titleBuilder totalQuantityField totalAmountField detailAmountField extraAmountField totalLabel extraAmountLabel totalAmountLabel labelWidth labelOffset |

	titleBuilder := TitleBuilder new.

	totalLabel := 'Totales' asMorph width: 200 ; yourself.
	extraAmountLabel := 'Importe adicional' asMorph.
	totalAmountLabel := 'Importe total' asMorph.
	
	totalQuantityField := self
		buildDynamicTextFor: self
		get: [:view | view modelValueAsString: #totalQuantity ]
		class: String
		width: 236.
	totalQuantityField setNameTo: 'eventTotalQuantity'.
	detailAmountField := self
		buildDynamicTextFor: self
		get: [:view | view modelValueAsString: #detailAmount ]
		class: String
		width: 100.
	detailAmountField setNameTo: 'eventDetailAmount'.
	extraAmountField := self
		buildDynamicTextFor: self
		get: [:view | view modelValueAsString: #extraAmount ]
		class: String
		width: 100.
	extraAmountField setNameTo: 'eventExtraAmount'.
	totalAmountField := self
		buildDynamicTextFor: self
		get: [:view | view modelValueAsString: #totalAmount ]
		class: String
		width: 100.
	totalAmountField setNameTo: 'eventTotalAmount'.

	titleBuilder addMorph: totalLabel ;
		addMorph: totalQuantityField ;
		addMorph: detailAmountField ;
		cr.
	labelWidth := (extraAmountLabel width max: totalAmountLabel width) + 10.
	labelOffset := 436 - labelWidth.
	titleBuilder 
		addMorph: (self buildRowSpacer: labelOffset) ;
		addMorph: (extraAmountLabel width: labelWidth ; yourself) ;
		addMorph: extraAmountField ; cr ;
		addMorph: (self buildRowSpacer: labelOffset) ;
		addMorph: (totalAmountLabel width: labelWidth ; yourself) ;
		addMorph: totalAmountField.
	^titleBuilder titleBox
! !

!BuyingEventDetailView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 11:34'!
buildUpperTitleBox
	"creates and answers the morph to include over the title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder	
		addMorph: ('Detalle del evento seleccionado' asMorph color: Color blue ; yourself)
		centeredInWidth: 552.
	^titleBuilder titleBox
		fillStyle: Color lightBlue ; borderColor: Color darkGray ;
		height: 25; yourself.
		
! !

!BuyingEventDetailView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 16:30'!
helpText
	"the help text to be shown in the list"

	^'Detalle de una compra de reactivos y/o consumibles'! !

!BuyingEventDetailView methodsFor: 'model accessing' stamp: 'CLom 12/27/2014 16:29'!
model: obj
	"set the object I edit"

	super model: obj.
	self updateView .! !

!BuyingEventDetailView methodsFor: 'list' stamp: 'CLom 12/27/2014 03:42'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model ifNil: [ #() ] ifNotNil: [ :event | event details	].
! !

!BuyingEventDetailView methodsFor: 'actions' stamp: 'CLom 12/27/2014 16:27'!
updateView
	"update my view as a result of an external change"

	window ifNotNil: [ 
		self invalidateList.
		(self window submorphNamed: 'eventTotalQuantity') textChanged.
		(self window submorphNamed: 'eventDetailAmount') textChanged.
		(self window submorphNamed: 'eventExtraAmount') textChanged.
		(self window submorphNamed: 'eventTotalAmount') textChanged.
	].

! !

!BuyingEventDetailView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 16:59'!
windowTitle
	"..."

	^'Compra de reactivos y/o consumibles', 
		(self model ifNil: [''] ifNotNil: [' - fecha: ', self model date asString])! !

BaseMorphListEditor subclass: #BuyingEventListView
	instanceVariableNames: 'eventDetailView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingEventListView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 17:01'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildTitleBox . self buildList }) 
		cellInset: 0 ; yourself.
! !

!BuyingEventListView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 16:52'!
buildRowFor: buying
	"creates and answers a row for my morph list, representing the given ReagentBuyingEvent, buying."

	| newRow |
	newRow := self newRowFor: buying.
	newRow 
		addMorphBack: 
			( (self dateConverter objectAsString: buying date) asMorph width: 80 ; yourself ) ; 
		addMorphBack: 
			( buying provider name asMorph width: 100 ; yourself ) ;
		addMorphBack: 
			( buying details size asString asMorph width: 40 ; yourself ) ;
		addMorphBack: 
			( buying totalQuantity asString asMorph width: 60 ; yourself ) ;
		addMorphBack: 
			( buying totalAmount asString asMorph width: 100 ; yourself ) .
	^newRow 
! !

!BuyingEventListView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 16:57'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Fecha' width: 80 ;
		addString: 'Proveedor' width: 100 ;
		addString: 'Artíc.' width: 40 ; 
		addString: 'Cantidad' width: 60 ;
		addString: 'Importe' width: 100.
	^titleBuilder titleBox
! !

!BuyingEventListView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 17:00'!
buildWindow
	"builds and returns the editing window"

	| newWindow |
	self initializeViews.
		
	newWindow := StandardWindow labelled: self windowTitle.
	
	newWindow addMorph: self buildPane frame: (0 @ 0 corner: 1 @ 0.48).
	newWindow addMorph: eventDetailView buildPane frame: (0 @ 0.52 corner: 1 @ 1).
	
	newWindow width: 980 ; height: 650.

	^ newWindow
! !

!BuyingEventListView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 17:02'!
helpText
	"the help text to be shown in the list"

	^'Compras de reactivos y/o consumibles'! !

!BuyingEventListView methodsFor: 'initialize-release' stamp: 'CLom 12/27/2014 16:58'!
initializeViews
	"Create the views for each of my panes."

	eventDetailView := BuyingEventDetailView for: self selectedObject.
	
! !

!BuyingEventListView methodsFor: 'list' stamp: 'CLom 12/27/2014 16:45'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^EventQuery new
		lab: self model ; addToExplicitConditions: [ :event | event isABuying ] ;
		forSortEventsByReversedDate ;
		events.
! !

!BuyingEventListView methodsFor: 'accessing' stamp: 'CLom 12/27/2014 17:01'!
selectedIndex: anObject
	"the selected item has changed"

	super selectedIndex: anObject .
	eventDetailView ifNotNil: [ :eventView | eventView model: self selectedObject. ].
! !

!BuyingEventListView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 17:02'!
window: aWindow
	"the reference window where I do my rendering"

	super window: aWindow.
	eventDetailView window: aWindow.
! !

!BuyingEventListView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 17:03'!
windowTitle
	"..."

	^'Compras de reactivos y/o consumibles'! !

BaseMorphListEditor subclass: #BuyingProposalDetailView
	uses: TBuildWindowFromPane + TUIGoodies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingProposalDetailView commentStamp: '<historical>' prior: 0!
A view of the details of a given BuyingProposal.

Model: the BuyingProposal.
Objects to show: model details.!

BuyingProposalDetailView class
	uses: TBuildWindowFromPane classTrait + TUIGoodies classTrait
	instanceVariableNames: ''!

!BuyingProposalDetailView methodsFor: 'ui building' stamp: 'CLom 11/24/2014 20:46'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildUpperTitleBox . self buildTitleBox . self buildList . self buildTotalsRow }) 
		cellInset: 0 ; yourself.
! !

!BuyingProposalDetailView methodsFor: 'ui building' stamp: 'CLom 11/25/2014 19:43'!
buildRowFor: aCurrentDetail
	"creates and answers a row for my morph list, representing aCurrentDetail"

	| newRow |
	newRow := self newRowFor: aCurrentDetail.
	newRow 
		addMorphBack: 
			( aCurrentDetail element name asMorph width: 180 ; yourself ) ; 
		addMorphBack: 
			( (StringMorph contents: aCurrentDetail quantity asString) width: 60 ; yourself ) ;
		addMorphBack: 
			( (StringMorph contents: aCurrentDetail element stockUnit asString) width: 80 ; yourself ) ;
		addMorphBack: 
			( (StringMorph contents: aCurrentDetail unitPrice asString) width: 80 ; yourself ) ;
		addMorphBack: 
			( (StringMorph contents: aCurrentDetail totalAmount asString) width: 80 ; yourself ).
	^newRow 
! !

!BuyingProposalDetailView methodsFor: 'ui building' stamp: 'CLom 11/25/2014 19:43'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Reactivo o consumible' width: 180 ;
		addString: 'Cantidad' width: 148 ; 
		addString: 'Precio\unitario' width: 80 ;
		addString: 'Importe' width: 80.
	^titleBuilder titleBox
! !

!BuyingProposalDetailView methodsFor: 'ui building' stamp: 'CLom 12/22/2014 01:21'!
buildTotalsRow
	"build a row with totals to show below the detail list"

	| titleBuilder totalQuantityField totalAmountField |
	titleBuilder := TitleBuilder new.
	titleBuilder addString: 'Totales: ' width: 180.
	totalQuantityField := self
		buildDynamicTextFor: self
		get: #totalQuantityString
		class: String
		width: 236.
	totalQuantityField setNameTo: 'proposalTotalQuantity'.
	totalAmountField := self
		buildDynamicTextFor: self
		get: #totalAmountString
		class: String
		width: 80.
	totalAmountField setNameTo: 'proposalTotalAmount'.

	titleBuilder addMorph: totalQuantityField.
	titleBuilder addMorph: totalAmountField.
	^ titleBuilder titleBox! !

!BuyingProposalDetailView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 11:35'!
buildUpperTitleBox
	"creates and answers the morph to include as upper title box (above the column titles)"

	| outerMorph innerMorph |
	outerMorph := PanelMorph new
		fillStyle: Color lightBlue ; borderColor: Color darkGray;
		borderWidth: 2;
		changeTableLayout;
		height: 25;	width: 1; hResizing: #spaceFill; vResizing: #rigid;
		cellPositioning: #center;
		listDirection: #leftToRight;
		layoutInset: 2; cellInset: 8;
		yourself.
	innerMorph := self buildDynamicTextFor: self get: #providerName class: String width: 	1.
	innerMorph 
		cellPositioning: #topCenter ; hResizing: #shrinkWrap; vResizing: #shrinkWrap;
		textColor: Color blue.
	innerMorph setNameTo: 'proposalProviderName'.
	innerMorph textChanged.  "to force the DynamicText to use the textColor set after the contents"
	outerMorph 
		addMorphBack: self buildRowFillSpacer ;
		addMorphBack: innerMorph ;
		addMorphBack: self buildRowFillSpacer .
	^ outerMorph
	! !

!BuyingProposalDetailView methodsFor: 'ui building' stamp: 'CLom 11/23/2014 12:51'!
helpText
	"the help text to be shown in the list"

	^'Detalle de una propuesta de compra'! !

!BuyingProposalDetailView methodsFor: 'list' stamp: 'CLom 11/23/2014 16:43'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model 
		ifNil: [ OrderedCollection new ]
		ifNotNil: [:proposal | 
			proposal details asSortedCollection: [ :det1 :det2 | det1 totalAmount >= det2 totalAmount ] 
				].
! !

!BuyingProposalDetailView methodsFor: 'model accessing' stamp: 'CLom 11/24/2014 20:56'!
providerName
	"the string to show corresponding to the total amount of the proposal being shown"
	^ 'Posible compra a proveedor: ', 
	(self model ifNil: '' ifNotNil: [ :proposal | proposal provider name ])! !

!BuyingProposalDetailView methodsFor: 'ui accessing' stamp: 'CLom 11/24/2014 20:54'!
providerNameField
	"the field in my form corresponding to the total amount of the proposal"

	^self window submorphNamed: 'proposalProviderName'! !

!BuyingProposalDetailView methodsFor: 'ui accessing' stamp: 'CLom 11/24/2014 01:17'!
totalAmountField
	"the field in my form corresponding to the total amount of the proposal"

	^self window submorphNamed: 'proposalTotalAmount'! !

!BuyingProposalDetailView methodsFor: 'model accessing' stamp: 'CLom 11/24/2014 01:07'!
totalAmountString
	"the string to show corresponding to the total amount of the proposal being shown"
	^ self model ifNil: '' ifNotNil: [ :proposal | proposal totalAmount asString ]! !

!BuyingProposalDetailView methodsFor: 'ui accessing' stamp: 'CLom 11/24/2014 01:18'!
totalQuantityField
	"the field in my form corresponding to the total quantity of the proposal"

	^self window submorphNamed: 'proposalTotalQuantity'! !

!BuyingProposalDetailView methodsFor: 'model accessing' stamp: 'CLom 11/24/2014 01:07'!
totalQuantityString
	"the string to show corresponding to the total quantity of the proposal being shown"
	^ self model ifNil: '' ifNotNil: [ :proposal | proposal totalQuantity asString ]! !

!BuyingProposalDetailView methodsFor: 'actions' stamp: 'CLom 11/24/2014 20:55'!
updateView
	"update my view as a result of an external change"

	self invalidateList.
	self providerNameField textChanged.
	self totalQuantityField textChanged.
	self totalAmountField textChanged.! !

!BuyingProposalDetailView methodsFor: 'ui building' stamp: 'CLom 11/23/2014 12:57'!
windowTitle
	"..."

	^'Propuesta de compra - ', self model provider name! !

BaseMorphListEditor subclass: #BuyingRequirementListView
	instanceVariableNames: 'requirementDetailView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingRequirementListView commentStamp: '<historical>' prior: 0!
A view of the registered BuyingRequirements.

Model: the lab.
Objects to show: the BuyingRequirements registered for the given lab.
!

!BuyingRequirementListView methodsFor: 'ui building' stamp: 'CLom 11/24/2014 21:30'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildTitleBox . self buildList }) 
		cellInset: 0 ; yourself.
! !

!BuyingRequirementListView methodsFor: 'ui building' stamp: 'CLom 11/25/2014 19:35'!
buildRowFor: req
	"creates and answers a row for my morph list, representing the given BuyingRequirement, req."

	| newRow pend descriptor |
	newRow := self newRowFor: req.
	pend := req pendingState.
	descriptor := BuyingRequirementDescriptor for: req.
	descriptor forAllDetails ; addRelevantDetails: 2.
	newRow 
		addMorphBack: 
			( (self dateConverter objectAsString: req date) asMorph width: 100 ; yourself ) ; 
		addMorphBack: 
			( pend details size asString asMorph width: 40 ; yourself ) ;
		addMorphBack: 
			( pend totalQuantity asString asMorph width: 60 ; yourself ) ;
		addMorphBack: 
			( req details size asString asMorph width: 40 ; yourself ) ;
		addMorphBack: 
			( req totalQuantity asString asMorph width: 60 ; yourself ) ;
		addMorphBack: 
			( descriptor stringDescription asMorph width: 500 ; yourself ) .
	^newRow 
! !

!BuyingRequirementListView methodsFor: 'ui building' stamp: 'CLom 12/17/2014 23:48'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder outer bottomRow twoLineBlock |

	twoLineBlock := [ :upperText |
		outer := self buildEmptyColumn.
		outer layoutInset: 0 ; cellInset: 0.
		outer addMorphBack: (self stringMorphFor: upperText centeredInWidth: 100) ;
			addMorphBack: (self buildRowSpacer: 2).
		bottomRow := self buildEmptyRow.
		bottomRow layoutInset: 0 ; cellInset: 0.
		bottomRow 
			addMorphBack: ('Artíc.' asMorph width: 40 ; yourself) ;
			addMorphBack: (self buildRowSpacer: 8) ;
			addMorphBack: ('Cantidad' asMorph width: 60 ; yourself).
		outer addMorphBack: bottomRow.
		outer hResizing: #shrinkWrap ;	vResizing: #shrinkWrap ; yourself
	].
	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Fecha' width: 100 ;
		addMorph: (twoLineBlock value: 'Pendiente') ;
		addMorph: (twoLineBlock value: 'Original') ;
"		addString: 'Artíc.' width: 40 ; 
		addString: 'Cantidad' width: 60 ;
		addString: 'Artíc.' width: 40 ; 
		addString: 'Cantidad' width: 60 ;"
		addString: 'Descripción' width: 500.
	^titleBuilder titleBox
! !

!BuyingRequirementListView methodsFor: 'ui building' stamp: 'CLom 12/18/2014 00:08'!
buildWindow
	"builds and returns the editing window"

	| newWindow |
	self initializeViews.
		
	newWindow := StandardWindow labelled: self windowTitle.
	
	newWindow addMorph: self buildPane frame: (0 @ 0 corner: 1 @ 0.48).
	newWindow addMorph: requirementDetailView buildPane frame: (0 @ 0.52 corner: 1 @ 1).
	
	newWindow width: 980 ; height: 650.

	^ newWindow
! !

!BuyingRequirementListView methodsFor: 'menu' stamp: 'CLom 12/22/2014 02:48'!
fillListMenu: aMenu 
	"fills the menu for the UI rendered by me"
	
	self thereIsSomethingSelected ifTrue: [ 
		aMenu
			add: 'ver detalle del pedido' action: #viewRequirementDetailedState.
	].
	^aMenu! !

!BuyingRequirementListView methodsFor: 'ui building' stamp: 'CLom 11/22/2014 21:08'!
helpText
	"the help text to be shown in the list"

	^'Pedidos de compra ingresados'! !

!BuyingRequirementListView methodsFor: 'initialize-release' stamp: 'CLom 12/27/2014 00:10'!
initializeViews
	"Create the views for each of my panes."

	requirementDetailView := BuyingRequirementPendingView for: self selectedObject.
	
! !

!BuyingRequirementListView methodsFor: 'list' stamp: 'CLom 11/22/2014 21:01'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^EventQuery new
		lab: self model ; addToExplicitConditions: [ :event | event isABuyingRequirement ] ;
		forSortEventsByReversedDate ;
		events.
! !

!BuyingRequirementListView methodsFor: 'accessing' stamp: 'CLom 12/22/2014 02:23'!
selectedIndex: anObject
	"the selected item has changed"

	super selectedIndex: anObject .
	requirementDetailView ifNotNil: [ :reqView | reqView model: self selectedObject pendingState. ].
! !

!BuyingRequirementListView methodsFor: 'menu' stamp: 'CLom 12/22/2014 02:48'!
viewRequirementDetailedState
	"open a (non-modal) window showing full details of the selected requirement"
	
	(BuyingRequirementStateView for: self selectedObject) open.! !

!BuyingRequirementListView methodsFor: 'ui building' stamp: 'CLom 12/22/2014 02:30'!
window: aWindow
	"the reference window where I do my rendering"

	super window: aWindow.
	requirementDetailView window: aWindow.
! !

!BuyingRequirementListView methodsFor: 'ui building' stamp: 'CLom 11/22/2014 21:07'!
windowTitle
	"..."

	^'Pedidos de compra ingresados'! !

BaseMorphListEditor subclass: #BuyingRequirementPendingView
	uses: TBuildWindowFromPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingRequirementPendingView commentStamp: '<historical>' prior: 0!
A view of the current state of each of the details of a given BuyingRequirement.

Model: the BuyingRequirement.
Objects to show: model currentDetails.!

BuyingRequirementPendingView class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!BuyingRequirementPendingView methodsFor: 'ui building' stamp: 'CLom 11/24/2014 21:25'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildUpperTitleBox . self buildTitleBox . self buildList . self buildTotalsRow }) 
		cellInset: 0 ; yourself.
! !

!BuyingRequirementPendingView methodsFor: 'ui building' stamp: 'CLom 12/22/2014 02:26'!
buildRowFor: aPendingDetail
	"creates and answers a row for my morph list, representing aCurrentDetail"

	| newRow |
	newRow := self newRowFor: aPendingDetail.
	newRow 
		addMorphBack: 
			( aPendingDetail element name asMorph width: 200 ; yourself ) ; 
		addMorphBack: 
			( aPendingDetail quantity asString asMorph width: 60 ; yourself ) ; 
		addMorphBack: 
			( aPendingDetail element stockUnit asString asMorph width: 80 ; yourself ) ; 
		addMorphBack: 
			( aPendingDetail unitPrice asString asMorph width: 80 ; yourself ) ;
		addMorphBack: 
			( aPendingDetail totalAmount asString asMorph width: 100 ; yourself ) ;
		addMorphBack: 
			( aPendingDetail originalQuantity asString asMorph width: 80 ; yourself ) ; 
		addMorphBack: 
			( aPendingDetail amountForOriginalQuantity asString asMorph width: 80 ; yourself ) .
	^newRow 
! !

!BuyingRequirementPendingView methodsFor: 'ui building' stamp: 'CLom 11/25/2014 19:35'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Reactivo o consumible' width: 200 ;
		addString: 'Cantidad pendiente' width: 148 ; 
		addString: 'Precio\unitario' width: 80 ;
		addString: 'Importe\pendiente' width: 100 ;
		addString: 'Cantidad\original' width: 80 ; 
		addString: 'Importe\original' width: 80 .
	^titleBuilder titleBox
! !

!BuyingRequirementPendingView methodsFor: 'ui building' stamp: 'CLom 12/22/2014 02:05'!
buildTotalsRow
	"build a row with totals to show below the detail list"

	| titleBuilder twoNumbersBlock detailCountField totalQuantityField totalAmountField originalQuantityField originalAmountField |

	titleBuilder := TitleBuilder new.
	twoNumbersBlock := [ :n1 :n2 | n1 asString, ' (', n2 asString, ')' ].

	detailCountField := self
		buildDynamicTextFor: self 
		get: [:view | 'Totales: ', (twoNumbersBlock 
						value: (view modelValueAsString: [:pendState | pendState details size])
						value: (view modelValueAsString: [:pendState | pendState details size + pendState fulfilledDetails size])) , 
					' artículos' ]
		class: String
		width: 200.
	detailCountField setNameTo: 'pendintDetailCountField'.
	totalQuantityField := self
		buildDynamicTextFor: self
		get: [:view | view modelValueAsString: #totalQuantity ]
		class: String
		width: 236.
	totalQuantityField setNameTo: 'pendingTotalQuantity'.
	totalAmountField := self
		buildDynamicTextFor: self
		get: [:view | view modelValueAsString: #totalAmount ]
		class: String
		width: 100.
	totalAmountField setNameTo: 'pendingTotalAmount'.
	originalQuantityField := self
		buildDynamicTextFor: self
		get: [:view | view modelValueAsString: #totalOriginalQuantity ]
		class: String
		width: 80.
	originalQuantityField setNameTo: 'pendingOriginalQuantity'.
	originalAmountField := self
		buildDynamicTextFor: self
		get: [:view | view modelValueAsString: #totalAmountForOriginalQuantities ]
		class: String
		width: 100.
	originalAmountField setNameTo: 'pendingOriginalAmount'.

	titleBuilder addMorph: detailCountField ;
		addMorph: totalQuantityField ;
		addMorph: totalAmountField ;
		addMorph: originalQuantityField ;
		addMorph: originalAmountField.
	^titleBuilder titleBox
! !

!BuyingRequirementPendingView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 11:33'!
buildUpperTitleBox
	"creates and answers the morph to include as upper title box (above the column titles)"

	| titleBuilder |
	titleBuilder := TitleBuilder new.
	titleBuilder	
		addMorph: ('Detalle de cantidades pendientes y originales' asMorph color: Color blue ; yourself)
		centeredInWidth: 728.
	^titleBuilder titleBox
		fillStyle: Color lightBlue ; borderColor: Color darkGray ;
		height: 25; yourself.
! !

!BuyingRequirementPendingView methodsFor: 'ui building' stamp: 'CLom 11/22/2014 12:09'!
helpText
	"the help text to be shown in the list"

	^'Estado actual del detalle de un requerimiento de compra'! !

!BuyingRequirementPendingView methodsFor: 'model accessing' stamp: 'CLom 12/22/2014 02:28'!
model: obj
	"set the object I edit"

	super model: obj.
	self updateView .! !

!BuyingRequirementPendingView methodsFor: 'list' stamp: 'CLom 12/22/2014 02:01'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model ifNil: [ #() ] ifNotNil: [ :req |
		(BuyingRequirementDescriptor for: req) forAllDetails ; sortedDetails
	].
! !

!BuyingRequirementPendingView methodsFor: 'actions' stamp: 'CLom 12/22/2014 02:31'!
updateView
	"update my view as a result of an external change"

	window ifNotNil: [ 
		self invalidateList.
		(self window submorphNamed: 'pendintDetailCountField') textChanged.
		(self window submorphNamed: 'pendingTotalQuantity') textChanged.
		(self window submorphNamed: 'pendingTotalAmount') textChanged.
		(self window submorphNamed: 'pendingOriginalQuantity') textChanged.
		(self window submorphNamed: 'pendingOriginalAmount') textChanged.
	].! !

!BuyingRequirementPendingView methodsFor: 'ui building' stamp: 'CLom 11/22/2014 12:07'!
windowTitle
	"..."

	^'Pedido de compra del ', self model date asString, ' - estado actual'! !

BaseMorphListEditor subclass: #BuyingRequirementProposalsView
	uses: TBuildWindowFromPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingRequirementProposalsView commentStamp: '<historical>' prior: 0!
A view of the proposals corresponding to a given BuyingRequirement.

Model: the BuyingRequirement.
Objects to show: the BusinessProposals corresponding to each provider who can provide at least one element included in the model.
!

BuyingRequirementProposalsView class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!BuyingRequirementProposalsView methodsFor: 'ui building' stamp: 'CLom 11/24/2014 21:30'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildUpperTitleBox . self buildTitleBox . self buildList }) 
		cellInset: 0 ; yourself.
! !

!BuyingRequirementProposalsView methodsFor: 'ui building' stamp: 'CLom 11/25/2014 19:35'!
buildRowFor: aProposal
	"creates and answers a row for my morph list, representing aProposal"

	| newRow twoNumbersBlock |
	newRow := self newRowFor: aProposal.
	twoNumbersBlock := [ :n1 :n2 | n1 asString, ' (', n2 asString, ')' ].
	newRow 
		addMorphBack: 
			( aProposal provider name asMorph width: 100 ; yourself ) ; 
		addMorphBack: 
			( (StringMorph contents: aProposal details size asString) width: 60 ; yourself ) ;
		addMorphBack: 
			( (StringMorph contents: aProposal totalQuantity asString) width: 80 ; yourself ) ;
		addMorphBack: 
			( (StringMorph contents: 
				(twoNumbersBlock value: aProposal totalAmount value: aProposal normalisedTotalAmount)) 
				width: 120 ; yourself ).
	^newRow 
! !

!BuyingRequirementProposalsView methodsFor: 'ui building' stamp: 'CLom 11/25/2014 19:35'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Proveedor' width: 100 ;
		addString: 'Cantidad\artículos' width: 60 ; 
		addString: 'Total de\unidades' width: 80 ;
		addString: 'Importe\proveedor (normal)' width: 120.
	^titleBuilder titleBox
! !

!BuyingRequirementProposalsView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 11:35'!
buildUpperTitleBox
	"creates and answers the morph to include as upper title box (above the column titles)"

	| titleBuilder |
	titleBuilder := TitleBuilder new.
	titleBuilder	
		addMorph: ('Posibles proveedores para cantidades pendientes' asMorph color: Color blue; yourself)
		centeredInWidth: 384.
	^titleBuilder titleBox
		fillStyle: Color lightBlue ; borderColor: Color darkGray ;
		height: 25; yourself.

! !

!BuyingRequirementProposalsView methodsFor: 'ui building' stamp: 'CLom 11/22/2014 21:08'!
helpText
	"the help text to be shown in the list"

	^'Proveedores que pueden satisfacer este pedido de compra'! !

!BuyingRequirementProposalsView methodsFor: 'initialize-release' stamp: 'CLom 11/23/2014 16:56'!
initialize
	"preparation for life"

	super initialize.
	self additionalEventOnSelectionChange: #proposalSelectionChange.! !

!BuyingRequirementProposalsView methodsFor: 'list' stamp: 'CLom 12/17/2014 23:51'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	| proposals |
	proposals := self model lab providers collect: [ :provider |  
		self model buyingProposalForProvider: provider.
	].
	proposals := proposals reject: [ :prop | prop isNil ].
	^proposals asSortedCollection: [ :prop1 :prop2 | 
		(prop1 normalisedTotalAmount > prop2 normalisedTotalAmount) | 
		((prop1 normalisedTotalAmount = prop2 normalisedTotalAmount) & (prop1 totalAmount <= prop2 totalAmount))
	].! !

!BuyingRequirementProposalsView methodsFor: 'ui building' stamp: 'CLom 11/22/2014 21:07'!
windowTitle
	"..."

	^'Pedido de compra del ', self model date asString, ' - proveedores'! !

BaseMorphListEditor subclass: #BuyingRequirementSatisfactionView
	uses: TBuildWindowFromPane
	instanceVariableNames: 'eventsAndDetails totalQuantity totalAmount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingRequirementSatisfactionView commentStamp: '<historical>' prior: 0!
A view of the satisfaction of a given BuyingRequirement.

Model: the BuyingRequirement.
Objects to show: each detail of a BuyingRequirementSatisfaction corresponding to my model.!

BuyingRequirementSatisfactionView class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!BuyingRequirementSatisfactionView class methodsFor: 'testing' stamp: 'CLom 12/13/2014 18:31'!
isAbstractClass
	self shouldBeImplemented! !

!BuyingRequirementSatisfactionView methodsFor: 'ui building' stamp: 'CLom 12/13/2014 18:50'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildUpperTitleBox . self buildTitleBox . self buildList . self buildTotalsRow }) 
		cellInset: 0 ; yourself.
! !

!BuyingRequirementSatisfactionView methodsFor: 'ui building' stamp: 'CLom 12/17/2014 10:19'!
buildRowFor: anAssociation
	"creates and answers a row for my morph list, representing anAssociation.
	 Remember from >>objectsToShow, the key is either a BuyingEvent or nil, the value is the detail to show."

	| newRow event detail |
	event := anAssociation key.
	detail := anAssociation value.
	newRow := self newRowFor: detail.
	event ifNotNil: [ 
		newRow 
			addMorphBack: 
				( (self dateConverter objectAsString: event date) asMorph width: 120 ; yourself ) ; 
			addMorphBack: 
				( event provider name asString asMorph width: 100 ; yourself ) .
	]
	ifNil: [
		newRow addMorphBack: ('' asMorph width: 228 ; yourself ). 
	].
	newRow 
		addMorphBack: 
			( detail element name asMorph width: 200 ; yourself ) ; 
		addMorphBack: 
			( detail quantity asString asMorph width: 60 ; yourself ) ; 
		addMorphBack: 
			( detail element stockUnit asString asMorph width: 80 ; yourself ) ; 
		addMorphBack: 
			( detail unitPrice asString asMorph width: 80 ; yourself ) ;
		addMorphBack: 
			( detail totalAmount asString asMorph width: 100 ; yourself ) .
	^newRow 
! !

!BuyingRequirementSatisfactionView methodsFor: 'ui building' stamp: 'CLom 12/13/2014 18:53'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Fecha' width: 120 ;
		addString: 'Proveedor' width: 100 ;
		addString: 'Reactivo o consumible' width: 200 ;
		addString: 'Cantidad' width: 148 ; 
		addString: 'Precio\unitario' width: 80 ;
		addString: 'Importe' width: 100.
	^titleBuilder titleBox
! !

!BuyingRequirementSatisfactionView methodsFor: 'ui building' stamp: 'CLom 12/22/2014 02:57'!
buildTotalsRow
	"build a row with totals to show below the detail list"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder	
		addString: 'Totales: ' width: 436 .
	eventsAndDetails 
	ifEmpty: [ titleBuilder addString: '' width: 328 ] 
	ifNotEmpty: [ 
		titleBuilder	
			addString: self totalQuantity asString width: 60 ;
			addString: '' width: 168 ;
			addString: self totalAmount asString width: 100 .
	].
	^titleBuilder titleBox
! !

!BuyingRequirementSatisfactionView methodsFor: 'ui building' stamp: 'CLom 12/27/2014 11:36'!
buildUpperTitleBox
	"creates and answers the morph to include as upper title box (above the column titles)"

	| titleBuilder |
	titleBuilder := TitleBuilder new.
	titleBuilder	
		addMorph: ('Detalle de compras que satisfacen este pedido' asMorph color: Color blue; yourself)
		centeredInWidth: 788.
	^titleBuilder titleBox
		fillStyle: Color lightBlue ; borderColor: Color darkGray ;
		height: 25; yourself.
		! !

!BuyingRequirementSatisfactionView methodsFor: 'list' stamp: 'CLom 12/22/2014 02:50'!
computeValues
	"Compute the objects and totals to show.
	 Each object is an association where the key is either nil or a BuyingEvent, and the value is a satisfaction detail.
 	 More specifically, the key is the event for the first detail of each satisfaction.
	 Event information will be shown for the objects having a non-nil key."

	| satisfactions dets |
	eventsAndDetails ifNil: [ 
		satisfactions := EventQuery new 
			lab: self model lab ; addToExplicitConditions: [ :event | event isABuyingRequirementSatisfaction ] ;
			addToExplicitConditions: [ :event | event buyingRequirement = self model ] ; forSortEventsByDate ;
			events.
		eventsAndDetails := satisfactions inject: OrderedCollection new
			into: [ :result :satis |
				dets := satis details asSortedCollection: [ :det1 :det2 | det1 totalAmount > det2 totalAmount ].
				result add: satis buyingEvent -> dets first ;
					addAll: (dets allButFirst collect: [:det | nil -> det] ) ; yourself.
				].
		eventsAndDetails 
			ifEmpty:  [ totalQuantity := 0 . totalAmount := 0 ]
			ifNotEmpty: [ 
				totalQuantity := eventsAndDetails sum: [ :ed | ed value quantity ].
				totalAmount := eventsAndDetails sum: [ :ed | ed value totalAmount ].
			].
	].
! !

!BuyingRequirementSatisfactionView methodsFor: 'ui building' stamp: 'CLom 12/13/2014 18:49'!
helpText
	"the help text to be shown in the list"

	^'Compras que satisfacen este pedido'! !

!BuyingRequirementSatisfactionView methodsFor: 'list' stamp: 'CLom 12/13/2014 19:28'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method.
	 Each object is an association where the key is either nil or a BuyingEvent, and the value is a satisfaction detail.
 	 More specifically, the key is the event for the first detail of each satisfaction.
	 Event information will be shown for the objects having a non-nil key."

	self computeValues.
	^eventsAndDetails ! !

!BuyingRequirementSatisfactionView methodsFor: 'accessing' stamp: 'CLom 12/13/2014 19:29'!
totalAmount
	"the total amount for the shown details"

	self computeValues.
	^totalAmount! !

!BuyingRequirementSatisfactionView methodsFor: 'accessing' stamp: 'CLom 12/13/2014 19:29'!
totalQuantity
	"the total quantity for the shown details"

	self computeValues.
	^totalQuantity! !

!BuyingRequirementSatisfactionView methodsFor: 'ui building' stamp: 'CLom 12/13/2014 19:01'!
windowTitle
	"..."

	^'Pedido de compra del ', self model date asString, ' - estado actual'! !

BaseMorphListEditor subclass: #ConsumableMorphListEditor
	uses: TBuildWindowFromPane + TEditObjectInListButtons + TBusinessObjectEditionInList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ConsumableMorphListEditor commentStamp: '<historical>' prior: 0!
A window to edit the list of consumables of a Lab. !

ConsumableMorphListEditor class
	uses: TBuildWindowFromPane classTrait + TEditObjectInListButtons classTrait + TBusinessObjectEditionInList classTrait
	instanceVariableNames: ''!

!ConsumableMorphListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 10:16'!
addNewBusinessObject: aConsumable
	"..."

	self model addToConsumables: aConsumable! !

!ConsumableMorphListEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 11:20'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildTitleBox . self buildList . self buildButtonBar }) 
		cellInset: 0 ; yourself.
! !

!ConsumableMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 4/28/2014 18:52'!
buildRowFor: aReagent
	"creates and answers a row for my morph list, representing aReagent"

	| newRow rowBuilder |
	newRow := self newRowFor: aReagent.
	rowBuilder := StockElementUIComponentBuilder new.
	rowBuilder element: aReagent ; lab: self model.
	rowBuilder 
		addNameColumnTo: newRow ;
		addCurrentStockColumnTo: newRow ;
		addCurrentPriceColumnTo: newRow .
	^newRow 
! !

!ConsumableMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 4/27/2014 23:30'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Nombre' width: 200 ;
		addString: 'Stock' width: 80 ; 
		addString: 'Ult. precio\compra' width: 120.
	^titleBuilder titleBox
! !

!ConsumableMorphListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 10:29'!
createBusinessObjectEditorFor: aConsumable
	"..."

	| newEditController |
	newEditController := ConsumableEditController new.
	newEditController consumable: aConsumable lab: self model.
	^ConsumableEditor for: newEditController! !

!ConsumableMorphListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 10:17'!
createNewBusinessObject
	"..."

	^Consumable new.
! !

!ConsumableMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 4/28/2014 00:09'!
helpText
	"the help text to be shown in the list"

	^'Consumibles de este Laboratorio'! !

!ConsumableMorphListEditor methodsFor: 'list' stamp: 'CarlosLombardi 4/28/2014 00:31'!
objectsToShow
	"the list of objects to be rendered, in the proper order"

	^self model consumables asSortedCollection: [ :r1 :r2 | r1 name asUppercase <= r2 name asUppercase ]! !

!ConsumableMorphListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 10:17'!
removeBusinessObject: aConsumable
	"..."

	self model removeFromConsumables: aConsumable! !

!ConsumableMorphListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 10:19'!
textForRemoveBusinessObjectConfirmation: aConsumable
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	textBuilder 
		nextPutAll: 'Confirmar eliminación del ' ; 
		nextPutAll: 'siguiente consumible' ; cr ; 
		nextPutAll: 'Nombre : ' ; nextPutAll: aConsumable name.
	^textBuilder contents
! !

!ConsumableMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 4/28/2014 13:07'!
windowTitle
	"..."

	^'Lista de Consumibles'! !

BaseMorphListEditor subclass: #EstimatedLogEntriesList
	uses: TBuildWindowFromPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!EstimatedLogEntriesList commentStamp: '<historical>' prior: 0!
An EstimatedLogEntriesList is xxxxxxxxx.
!

EstimatedLogEntriesList class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!EstimatedLogEntriesList methodsFor: 'accessing' stamp: 'EstebanTolaba 10/31/2015 15:23'!
buildRowFor: aLogEntry
	"creates and answers a row for my morph list, representing aLabProject"

	| newRow |
	newRow := self newRowFor: aLogEntry.
	newRow addMorphBack: 
			( aLogEntry description asMorph width: 350 ; yourself ) ;
		addMorphBack:  (aLogEntry loadDate printFormat: #(1 2 3 $/ 1 1 2)) asMorph;
		addMorphBack:  ('            ',(aLogEntry toDoDate printFormat: #(1 2 3 $/ 1 1 2))) asMorph.		 
	^newRow! !

!EstimatedLogEntriesList methodsFor: 'accessing' stamp: 'EstebanTolaba 7/8/2015 01:30'!
helpText
	"the help text to be shown in the list"

	^ 'Tareas con fecha de estimacion'! !

!EstimatedLogEntriesList methodsFor: 'accessing' stamp: 'Fernando 8/7/2015 02:43'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"
	| toShow |
	
	toShow := self model logEntries select: [:entry | entry toDoDate notNil & entry completionDate isNil].
	toShow := toShow asSortedCollection: [ :p1 :p2 | p1 toDoDate < p2 toDoDate ].
	^toShow.! !

BaseMorphListEditor subclass: #LabProjectListEditor
	uses: TBuildWindowFromPane + TEditObjectInListButtons + TBusinessObjectEditionInList + TListPane + (TListOfNames - {#stringList}) + TCentralizeAttachedFiles
	instanceVariableNames: 'fileSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectListEditor commentStamp: 'CarlosLombardi 3/31/2015 19:39' prior: 0!
An editor for the list of LabProjects of a Lab.
My model is the Lab.
!

LabProjectListEditor class
	uses: TBuildWindowFromPane classTrait + TEditObjectInListButtons classTrait + TBusinessObjectEditionInList classTrait + TListPane classTrait + TListOfNames classTrait + TCentralizeAttachedFiles classTrait
	instanceVariableNames: ''!

!LabProjectListEditor methodsFor: 'actions' stamp: ''!
addElement
	"opens a window to add a new reagent"

	| boEditor editResult newBO oldSelectedBO |
	oldSelectedBO := self selectedObject.
	newBO := self createNewBusinessObject.
	
	boEditor := self createBusinessObjectEditorFor: newBO.
	boEditor uiParent: self window.
	editResult := boEditor edit.
	editResult ifTrue: [ 
		self addNewBusinessObject: boEditor businessObject.
		self invalidateList.
		self selectedObject: (editResult ifTrue: [ boEditor businessObject ] ifFalse: [ oldSelectedBO ])
	].
! !

!LabProjectListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/30/2015 00:22'!
addNewBusinessObject: aLabProject
	"..."

	self model addToProjects: aLabProject! !

!LabProjectListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/29/2015 23:01'!
buildActivityButtonFor: aLabProject
	"creates and answers a button to access to the activities of the given project"

	^self uiBuilder 
		newButtonFor: self 
		getState: nil 
		action: #editLogEntryTreeFor: 
		arguments: { aLabProject } 
		getEnabled: nil 
		label: 'Actividades' 
		help: 'Editar las actividades de este proyecto'! !

!LabProjectListEditor methodsFor: 'ui building' stamp: ''!
buildAddButton
	"build the add button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #addElement
    		label: 'Agregar' translated 
		help: 'Agregar un nuevo elemento' translated.

! !

!LabProjectListEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 8/29/2015 14:55'!
buildButtonBar
	"build a UI component to show the buttons to appear under the list"
	
	| buttons buttonBar |
	buttons := OrderedCollection new.
	(self respondsTo: #buildAddButton) ifTrue: [ buttons add: self buildAddButton ]. 
	(self respondsTo: #buildEditButton) ifTrue: [ buttons add: self buildEditButton ].
	(self respondsTo: #buildDeleteButton) ifTrue: [ buttons add: self buildDeleteButton ].
	(self respondsTo: #buildScheduleButton) ifTrue: [ buttons add: self buildScheduleButton ].
	(self respondsTo: #buildCentralizeButton) ifTrue: [ buttons add: self buildCentralizeButton ].
	(self respondsTo: #buildReportButton) ifTrue: [ buttons add: self buildReportButton ].
	buttonBar := self uiBuilder newRow: buttons asArray.
	^self buildEmptyColumn
		cellInset: 0 ;
		addMorphBack: (self buildColumnSpacer: 2) ;
		addMorphBack: buttonBar 

! !

!LabProjectListEditor methodsFor: 'centralize' stamp: 'FernandoDiMeglio 8/25/2015 20:34'!
buildCentralizeButton
	"build the centralize button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #centralizeAttachedFiles 
		getEnabled: #thereIsSomethingSelected
    		label: 'Centralizar archivos' translated
		help: 'Centraliza todos los archivos de la actividad' translated.! !

!LabProjectListEditor methodsFor: 'ui building' stamp: ''!
buildDeleteButton
	"build the delete button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #deleteSelected 
		getEnabled: #thereIsSomethingSelected
    		label: 'Eliminar' translated
		help: 'Eliminar el elemento elegido' translated.

! !

!LabProjectListEditor methodsFor: 'ui building' stamp: ''!
buildEditButton
	"build the edit button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #editSelected 
		getEnabled: #thereIsSomethingSelected
    		label: 'Modificar' translated
		help: 'Modificar los datos del elemento elegido' translated.

! !

!LabProjectListEditor methodsFor: 'accessing' stamp: ''!
buildPane
	"builds a pane including all the elements to show"

	| rows |
	rows := { #buildUpperTitleBox . #buildTitleBox . #buildList . #buildTotalsRow . #buildButtonBar }
		select: [ :sym | self respondsTo: sym ] thenCollect: [ :sym | sym value: self ].
	^(self uiBuilder 	newColumn: rows ) 
		cellInset: 0 ; yourself.
! !

!LabProjectListEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 8/29/2015 14:56'!
buildReportButton
	"build the report button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #generateSelectedProjectReport
		getEnabled: #thereIsSomethingSelected
    		label: 'Generar reporte' translated 
		help: 'Genera un reporte del proyecto seleccionado' translated.

! !

!LabProjectListEditor methodsFor: 'ui building' stamp: 'FernandoDiMeglio 9/8/2015 20:55'!
buildRowFor: aLabProject
	"creates and answers a row for my morph list, representing aLabProject"

	| newRow |
	newRow := self newRowFor: aLabProject.
	newRow addMorphBack: 
			( aLabProject description asMorph width: 400 ; yourself ) ;
		addMorphBack: ( self buildActivityButtonFor: aLabProject ) .
	^newRow 
! !

!LabProjectListEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 6/29/2015 18:24'!
buildScheduleButton
	"build the edit button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #seeSelected 
		getEnabled: #thereIsSomethingSelected
    		label: 'Agenda' translated
		help: 'Ver agenda de tareas del proyecto' translated.

! !

!LabProjectListEditor methodsFor: 'ui building' stamp: 'FernandoDiMeglio 10/22/2015 00:08'!
buildWindow
	"builds and returns the editing window"

	| newWindow thePane maxWidth |
	newWindow := StandardWindow labelled: self windowTitle.
	thePane := self buildPane.
	thePane setNameTo: 'mainPane'.
	
	newWindow addMorph: thePane frame: (0 @ 0 corner: 1 @ 1).
	
	maxWidth := (thePane submorphs collect: [ :morph | morph width ]) max.
	newWindow width: ((maxWidth + 20) max: newWindow width).
	
	^ newWindow
! !

!LabProjectListEditor methodsFor: 'centralize' stamp: 'FernandoDiMeglio 11/21/2015 02:37'!
centralizeAttachedFiles

	| result |
	
	result := self openDirectoryWith: 'Centralizar Archivos - Elija una carpeta para guardarlos'.
	
	result ifNotNil: [ 
			self selectedObject children do: [:child | self centralizeAttachedFilesFrom: child with: result ]
		 ]! !

!LabProjectListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/30/2015 00:19'!
createBusinessObjectEditorFor: aLabProject
	"..."

	^LabProjectEditor for: aLabProject ! !

!LabProjectListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/30/2015 00:19'!
createNewBusinessObject
	"..."

	^LabProject new! !

!LabProjectListEditor methodsFor: 'actions' stamp: ''!
deleteSelected
	"delete action"

	(self window
		proceed: (self textForRemoveBusinessObjectConfirmation: self selectedObject)
		title: 'Confirmación requerida')
	ifTrue: [ 
		self removeBusinessObject: self selectedObject.
		self invalidateList.
	]
! !

!LabProjectListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 23:02'!
editLogEntryTreeFor: aLabProject
	"open a window to edit the log entries of the given project"

	(LabProjectLogEntryTreeEditor for: aLabProject) 
		lab: self model ; open.
! !

!LabProjectListEditor methodsFor: 'actions' stamp: ''!
editSelected
	"edit action"

	| boEditor oldSelectedBO oldKey  |
	oldSelectedBO := self selectedObject.
	oldKey := self keyFor: oldSelectedBO .
	boEditor := self createBusinessObjectEditorFor: self selectedObject.
	boEditor uiParent: self window.
	( (boEditor edit) & (oldKey ~= (self keyFor: oldSelectedBO)) ) 
	ifTrue: [ 
		self invalidateList.
		self selectedObject: oldSelectedBO.
	]
! !

!LabProjectListEditor methodsFor: 'accessing' stamp: 'FernandoDiMeglio 8/25/2015 22:20'!
fileSystem
	^fileSystem ! !

!LabProjectListEditor methodsFor: 'accessing' stamp: 'FernandoDiMeglio 8/25/2015 22:21'!
fileSystem: anObject
	fileSystem := anObject! !

!LabProjectListEditor methodsFor: 'centralize' stamp: 'FernandoDiMeglio 10/16/2015 04:52'!
generateSelectedProjectReport

	|reportFile result fileStream path |
	
	result := self openDirectoryWith: 'Generar Reporte - Elija una carpeta para guardarlo'.
	
	result ifNotNil: [ 
			path := (result fullName copyReplaceAll: '.\.' with: '\'), '\Reporte ', (self selectedObject description), '.pdf'.
			
			(fileSystem exists: path) ifTrue:[
				
				(LabProjectReportDialogError for: path) openModal.
				
				]ifFalse:[
					fileStream := (FileStream fileNamed:  path).
					reportFile := self selectedObject generateReport.
					reportFile exportTo: fileStream.
			
					fileStream  close.
					(LabProjectReportDialog for: path) openModal.
			]
		].
	

	

	
	! !

!LabProjectListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/29/2015 11:27'!
helpText
	"the help text to be shown in the list"

	^'Proyectos que se llevan a cabo'! !

!LabProjectListEditor methodsFor: 'actions' stamp: ''!
keyFor: anObject
	"the 'key' corresponding to this object wrt the list edition. To be overwritten if needed."

	^Time now! !

!LabProjectListEditor methodsFor: 'accessing' stamp: 'FernandoDiMeglio 8/25/2015 22:26'!
model: aLabProject
	
	super model: aLabProject.
	self fileSystem: FileSystem disk.! !

!LabProjectListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/29/2015 11:38'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model projects asSortedCollection: [ :p1 :p2 | p1 description asUppercase < p2 description asUppercase ]! !

!LabProjectListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/30/2015 00:21'!
removeBusinessObject: aLabProject
	"..."

	^self model removeFromProjects: aLabProject! !

!LabProjectListEditor methodsFor: 'accessing' stamp: 'EstebanTolaba 7/24/2015 16:41'!
scheduleFor: aLabProject
	"open a window to edit the log entries of the given project"

	(LabProjectSchedule for: aLabProject) 
		lab: self model ; openModal.
! !

!LabProjectListEditor methodsFor: 'list' stamp: 'EstebanTolaba 7/24/2015 16:41'!
seeSelected
	"view schedule project"

	| boEditor oldSelectedBO   |
	oldSelectedBO := self selectedObject.
	boEditor := self scheduleFor: self selectedObject.
	boEditor uiParent: self window.
! !

!LabProjectListEditor methodsFor: 'sorting' stamp: ''!
sortByUppercaseName: aCollection
	"a collection having the same elements as aCollection, sorted by their uppercase name"

	^aCollection asSortedCollection: self uppercaseNameSortBlock .! !

!LabProjectListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/30/2015 00:21'!
textForRemoveBusinessObjectConfirmation: aLabProject
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	textBuilder 
		nextPutAll: 'Confirmar eliminación del siguiente proyecto ' ; cr ; 
		nextPutAll: aLabProject description.
	^textBuilder contents
! !

!LabProjectListEditor methodsFor: 'sorting' stamp: ''!
uppercaseNameSortBlock
	"a block to build a collection sorted by the uppercase name of its elements"

	^[ :obj1 :obj2 | obj1 name asUppercase < obj2 name asUppercase ]! !

!LabProjectListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 11:30'!
windowTitle
	"..."

	^'Proyectos'! !

BaseMorphListEditor subclass: #LabProjectLogEntryListEditor
	uses: TBuildWindowFromPane - {#windowTitle} + TEditObjectInListButtons + TBusinessObjectEditionInList + TOrderOfLogEntries + TLogEntryCollectionEdition
	instanceVariableNames: 'lab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectLogEntryListEditor commentStamp: 'CarlosLombardi 2/15/2015 00:24' prior: 0!
A window to edit a list of LabProjectLogEntry
!

LabProjectLogEntryListEditor class
	uses: TBuildWindowFromPane classTrait + TEditObjectInListButtons classTrait + TBusinessObjectEditionInList classTrait + TOrderOfLogEntries classTrait + TLogEntryCollectionEdition classTrait
	instanceVariableNames: ''!

!LabProjectLogEntryListEditor methodsFor: 'actions' stamp: ''!
addElement
	"opens a window to add a new reagent"

	| boEditor editResult newBO oldSelectedBO |
	oldSelectedBO := self selectedObject.
	newBO := self createNewBusinessObject.
	
	boEditor := self createBusinessObjectEditorFor: newBO.
	boEditor uiParent: self window.
	editResult := boEditor edit.
	editResult ifTrue: [ 
		self addNewBusinessObject: boEditor businessObject.
		self invalidateList.
		self selectedObject: (editResult ifTrue: [ boEditor businessObject ] ifFalse: [ oldSelectedBO ])
	].
! !

!LabProjectLogEntryListEditor methodsFor: 'ui building' stamp: ''!
buildAddButton
	"build the add button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #addElement
    		label: 'Agregar' translated 
		help: 'Agregar un nuevo elemento' translated.

! !

!LabProjectLogEntryListEditor methodsFor: 'ui building' stamp: ''!
buildButtonBar
	"build a UI component to show the buttons to appear under the list"
	
	| buttons buttonBar |
	buttons := OrderedCollection new.
	(self respondsTo: #buildAddButton) ifTrue: [ buttons add: self buildAddButton ]. 
	(self respondsTo: #buildEditButton) ifTrue: [ buttons add: self buildEditButton ].
	(self respondsTo: #buildDeleteButton) ifTrue: [ buttons add: self buildDeleteButton ].
	buttonBar := self uiBuilder newRow: buttons asArray.
	^self buildEmptyColumn
		cellInset: 0 ;
		addMorphBack: (self buildColumnSpacer: 2) ;
		addMorphBack: buttonBar 

! !

!LabProjectLogEntryListEditor methodsFor: 'ui building' stamp: ''!
buildDeleteButton
	"build the delete button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #deleteSelected 
		getEnabled: #thereIsSomethingSelected
    		label: 'Eliminar' translated
		help: 'Eliminar el elemento elegido' translated.

! !

!LabProjectLogEntryListEditor methodsFor: 'ui building' stamp: ''!
buildEditButton
	"build the edit button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #editSelected 
		getEnabled: #thereIsSomethingSelected
    		label: 'Modificar' translated
		help: 'Modificar los datos del elemento elegido' translated.

! !

!LabProjectLogEntryListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 2/15/2015 00:34'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildTitleBox . self buildList . self buildButtonBar }) 
		cellInset: 0 ; yourself.
! !

!LabProjectLogEntryListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/8/2015 01:32'!
buildRowFor: logEntry
	"creates and answers a row for my morph list, representing the given log entry."

	| newRow |
	newRow := self newRowFor: logEntry.
	newRow 
		addMorphBack: 
			( (self dateConverter objectAsString: logEntry date) asMorph width: 100 ; yourself ) ; 
		addMorphBack: 
			( logEntry description asMorph width: 400 ; yourself ) .
	^newRow 
! !

!LabProjectLogEntryListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/8/2015 01:32'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Fecha' width: 100 ;
		addString: 'Descripción' width: 400.
	^titleBuilder titleBox
! !

!LabProjectLogEntryListEditor methodsFor: 'ui building' stamp: ''!
buildWindow
	"builds and returns the editing window"

	| newWindow thePane maxWidth |
	newWindow := StandardWindow labelled: self windowTitle.
	thePane := self buildPane.
	thePane setNameTo: 'mainPane'.
	
	"to force recomputation of subpane bounds"
"	thePane fullBounds.
	maxWidth := (thePane submorphs collect: [ :morph | morph width ]) max.
"	
	newWindow addMorph: thePane frame: (0 @ 0 corner: 1 @ 1).
	
	maxWidth := (thePane submorphs collect: [ :morph | morph width ]) max.
	newWindow width: ((maxWidth + 20) max: newWindow width).
	
	^ newWindow
! !

!LabProjectLogEntryListEditor methodsFor: 'actions' stamp: ''!
deleteSelected
	"delete action"

	(self window
		proceed: (self textForRemoveBusinessObjectConfirmation: self selectedObject)
		title: 'Confirmación requerida')
	ifTrue: [ 
		self removeBusinessObject: self selectedObject.
		self invalidateList.
	]
! !

!LabProjectLogEntryListEditor methodsFor: 'actions' stamp: ''!
editSelected
	"edit action"

	| boEditor oldSelectedBO oldKey  |
	oldSelectedBO := self selectedObject.
	oldKey := self keyFor: oldSelectedBO .
	boEditor := self createBusinessObjectEditorFor: self selectedObject.
	boEditor uiParent: self window.
	( (boEditor edit) & (oldKey ~= (self keyFor: oldSelectedBO)) ) 
	ifTrue: [ 
		self invalidateList.
		self selectedObject: oldSelectedBO.
	]
! !

!LabProjectLogEntryListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:21'!
lab
	"my reference lab, used to obtain the list of available solutions for the 
	 eventual solution preparation activities to include into log entries"
	^ lab! !

!LabProjectLogEntryListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:21'!
lab: anObject
	"cfr >>lab"
	lab := anObject! !

!LabProjectLogEntryListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/8/2015 00:31'!
logEntries
	"the raw list of raw entries I am editing - needed by TOrderOfLogEntries"

	^self model! !

!LabProjectLogEntryListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/5/2015 15:12'!
objectsToShow
	"the list of objects to be rendered, in the proper order"

	^self logEntriesOrderedByDate ! !

BaseMorphListEditor subclass: #LabProjectSchedule
	uses: TBuildWindowFromPane + TListPane
	instanceVariableNames: 'estimatedLogEntries notEstimatedLogEntries treeModel lab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectSchedule commentStamp: '<historical>' prior: 0!
A LabProjectSchedule is xxxxxxxxx.

Instance Variables
	estimatedLogEntries:		<Object>
	lab:		<Object>
	notEstimatedLogEntries:		<Object>
	treeModel:		<Object>

estimatedLogEntries
	- xxxxx

lab
	- xxxxx

notEstimatedLogEntries
	- xxxxx

treeModel
	- xxxxx
!

LabProjectSchedule class
	uses: TBuildWindowFromPane classTrait + TListPane classTrait
	instanceVariableNames: ''!

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 8/4/2015 16:10'!
buildButtonBar
	"build a UI component to show the buttons to appear under the list"
	
	^self buildEmptyColumn
		cellInset: 0 ;
		addMorphBack: (self buildColumnSpacer: 2);
		addMorphBack: ( self uiBuilder newRow: { self buildOKButton} )
! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 7/7/2015 00:34'!
buildOKButton
	"build the add button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #close
    		label: 'OK' translated 
		help: 'OK' translated.

! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 10/31/2015 15:26'!
buildPane
	"I build and return the pane which is the contents of my window"

	^ (self uiBuilder
		newColumn: {((Text fromString: 'Tareas estimadas                                                              Fecha de Carga       Fecha estimada')) asMorph  . (self estimatedLogEntries) buildList . 'Tareas no estimadas                                                         Fecha de Carga' asMorph  . (self notEstimatedLogEntries) buildList . self buildButtonBar} )  
		cellInset: 0;
		yourself! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 7/8/2015 01:59'!
buildRowFor: aLogEntry
	"creates and answers a row for my morph list, representing aLabProject"

	| newRow |
	newRow := self newRowFor: aLogEntry.
	newRow addMorphBack: 
			( aLogEntry description asMorph width: 300 ; yourself ) ;
		addMorphBack:  aLogEntry loadDate asMorph;
		addMorphBack:  aLogEntry toDoDate asMorph.		 
	^newRow ! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 18:52'!
buildTreeMorph
	| treeMorph |
	treeMorph := treeModel defaultTreeMorph
		doubleClickBlock: [ self editSelected ] ;
		buildContents ; 
		selectedItems: {} ; 
		yourself.
	treeModel treeMorph: treeMorph .
	^ treeMorph! !

!LabProjectSchedule methodsFor: 'ui building' stamp: 'FernandoDiMeglio 11/2/2015 13:46'!
buildWindow
	"builds and returns the editing window"

	| newWindow thePane maxWidth |
	newWindow := StandardWindow labelled: self windowTitle.
	thePane := self buildPane.
	thePane setNameTo: 'mainPane'.

	newWindow addMorph: thePane frame: (0 @ 0 corner: 1 @ 1).
	
	maxWidth := (thePane submorphs collect: [ :morph | morph width ]) max.
	newWindow width: ((maxWidth + 20) max: newWindow width).
	
	^ newWindow
! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 7/24/2015 16:39'!
close

	^self window close.! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 18:12'!
createScheduleFor: aLabProject
	"..."

	^LabProjectEditor for: aLabProject ! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 17:10'!
estimatedLogEntries
	^ estimatedLogEntries! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 17:10'!
estimatedLogEntries: anObject
	estimatedLogEntries := anObject! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 7/8/2015 01:46'!
helpText
	"the help text to be shown in the list"

	^ 'Agenda '! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 18:59'!
lab
	^ lab! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 18:59'!
lab: anObject
	lab := anObject! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 7/8/2015 02:54'!
model: aLabProject
	"set the model to be shown and edited"

	super model: aLabProject.
	self estimatedLogEntries: (EstimatedLogEntriesList for: self model ). 
	self notEstimatedLogEntries: (NotEstimatedLogEntriesList for: self model).
	treeModel := LabProjectLogEntryTreeModel new.
	treeModel model: aLabProject.
	treeModel addDependent: self.
! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 17:10'!
notEstimatedLogEntries
	^ notEstimatedLogEntries! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 17:10'!
notEstimatedLogEntries: anObject
	notEstimatedLogEntries := anObject! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 7/7/2015 00:08'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model logEntries asSortedCollection: [ :p1 :p2 | p1 description asUppercase < p2 description asUppercase ]! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 18:59'!
treeModel
	^ treeModel! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 18:59'!
treeModel: anObject
	treeModel := anObject! !

!LabProjectSchedule methodsFor: 'accessing' stamp: 'EstebanTolaba 6/29/2015 19:08'!
windowTitle
	"..."

	^ 'Agenda de ' , (self model description).! !

BaseMorphListEditor subclass: #NotEstimatedLogEntriesList
	uses: TBuildWindowFromPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!NotEstimatedLogEntriesList commentStamp: '<historical>' prior: 0!
A NotEstimatedLogEntriesList is xxxxxxxxx.
!

NotEstimatedLogEntriesList class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!NotEstimatedLogEntriesList methodsFor: 'accessing' stamp: 'EstebanTolaba 10/31/2015 15:23'!
buildRowFor: aLogEntry
	"creates and answers a row for my morph list, representing aLabProject"

	| newRow |
	newRow := self newRowFor: aLogEntry.
	newRow addMorphBack: 
			( aLogEntry description asMorph width: 350 ; yourself ) ;
		addMorphBack:  (aLogEntry loadDate printFormat: #(1 2 3 $/ 1 1 2)) asMorph.	 
	^newRow ! !

!NotEstimatedLogEntriesList methodsFor: 'accessing' stamp: 'EstebanTolaba 7/8/2015 01:30'!
helpText
	"the help text to be shown in the list"

	^ 'Tareas sin fecha de estimacion'! !

!NotEstimatedLogEntriesList methodsFor: 'accessing' stamp: 'EstebanTolaba 7/24/2015 16:17'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"
	| toShow |
	
	
	toShow := self model logEntries asSortedCollection: [ :p1 :p2 | p1 loadDate < p2 loadDate].
	toShow := toShow select: [:entry | entry toDoDate isNil].
	^toShow.! !

BaseMorphListEditor subclass: #ReagentInSolutionListEditor
	uses: TBuildWindowFromPane + (TEditObjectInListButtons - {#buildEditButton}) + TBusinessObjectEditionInListOnPlace + TListPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Solutions'!

!ReagentInSolutionListEditor commentStamp: 'CarlosLombardi 3/29/2015 06:16' prior: 0!
An editor for the collection of ReagentInSolution of a Solution.
My model is a SolutionEditController corresponding to that Solution.
!

ReagentInSolutionListEditor class
	uses: TBuildWindowFromPane classTrait + TEditObjectInListButtons classTrait + TBusinessObjectEditionInListOnPlace classTrait + TListPane classTrait
	instanceVariableNames: ''!

!ReagentInSolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/29/2015 06:36'!
addBO: newBO after: existingBO
	"adds newBO as an element in my list, after existingBO"

	^self model addComponent: newBO after: existingBO! !

!ReagentInSolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/29/2015 06:37'!
addFirstBO: anObject
	"adds the given object as the first element in my list"

	^self model addFirstComponent: anObject! !

!ReagentInSolutionListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 01:10'!
buildRowFor: anEditor
	"creates and answers a row for my morph list, representing anEditor"

	^ anEditor buildRow! !

!ReagentInSolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/29/2015 06:11'!
createNewBusinessObject
	"creates a new object, which will be included in my model"

	^self model createEditorForNewComponent! !

!ReagentInSolutionListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 01:48'!
helpText
	"the help text to be shown in the list"

	'Componentes de esta solución'! !

!ReagentInSolutionListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/29/2015 06:21'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model components! !

!ReagentInSolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/29/2015 06:18'!
removeBusinessObject: aBO
	"removes aBO from my list"

	^self model removeComponent: aBO! !

!ReagentInSolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/26/2015 01:35'!
textForRemoveBusinessObjectConfirmation: aReagentInSolutionEditor
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	aReagentInSolutionEditor reagent isNil ifTrue: [ 
		textBuilder 	nextPutAll: 'Confirmar eliminación del componente elegido' 
	] ifFalse: [ 
		textBuilder 
			nextPutAll: 'Confirmar eliminación del componente correspondiente a  ' ; cr ;
			nextPutAll: aReagentInSolutionEditor reagent name.
	 ].
	^textBuilder contents! !

!ReagentInSolutionListEditor methodsFor: 'updating' stamp: 'CarlosLombardi 3/26/2015 23:08'!
updateModel
	"update each of the ReagentInSolutions in my model wrt the edited values"

	self objectList do: [ :reagentInSolutionEditor | reagentInSolutionEditor updateModel ]! !

!ReagentInSolutionListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2015 01:42'!
windowTitle
	"..."

	^'Test de edición ReagentInSolution'! !

BaseMorphListEditor subclass: #ReagentMorphListEditor
	uses: TBuildWindowFromPane + TEditObjectInListButtons + TBusinessObjectEditionInList + TReagentListEditorActions + TReagentListEdition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ReagentMorphListEditor commentStamp: 'CarlosLombardi 3/24/2015 12:04' prior: 0!
A window to edit the list of reagents of a Lab. 
There are different such windows, showing different information of each reagent in the list. Each of these variants is modeled as a subclass of this class.!

ReagentMorphListEditor class
	uses: TBuildWindowFromPane classTrait + TEditObjectInListButtons classTrait + TBusinessObjectEditionInList classTrait + TReagentListEditorActions classTrait + TReagentListEdition classTrait
	instanceVariableNames: ''!

ReagentMorphListEditor subclass: #ReagentInSolutionMorphListEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ReagentInSolutionMorphListEditor commentStamp: 'CarlosLombardi 3/24/2015 12:20' prior: 0!
A reagent-list-window showing data relevant for the participation of each reagent in the preparation of solutions.
!

!ReagentInSolutionMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/24/2015 12:23'!
buildRowFor: aReagent
	"creates and answers a row for my morph list, representing aReagent"

	| newRow rowBuilder |
	newRow := self newRowFor: aReagent.
	rowBuilder := StockElementUIComponentBuilder new.
	rowBuilder element: aReagent ; lab: self model.
	rowBuilder 
		addNameColumnTo: newRow ;
		addCasNumberColumnTo: newRow ; 
		addMolecularWeightColumnTo: newRow .
	^newRow ! !

!ReagentInSolutionMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/24/2015 12:24'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Nombre' width: 200 ;
		addString: 'Nro CAS' width: 120 ;
		addString: 'Peso molec.' width: 120.
	^titleBuilder titleBox
! !

!ReagentMorphListEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 11:20'!
buildPane
	"builds a pane including all the elements to show"
	
	^(self uiBuilder 
		newColumn: { self buildTitleBox . self buildList . self buildButtonBar }) 
		cellInset: 0 ; yourself.
! !

!ReagentMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/25/2015 21:13'!
buildWindow
	"builds and returns the editing window"

	| newWindow thePane maxWidth |
	newWindow := StandardWindow labelled: self windowTitle.
	thePane := self buildPane.
	thePane setNameTo: 'mainPane'.
	
	"to force recomputation of subpane bounds"
"	thePane fullBounds.
	maxWidth := (thePane submorphs collect: [ :morph | morph width ]) max.
"	
	newWindow color: Color transparent.
	newWindow addMorph: thePane frame: (0 @ 0 corner: 1 @ 1).""
	
	maxWidth := (thePane submorphs collect: [ :morph | morph width ]) max.
	newWindow width: ((maxWidth + 20) max: newWindow width).
	
	^ newWindow
! !

!ReagentMorphListEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/28/2014 03:47'!
editStockUnit
	"opens a window to edit my reagent"

	| suEditor oldSelectedReagent |
	oldSelectedReagent := self selectedObject.
	"oldName := self selectedObject name."
	suEditor := StockUnitEditor for: self selectedObject stockUnit.
	suEditor uiParent: self window.
	suEditor edit.
	self invalidateList.
	self selectedObject: oldSelectedReagent 
! !

!ReagentMorphListEditor methodsFor: 'ui building' stamp: 'CLom 12/22/2014 02:43'!
fillListMenu: aMenu 
	"fills the menu for the UI rendered by me"
	
	self thereIsSomethingSelected ifTrue: [ 
		aMenu
			title: 'Acciones sobre el reactivo';
			add: 'editar unidad de stock' action: #editStockUnit.
	].
	^aMenu! !

!ReagentMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 4/28/2014 00:09'!
helpText
	"the help text to be shown in the list"

	^'Reactivos de este Laboratorio'! !

!ReagentMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/19/2014 15:43'!
windowTitle
	"..."

	^'Lista de Reactivos'! !

ReagentMorphListEditor subclass: #ReagentStockMorphListEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ReagentStockMorphListEditor commentStamp: 'CarlosLombardi 3/24/2015 12:05' prior: 0!
A reagent-list-window showing data related to the stock of each reagent in the reference lab.
!

!ReagentStockMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/24/2015 12:03'!
buildRowFor: aReagent
	"creates and answers a row for my morph list, representing aReagent"

	| newRow rowBuilder |
	newRow := self newRowFor: aReagent.
	rowBuilder := StockElementUIComponentBuilder new.
	rowBuilder element: aReagent ; lab: self model.
	rowBuilder 
		addNameColumnTo: newRow ;
		addCasNumberColumnTo: newRow ; 
		addCurrentStockColumnTo: newRow ;
		addStockUnitColumnTo: newRow ; 
		addCurrentPriceColumnTo: newRow .
	^newRow 
! !

!ReagentStockMorphListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/24/2015 12:03'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Nombre' width: 200 ;
		addString: 'Nro CAS' width: 120 ;
		addString: 'Stock' width: 80 ; 
		addString: '' width: 100 ; 
		addString: 'Ult. precio\compra' width: 120.
	^titleBuilder titleBox
! !

BaseMorphListEditor subclass: #SolutionListEditor
	uses: TBuildWindowFromPane + TEditObjectInListButtons + TBusinessObjectEditionInList + TListPane + TSolutionListEdition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Solutions'!

!SolutionListEditor commentStamp: 'CarlosLombardi 3/26/2015 19:39' prior: 0!
An editor for the list of solution of a Lab. 
My model is the Lab.!

SolutionListEditor class
	uses: TBuildWindowFromPane classTrait + TEditObjectInListButtons classTrait + TBusinessObjectEditionInList classTrait + TListPane classTrait + TSolutionListEdition classTrait
	instanceVariableNames: ''!

!SolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/27/2015 01:25'!
addNewBusinessObject: aSolution
	"..."

	self lab addToSolutions: aSolution! !

!SolutionListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 19:45'!
buildRowFor: aSolution
	"creates and answers a row for my morph list, representing aSolution"

	| newRow |
	newRow := self newRowFor: aSolution.
	newRow addMorphBack: 
			( aSolution name asMorph width: 200 ; yourself ) .
	^newRow 
! !

!SolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/20/2015 00:07'!
createBusinessObjectEditorFor: aSolution
	"..."

	| newEditController |
	newEditController := SolutionEditController for: aSolution labProvider: self .
	^SolutionEditor for: newEditController! !

!SolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/27/2015 01:29'!
createNewBusinessObject
	"..."

	^Solution new.
! !

!SolutionListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 19:43'!
helpText
	"the help text to be shown in the list"

	^'Soluciones registradas'! !

!SolutionListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2015 19:43'!
lab
	"my reference Lab"

	^self model! !

!SolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/27/2015 01:30'!
removeBusinessObject: aSolution
	"..."

	self lab removeFromSolutions: aSolution! !

!SolutionListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/27/2015 01:36'!
textForRemoveBusinessObjectConfirmation: aSolution
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	textBuilder 
		nextPutAll: 'Confirmar eliminación de la ' ; 
		nextPutAll: 'siguiente solución' ; cr ; 
		nextPutAll: 'Nombre : ' ; nextPutAll: aSolution name.
	^textBuilder contents
! !

!SolutionListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2015 19:42'!
windowTitle
	"..."

	^'Soluciones'! !

BaseMorphListEditor subclass: #SolutionPreparationEditor
	uses: TUIGoodies + (TBuildWindowFromPane @ {#baseBuildWindow->#buildWindow})
	instanceVariableNames: 'transientModel labProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Solutions'!

!SolutionPreparationEditor commentStamp: 'CarlosLombardi 3/20/2015 22:42' prior: 0!
I know how to display and edit a SolutionPreparationActivity.

I play both the editor and edit controller roles. This is because the edit controller responsibilities are simple.!

SolutionPreparationEditor class
	uses: TUIGoodies classTrait + TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!SolutionPreparationEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/25/2015 20:06'!
buildPane
	"..."

	| coloredPane upperPart paneList innerPane outerPane borderColor modelPane |
	upperPart := self buildEmptyRow.
	upperPart
		addMorphBack: self buildSolutionDropList;
		addMorphBack: (self buildRowSpacer: 10);
		addMorphBack: self buildSolutionQuantityField ;
		addMorphBack: self model solutionQuantity unit abbreviation asMorph .
	paneList := self buildEmptyRow.
	paneList
		hResizing: #spaceFill;
		vResizing: #rigid;
		height: 100.
	paneList addMorphBack: self buildList.

	borderColor := Color green darker darker darker.
	innerPane := self buildEmptyColumn.
	innerPane
		borderWidth: 5;
		borderColor: Color transparent;
		addMorphBack: upperPart;
		addMorphBack: paneList.
	coloredPane := self surround: innerPane withBorderColor: borderColor width: 3.
	outerPane := self surround: coloredPane withBorderColor: Color transparent width: 5.
	modelPane := self newRowFor: self.
	modelPane cellInset: 0 ; addMorphBack: outerPane.
	^ modelPane! !

!SolutionPreparationEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/25/2015 09:56'!
buildRowFor: anObject
	"creates and answers a row for my morph list, representing anObject"

	| newRow |
	newRow := self newRowFor: anObject.
	newRow 
		addMorphBack: 
			( anObject reagent name asMorph width: 200 ; yourself ) ; 
		addMorphBack: 
			( self buildRightAlignedMorphFor: (anObject reagentConcentration printStringAbbreviated ) width: 80 ) ;
		addMorphBack: 
			( self buildRightAlignedMorphFor: 
						((anObject reagentQuantity asFloat round: 5) printStringAbbreviated) 
				   width: 120 ) .
	^newRow 
! !

!SolutionPreparationEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 21:09'!
buildSolutionDropList
	"builds and returns the drop list to select the solution to prepare"

	| field editor |
	editor := (SolutionDropListModel for: self lab).
	editor
		selectedObject: transientModel solution ;
		setObjectSelectedBlock: [ :solution | self solution: solution ] .
	field := editor buildDropList.
	field setNameTo: 'solution'.
	^field ! !

!SolutionPreparationEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 10:40'!
buildSolutionQuantityField
	"builds and returns the field to edit the quantity of solution to prepare"

	| field |
	field := self uiBuilder
		newTextEntryFor: self 
		get: #solutionQuantity
		set: #solutionQuantity:
		class: Float
		getEnabled: nil
		help: 'Cantidad de solución producida'.
	field
		acceptOnFocusChange: true ;
		width: 80;
		hResizing: #rigid.
	^field.
! !

!SolutionPreparationEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 11:39'!
buildWindow
	"builds and returns the editing window"

	| newWindow |
	newWindow := self baseBuildWindow.
	newWindow height: ((newWindow submorphNamed: 'mainPane') submorphs collect: #height) sum + 50.
	^ newWindow .
! !

!SolutionPreparationEditor methodsFor: 'model accessing' stamp: 'CarlosLombardi 3/20/2015 01:06'!
components
	"the components of the solution preparation I am editing"

	^transientModel components! !

!SolutionPreparationEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 10:20'!
helpText
	"the help text to be shown in the list"

	^'Componentes usados en la preparación'! !

!SolutionPreparationEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:05'!
lab
	"my reference lab"
	^ labProvider lab! !

!SolutionPreparationEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:05'!
labProvider
	"the object responsible to give me access to a reference Lab"
	^ labProvider! !

!SolutionPreparationEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:05'!
labProvider: anObject
	"the object responsible to give me access to a reference Lab"
	labProvider := anObject! !

!SolutionPreparationEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/19/2015 01:08'!
model: aSolutionPreparationActivity
	"..."

	super model: aSolutionPreparationActivity .
	transientModel := SolutionPreparationActivityAlone new .
	transientModel 
		solution: self model solution ;
		solutionQuantity: self model solutionQuantity .! !

!SolutionPreparationEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/20/2015 01:06'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self components! !

!SolutionPreparationEditor methodsFor: 'model accessing' stamp: 'CarlosLombardi 3/20/2015 01:00'!
solution
	"the solution to prepare"

	^transientModel solution! !

!SolutionPreparationEditor methodsFor: 'model accessing' stamp: 'CarlosLombardi 3/20/2015 09:23'!
solution: aSolution
	"the solution to prepare"

	transientModel solution: aSolution.
	self invalidateList .! !

!SolutionPreparationEditor methodsFor: 'model accessing' stamp: 'CarlosLombardi 3/25/2015 09:58'!
solutionQuantity
	"the quantity of solution to prepare"

	^transientModel solutionQuantity value! !

!SolutionPreparationEditor methodsFor: 'model accessing' stamp: 'CarlosLombardi 3/25/2015 10:08'!
solutionQuantity: aNumber
	"the quantity of solution to prepare"

	transientModel solutionQuantity: (aNumber units: LabApplication current solutionQuantityUnit ).
	self invalidateList .! !

!SolutionPreparationEditor methodsFor: 'updating' stamp: 'CarlosLombardi 3/20/2015 09:26'!
updateModel
	"reflect in the model the changes performed in the edition"

	self model 
		solution: transientModel solution ;
		solutionQuantity: transientModel solutionQuantity .! !

!SolutionPreparationEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 10:20'!
windowTitle
	"..."

	^'Preparación de una solución -- ejemplo'! !

BaseMorphListEditor subclass: #SolutionPreparationListEditor
	uses: TUIGoodies + TBuildWindowFromPane + (TEditObjectInListButtons - {#buildButtonBar}) + TLabProvider + (TBusinessObjectEditionInList - {#editSelected. #keyFor:}) + TSolutionPreparationEditorCreator
	instanceVariableNames: 'lab logEntry editorFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Solutions'!

!SolutionPreparationListEditor commentStamp: 'CarlosLombardi 3/20/2015 22:40' prior: 0!
I know how to show and edit a list of SolutionPreparationActivities. 
These SolutionPreparationActivities can be those associated to a given logEntry, or not.

The list of activities I am asked to edit is my collectionOfPreparationActivities.
My model has an internal nature. Namely, it is a list of  SolutionPreparationEditors.

There is another object, my editorFactory, which knows how to create a SolutionPreparationEditor for a given, or a new, SolutionPreparationActivity.
I am an appropiate editorFactory. However, I also accept to use an editorFactory other than me. In this case, it is not necessary to set me a lab, I only use my reference Lab to create editors.
Cfr. the method category called editor creation.!

SolutionPreparationListEditor class
	uses: TUIGoodies classTrait + TBuildWindowFromPane classTrait + TEditObjectInListButtons classTrait + TLabProvider classTrait + TBusinessObjectEditionInList classTrait + TSolutionPreparationEditorCreator classTrait
	instanceVariableNames: ''!

!SolutionPreparationListEditor class methodsFor: 'instance creation' stamp: 'CarlosLombardi 3/20/2015 20:43'!
for: aListOfPreparationActivities
	"creates and returns a new editor for the given list"

	^self new 
		collectionOfPreparationActivities: aListOfPreparationActivities ; 	
		yourself! !

!SolutionPreparationListEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/25/2015 10:08'!
addElement
	"adds a new preparation activity into the list"
	
	| newEditor |
	newEditor := self editorFactory buildPreparationEditorForNewActivity.
	self selectedObject 
		ifNil: [ self model addFirst: newEditor ]
		ifNotNil: [ :editor | self model add: newEditor after: editor ] .
	self invalidateList.
	self selectedObject: newEditor .
! !

!SolutionPreparationListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 19:14'!
buildButtonBar
	"build a UI component to show the buttons to appear under the list"
	
	^self uiBuilder 
		newRow: { self buildAddButton . self buildDeleteButton } .

! !

!SolutionPreparationListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 19:14'!
buildPane
	"creates and answers the main pane to be included in a Window"

	^(self uiBuilder 
		newColumn: { self buildList . self buildButtonBar }) 
		cellInset: 0 ; yourself.
! !

!SolutionPreparationListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 21:02'!
buildRowFor: anObject
	"creates and answers a row for my morph list, representing anObject.
	 Remember that anObject is a PreparationEditor"

	^anObject buildPane! !

!SolutionPreparationListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 21:00'!
collectionOfPreparationActivities
	"The collection (in fact, a list) of preparation activities I am editing"

	^ self model collect: #model
! !

!SolutionPreparationListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:35'!
collectionOfPreparationActivities: aCollection
	"I am informed about the collection of preparation activities I must show and edit"

	self model: ( aCollection collect: [ :act | self editorFactory buildPreparationEditorFor: act ] ).
! !

!SolutionPreparationListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:35'!
editorFactory
	"The object responsible of the creation of SolutionPreparationEditors 
	  for the preparation activities to edit.
	  If no editor factory is set to me, I act myself as editor factory for me."
	^ editorFactory ifNil: [ self ]! !

!SolutionPreparationListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:34'!
editorFactory: anObject
	editorFactory := anObject! !

!SolutionPreparationListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 19:20'!
helpText
	"the help text to be shown in the list"

	^'preparación de soluciones en esta actividad'! !

!SolutionPreparationListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:07'!
lab
	"the reference lab corresponding to myself"

	^lab! !

!SolutionPreparationListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:07'!
lab: aLab
	"the reference lab corresponding to myself"

	lab := aLab! !

!SolutionPreparationListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:51'!
logEntry
	^ logEntry! !

!SolutionPreparationListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 19:51'!
logEntry: anObject
	logEntry := anObject! !

!SolutionPreparationListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/20/2015 20:46'!
objectsToShow
	"the list of raw objects to show. 
	 The list of morphs is the result of transforming each of these raw objects via the buildRowFor: method"

	^self model! !

!SolutionPreparationListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/20/2015 21:26'!
removeBusinessObject: aPreparationEditor
	"..."

	self model remove: aPreparationEditor! !

!SolutionPreparationListEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/20/2015 23:27'!
textForRemoveBusinessObjectConfirmation: aSolutionPreparationEditor
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	aSolutionPreparationEditor solution isNil ifTrue: [ 
		textBuilder 	nextPutAll: 'Confirmar eliminación de la preparación elegida' 
	] ifFalse: [ 
		textBuilder 
			nextPutAll: 'Confirmar eliminación de la preparación de  ' ; cr ;
			nextPutAll: aSolutionPreparationEditor solution name.
	 ].
	^textBuilder contents! !

!SolutionPreparationListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 19:20'!
windowTitle
	"..."

	^'Lista de preparación de soluciones' ! !

BaseMorphListEditor subclass: #StockEventEditor
	uses: TBuildWindowFromPane + TTotalAmountField
	instanceVariableNames: 'detailUiRenderers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!StockEventEditor commentStamp: '<historical>' prior: 0!
An UI renderer to edit a StockEvent, collaborating with an StockEventEditController. 
It is an abstract class, a subclass is required for each kind of StockEvent. Each concrete subclass must define
- helpText
- windowTitle!

StockEventEditor class
	uses: TBuildWindowFromPane classTrait + TTotalAmountField classTrait
	instanceVariableNames: ''!

StockEventEditor subclass: #BuyingEventEditor
	instanceVariableNames: 'requirementSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingEventEditor commentStamp: '<historical>' prior: 0!
A BuyingEventEditor is a StockEventEditor specified for the edition of a BuyingEvent.
!

!BuyingEventEditor methodsFor: 'ui building' stamp: 'CLom 12/17/2014 00:49'!
buildForm
	"build the form preceding the detail list"

	| wholeForm centreRow bottomRow pedidoLabel |
	wholeForm := self newColumnFor: self model.
	centreRow := self newRowFor: self model.
	pedidoLabel := 'Pedido:' asMorph.
	centreRow
		addMorphBack: pedidoLabel
		; addMorphBack: self buildRequirementField.
	bottomRow := self newRowFor: self model.
	bottomRow 
		addMorphBack: (self buildRowSpacer: pedidoLabel width) 
		; addMorphBack: self requirementSelector buildFilterChooser.
	^ wholeForm addMorphBack: super buildForm
		; addMorphBack: centreRow
		; addMorphBack: bottomRow
		; addMorphBack: (self buildColumnSpacer: 6)
		; yourself! !

!BuyingEventEditor methodsFor: 'ui building' stamp: 'CLom 12/17/2014 10:45'!
buildRequirementField
	"creates and answer a UI component to edit the buying requirement 
	  to link with the buying event being edited"

	| field |
	field := self requirementSelector buildDropList.
	field
		setNameTo: 'requirement' ;
		width: 750 ; 
		hResizing: #rigid ;
		vResizing: #rigid.
	^field
! !

!BuyingEventEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 00:32'!
helpText
	"the help text to be shown in the list"

	^'Detalles de la compra de reactivos y consumibles'! !

!BuyingEventEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/8/2015 01:18'!
requirementField
	"..."

	^self window submorphNamed: 'requirement'
! !

!BuyingEventEditor methodsFor: 'accessing' stamp: 'CLom 12/13/2014 12:41'!
requirementSelector
	"the controller for the selection of a buying requirement to fulfill"

	requirementSelector ifNil: [ 
		requirementSelector := BuyingRequirementSelector for: self model lab.
		requirementSelector provider: self model provider.
		requirementSelector addDependent: self.	
	 ].
	^requirementSelector.! !

!BuyingEventEditor methodsFor: 'updating' stamp: 'CLom 12/13/2014 12:37'!
update: aSymbol
	"handling of receiving events"

	super update: aSymbol.
	
	"events from UI to model"
	"requirement selection"
	aSymbol = #selectedBuyingRequirementChanged | (aSymbol = #selectedBuyingRequirementCleared)
		ifTrue: [ self model buyingRequirement: self requirementField model selectedObject ].

	"events from model to UI"
	"provider changed"
	aSymbol = #providerChangedFromModel
		ifTrue: [ self requirementField model provider: self model provider. ].
		
! !

!BuyingEventEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 00:32'!
windowTitle
	"..."

	^'Ingreso de reactivos y consumibles por compra'! !

StockEventEditor subclass: #BuyingRequirementEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingRequirementEditor commentStamp: '<historical>' prior: 0!
A StockEventEditor specified for the edition of a BuyingRequirement.
!

!BuyingRequirementEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 00:32'!
helpText
	"the help text to be shown in the list"

	^'Detalles del pedido de compra de reactivos y consumibles'! !

!BuyingRequirementEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 00:32'!
windowTitle
	"..."

	^'Pedido de compra de reactivos y consumibles'! !

!StockEventEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/24/2014 22:55'!
addDetail
	"adds a new detail to the edition"

	self model addNewDetail.
	self invalidateList.! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CLom 11/21/2014 11:48'!
buildAddButton
	"..."
	
	^self uiBuilder 
		newButtonFor: self
		action: #addDetail
    		label: 'Agregar linea' translated 
		help: 'Agregar una linea' translated.! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/27/2015 00:10'!
buildButtonBar
	"build a UI component to show the buttons to appear under the list"
	
	| row |
	row := self uiBuilder 
		newRow: { self buildAddButton . self buildRemoveButton . self buildRowFillSpacer . self buildSaveButton } .
	^self buildEmptyColumn 
		cellInset: 0 ;
		addMorphBack: ( self buildColumnSpacer: 2 ) ;
		addMorphBack: row.! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/23/2014 11:35'!
buildExtraAmountField
	"creates and answer a UI component to edit the extra amount of my BuyingEvent"

	| newField |
	newField := self uiBuilder
		newTextEntryFor: self model
		get: #extraAmount
		set: #extraAmount:  
		class: Float 
		getEnabled: nil 
		help: 'Importe adicional'.
	newField 
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	^newField! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 02:07'!
buildForm
	"build the form preceding the detail list"

	| newRow |
	newRow := self newRowFor: self model.
	newRow 
		addMorphBack: (StringMorph contents: 'Fecha: ') ;
		addMorphBack: self buildDateField.
	self model providerIsRelevant ifTrue: [ 
		newRow 
			addMorphBack: (self buildRowSpacer: 20) ; 
			addMorphBack: (StringMorph contents: 'Proveedor: ') ;
			addMorphBack: self buildProviderField.
	 ].
	^newRow.! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CLom 12/7/2014 01:07'!
buildList
	"build a UI component to show the list of details of my model"

	| list |
	list := super buildList.
	list 
		"minWidth: 544 ; "
		"minWidth: self buildTitleBox width + 40 ; "
		hResizing: #spaceFill ; vResizing: #spaceFill ;  setNameTo: 'detailList' .
	^ list! !

!StockEventEditor methodsFor: 'list' stamp: 'CarlosLombardi 4/28/2014 00:35'!
buildMorphList
	"build the list of morphs to show"

	"reset the list of ui renderers"
	detailUiRenderers := OrderedCollection new.
	
	"build and returns the list of morphs"
	^super buildMorphList! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/24/2014 22:42'!
buildPane
	"build the UI container component including all the controls"

	^(self uiBuilder 
		newColumn: { 
			self buildForm . self buildTitleBox . self buildList . 
			self buildTotalsRow . self buildButtonBar }) 
		cellInset: 0 ; yourself.
! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/19/2014 22:12'!
buildProviderField
	"creates and answer a UI component to edit the provider of the event being edited"

	| newField authorityUIRenderer |
	authorityUIRenderer := AuthorityEditorEmittingSignals  for: self model lab.
	newField := authorityUIRenderer buildField.
	newField 
		setNameTo: 'provider' ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid.
	^newField
! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CLom 11/21/2014 11:48'!
buildRemoveButton
	"..."
	
	^self uiBuilder 
		newButtonFor: self
		action: #removeSelectedDetail
		getEnabled: #thereIsSomethingSelected
    		label: 'Eliminar linea' translated 
		help: 'Elimina la linea elegida' translated.! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/2/2014 14:38'!
buildRowFor: anEditingEventDetail
	"a row being an ui for the given event detail edit controller"

	| uiRenderer newRow |
	uiRenderer := StockEventDetailEditor for: anEditingEventDetail.
	newRow := self newRowFor: anEditingEventDetail.
	newRow 
		addMorphBack: uiRenderer buildElementField ;
		addMorphBack: uiRenderer buildQuantityField ; 
		addMorphBack: uiRenderer buildStockUnitField ; 
		addMorphBack: uiRenderer buildUnitPriceField ;
		addMorphBack: uiRenderer buildTotalAmountField.
	uiRenderer window: newRow.
	"remember the uiRenderer, just to let it have a reference outside the dependent arrays"
	detailUiRenderers addLast: uiRenderer.
	^newRow.! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/23/2014 13:49'!
buildSaveButton
	"..."
	
	^self uiBuilder 
		newButtonFor: self
		action: #saveEvent
    		label: 'Aceptar' translated 
		help: 'Aceptar el registro de la nueva compra de reactivos' translated.

! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CLom 12/7/2014 01:32'!
buildTitleBox
	"creates and answers the morph to include as title box"

	| titleBuilder |

	titleBuilder := TitleBuilder new.
	titleBuilder
		addString: 'Reactivo o consumible' width: 200 ;
		addString: 'Cantidad' width: 188 ; 
		addString: 'Precio unitario' width: 120 ;
		addString: 'Importe' width: 120.
	^titleBuilder titleBox

! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CLom 12/27/2014 03:39'!
buildTotalsRow
	"build the row for extraAmount and totalAmount"

	| builder totalAmountDisplayField totalAmountLabel extraAmountLabel extraAmountField leftMargin |
	totalAmountDisplayField := self buildTotalAmountField.
	totalAmountDisplayField setNameTo: 'eventTotalAmount'.
	totalAmountLabel := StringMorph contents: 'Importe total: '.
	leftMargin := 524 - (totalAmountLabel width + 8).
	self model extraAmountIsRelevant
		ifTrue: [ 
			extraAmountLabel := StringMorph contents: 'Importe adicional: '.
			extraAmountField := self buildExtraAmountField.
			leftMargin := leftMargin - (extraAmountLabel width + extraAmountField width + 44).
		].
	builder := TitleBuilder new.
	builder addMorph: (self buildRowSpacer: leftMargin).
	self model extraAmountIsRelevant
		ifTrue: [ builder addMorph: extraAmountLabel; addMorph: extraAmountField;
				addMorph: (self buildRowSpacer: 20) ].
	builder addMorph: totalAmountLabel; addMorph: totalAmountDisplayField.
	^ builder titleBox! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CLom 12/27/2014 03:26'!
buildTotalsRowx
	"build the row for extraAmount and totalAmount"

	| newRow totalAmountDisplayField |
	newRow := TitleBuilder new titleBox.
	totalAmountDisplayField := self buildTotalAmountField.
	totalAmountDisplayField setNameTo: 'eventTotalAmount'.
	newRow hResizing: #spaceFill.
	newRow
		addMorphBack: self buildRowFillSpacer.
	self model extraAmountIsRelevant ifTrue: [ 
		newRow
			addMorphBack: (StringMorph contents: 'Importe adicional: ');
			addMorphBack: self buildExtraAmountField;
			addMorphBack: (self buildRowSpacer: 20) .
	].
	newRow
		addMorphBack: (StringMorph contents: 'Importe total: ');
		addMorphBack: totalAmountDisplayField;
		addMorphBack: (self buildRowSpacer: 2).
	^ newRow! !

!StockEventEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/19/2014 22:06'!
dateField
	"the field in my form corresponding to the date"

	^self window submorphNamed: #date! !

!StockEventEditor methodsFor: 'ui accessing' stamp: 'CLom 12/7/2014 01:16'!
detailList
	"the list of morph details"

	^self window submorphNamed: 'detailList'! !

!StockEventEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/23/2014 11:02'!
model: obj
	"set the object I edit, in this case is a EditingStockEventDetail"

	super model: obj.
	model addDependent: self! !

!StockEventEditor methodsFor: 'list' stamp: 'CarlosLombardi 4/28/2014 00:35'!
objectsToShow
	"the list of objects to be rendered, in the proper order"
	^self model editingDetails ! !

!StockEventEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/19/2014 22:15'!
providerField
	"the field in my form corresponding to the provider"

	^self window submorphNamed: 'provider'! !

!StockEventEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/24/2014 22:59'!
removeSelectedDetail
	"removes the selected detail from the edition of the event"

	self model removeFromEditingDetails: self selectedObject.
	self invalidateList.
	self totalAmountChanged.! !

!StockEventEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/23/2014 13:51'!
saveEvent
	"save the event in the lab"

	self model saveEvent.
	self window delete.! !

!StockEventEditor methodsFor: 'updating' stamp: 'CarlosLombardi 3/24/2014 22:58'!
totalAmountChanged
	self totalAmountField textChanged! !

!StockEventEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/23/2014 11:17'!
totalAmountField
	"the field in my form corresponding to the total amount of the event"

	^self window submorphNamed: 'eventTotalAmount'! !

!StockEventEditor methodsFor: 'updating' stamp: 'CLom 12/7/2014 01:43'!
update: aSymbol
	"handling of receiving events"

	"events from UI to model"
	"provider selection"
	aSymbol = #providerChanged | (aSymbol = #providerCleared)
		ifTrue: [ self model provider: self providerField model selectedAuthority].	
	
	"events from model to UI"	

	"detail list changed"
	aSymbol = #detailList
		ifTrue: [ self invalidateList. ].
			
	"total amount of a detail changed"
	aSymbol = #totalAmount
		ifTrue: [ self totalAmountChanged ].! !

!StockEventEditor methodsFor: 'ui accessing' stamp: 'CLom 11/22/2014 03:08'!
window: aWindow
	"the window I use to do my rendering"

	super window: aWindow.
	self model providerIsRelevant ifTrue: [ 
		self providerField model addDependent: self.
	].
! !

!StockEventEditor methodsFor: 'ui building' stamp: 'CLom 11/21/2014 23:48'!
windowTitle
	"..."

	self subclassResponsibility ! !

BaseListEditor subclass: #BaseStringListEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BaseStringListEditor commentStamp: '<historical>' prior: 0!
A superclass for editors based on a list of Strings.
The corresponding list morph in a rendering of a BaseStringListEditor must refer to #stringList to obtain its contents.
!

!BaseStringListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 00:37'!
buildDropList
	"build a UI component to show this list as a drop list"
	
	^(self uiBuilder 
                newDropListFor: self   
                list: #stringList
                getSelected: #selectedIndex
                setSelected: #selectedIndex:
                help: self helpText)
		hResizing: #spaceFill ; vResizing: #rigid ; 
		width: self width ; minWidth: self width ; yourself

! !

!BaseStringListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/13/2014 14:30'!
invalidateList
	"the list must be rebuilt"
	self selectedIndex: 0.
	self changed: #stringList! !

!BaseStringListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/13/2014 14:11'!
stringList
	"the list of strings to show"
	
	^self subclassResponsibility ! !

!BaseStringListEditor methodsFor: 'list' stamp: 'CarlosLombardi 4/1/2015 12:10'!
updateList
	"the list must be updated because of an external change"
	
	| selected |
	selected := self selectedObject.
	self invalidateList.
	(self objectList includes: selected) ifTrue: [ 
		self selectedObject: selected.		
	]
! !

!BaseStringListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 00:37'!
width
	"..."

	^200! !

BaseStringListEditor subclass: #BuyingRequirementSelector
	instanceVariableNames: 'provider computedRequirements selectedFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingRequirementSelector commentStamp: '<historical>' prior: 0!
A DropList for BuyingRequirement's 

(BuyingRequirementDropListModel for: aLab) buildDropList!

!BuyingRequirementSelector methodsFor: 'ui building' stamp: 'CLom 12/5/2014 09:51'!
buildDropList
	"build a UI component to show this list as a drop list"
	
	^super buildDropList 
		width: 500 ; minWidth: 500 ; yourself! !

!BuyingRequirementSelector methodsFor: 'filter chooser' stamp: 'CLom 12/13/2014 12:19'!
buildFilterChooser
	"build a UI component to show this list as a drop list"
	
	^(self uiBuilder 
                newDropListFor: self   
                list: #filterChooserOptions
                getSelected: #selectedFilter
                setSelected: #selectedFilter:
                help: self filterChooserHelpText)
		hResizing: #spaceFill ; vResizing: #rigid ; 
		width: 300 ; minWidth: 300 ; yourself
! !

!BuyingRequirementSelector methodsFor: 'list' stamp: 'CLom 12/17/2014 11:43'!
buildStringFor: aBuyingReq
	"The string to show corresponding to aBuyingReq"

	| descriptor |
	descriptor := BuyingRequirementDescriptor for: aBuyingReq .
	descriptor forOnlyPendingDetails ;
		addDate ; addTotalQuantity ; addRelevantDetails: 2.
	^descriptor stringDescription.




! !

!BuyingRequirementSelector methodsFor: 'list' stamp: 'CLom 12/7/2014 00:42'!
computedRequirements
	"Private - the computed list of pending buying requirements to show in this list."
	
	^computedRequirements 
	! !

!BuyingRequirementSelector methodsFor: 'filter chooser' stamp: 'CLom 12/13/2014 13:03'!
filterByProvider
	"whether the pending is filtered wrt the selected provider"
	^ selectedFilter = 1! !

!BuyingRequirementSelector methodsFor: 'filter chooser' stamp: 'CLom 12/13/2014 12:19'!
filterChooserHelpText
	"..."

	^'Elegir si el pendiente se filtra o no por proveedor'! !

!BuyingRequirementSelector methodsFor: 'filter chooser' stamp: 'CLom 12/13/2014 12:44'!
filterChooserOptions
	"the options for the filter chooser, i.e., filter by provider, or do not filter"
	
	^{ 'Filtrar pendientes según proveedor elegido' . 'No filtrar pendientes' }.! !

!BuyingRequirementSelector methodsFor: 'ui building' stamp: 'CLom 12/6/2014 22:17'!
helpText
	"..."

	^'Pedidos con cantidades pendientes'! !

!BuyingRequirementSelector methodsFor: 'initialize-release' stamp: 'CLom 12/13/2014 12:44'!
initialize
	"preparation for life"

	super initialize.
	self selectedFilter: 1.! !

!BuyingRequirementSelector methodsFor: 'list' stamp: 'CLom 12/7/2014 00:40'!
invalidateList
	"the list must be rebuilt"
	
	computedRequirements := self requirementsToShow.
	super invalidateList.! !

!BuyingRequirementSelector methodsFor: 'list' stamp: 'CLom 12/7/2014 00:42'!
objectList
	"The list of object being shown"
	
	^computedRequirements 
	! !

!BuyingRequirementSelector methodsFor: 'accessing' stamp: 'CLom 12/6/2014 15:53'!
provider
	^ provider! !

!BuyingRequirementSelector methodsFor: 'accessing' stamp: 'CLom 12/13/2014 13:06'!
provider: anObject
	provider := anObject.
	self filterByProvider ifTrue: [ self invalidateList. ].
! !

!BuyingRequirementSelector methodsFor: 'list' stamp: 'CLom 12/17/2014 02:46'!
requirementsToShow
	"A list with the pending buying requirements to show in this list."
	
	| allBuyingRequirements |
	allBuyingRequirements := EventQuery new
		lab: self model ; addToExplicitConditions: [ :event | event isABuyingRequirement ] ;
		forSortEventsByReversedDate ;
		events.
	^(self provider isNil | self filterByProvider not)
		ifTrue: [ allBuyingRequirements
					collect:  #pendingState
					thenSelect: [ :pendState | pendState totalQuantity > 0 ] ]
		ifFalse: [ allBuyingRequirements 
					collect:  [:req | req pendingState buyingProposalForProvider: self provider ] 
					thenSelect: #notNil ]

	! !

!BuyingRequirementSelector methodsFor: 'filter chooser' stamp: 'CLom 12/13/2014 12:22'!
selectedFilter
	^ selectedFilter! !

!BuyingRequirementSelector methodsFor: 'filter chooser' stamp: 'CLom 12/13/2014 13:07'!
selectedFilter: anObject
	| oldSelectedFilter |
	oldSelectedFilter := selectedFilter.
	selectedFilter := anObject.
	(oldSelectedFilter = selectedFilter) ifFalse: [ self invalidateList. ].
	! !

!BuyingRequirementSelector methodsFor: 'accessing' stamp: 'CLom 12/5/2014 09:56'!
selectedIndex: anObject
	super selectedIndex: anObject.
	anObject = 0
		ifFalse: [ self changed: #selectedBuyingRequirementChanged ]
		ifTrue: [ self changed: #selectedBuyingRequirementCleared ].
! !

!BuyingRequirementSelector methodsFor: 'list' stamp: 'CLom 12/7/2014 00:40'!
stringList
	"the list of strings to show"
	
	^self computedRequirements collect: [ :req | self buildStringFor: req ].! !

BaseStringListEditor subclass: #GenericDropListModel
	uses: TBuildWindowFromForm
	instanceVariableNames: 'helpText renderBlock sortBlock width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!GenericDropListModel commentStamp: 'CarlosLombardi 3/25/2015 21:42' prior: 0!
A generic model for a drop list. 

"this is a simple example"
(GenericDropListModel for: someCollection )
	helpText: 'Some text' ;
	renderSelector: #abbreviation ;
	width: 80 ;
	open.


In order to obtain a working drop list, you must provide the following:
- the collection to be shown in the drop list, which is my model; it can be set at creation time by sending #for: to my class.
- a helpText.

By default, the #name of each element is shown. 
This default can be overriden by defining either a renderSelector or a renderBlock, to be evaluated on each element on my model.

By default, the elements are ordered by the rendered String uppercase. This default can be overriden by setting me a sortBlock.
The width defaults to 200, it can be overriden as well.!

GenericDropListModel class
	uses: TBuildWindowFromForm classTrait
	instanceVariableNames: ''!

!GenericDropListModel methodsFor: 'ui building' stamp: 'CarlosLombardi 3/25/2015 21:24'!
buildForm
	"build a test form"

	| newForm |
	newForm := self buildEmptyColumn .
	newForm addMorphBack: self buildDropList.
	^newForm! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:10'!
helpText
	^ helpText! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:10'!
helpText: anObject
	helpText := anObject! !

!GenericDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 3/25/2015 21:17'!
objectList
	"the list of objects to render"

	^ self model asSortedCollection: self sortBlock! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:26'!
renderBlock
	^ renderBlock ifNil: [ #name ]! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:10'!
renderBlock: anObject
	renderBlock := anObject! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:14'!
renderSelector: aSelector
	self renderBlock: aSelector! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:16'!
sortBlock
	^ sortBlock ifNil: [ [ :elem1 :elem2 | 
				(self stringToRender: elem1) asUppercase < (self stringToRender: elem1) asUppercase 
	   ] ]! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:10'!
sortBlock: anObject
	sortBlock := anObject! !

!GenericDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 3/25/2015 21:18'!
stringList
	"the list of strings to show"

	^ self objectList collect: [ :elem | self stringToRender: elem ]! !

!GenericDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 3/25/2015 21:13'!
stringToRender: anObject
	"the string I use to render anObject "
	^self renderBlock value: anObject! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:28'!
width
	^ width ifNil: [ 200 ]! !

!GenericDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:27'!
width: anObject
	width := anObject! !

!GenericDropListModel methodsFor: 'ui building' stamp: 'CarlosLombardi 3/25/2015 21:32'!
windowTitle
	"the title for a test window"

	^'Testing a drop list'! !

BaseStringListEditor subclass: #LogEntryDropListModel
	uses: TOrderOfLogEntries
	instanceVariableNames: 'logEntriesWithDepths'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LogEntryDropListModel commentStamp: 'CarlosLombardi 3/28/2015 17:39' prior: 0!
A model for a drop list to select a LabProjectLogEntry among the entries of a given LabProject, excluding a given log. 
My model is a pair (LabProject, excuded log entry).
If the excluded log entry is nil, then all the entries in the given LabProject are considered.
But ... the selected object is a pair (depth, logEntry).

LogEntryDropListModel new 
	model: (aLabProject -> an excluded logEntry) ;
	buildDropList 
!

LogEntryDropListModel class
	uses: TOrderOfLogEntries classTrait
	instanceVariableNames: ''!

!LogEntryDropListModel methodsFor: 'ui building' stamp: 'CarlosLombardi 3/7/2015 23:18'!
helpText
	"..."

	^'Registros de actividad'! !

!LogEntryDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/7/2015 23:19'!
logEntries
	"the collection of logEntries I must show - needed by TOrderOfLogEntries "

	^model! !

!LogEntryDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2015 17:38'!
model: assoc
	"the association is (LabProject, excluded LogEntry)"

	super model: assoc .
	logEntriesWithDepths := assoc key flattenDescendantsWithDepthExcluding: assoc value.
! !

!LogEntryDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 3/8/2015 23:57'!
objectList
	"the list of objects to render"

	^logEntriesWithDepths collect: #value! !

!LogEntryDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 3/28/2015 17:47'!
stringList
	"the list of strings to show"

	^logEntriesWithDepths collect: [:elem | elem value 
		ifNil: [ '<actividad principal>' ] 
		ifNotNil: [ (String new: (5 * (elem key)) withAll: $ ), elem value description ] 
	  ] .! !

BaseStringListEditor subclass: #ReagentListEditor
	uses: TBuildWindowFromPane + TListOfNames + TEditObjectInListButtons + TBusinessObjectEditionInList + TReagentListEditorActions
	instanceVariableNames: 'cachedReagentList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ReagentListEditor commentStamp: '<historical>' prior: 0!
A window to edit the list of reagents of a Lab. The name of each reagent is shown.!

ReagentListEditor class
	uses: TBuildWindowFromPane classTrait + TListOfNames classTrait + TEditObjectInListButtons classTrait + TBusinessObjectEditionInList classTrait + TReagentListEditorActions classTrait
	instanceVariableNames: ''!

!ReagentListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/14/2014 16:45'!
buildList
	"build a UI component to show the list of reagent of my model"
	
	^(self uiBuilder 
                newListFor: self   
                list: #stringList
                selected: #selectedIndex
                changeSelected: #selectedIndex:
                help: 'Reactivos de este Laboratorio')
		width: 200 ; yourself

! !

!ReagentListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/31/2015 22:31'!
buildObjectList
	"build and remember the list of reagents to be shown"

	cachedReagentList := 
	self model 
		ifNotNil: [ :lab | lab reagents asSortedCollection: [ :r1 :r2 | r1 name asUppercase < r2 name asUppercase ] ]
		ifNil: [ #() ] ! !

!ReagentListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/10/2014 21:46'!
buildPane
	"build the edit button"
	
	^self uiBuilder 
		newColumn: { self buildList . self buildButtonBar }.

! !

!ReagentListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/2/2014 14:07'!
helpText
	"..."

	^'Reactivos de este laboratorio'! !

!ReagentListEditor methodsFor: 'list' stamp: 'CarlosLombardi 4/1/2015 11:43'!
invalidateList
	"the list must be rebuilt"
	
	self buildObjectList.
	super invalidateList.
! !

!ReagentListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/24/2014 23:44'!
model: obj
	"set the object I edit, in this case is a Lab"

	super model: obj.
	model addDependent: self! !

!ReagentListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/31/2015 22:23'!
objectList
	"the reagents to include in the list"

	cachedReagentList ifNil: [ self buildObjectList ].
	^cachedReagentList ! !

!ReagentListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/16/2014 12:42'!
selectedIndex: anObject
	super selectedIndex: anObject.
	anObject = 0
		ifFalse: [ self changed: #selectedReagentChanged ]
		ifTrue: [ self changed: #selectedReagentCleared ].
! !

!ReagentListEditor methodsFor: 'updating' stamp: 'CarlosLombardi 4/1/2015 11:43'!
update: aSymbol
	"I am informed of some interesting event"

	(aSymbol = #labReagentList) ifTrue: [ 
		self updateList .
	]
! !

!ReagentListEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/2/2014 09:41'!
windowTitle
	"..."

	^'Lista de Reactivos'! !

BaseStringListEditor subclass: #SolutionDropListModel
	uses: TListOfNames
	instanceVariableNames: 'cachedSolutionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Solutions'!

!SolutionDropListModel commentStamp: 'CarlosLombardi 3/20/2015 18:34' prior: 0!
An object having the ability to create a drop list to select a Solution, from the solutions registered at a given Lab. 
Its model is the Lab. 
!

SolutionDropListModel class
	uses: TListOfNames classTrait
	instanceVariableNames: ''!

!SolutionDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 3/31/2015 22:31'!
buildObjectList
	"build and remember the list of objects to render"

	cachedSolutionList := self sortByUppercaseName: self model solutions.
! !

!SolutionDropListModel methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 00:48'!
helpText
	"..."

	^'Elegir la solución deseada'! !

!SolutionDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 4/1/2015 11:46'!
invalidateList
	"the list must be rebuilt"
	
	self buildObjectList.
	super invalidateList.
! !

!SolutionDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/31/2015 22:39'!
model: obj
	"set my reference object, in this case is a Lab"

	super model: obj.
	model addDependent: self! !

!SolutionDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 3/31/2015 22:31'!
objectList
	"the list of objects to render"

	cachedSolutionList ifNil: [ self buildObjectList ].
	^cachedSolutionList 
! !

!SolutionDropListModel methodsFor: 'sorting' stamp: ''!
sortByUppercaseName: aCollection
	"a collection having the same elements as aCollection, sorted by their uppercase name"

	^aCollection asSortedCollection: self uppercaseNameSortBlock .! !

!SolutionDropListModel methodsFor: 'list' stamp: ''!
stringList
	"the list of strings to show"

	^self objectList collect: [ :obj | obj name ]! !

!SolutionDropListModel methodsFor: 'updating' stamp: 'CarlosLombardi 4/1/2015 11:47'!
update: aSymbol
	"I am informed of some interesting event"

	(aSymbol = #labSolutionList) ifTrue: [ 
		self updateList .
	]
! !

!SolutionDropListModel methodsFor: 'sorting' stamp: ''!
uppercaseNameSortBlock
	"a block to build a collection sorted by the uppercase name of its elements"

	^[ :obj1 :obj2 | obj1 name asUppercase < obj2 name asUppercase ]! !

!SolutionDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 10:53'!
width
	"..."

	^300! !

BaseStringListEditor subclass: #StockElementDropListModel
	uses: TListOfNames
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!StockElementDropListModel commentStamp: '<historical>' prior: 0!
A DropList for stock elements 

(StockElementDropListModel for: aLab) buildDropList!

StockElementDropListModel class
	uses: TListOfNames classTrait
	instanceVariableNames: ''!

!StockElementDropListModel methodsFor: 'ui building' stamp: 'CarlosLombardi 5/2/2014 14:09'!
helpText
	"..."

	^'Elementos de stock de este laboratorio'! !

!StockElementDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 5/2/2014 14:00'!
model: obj
	"set the object I edit, in this case is a Lab"

	super model: obj.
	model addDependent: self! !

!StockElementDropListModel methodsFor: 'list' stamp: 'CarlosLombardi 3/20/2015 00:41'!
objectList
	"the stock elements to include in the list"

	^self model 
		ifNotNil: [ :lab | lab stockElements asSortedCollection: self uppercaseNameSortBlock ]
		ifNil: [ #() ]	! !

!StockElementDropListModel methodsFor: 'accessing' stamp: 'CarlosLombardi 5/2/2014 14:10'!
selectedIndex: anObject
	super selectedIndex: anObject.
	anObject = 0
		ifFalse: [ self changed: #selectedStockElementChanged ]
		ifTrue: [ self changed: #selectedStockElementCleared ].
! !

!StockElementDropListModel methodsFor: 'updating' stamp: 'CarlosLombardi 5/2/2014 14:11'!
update: aSymbol
	"I am informed of some interesting event"

	((aSymbol = #labReagentList) | (aSymbol = #labConsumableList)) ifTrue: [ 
		self invalidateList .
		self changed: #stringList.
	]! !

BaseStringListEditor subclass: #StockUnitListEditor
	uses: TListOfNames @ {#stringListForField->#stringList} - {#stringList} + TEditObjectInListButtons + TBuildWindowFromPane + TBusinessObjectEditionInList
	instanceVariableNames: 'list whatToShow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!StockUnitListEditor commentStamp: '<historical>' prior: 0!
The UI renderer for the list of stock units.
Beware!!!! In the current version, a StockUnitListEditor expect its model to be an EditingReagent. It is necessary only for the defaultValue.!

StockUnitListEditor class
	uses: TListOfNames classTrait + TEditObjectInListButtons classTrait + TBuildWindowFromPane classTrait + TBusinessObjectEditionInList classTrait
	instanceVariableNames: ''!

!StockUnitListEditor methodsFor: 'bo edition' stamp: 'CLom 12/28/2014 00:54'!
addNewBusinessObject: aStockUnit
	"..."

	self lab addToStockUnits: aStockUnit ! !

!StockUnitListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/28/2014 00:29'!
addString: aString
	"adds aString to the list of strings to show"

	list add: (StockUnit new name: aString ; yourself).
	self changed: #stringList.
	^aString! !

!StockUnitListEditor methodsFor: 'ui building' stamp: 'CLom 12/28/2014 01:01'!
buildField
	"builds and returns a field to allow my edition inside a form"

	| newField |
	whatToShow := #field.
	newField := self uiBuilder 
		newEditableDropListFor: self 
		list: #stringList 
		getSelected: #selectedIndex 
		setSelected: #selectedIndex:
		addToList: #addString: 
		class: String
		default: nil
		ghostText: 'es posible agregar una nueva unidad de stock' 
		getEnabled: nil 
		useIndex: true
		help: 'Unidad de stock'.
	newField 
		width: 100 ; 
		hResizing: #rigid.
	"to set the default for the list"
	self selectedObject: self defaultValue.
	^newField! !

!StockUnitListEditor methodsFor: 'list' stamp: 'CLom 12/28/2014 01:01'!
buildList
	"build a UI component to show the list of stock units of my model"
	
	whatToShow := #list.
	^(self uiBuilder 
                newListFor: self   
                list: #stringList
                selected: #selectedIndex
                changeSelected: #selectedIndex:
                help: 'Unidades de medida de este Laboratorio')
		width: 200 ; yourself! !

!StockUnitListEditor methodsFor: 'ui building' stamp: 'CLom 12/28/2014 00:06'!
buildPane
	"build the edit button"
	
	^self uiBuilder 
		newColumn: { self buildList . self buildButtonBar }.

! !

!StockUnitListEditor methodsFor: 'bo edition' stamp: 'CLom 12/28/2014 00:49'!
createBusinessObjectEditorFor: aStockUnit
	"..."

	^StockUnitEditor for: aStockUnit ! !

!StockUnitListEditor methodsFor: 'bo edition' stamp: 'CLom 12/28/2014 00:48'!
createNewBusinessObject
	"..."

	^StockUnit new
! !

!StockUnitListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 01:26'!
defaultValue
	"the default value for my field"

	^self model stockUnit ! !

!StockUnitListEditor methodsFor: 'list' stamp: 'CLom 12/28/2014 01:04'!
getListFromLab
	"obtain the list from the lab of my model"

	list := self lab stockUnits ! !

!StockUnitListEditor methodsFor: 'ui building' stamp: 'CLom 12/28/2014 00:08'!
helpText
	"..."

	^'Unidades de medida de este laboratorio'! !

!StockUnitListEditor methodsFor: 'accessing' stamp: 'CLom 12/28/2014 00:53'!
lab
	"the lab whose stock units I am editing"

	^self model lab  
! !

!StockUnitListEditor methodsFor: 'accessing' stamp: 'CLom 12/28/2014 01:05'!
model: obj
	"set the object I edit, in this case is an EditingReagent"

	super model: obj.
	self getListFromLab.
! !

!StockUnitListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/28/2014 00:31'!
objectList
	"the list of strings to show"

	^list asSortedCollection: [ :n1 :n2 | n1 name asUppercase <= n2 name asUppercase ]! !

!StockUnitListEditor methodsFor: 'bo edition' stamp: 'CLom 12/28/2014 01:35'!
removeBusinessObject: aStockUnit
	"..."

	[ self lab removeFromStockUnits: aStockUnit ]
		on: Error 
		do: [ :e | self window message: e messageText title: 'Error' ]! !

!StockUnitListEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2014 01:22'!
selectedIndex: anObject
	super selectedIndex: anObject.
	self changed: #stockUnitChanged.! !

!StockUnitListEditor methodsFor: 'list' stamp: 'CLom 12/28/2014 01:10'!
stringList
	"the list of strings to show"

	^self perform: ('stringListFor', whatToShow capitalized) asSymbol! !

!StockUnitListEditor methodsFor: 'list' stamp: 'CLom 12/28/2014 01:06'!
stringListForList
	"the list of strings to show in the list (not drop-down)"

	self getListFromLab.
	^self objectList collect: [ :obj | obj asString ]! !

!StockUnitListEditor methodsFor: 'bo edition' stamp: 'CLom 12/28/2014 01:19'!
textForRemoveBusinessObjectConfirmation: aStockUnit
	"..."

	| textBuilder |
	textBuilder := WriteStream on: ''.
	textBuilder 
		nextPutAll: 'Confirmar eliminación de: ', aStockUnit name.
	^textBuilder contents
! !

!StockUnitListEditor methodsFor: 'ui building' stamp: 'CLom 12/28/2014 00:08'!
windowTitle
	"..."

	^'Unid. medida'! !

BaseStringListEditor subclass: #StringListEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!StringListEditor commentStamp: '<historical>' prior: 0!
A base class editor for a list of strings. 
If used only to show a list of strings, i.e. never modify the list, it is enough to realize the method #stringList.!

StringListEditor subclass: #AuthorityEditor
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!AuthorityEditor methodsFor: 'list' stamp: 'CarlosLombardi 10/4/2014 13:55'!
addString: aString
	"adds aString to the list of strings to show"

	(list includes: aString)
	ifTrue: [ self selectedObject: aString ]
	ifFalse: [ 
		list add: aString.
		self changed: #stringList.
	 ].
	^aString! !

!AuthorityEditor methodsFor: 'list' stamp: 'CarlosLombardi 10/4/2014 12:02'!
authorityList
	"the list of possible authorities"

	self subclassResponsibility ! !

!AuthorityEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/19/2014 21:51'!
buildField
	"builds and returns a field to allow my edition inside a form"

	| newField |
	newField := self uiBuilder 
		newEditableDropListFor: self 
		list: #stringList 
		getSelected: #selectedIndex 
		setSelected: #selectedIndex:
		addToList: #addString: 
		class: String
		default: nil
		ghostText: 'es posible agregar una nueva autoridad para referencias' 
		getEnabled: nil 
		useIndex: true
		help: self helpMessage.
	newField 
		width: 120 ; 
		hResizing: #rigid.
	"to set the default for the list"
	self selectedObject: self defaultValue.
	^newField! !

!AuthorityEditor methodsFor: 'list' stamp: 'CarlosLombardi 10/4/2014 13:13'!
buildList
	"creates and answers the list of strings to show. To be called on initialization"

	^(self authorityList collect: [ :auth | auth name ]) asSortedCollection! !

!AuthorityEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 11:58'!
defaultAuthority
	"the default authority"

	self subclassResponsibility 
! !

!AuthorityEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/19/2014 21:52'!
defaultIndex
	"the default value for my field"

	^self indexForObject: self defaultValue! !

!AuthorityEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 12:23'!
defaultValue
	"the default value for my field"
	
	^self defaultAuthority
		ifNil: [ '' ]
		ifNotNil: [:auth | auth name]! !

!AuthorityEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/19/2014 21:53'!
helpMessage
	"the help message for my field"
	
	^self subclassResponsibility ! !

!AuthorityEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 12:13'!
lab
	"the reference Lab"

	self subclassResponsibility 
! !

!AuthorityEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 4/29/2014 18:34'!
model: obj
	"set the object I edit, in this case is an ReagentReferenceEditController"

	super model: obj.
	list := self buildList.! !

!AuthorityEditor methodsFor: 'objects' stamp: 'CarlosLombardi 10/4/2014 13:36'!
selectedAuthority
	"the selected authority, nil if nothing selected"

	| selectedString |
	selectedString := self selectedObject.
	^selectedString isEmpty
		ifTrue: [ nil ]
		ifFalse: [ (self lab referenceAuthorityNamed: selectedString) 
					ifNil: [ Provider newNamed: selectedString  ] ]
		
! !

!AuthorityEditor methodsFor: 'objects' stamp: 'CarlosLombardi 3/19/2014 21:55'!
selectedObject
	"the selected object. In this case seems to be better to give the empty string, instead of nil, if nothing is selected"

	^super selectedObject ifNil: [ '' ]! !

!AuthorityEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/20/2014 19:34'!
stringList
	"the list of strings to show"

	^list asSortedCollection: [ :n1 :n2 | n1 asUppercase <= n2 asUppercase ]! !

AuthorityEditor subclass: #AuthorityEditorEmittingSignals
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!AuthorityEditorEmittingSignals class methodsFor: 'testing' stamp: 'CarlosLombardi 3/19/2014 21:58'!
isAbstractClass
	self shouldBeImplemented! !

!AuthorityEditorEmittingSignals methodsFor: 'list' stamp: 'CarlosLombardi 10/4/2014 12:03'!
authorityList
	"the list of possible authorities"
	
	^self model providers ! !

!AuthorityEditorEmittingSignals methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 11:57'!
defaultAuthority
	"the default authority"

	^self model defaultProvider 
! !

!AuthorityEditorEmittingSignals methodsFor: 'accessing' stamp: 'CarlosLombardi 3/19/2014 21:59'!
helpMessage
	"the help message for my field"

	^'Elija el proveedor, puede agregar un nuevo proveedor desde aqui'! !

!AuthorityEditorEmittingSignals methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 12:14'!
lab
	"the reference Lab"

	^self model! !

!AuthorityEditorEmittingSignals methodsFor: 'accessing' stamp: 'CarlosLombardi 10/3/2014 23:24'!
selectedIndex: anObject
	super selectedIndex: anObject.
	anObject = 0
		ifFalse: [ self changed: #providerChanged ]
		ifTrue: [ self changed: #providerCleared ].
! !

AuthorityEditor subclass: #AuthorityInReagentEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!AuthorityInReagentEditor commentStamp: '<historical>' prior: 0!
A model for the editable drop-box of the reference authorities (other from CAS) inside the edition of a reagent.!

!AuthorityInReagentEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 13:12'!
authorityList
	"the list of possible authorities"
	
	^self model authoritiesToChoose 
! !

!AuthorityInReagentEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 11:59'!
defaultAuthority
	"the default authority"

	^self model authority! !

!AuthorityInReagentEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2014 01:07'!
helpMessage
	"the help message for my field"

	^'Autoridad'! !

!AuthorityInReagentEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 12:15'!
lab
	"the reference Lab"

	^self model lab! !

!AuthorityInReagentEditor methodsFor: 'actions' stamp: 'CarlosLombardi 10/4/2014 13:34'!
updateModel
	"set the authority value for my ReagentReferenceEditController"

	self model authority: self selectedAuthority.
! !

!StringListEditor methodsFor: 'list' stamp: 'CarlosLombardi 3/13/2014 14:11'!
objectList
	"the list of objects to render"

	^self stringList! !

ObjectEditor subclass: #BuyingRequirementStateView
	instanceVariableNames: 'detailCurrentView proposalsView proposalDetailView satisfactionsView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!BuyingRequirementStateView commentStamp: '<historical>' prior: 0!
A view of the current state of a BuyingRequirement.

Model: the BuyingRequirement.!

!BuyingRequirementStateView methodsFor: 'ui building' stamp: 'CLom 12/13/2014 19:11'!
buildWindow
	"builds and returns the editing window"

	| newWindow centreRow |
	self initializeViews.
		
	centreRow := (self uiBuilder newRow: {  proposalsView buildPane . proposalDetailView buildPane }) 
		cellInset:  10 ; yourself.
	newWindow := StandardWindow labelled: self windowTitle.
	
	newWindow addMorph: detailCurrentView buildPane frame: (0 @ 0 corner: 1 @ 0.31).
	newWindow addMorph: centreRow frame: (0 @ 0.34 corner: 1 @ 0.65).
	newWindow addMorph: satisfactionsView buildPane frame: (0 @ 0.68 corner: 1 @ 1).
	
	newWindow width: 980 ; height: 650.

	^ newWindow

"	^ self prebuildWindow 
"! !

!BuyingRequirementStateView methodsFor: 'initialize-release' stamp: 'CLom 12/13/2014 19:03'!
initializeViews
	"Create the views for each of my panes. 
	 Beware: my model must be set before sending this message."

	detailCurrentView  := BuyingRequirementPendingView for: self model pendingState.
	proposalsView := BuyingRequirementProposalsView for: self model pendingState.
	proposalDetailView := BuyingProposalDetailView for: nil.
	satisfactionsView := BuyingRequirementSatisfactionView for: self model.
	
	proposalsView addDependent: self.
! !

!BuyingRequirementStateView methodsFor: 'updating' stamp: 'CLom 11/23/2014 16:58'!
update: event
	"An event relevant to me just happened"

	(event = #proposalSelectionChange) ifTrue: [ 
		proposalDetailView 
			model: proposalsView selectedObject ;
			updateView.
	].! !

!BuyingRequirementStateView methodsFor: 'ui building' stamp: 'CLom 12/13/2014 19:04'!
window: aWindow
	"the reference window where I do my rendering"

	super window: aWindow.
	detailCurrentView window: aWindow.
	proposalsView window: aWindow.
	proposalDetailView window: aWindow.
	satisfactionsView window: aWindow.
! !

!BuyingRequirementStateView methodsFor: 'ui building' stamp: 'CLom 11/23/2014 11:13'!
windowTitle
	"..."

	^'Pedido de compra del ', (self dateConverter objectAsString: self model date), ' - estado'! !

ObjectEditor subclass: #ConsumableEditor
	uses: TBuildWindowFromForm + TBusinessObjectEditorEdit
	instanceVariableNames: 'authorityEditors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ConsumableEditor commentStamp: '<historical>' prior: 0!
An object who knows how to edit a Consumable.

The edition works in collaboration with a ConsumableEditController.!

ConsumableEditor class
	uses: TBuildWindowFromForm classTrait + TBusinessObjectEditorEdit classTrait
	instanceVariableNames: ''!

!ConsumableEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/2/2014 10:03'!
buildForm
	"builds and returns a form tailored to edit my consumable"

	| consumableForm rows componentBuilder |
	componentBuilder := StockElementUIComponentBuilder new.
	componentBuilder element: self model ; lab: self lab ; editor: self.

	rows  := OrderedCollection new.
	componentBuilder 
		addNameFieldRowTo: rows ;
		addReferenceRowsTo: rows .

	"must remember the authority editors, created by the componentBuilder
	 when adding the reference rows"
	authorityEditors := componentBuilder authorityEditors.
	
	consumableForm := self uiBuilder newLabelGroup: rows asArray.
	consumableForm setNameTo: 'form'.
	
	^ consumableForm! !

!ConsumableEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 10:11'!
businessObject
	^ self model businessObject! !

!ConsumableEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 5/2/2014 10:13'!
lab
	"the lab being the context of my edition"

	^self model lab! !

!ConsumableEditor methodsFor: 'actions' stamp: 'CarlosLombardi 5/2/2014 10:14'!
updateModel
	"reflect edition in the consumable"

	"first update the EditingReagent reference edit controllers from the authority editors"
	authorityEditors do: [ :editor | editor updateModel ].
	"then update the Reagent from the EditingReagent"
	self model updateModel.! !

!ConsumableEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/2/2014 10:03'!
windowTitle

	^'Consumible'! !

ObjectEditor subclass: #LabApplicationMenu
	uses: TBuildWindowFromPane @ {#preBuildWindow->#buildWindow} - {#buildWindow}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!LabApplicationMenu commentStamp: '<historical>' prior: 0!
The main menu of the LabApplication!

LabApplicationMenu class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!LabApplicationMenu methodsFor: 'ui building' stamp: 'CarlosLombardi 3/24/2015 12:11'!
buildPane
	"builds the menu"

	| menuPane titleRow buttonRow |
	menuPane := self buildEmptyColumn .
	
	titleRow := self buildEmptyRow .
	titleRow cellInset: 16.
	titleRow 
		addMorphBack: ((self stringMorphFor: 'Cargar' centeredInWidth: 150) fillStyle: Color lightBlue ; yourself ) ;
		addMorphBack: ((self stringMorphFor: 'Ver' centeredInWidth: 150) fillStyle: Color lightBlue ; yourself );
		addMorphBack: ((self stringMorphFor: 'Administrar' centeredInWidth: 150) fillStyle: Color lightBlue ; yourself ).
	menuPane addMorphBack: titleRow.
	
	buttonRow := self buildEmptyRow .
	buttonRow cellInset: 16.
	buttonRow 
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #newRequirement
 	   		label: 'Pedido' help: 'Cargar un nuevo pedido') width: 150 ; height: 32 ; yourself) ;
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #showRequirements
 	   		label: 'Pedidos' help: 'Ver los pedidos cargados') width: 150 ; height: 32 ; yourself) ;
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #manageReagentsForSolutionPreparation
 	   		label: 'Reactivos (en solución)' help: 'Administrar los reactivos registrados') width: 150 ; height: 32 ; yourself) .
	menuPane addMorphBack: buttonRow.
	
	buttonRow := self buildEmptyRow .
	buttonRow cellInset: 16.
	buttonRow 
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #newBuyingEvent
 	   		label: 'Compra' help: 'Cargar una nueva compra') width: 150 ; height: 32 ; yourself) ;
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #showBuyingEvents
 	   		label: 'Compras' help: 'Ver las compras cargadas') width: 150 ; height: 32 ; yourself) ;
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #manageReagentsForStock
 	   		label: 'Reactivos (stock)' help: 'Administrar los reactivos registrados') width: 150 ; height: 32 ; yourself) .
	menuPane addMorphBack: buttonRow.

	buttonRow := self buildEmptyRow .
	buttonRow cellInset: 16.
	buttonRow 
		addMorphBack: (self buildRowSpacer: 150) ;
		addMorphBack: (self buildRowSpacer: 150) ;
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #manageConsumables
 	   		label: 'Consumibles' help: 'Administrar los consumibles registrados') width: 150 ; height: 32 ; yourself) .
	menuPane addMorphBack: buttonRow.

	buttonRow := self buildEmptyRow .
	buttonRow cellInset: 16.
	buttonRow 
		addMorphBack: (self buildRowSpacer: 150) ;
		addMorphBack: (self buildRowSpacer: 150) ;
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #manageStockUnits
 	   		label: 'Unid. medida' help: 'Administrar las unidades de medida') width: 150 ; height: 32 ; yourself) .
	menuPane addMorphBack: buttonRow.

	^menuPane! !

!LabApplicationMenu methodsFor: 'ui building' stamp: 'CarlosLombardi 3/24/2015 12:19'!
buildWindow
	"builds the window. Adds positioning to the algorithm taken from TBuildWindowFromPane"

	| theWindow thePane sumHeight |
	theWindow := self preBuildWindow .
	thePane := theWindow submorphNamed: 'mainPane'.
	sumHeight := (thePane submorphs collect: #height) sum.
	theWindow height: ((sumHeight + 20 + (8 * (thePane submorphs size + 2))) max: theWindow height ).

	theWindow position: 700@400.
	^theWindow! !

!LabApplicationMenu methodsFor: 'accessing' stamp: 'CLom 12/27/2014 17:13'!
lab
	"the lab I am editing/showing"

	^self model! !

!LabApplicationMenu methodsFor: 'actions' stamp: 'CLom 12/28/2014 01:37'!
manageConsumables
	"window to manage the consumables"

	| view |
	view := ConsumableMorphListEditor for: self model.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabApplicationMenu methodsFor: 'actions' stamp: 'CarlosLombardi 3/24/2015 12:25'!
manageReagentsForSolutionPreparation
	"window to manage the reagents"

	| view |
	view := ReagentInSolutionMorphListEditor for: self model.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabApplicationMenu methodsFor: 'actions' stamp: 'CarlosLombardi 3/24/2015 12:06'!
manageReagentsForStock
	"window to manage the reagents"

	| view |
	view := ReagentStockMorphListEditor for: self model.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabApplicationMenu methodsFor: 'actions' stamp: 'CLom 12/28/2014 01:38'!
manageStockUnits
	"window to manage the stock units"

	| view |
	view := StockUnitListEditor for: self.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabApplicationMenu methodsFor: 'actions' stamp: 'CLom 12/28/2014 01:38'!
newBuyingEvent
	"window to compile a new buying event"

	| beEditController beUiRenderer |
	beEditController := BuyingEventController forNewEvent.
	beEditController 
		lab: self model ; 
		provider: (self model providerNamed: 'SIGMA').
	beUiRenderer := BuyingEventEditor for: beEditController.
	beUiRenderer window position: 0@0.
	beUiRenderer uiParent: self window.
	beUiRenderer open.
! !

!LabApplicationMenu methodsFor: 'actions' stamp: 'CLom 12/28/2014 01:38'!
newRequirement
	"window to compile a new requirement"

	| beEditController beUiRenderer |
	beEditController := StockEventEditController forNewEventOfClass: BuyingRequirement.
	beEditController lab: self model.
	beUiRenderer := BuyingRequirementEditor for: beEditController.
	beUiRenderer uiParent: self window.
	beUiRenderer open.
! !

!LabApplicationMenu methodsFor: 'actions' stamp: 'CLom 12/28/2014 01:38'!
showBuyingEvents
	"window to show the registered buying events"

	| view |
	view := BuyingEventListView for: self model.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabApplicationMenu methodsFor: 'actions' stamp: 'CLom 12/28/2014 01:38'!
showRequirements
	"window to show the registered requirements"

	| view |
	view := BuyingRequirementListView for: self model.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabApplicationMenu methodsFor: 'ui building' stamp: 'CLom 12/15/2014 00:40'!
windowTitle
	"..."

	^''! !

ObjectEditor subclass: #LabProjectEditor
	uses: TBuildWindowFromForm + TBusinessObjectEditorEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectEditor commentStamp: 'CarlosLombardi 3/31/2015 19:39' prior: 0!
An editor for a LabProject. This edition does not require an edit controller, because it is straightforward.
My model is the LabProject.
!

LabProjectEditor class
	uses: TBuildWindowFromForm classTrait + TBusinessObjectEditorEdit classTrait
	instanceVariableNames: ''!

!LabProjectEditor methodsFor: 'ui building' stamp: 'FernandoDiMeglio 10/27/2015 21:38'!
buildDescriptionField
	"build and return a field to edit my model description"
	| descriptionField |
	
	descriptionField := self uiBuilder
		newTextMorphKeyStrokeSignalFor: self model
		context: self
		getText: #description
		setText: #description:
		help: 'Descripción breve del proyecto'.
	^ descriptionField! !

!LabProjectEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/30/2015 00:18'!
buildForm
	"build and return the editing form"

	| descriptionRow |
	descriptionRow := self buildEmptyRow.
	descriptionRow
		addMorphBack: (StringMorph contents: 'Descripción: ');
		addMorphBack: self buildDescriptionField.
	
	^self buildEmptyColumn
		addMorphBack: descriptionRow;
		yourself! !

!LabProjectEditor methodsFor: 'ui building' stamp: ''!
buildWindow
	"builds and returns a window which can be opened to edit my model"

	| newWindow |
	newWindow := self uiBuilder newPluggableDialogWindow: self windowTitle for: self buildForm.
	^ newWindow! !

!LabProjectEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/30/2015 00:26'!
businessObject
	"the business object related with me"

	^self model! !

!LabProjectEditor methodsFor: 'actions' stamp: 'FernandoDiMeglio 10/28/2015 21:56'!
edit
	"opens a window to edit my reagent"
	
	self enableDisableButtonInPosition: 10.
	self openModal.
	self window cancelled
		ifFalse: [ self updateModel ].
	^ self window cancelled not! !

!LabProjectEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/30/2015 00:23'!
helpText
	"..."

	^'Edición de datos básicos de un proyecto'! !

!LabProjectEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/30/2015 00:24'!
updateModel
	"there is nothing to do in this simple edition"

! !

!LabProjectEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/30/2015 00:23'!
windowTitle
	"..."

	^'Proyecto'! !

ObjectEditor subclass: #LabProjectLogEntryEditor
	uses: TBuildWindowFromForm + TBusinessObjectEditorEdit
	instanceVariableNames: 'filesEditor possibleParents solutionPreparationActivitiesEditor labProject statusStyleMap editor noteEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectLogEntryEditor commentStamp: 'CarlosLombardi 3/28/2015 17:44' prior: 0!
An object who knows how to edit a LabProjectLogEntry.

(LabProjectLogEntryEditor for: aLogEntry inLab: aLab) 
	labProject: aLabProject ;
	open
!

LabProjectLogEntryEditor class
	uses: TBuildWindowFromForm classTrait + TBusinessObjectEditorEdit classTrait
	instanceVariableNames: ''!

!LabProjectLogEntryEditor class methodsFor: 'instance creation' stamp: 'CarlosLombardi 3/9/2015 13:39'!
for: aLogEntry
	"a new editor for the given log entry edit "

	^super for: 
		( (aLogEntry isKindOf: LabProjectLogEntryEditController) 
			ifTrue: [ aLogEntry ]
			ifFalse: [ LabProjectLogEntryEditController for: aLogEntry ]
		)! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 11/29/2015 20:54'!
boldSelectedText 

	"Bold the selected text"

	self setEmphasisText: (TextEmphasis bold) withName: 'bold'. 
	! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:38'!
buildBoldButton
	"build the bold button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #boldSelectedText 
		getEnabled: #thereIsSomethingSelected
    		label: Smalltalk ui icons smallBoldIcon asMorph
		help: 'Poner en negrita el texto seleccionado' translated.

! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:39'!
buildColorButton
	"build the color chooser button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #colorSelectedText 
		getEnabled: #thereIsSomethingSelected
    		label: Smalltalk ui icons smallPaintIcon asMorph
		help: 'Colorear el texto seleccionado' translated.

! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'FernandoDiMeglio 10/27/2015 22:09'!
buildDescriptionField
	"build and return a field to edit my model description"
	| descriptionField |
	"descriptionField := self uiBuilder
		newSingleLineTextEntryFor: self model
		getText: #description
		setText: #description:
		help: 'Descripción breve de la actividad realizada'."
	descriptionField := self uiBuilder
		newTextMorphKeyStrokeSignalFor: self model
		context: self
		getText: #description
		setText: #description:
		help: 'Descripción breve del proyecto'.
	descriptionField
		acceptOnCR: false ;
		acceptOnFocusChange: true ;
		width: 400;
		hResizing: #rigid;
		vResizing: #rigid.
	^ descriptionField! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 4/1/2015 12:25'!
buildFilesField
	"build and return a field to edit my model files"
	
	| newPane newRow |
	filesEditor := ActiveFileListEditor for: self model attachedFiles.
	newPane := filesEditor buildPane.
	newPane 
		setNameTo: 'attachedFiles' ;
		minWidth: 700 ;
		minHeight: 400.
	newRow := self buildEmptyRow .
	newRow addMorphBack: newPane.
	^newRow
	
! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:39'!
buildFontButton
	"build the font size button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #changeFontSelectedText 
		getEnabled: #thereIsSomethingSelected
    		label: Smalltalk ui icons smallFontsIcon asMorph
		help: 'Cambiar la fuente del texto seleccionado' translated.

! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 2/12/2015 18:02'!
buildForm
	"build and return the editing form"

	| form |
	form := self buildEmptyColumn.
	form 
		addMorphBack: self buildFormUpperPart ;
		addMorphBack: self buildFormLowerPart.
	^form! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 10/6/2015 18:30'!
buildFormLowerPart
	"Internal - build and return the lower part of the form, including notes, files and used material"

	| lowerPart tabs |
	tabs := self uiBuilder newTabGroup: {
		'Notas'  -> self buildNotesField.
		'Archivos' -> self buildFilesField .
		'Soluciones' -> self buildSolutionPreparationActivitiesPane  
	}.
	lowerPart := self buildEmptyColumn.
	lowerPart addMorphBack: tabs.
	^lowerPart ! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 7/24/2015 17:11'!
buildFormUpperPart
	"Internal - build and return the upper part of the form, including date and description fields"

	| parentField dateField toDoDateField completionDateField descriptionField upperPart parentRow dateRow   descriptionRow |
	parentField := self buildParentField .
	dateField := self buildDateField.
	toDoDateField := self buildToDoDateField.
	completionDateField := self buildCompletionDateField.
	
	dateField := self buildDateField.
	dateField 
		acceptOnFocusChange: true ;
		setBalloonText: 'Fecha de la actividad realizada'.
		
	toDoDateField := self buildToDoDateField.
	toDoDateField 
		acceptOnFocusChange: true ;
		setBalloonText: 'Fecha estimada a realizarse'.
		
	completionDateField := self buildCompletionDateField.
	completionDateField
		acceptOnFocusChange: true ;
		setBalloonText: 'Fecha de terminacion'.
	
		
	descriptionField := self buildDescriptionField.
	
	parentRow := self buildEmptyRow.
	parentRow
		addMorphBack: (StringMorph contents: 'Es parte de: ');
		addMorphBack: parentField.
		
	dateRow := self buildEmptyRow.
	dateRow
		addMorphBack: (StringMorph contents: 'Fecha: ');
		addMorphBack: dateField;
		addMorphBack: (StringMorph contents: 'Fecha estimada: ');
		addMorphBack: toDoDateField;
		addMorphBack: (StringMorph contents: 'Fecha de terminacion: ');
		addMorphBack: completionDateField.

		
	descriptionRow := self buildEmptyRow.
	descriptionRow
		addMorphBack: (StringMorph contents: 'Descripcion: ');
		addMorphBack: descriptionField.
	
	upperPart := self buildEmptyColumn.
	^ upperPart
		addMorphBack: parentRow;
		addMorphBack: descriptionRow;
		addMorphBack: dateRow;
		yourself! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:39'!
buildItalicButton
	"build the italic button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #italicSelectedText 
		getEnabled: #thereIsSomethingSelected
    		label: Smalltalk ui icons smallItalicIcon asMorph
		help: 'Poner en italica el texto seleccionado' translated.

! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'FernandoDiMeglio 12/8/2015 23:07'!
buildNotesField
	"build and return a field to edit my model notes"
	| notesField column |
	column := self buildEmptyColumn.
	self initializeStyleMap.
	
	(self model noteEditor isNil) ifTrue:[ self model noteEditor: ((self uiBuilder newTextEditorFor: self model getText: #notes setText: #notes:)).
		                                                 notesField := self model noteEditor.]
	ifFalse:[ notesField :=  self model noteEditor].

	notesField
		acceptOnCR: false ;
		acceptOnFocusChange: true ;
		minWidth: 400 ;
		minHeight: 150.
	column addMorphBack: notesField.	
	column addMorphBack: (self buildStyleTextBar).
	^ column.! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/28/2015 20:51'!
buildParentField
	"build and return a field to select the parent of my model"
	| parentEditor parentField |
	parentEditor := (LogEntryDropListModel for: (self labProject -> self model model)).
	parentEditor 
		semiSilentSelectedObject: self model parent ;
		addDependent: self ;
		additionalEventOnSelectionChange: #parentLogEntryChanged .
	parentField := parentEditor buildDropList.
	^parentField 
		setNameTo: 'parentLogEntry' ;
		width: 500 ; minWidth: 500 ; yourself .
! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 23:05'!
buildSolutionPreparationActivitiesPane
	"build and return a pane where my model solution preparation activities can be edited"
	
	solutionPreparationActivitiesEditor := SolutionPreparationListEditor new.
	solutionPreparationActivitiesEditor 
		logEntry: self model ; 
		model: self model solutionPreparationActivities ;
		editorFactory: self model.
	^solutionPreparationActivitiesEditor buildPane
	
! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 10/13/2015 15:51'!
buildStyleTextBar

	"build the button bar with the style text items"

	|bar|
	
	bar := self buildEmptyRow.
	bar addMorphBack: self buildBoldButton;
		addMorphBack: self buildUnderlineButton;
		addMorphBack: self buildItalicButton;
		addMorphBack: self buildColorButton;
		addMorphBack: self buildFontButton;
		addMorphBack: self buildUndoButton.
	^bar.! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:40'!
buildUnderlineButton
	"build the underline button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #underlineSelectedText 
		getEnabled: #thereIsSomethingSelected
    		label: Smalltalk ui icons smallUnderlineIcon  asMorph
		help: 'Subrayar el texto seleccionado' translated.

! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:40'!
buildUndoButton
	"build the undo button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #undoTextEdition 
		getEnabled: #thereIsSomethingSelected
    		label: Smalltalk ui icons smallUndoIcon  asMorph
		help: 'Deshacer la ultima accion' translated.

! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 2/14/2015 16:30'!
buildUsedMaterialField
	"build and return a field to edit my model used material"
	| newField tempModel |	
	tempModel := ValueHolder new contents: 'Aca va a ir la lista de materiales usados.' ; yourself.
	newField := self uiBuilder
		newTextEditorFor: tempModel
		getText: #contents
		setText: #contents: .
	newField
		acceptOnCR: false ;
		enabled: false ;
		minWidth: 200.
	^ newField! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 11/3/2015 23:00'!
buildWindow
	"builds and returns a window which can be opened to edit my reagent"

	| newWindow |
	newWindow := self uiBuilder newLogEntryDialogWindowIn: self windowTitle for: self buildForm.
	newWindow acceptOnCR: false.
	^ newWindow! !

!LabProjectLogEntryEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 2/28/2015 23:34'!
businessObject
	^ self model model! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:41'!
changeFontSelectedText 

	"change the size of the selected text"

		self textEditor changeTextFont.
		self textEditor accept.
! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:40'!
colorSelectedText 

	"color the selected text"
	
	|editor|
	
	editor := self textEditor. 
	
	editor applyAttribute: editor chooseColor..
	
	editor accept.
! !

!LabProjectLogEntryEditor methodsFor: 'actions' stamp: 'EstebanTolaba 11/4/2015 17:49'!
completionDateBeforeEstimatedDate

	"True is the completion date is before the estimated date"
	
	(self model completionDate notNil & self model toDoDate notNil & self model loadDate notNil) ifTrue:[
			((self model completionDate < self model loadDate) | (self model completionDate < self model toDoDate)) ifTrue: [^true]
		].
	^false.! !

!LabProjectLogEntryEditor methodsFor: 'actions' stamp: 'EstebanTolaba 12/8/2015 20:31'!
edit
	"opens a window to edit my reagent"

	| oldNotes  isNotNew|
	isNotNew := self model noteEditor notNil.
	isNotNew ifTrue:[oldNotes := self model noteEditor textMorph contents copy ].
	

	self enableDisableButtonInPosition: 17.
	self openModal.
	self window cancelled
		ifTrue:[
			isNotNew ifTrue:[self model model noteEditor textMorph contents: oldNotes wrappedTo:30].
		]
		ifFalse: [ self updateModelIfCompletedForm].
	^ self window cancelled not.! !

!LabProjectLogEntryEditor methodsFor: 'accessing' stamp: 'EstebanTolaba 9/21/2015 16:43'!
editor
	^ editor! !

!LabProjectLogEntryEditor methodsFor: 'accessing' stamp: 'EstebanTolaba 9/21/2015 16:43'!
editor: anObject
	editor := anObject! !

!LabProjectLogEntryEditor methodsFor: 'actions' stamp: 'EstebanTolaba 11/4/2015 17:50'!
estimatedDateBeforeLoadDate

	"True if estimated date is before load date"

	(self model toDoDate notNil & self model loadDate notNil) ifTrue:[ (self model toDoDate < self model loadDate) ifTrue: [^true] ].
	^false.! !

!LabProjectLogEntryEditor methodsFor: 'mistery' stamp: 'CarlosLombardi 3/9/2015 13:06'!
handleUpdate: anObject
	"it seems that I must respond to this message, for some obscure reason related
	 by the duality about event management between dependents and announcements
	 in morphs"

! !

!LabProjectLogEntryEditor methodsFor: 'actions' stamp: 'EstebanTolaba 11/4/2015 17:51'!
incorrectDates

	"True if any date is not properly set"

	^(self nilLoadDate  | self estimatedDateBeforeLoadDate | self completionDateBeforeEstimatedDate ).! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:41'!
initializeStyleMap

	"set all the emphasis flags in false"

	self statusStyleMap: Dictionary new.
	self statusStyleMap at: 'bold' put: false.
	self statusStyleMap at: 'underlined' put: false.
	self statusStyleMap at: 'italic' put: false.! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 11/29/2015 20:54'!
italicSelectedText 
	"set the selected text in italic"

	self setEmphasisText: (TextEmphasis italic) withName: 'italic'. ! !

!LabProjectLogEntryEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2015 17:44'!
labProject
	^ labProject! !

!LabProjectLogEntryEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2015 17:44'!
labProject: anObject
	labProject := anObject! !

!LabProjectLogEntryEditor methodsFor: 'actions' stamp: 'EstebanTolaba 11/4/2015 17:52'!
nilLoadDate

	"True if the load date field is empty"

	(self model loadDate isNil | self model loadDate = '') ifTrue:[^true].
	^false.! !

!LabProjectLogEntryEditor methodsFor: 'accessing' stamp: 'FernandoDiMeglio 12/8/2015 00:48'!
noteEditor
	^ noteEditor! !

!LabProjectLogEntryEditor methodsFor: 'accessing' stamp: 'FernandoDiMeglio 12/8/2015 00:48'!
noteEditor: anObject
	noteEditor := anObject! !

!LabProjectLogEntryEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/8/2015 01:19'!
parentField
	"the field to select the parent of the LogEntry I edit"

	^self window submorphNamed: 'parentLogEntry'
! !

!LabProjectLogEntryEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/8/2015 00:33'!
possibleParents
	^ possibleParents! !

!LabProjectLogEntryEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/8/2015 00:33'!
possibleParents: anObject
	possibleParents := anObject! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 11/4/2015 17:53'!
selectedText

	"Returns the selected text in notes"

	^self textEditor selection.! !

!LabProjectLogEntryEditor methodsFor: 'as yet unclassified' stamp: 'EstebanTolaba 11/29/2015 20:54'!
setEmphasisText: emphasis withName: eName

	"Set an emphasis in the selected text"

	|editors hasEmphasis|
	
	editors := self textEditor.
	
	hasEmphasis := (self selectedText runs concatenation reject: [:att | (att respondsTo: #emphasisCode) not]) contains:[:att2 | att2 emphasisCode = (emphasis emphasisCode)].
	
	(hasEmphasis | (self statusStyleMap at: eName)) 
	ifTrue: [self statusStyleMap at: eName put: false.
		 	editors applyAttribute: emphasis turnOff]
	 
	ifFalse:[self statusStyleMap at: eName put: true.
		editors applyAttribute: emphasis].
	
	editors accept.
! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 11/4/2015 17:55'!
setEmphasisText: emphasis withName: eName andCode: ecode

	"Set an emphasis in the selected text"

	|editors hasEmphasis|
	
	editors := self textEditor.
	
	hasEmphasis := (self selectedText runs concatenation reject: [:att | (att respondsTo: #emphasisCode) not]) contains:[:att2 | att2 emphasisCode = ecode].
	
	(hasEmphasis | (self statusStyleMap at: eName)) 
	ifTrue: [self statusStyleMap at: eName put: false.
		 	editors applyAttribute: emphasis turnOff]
	 
	ifFalse:[self statusStyleMap at: eName put: true.
		editors applyAttribute: emphasis].
	
	editors accept.
! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/4/2015 18:14'!
statusStyleMap
	^ statusStyleMap! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/4/2015 18:15'!
statusStyleMap: anObject
	statusStyleMap := anObject! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'FernandoDiMeglio 10/22/2015 00:07'!
textEditor
	"return the SmalltalkEditor of the current Log Entry"

	^ self model noteEditor textMorph editor.
! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'FernandoDiMeglio 10/22/2015 00:07'!
thereIsSomethingSelected
	
	^true.! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 11/29/2015 20:54'!
underlineSelectedText 
	
	"underline selected text"
	self setEmphasisText: (TextEmphasis underlined) withName: 'underlined'. ! !

!LabProjectLogEntryEditor methodsFor: 'text support' stamp: 'EstebanTolaba 9/14/2015 22:44'!
undoTextEdition 

	"undo the last action on text edition"

	self textEditor undo.
	self textEditor accept.! !

!LabProjectLogEntryEditor methodsFor: 'updating' stamp: 'CarlosLombardi 3/9/2015 13:31'!
update: aSymbol
	"I am informed of an event I am interested in"

	(aSymbol = #parentLogEntryChanged) ifTrue: [ 
		self model selectedParent: self parentField model selectedObject 
	] .! !

!LabProjectLogEntryEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/9/2015 13:34'!
updateModel
	"reflect edition in the log entry (in fact, in the corresponding LabProjectLogEntryEditController) "

	self model updateModel! !

!LabProjectLogEntryEditor methodsFor: 'actions' stamp: 'EstebanTolaba 11/4/2015 19:16'!
updateModelIfCompletedForm

	"reflect edition in the log entry (in fact, in the corresponding LabProjectLogEntryEditController) verifying the correct information in the date fields "
	"If there is an error, it raises an error dialog with the reasons listed"
	(self model loadDate isNil | self incorrectDates) 
	ifTrue:[
		|errors|
		errors:= OrderedCollection new. 
		(self nilLoadDate | self model loadDate = '') ifTrue:[errors add: 'La fecha de carga está vacía'].
		(self estimatedDateBeforeLoadDate ) ifTrue:[errors add: 'La fecha de estimación no puede ser anterior a la fecha de carga'].
		(self completionDateBeforeEstimatedDate ) ifTrue:[errors add: 'La fecha de terminación no puede ser anterior a la fecha de carga o estimación'].	
		(self nilLoadDate | self model loadDate = '') ifTrue:[errors add: 'La fecha de carga está vacía'].	
		self window errors: errors.
		self window logEntryEditor: self.
		self window ok.
		
		]
	ifFalse: [self updateModel].! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/20/2015 23:26'!
window: aWindow
	"the reference window where I do my rendering"

	super window: aWindow.
	filesEditor window: aWindow.
	solutionPreparationActivitiesEditor window: aWindow.
! !

!LabProjectLogEntryEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 2/12/2015 10:30'!
windowTitle

	^'Actividad de Laboratorio'! !

ObjectEditor subclass: #LabProjectLogEntryErrorWindow
	uses: TBuildWindowFromPane
	instanceVariableNames: 'logEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectLogEntryErrorWindow commentStamp: '<historical>' prior: 0!
A LabProjectLogEntryErrorWindow is xxxxxxxxx.

Instance Variables
	logEntry:		<Object>

logEntry
	- xxxxx
!

LabProjectLogEntryErrorWindow class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!LabProjectLogEntryErrorWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/4/2015 17:43'!
buildCloseButton
	"build the OK button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #close 
		getEnabled: #thereIsSomethingSelected
    		label: 'OK'
		help: 'Terminar' translated.

! !

!LabProjectLogEntryErrorWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/4/2015 17:45'!
buildPane
	"build and return the error log"

	| mainColumn buttonsRow|
	
	mainColumn := self buildEmptyColumn.
	buttonsRow := self buildEmptyRow.
	buttonsRow addMorphBack: self buildCloseButton.
	mainColumn addMorphBack: (StringMorph contents: 'No se pudo crear/modificar la actividad por las siguientes razones:') .
	self logEntry1 do:[:err | mainColumn addMorphBack: ((StringMorph  contents: err) fillStyle: (Color red))].
	mainColumn addMorphBack: (StringMorph contents: 'Por favor verifique los errores señalados y vuelva a intentarlo') .
	mainColumn addMorphBack: buttonsRow.
	

	^mainColumn.! !

!LabProjectLogEntryErrorWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/3/2015 17:39'!
buildWindow
	"builds and returns the window"

	| newWindow thePane  |
	newWindow := PluggableDialogWindow new.
	newWindow title: '¡Error al crear/modificar la actividad!!'.
	
	thePane := self buildPane.
	thePane setNameTo: 'mainPane'.
	
	newWindow addMorph: thePane frame: (0 @ 0 corner: 1 @ 1).
	
	^ newWindow! !

!LabProjectLogEntryErrorWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/4/2015 17:45'!
close

	"Close the window"

	self window close.! !

!LabProjectLogEntryErrorWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/2/2015 18:20'!
logEntry1
	^ logEntry! !

!LabProjectLogEntryErrorWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/2/2015 18:20'!
logEntry: anObject
	logEntry := anObject! !

!LabProjectLogEntryErrorWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/4/2015 15:06'!
model: anObject 

	self logEntry: anObject .! !

!LabProjectLogEntryErrorWindow methodsFor: 'accessing' stamp: 'EstebanTolaba 11/2/2015 18:22'!
thereIsSomethingSelected

	
	^true.! !

ObjectEditor subclass: #LabProjectLogEntryTreeEditor
	uses: TBuildWindowFromPane - {#windowTitle} + TBusinessObjectEditionInList + TLogEntryCollectionEdition + TEditObjectInListButtons + TCentralizeAttachedFiles
	instanceVariableNames: 'treeModel lab fileSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectLogEntryTreeEditor commentStamp: 'CarlosLombardi 3/28/2015 01:18' prior: 0!
Support for a window to edit of the log entries included in a LabProject, shown as a tree.
My model is the LabProject.!

LabProjectLogEntryTreeEditor class
	uses: TBuildWindowFromPane classTrait + TBusinessObjectEditionInList classTrait + TLogEntryCollectionEdition classTrait + TEditObjectInListButtons classTrait + TCentralizeAttachedFiles classTrait
	instanceVariableNames: ''!

!LabProjectLogEntryTreeEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/28/2015 01:20'!
addNewBusinessObject: aLogEntry
	"..."

	self model addToLogEntries: aLogEntry! !

!LabProjectLogEntryTreeEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 8/13/2015 14:45'!
buildButtonBar
	"build a UI component to show the buttons to appear under the list"
	
	^self buildEmptyColumn
		cellInset: 0 ;
		addMorphBack: (self buildColumnSpacer: 2) ;
		addMorphBack: ( self uiBuilder newRow: { self buildAddButton . self buildEditButton . self buildDeleteButton . self buildPromoteButton . self buildDemoteButton . self buildReplicateButton . self buildCentralizeFilesButton } )

! !

!LabProjectLogEntryTreeEditor methodsFor: 'data morphs' stamp: 'EstebanTolaba 8/13/2015 14:45'!
buildCentralizeFilesButton
	"build the delete button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #centralizeAttachedFiles
		getEnabled: #thereIsSomethingSelected
    		label: 'Centralizar archivos' translated
		help: 'Centralizar todos los archivos en una carpeta seleccionada' translated.

! !

!LabProjectLogEntryTreeEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/31/2015 21:30'!
buildDemoteButton
	"build the edit button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #demoteSelected 
		getEnabled: #selectedCanBeDemoted
    		label: 'Bajar' translated
		help: 'Baja la actividad elegida' translated.

! !

!LabProjectLogEntryTreeEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/14/2015 19:08'!
buildPane
	"I build and return the pane which is the contents of my window"

	^ (self uiBuilder
		newColumn: { self buildTreeMorph . self buildButtonBar } )
		cellInset: 0;
		yourself! !

!LabProjectLogEntryTreeEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/31/2015 21:20'!
buildPromoteButton
	"build the edit button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #promoteSelected 
		getEnabled: #selectedCanBePromoted
    		label: 'Subir' translated
		help: 'Sube la actividad elegida' translated.

! !

!LabProjectLogEntryTreeEditor methodsFor: 'ui building' stamp: 'EstebanTolaba 7/27/2015 18:50'!
buildReplicateButton
	"build the edit button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #replicateSelected
		getEnabled: #selectedCanBeReplicated
    		label: 'Replicar' translated
		help: 'Replica la actividad tantas veces como lo indique su nombre' translated.

! !

!LabProjectLogEntryTreeEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/14/2015 20:00'!
buildTreeMorph
	| treeMorph |
	treeMorph := treeModel defaultTreeMorph
		doubleClickBlock: [ self editSelected ] ;
		buildContents ; 
		selectedItems: {} ; 
		yourself.
	treeModel treeMorph: treeMorph .
	^ treeMorph! !

!LabProjectLogEntryTreeEditor methodsFor: 'centralize' stamp: 'FernandoDiMeglio 11/21/2015 02:36'!
centralizeAttachedFiles
	"Open a directory chooser to select a folder where copy the log entry selected attached files"
			
	| result |
	
	result := self openDirectoryWith: 'Centralizar Archivos - Elija una carpeta para guardarlos'.

	result ifNotNil: [ 
			self centralizeAttachedFilesFrom: self selectedObject with: result.
			self selectedObject: self selectedObject.
		]
	
	
	
	
	
	! !

!LabProjectLogEntryTreeEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/29/2015 23:47'!
createBusinessObjectEditorFor: aLogEntry
	"..."

	| controller |
	controller := LabProjectLogEntryEditController for: aLogEntry.
	controller 
		lab: self lab ; labProject: self model ; 
		defaultParent: self selectedObject ; setDefaults .
	^ (LabProjectLogEntryEditor for: controller)
			labProject: self model ; 
			yourself! !

!LabProjectLogEntryTreeEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/29/2015 23:42'!
createNewBusinessObject
	"..."

	| newLogEntry |
	newLogEntry := LabProjectLogEntry new.
	^ newLogEntry
! !

!LabProjectLogEntryTreeEditor methodsFor: 'bo edition' stamp: 'EstebanTolaba 7/27/2015 18:52'!
createReplicatedLogEntries
	"..."

	| newLogEntry |
	newLogEntry := LabProjectLogEntry new.
	^ newLogEntry
! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/31/2015 21:52'!
demoteSelected
	"demote the selected entry"

	| selected |
	selected := self selectedObject.
	self selectedObject parent demoteChild: self selectedObject.
	self invalidateList.
	self selectedObject: selected.
! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'EstebanTolaba 8/13/2015 14:56'!
fileSystem
	^ fileSystem! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'EstebanTolaba 8/13/2015 14:56'!
fileSystem: anObject
	fileSystem := anObject! !

!LabProjectLogEntryTreeEditor methodsFor: 'list edition adaptor' stamp: 'EstebanTolaba 8/4/2015 12:24'!
invalidateList
	"the list, in fact a tree, must be rebuilt"

	self selectedObject: nil.
	treeModel invalidateList.! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'EstebanTolaba 8/4/2015 12:29'!
keyFor: aLogEntry
	"the 'key' corresponding to this object wrt the list edition. To be overwritten if needed."

	^{ aLogEntry parent . aLogEntry description . aLogEntry completionState class }! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:20'!
lab
	"my reference lab, used to obtain the list of available solutions for the 
	 eventual solution preparation activities to include into log entries"
	^ lab! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 22:20'!
lab: anObject
	"cfr >>lab"
	lab := anObject! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'EstebanTolaba 8/23/2015 23:09'!
locateReplica: aReplica with: aNum
	
	"Locate the replica under his predecessor "
	
	| index toPromote |
	
	index := self selectedBrothers indexOf:  self selectedObject.
	toPromote := (self selectedBrothers size  - index) -  aNum .
	toPromote timesRepeat: [ self selectedObject parent promoteChild: aReplica ].
! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2015 01:19'!
logEntries
	"the log entries I am showing"

	^self model logEntries! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'EstebanTolaba 8/13/2015 14:57'!
model: aLabProject
	"set the model to be shown and edited"

	super model: aLabProject.
	treeModel := LabProjectLogEntryTreeModel new.
	treeModel model: aLabProject.
	treeModel addDependent: self.
	self fileSystem: FileSystem disk.
! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'FernandoDiMeglio 10/22/2015 00:05'!
nameForReplica: number to: limit
	"Name for a replica based on the original log entry's description"

		| sizeD newDesc |
	
	self selectedObject isReplicableOneDigit ifTrue: [
		sizeD := self selectedObject description size.
		newDesc := (self selectedObject description ) first: sizeD - 8.
		newDesc := newDesc, '(' , (number asString), ' de ', limit asString , ')'. ].
	self selectedObject  isReplicableTwoDigits ifTrue: [
		sizeD := self selectedObject description size.
		newDesc := (self selectedObject description ) first: sizeD - 9.
		newDesc := newDesc, '(' , (number asString), ' de ', limit asString , ')'. ].
	
	
	
	^newDesc.
	
	! !

!LabProjectLogEntryTreeEditor methodsFor: 'scaffolding morphs' stamp: 'EstebanTolaba 8/13/2015 22:03'!
pathToFindFiles
	"the full name of the path where my directory chooser must open upon"

	self selectedObject rootDirectoryPath ifNotNil: [ :ref | ^ref  ].
	^nil
! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/31/2015 21:53'!
promoteSelected
	"promote the selected entry"

	| selected |
	selected := self selectedObject.
	self selectedObject parent promoteChild: self selectedObject.
	self invalidateList.
	self selectedObject: selected.
! !

!LabProjectLogEntryTreeEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 3/28/2015 01:23'!
removeBusinessObject: aLogEntry
	"..."

	self model removeFromLogEntries: aLogEntry! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'EstebanTolaba 8/23/2015 23:13'!
replicateSelected
	"Create replicas of the selected log entry based on his description"

	| totalToReplicate nameNumber currentlySelected aNum |

	nameNumber := 2.
	totalToReplicate := self selectedObject numberToReplicate.
	
	"Variable using the method sortReplica: with: to adjust the number of times that has to accommodate replication"
	aNum := 1.
	
	((totalToReplicate asNumber) - 1) timesRepeat: [  
		
		(self thereIsLogEntryNamed: (self nameForReplica: nameNumber to: totalToReplicate) inBrothers: self selectedBrothers) ifFalse:[
			| replica |
		
			replica := LabProjectLogEntry new. 
			replica replicateFromLogEntry: self selectedObject;
			     description:	(self nameForReplica: nameNumber to: totalToReplicate ).
			
			self model addToLogEntriesRecursively: replica.
			self locateReplica: replica with: aNum.
		].
		aNum:= aNum + 1.		
		nameNumber := nameNumber + 1.
	].

	currentlySelected := self selectedObject.

	self invalidateList .
	self selectedObject: currentlySelected .! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'EstebanTolaba 8/23/2015 23:11'!
selectedBrothers

	"A Collection of the selected log entry's brothers"

	^(self selectedObject parent) children.! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/31/2015 21:22'!
selectedCanBeDemoted
	"true iff the selected LogEntry can be demoted"
	^self selectedObject 
		ifNil: [ false ]
		ifNotNil: [ :entry | entry canBeDemoted ]! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/31/2015 21:23'!
selectedCanBePromoted
	"true iff the selected LogEntry can be promoted"
	^self selectedObject 
		ifNil: [ false ]
		ifNotNil: [ :entry | entry canBePromoted ]! !

!LabProjectLogEntryTreeEditor methodsFor: 'accessing' stamp: 'EstebanTolaba 8/23/2015 22:39'!
selectedCanBeReplicated
	"true iff the selected LogEntry can be replicated"
	|totalToReplicate|
	
	
	^self selectedObject 
		ifNil: [ false ]
		ifNotNil: [ :entry | 
			
			entry canBeReplicated and:[ 
				totalToReplicate := entry numberToReplicate.
				(self selectedIsAlreadyReplicated: totalToReplicate) not ]].! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'EstebanTolaba 8/23/2015 23:11'!
selectedIsAlreadyReplicated: total

	"True if all selected log entry's replicas are created"

	 |nameNumber|
	
	 nameNumber :=  1.
	
	total timesRepeat:[
		
		(self selectedBrothers contains:[:entry | entry description = (self nameForReplica: nameNumber to: total)]) ifFalse:[^false].
		nameNumber := nameNumber + 1.
	].

	^true.! !

!LabProjectLogEntryTreeEditor methodsFor: 'list edition adaptor' stamp: 'CarlosLombardi 3/14/2015 19:24'!
selectedObject
	"the model object, i.e. a LogEntry, selected"

	^treeModel selectedObject! !

!LabProjectLogEntryTreeEditor methodsFor: 'list edition adaptor' stamp: 'FernandoDiMeglio 11/11/2015 23:20'!
selectedObject: aLogEntry
	"set the model object, i.e. a LogEntry, selected"

	treeModel selectedObject: aLogEntry.
! !

!LabProjectLogEntryTreeEditor methodsFor: 'actions' stamp: 'EstebanTolaba 8/23/2015 23:12'!
thereIsLogEntryNamed: aName inBrothers: logEntries

	"True if there is a log entry named aName in the collection logEntries"

	^(logEntries contains:[:log | log description = aName]).! !

!LabProjectLogEntryTreeEditor methodsFor: 'list edition adaptor' stamp: 'CarlosLombardi 3/14/2015 19:05'!
thereIsSomethingSelected
	"a Boolean having the expected meaning"

	^treeModel thereIsSomethingSelected! !

!LabProjectLogEntryTreeEditor methodsFor: 'updating' stamp: 'EstebanTolaba 7/27/2015 17:40'!
update: aSymbol
	"receive events"

	(aSymbol = #thereIsSomethingSelected) ifTrue: [ 
		self changed:  #thereIsSomethingSelected. 
		"also emit the events for the promote and demote buttons"
		self changed: #selectedCanBePromoted.
		self changed: #selectedCanBeDemoted.
		self changed: #selectedCanBeReplicated.

	]! !

!LabProjectLogEntryTreeEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/28/2015 11:02'!
windowTitle
	"..."

	^self model description ! !

ObjectEditor subclass: #LabProjectMenu
	uses: TBuildWindowFromPane @ {#preBuildWindow->#buildWindow} - {#buildWindow}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

LabProjectMenu class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!LabProjectMenu methodsFor: 'ui building' stamp: 'CarlosLombardi 4/1/2015 12:11'!
buildPane
	"builds the menu"

	| menuPane  buttonRow |
	menuPane := self buildEmptyColumn .
	
	buttonRow := self buildEmptyRow .
	buttonRow cellInset: 16.
	buttonRow 
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #manageProjects
 	   		label: 'Proyectos' help: 'Administrar los proyectos') width: 150 ; height: 32 ; yourself) ;
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #manageSolutions
 	   		label: 'Soluciones' help: 'Administrar las soluciones registradas') width: 150 ; height: 32 ; yourself) ;
		addMorphBack: ((self uiBuilder 
			newButtonFor: self	action: #manageReagentsForSolutionPreparation
 	   		label: 'Reactivos' help: 'Administrar los reactivos registrados') width: 150 ; height: 32 ; yourself) .
	menuPane addMorphBack: buttonRow.
	
	^menuPane! !

!LabProjectMenu methodsFor: 'ui building' stamp: 'CarlosLombardi 3/31/2015 22:51'!
buildWindow
	"builds the window. Adds positioning to the algorithm taken from TBuildWindowFromPane"

	| theWindow thePane sumHeight |
	theWindow := self preBuildWindow .
	thePane := theWindow submorphNamed: 'mainPane'.
	sumHeight := (thePane submorphs collect: #height) sum.
	theWindow height: (sumHeight + 20 + (8 * (thePane submorphs size + 2))).

	theWindow position: 700@400.
	^theWindow! !

!LabProjectMenu methodsFor: 'actions' stamp: 'CarlosLombardi 3/31/2015 22:49'!
manageProjects
	"window to manage the projects"

	| view |
	view := LabProjectListEditor for: self model.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabProjectMenu methodsFor: 'actions' stamp: 'CarlosLombardi 3/31/2015 22:47'!
manageReagentsForSolutionPreparation
	"window to manage the reagents"

	| view |
	view := ReagentInSolutionMorphListEditor for: self model.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabProjectMenu methodsFor: 'actions' stamp: 'CarlosLombardi 3/31/2015 22:48'!
manageSolutions
	"window to manage the solutions"

	| view |
	view := SolutionListEditor for: self model.
	view uiParent: self window.
	view window position: 0@0.
	view open.
! !

!LabProjectMenu methodsFor: 'ui building' stamp: 'CarlosLombardi 4/1/2015 12:28'!
windowTitle
	"..."

	^'Actividades de laboratorio'! !

ObjectEditor subclass: #LabProjectReportDialog
	uses: TBuildWindowFromPane
	instanceVariableNames: 'reportFullName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectReportDialog commentStamp: '<historical>' prior: 0!
A LabProjectReportDialog is xxxxxxxxx.

Instance Variables
	reportFullName:		<Object>

reportFullName
	- xxxxx
!

LabProjectReportDialog class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!LabProjectReportDialog methodsFor: 'actions' stamp: 'FernandoDiMeglio 10/7/2015 03:02'!
buildCloseButton
	"build the color chooser button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #close 
		getEnabled: #thereIsSomethingSelected
    		label: 'Cancelar'
		help: 'Terminar' translated.

! !

!LabProjectReportDialog methodsFor: 'actions' stamp: 'FernandoDiMeglio 10/7/2015 03:02'!
buildOpenButton
	"build the color chooser button"
	
	^self uiBuilder 
		newButtonFor: self
		action: #openReport 
		getEnabled: #thereIsSomethingSelected
    		label: 'Abrir'
		help: 'Abrir el reporte generado' translated.

! !

!LabProjectReportDialog methodsFor: 'actions' stamp: 'FernandoDiMeglio 10/7/2015 03:06'!
buildPane
	"build and return the editing form"

	| mainColumn buttonsRow|
	mainColumn := self buildEmptyColumn.
	buttonsRow := self buildEmptyRow.
	buttonsRow addMorphBack: self buildOpenButton.
	buttonsRow addMorphBack: self buildCloseButton.
	mainColumn
		addMorphBack: (StringMorph contents: 'El reporte fue creado con exito. ¿Desea abrirlo?');
		addMorphBack: buttonsRow.

	^mainColumn.! !

!LabProjectReportDialog methodsFor: 'ui building' stamp: 'FernandoDiMeglio 10/16/2015 04:33'!
buildWindow
	"builds and returns the window"

	| newWindow thePane  |
	newWindow := PluggableDialogWindow new.
	newWindow title: '¡Reporte creado!!'.
	
	thePane := self buildPane.
	thePane setNameTo: 'mainPane'.
	
	newWindow addMorph: thePane frame: (0 @ 0 corner: 1 @ 1).
	
	^ newWindow! !

!LabProjectReportDialog methodsFor: 'actions' stamp: 'EstebanTolaba 10/6/2015 18:37'!
businessObject
	"the business object related with me"

	^self model! !

!LabProjectReportDialog methodsFor: 'actions' stamp: 'EstebanTolaba 10/6/2015 18:43'!
close

	self window close.! !

!LabProjectReportDialog methodsFor: 'actions' stamp: 'EstebanTolaba 10/6/2015 20:04'!
model: anObject 

	|file|
	file := ActiveFile new.
	self reportFullName: file.
	file fullName: anObject.
	file externalCommand: LabApplication current externalCommandSuite .
	
	! !

!LabProjectReportDialog methodsFor: 'actions' stamp: 'EstebanTolaba 10/6/2015 20:04'!
openReport

	self reportFullName performAction.
	self window close.! !

!LabProjectReportDialog methodsFor: 'accessing' stamp: 'EstebanTolaba 10/6/2015 18:31'!
reportFullName
	^ reportFullName! !

!LabProjectReportDialog methodsFor: 'accessing' stamp: 'EstebanTolaba 10/6/2015 18:31'!
reportFullName: anObject
	reportFullName := anObject! !

!LabProjectReportDialog methodsFor: 'actions' stamp: 'FernandoDiMeglio 11/2/2015 13:47'!
thereIsSomethingSelected

	^true.! !

LabProjectReportDialog subclass: #LabProjectReportDialogError
	uses: TBuildWindowFromPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectReportDialogError commentStamp: '<historical>' prior: 0!
A LabProjectReportDialogError is xxxxxxxxx.
!

LabProjectReportDialogError class
	uses: TBuildWindowFromPane classTrait
	instanceVariableNames: ''!

!LabProjectReportDialogError methodsFor: 'actions' stamp: 'FernandoDiMeglio 10/16/2015 04:40'!
buildPane
	"build and return the editing form"

	| mainColumn buttonsRow|
	mainColumn := self buildEmptyColumn.
	buttonsRow := self buildEmptyRow.
	buttonsRow addMorphBack: self buildCloseButton.
	mainColumn
		addMorphBack: (StringMorph contents: 'No se pudo crear el reporte, el nombre del archivo ya existe.');
		addMorphBack: buttonsRow.

	^mainColumn.! !

!LabProjectReportDialogError methodsFor: 'ui building' stamp: 'FernandoDiMeglio 10/16/2015 04:38'!
buildWindow
	"builds and returns the window"

	| newWindow thePane  |
	newWindow := PluggableDialogWindow new.
	newWindow title: '¡El archivo ya existe!!'.
	
	thePane := self buildPane.
	thePane setNameTo: 'mainPane'.
	
	newWindow addMorph: thePane frame: (0 @ 0 corner: 1 @ 1).
	
	^ newWindow
! !

!ObjectEditor class methodsFor: 'utilities' stamp: 'CarlosLombardi 3/31/2015 21:03'!
dateConverter
	"a ObjectStringConverter for dates using dd/mm/yyyy as format"

	DateConverter ifNil: [ 
		DateConverter := ObjectStringConverter new.
		DateConverter 
			objectTransformBlock: [ :date | 
				date ifNil: [ '' ] ifNotNil: [ date printFormat: #(1 2 3 $/ 1 1 2) ]
				 ] ;
			stringTransformBlock: [ :string | 
				string ifNil: [ nil ] ifNotNil: [ 
					Date readFrom: string readStream pattern: 'd/m/y' 
			 ] ] .		
	].
	^DateConverter! !

!ObjectEditor class methodsFor: 'instance creation' stamp: 'CarlosLombardi 2/28/2015 22:56'!
for: anObject
	"a new editor to edit the given object"

	^self new
		model: anObject ;
		yourself! !

!ObjectEditor methodsFor: 'data morphs' stamp: 'EstebanTolaba 5/29/2015 21:25'!
buildDateField
	"creates and answer a UI component to edit a date for the #date attribute of the model"

	| newField |
	newField := self uiBuilder
		newTextEntryFor: self model
		get: #loadDate
		set: #loadDate:  
		class: nil
		getEnabled: nil 
		help: 'Fecha del evento'.
	newField 
		converter: self dateConverter ;
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	"to initialize contents soundly"
	newField setText: newField getText.
	^newField
! !

!ObjectEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/12/2014 09:47'!
buildWindow
	"builds and returns the editing window"

	self subclassResponsibility ! !

!ObjectEditor methodsFor: 'actions' stamp: 'FernandoDiMeglio 10/28/2015 21:55'!
enableDisableButtonInPosition: aPosition
	"Enable or disable the button Ok if the field of name project is empty"
	
	| nameProject |
	
	nameProject := ((self window allMorphs) at: aPosition) text asString.
	nameProject isEmpty ifTrue: [ self window buttons first disable ] ifFalse: [ self window buttons first enable ].! !

!ObjectEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/10/2014 17:42'!
model
	"the reagent I edit"

	^model! !

!ObjectEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/12/2014 10:38'!
model: obj
	"set the object I edit"

	model := obj ! !

!ObjectEditor methodsFor: 'model accessing' stamp: 'CLom 12/27/2014 00:15'!
modelValueAsString: blockOrSymbol
	"the value for my model correponding to blockOrSymbol, as a String. 
	 The empty string if no model is set to me."

	^self model ifNil: [ '' ] ifNotNil: [ :theModel | (blockOrSymbol value: theModel ) asString ]! !

!ObjectEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/14/2014 03:10'!
open
	"opens a window to edit my reagent"

	self window openAsIs.! !

!ObjectEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/14/2014 03:07'!
openModal
	"open my window in a modal fashion"
	self uiParent 
		ifNotNil: [ :parentWindow | parentWindow openModal: self window ] 
		ifNil: [ self window openModal ]! !

!ObjectEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/10/2014 17:42'!
uiParent
	"the UI object who is parent of this editor in the graphic hierarchy of UI components"
	^ uiParent! !

!ObjectEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/10/2014 17:42'!
uiParent: anObject
	"set the UI object who is parent of this editor in the graphic hierarchy of UI components"
	uiParent := anObject! !

!ObjectEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/19/2014 14:49'!
window
	"a window which can be opened to edit my reagent"

	window ifNil: [ 
		self window: self buildWindow.
	].
	^ window.
! !

!ObjectEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/19/2014 14:49'!
window: aWindow
	"the reference window where I do my rendering"

	window := aWindow.
! !

ObjectEditor subclass: #ReagentEditor
	uses: TBuildWindowFromForm + TBusinessObjectEditorEdit
	instanceVariableNames: 'authorityEditors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!ReagentEditor commentStamp: 'CarlosLombardi 2/12/2015 10:29' prior: 0!
An object who knows how to edit a Reagent.

(ReagentEditor for: aReagent inLab: aLab) edit

The edition works in collaboration with a ReagentEditController.!

ReagentEditor class
	uses: TBuildWindowFromForm classTrait + TBusinessObjectEditorEdit classTrait
	instanceVariableNames: ''!

!ReagentEditor class methodsFor: 'instance creation' stamp: 'CarlosLombardi 4/29/2014 18:59'!
for: aReagent inLab: aLab
	"creates an Editor to edit the given reagent, in the context of the given lab"

	^self for: (ReagentEditController for: aReagent inLab: aLab)! !

!ReagentEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/24/2015 01:03'!
buildForm
	"builds and returns a form tailored to edit my reagent"

	| reagentForm rows componentBuilder |
	componentBuilder := StockElementUIComponentBuilder new.
	componentBuilder element: self model ; lab: self lab ; editor: self.

	rows  := OrderedCollection new.
	componentBuilder 
		addNameFieldRowTo: rows ;
		addCasNumberFieldRowTo: rows ;
		addMolecularWeightFieldRowTo: rows .
	rows add: '' -> '' asMorph.
	componentBuilder 
		addStockUnitFieldRowTo: rows ; 
		addReferenceRowsTo: rows .

	"must remember the authority editors, created by the componentBuilder
	 when adding the reference rows"
	authorityEditors := componentBuilder authorityEditors.
	
	reagentForm := self uiBuilder newLabelGroup: rows asArray.
	reagentForm setNameTo: 'form'.
	
	^ reagentForm! !

!ReagentEditor methodsFor: 'bo edition' stamp: 'CarlosLombardi 5/2/2014 10:04'!
businessObject
	^ self reagent! !

!ReagentEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/28/2014 02:46'!
editStockUnit
	"opens a window to edit the selected stock unit"

	| reagentEditor editResult |
	reagentEditor := StockUnitEditor for: self model stockUnit.
	reagentEditor uiParent: self window.
	editResult := reagentEditor edit.
	editResult ifTrue: [ 
		self stockUnitPrefixField textChanged.
	]! !

!ReagentEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 4/28/2014 20:34'!
lab
	"the lab being the context of my edition"

	^self model lab! !

!ReagentEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 4/29/2014 00:22'!
reagent
	"the reagent I am editing"

	^self model element! !

!ReagentEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/28/2014 01:25'!
stockUnitField
	"the field in my form corresponding to the reagent"

	^self window submorphNamed: 'stockUnit'! !

!ReagentEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/28/2014 01:45'!
stockUnitPrefixField
	"the field in my form corresponding to the prefix of the stock unit"

	^self window submorphNamed: #stockUnitPrefix! !

!ReagentEditor methodsFor: 'updating' stamp: 'CarlosLombardi 3/28/2014 01:57'!
update: aSymbol
	"process incomiing events"

	(aSymbol = #stockUnitChanged)
		ifTrue: [ self model stockUnit: self stockUnitField model selectedObject.
				 self stockUnitPrefixField textChanged ]! !

!ReagentEditor methodsFor: 'actions' stamp: 'CarlosLombardi 10/4/2014 12:25'!
updateModel
	"reflect edition in the reagent"

	"first update the ReagentEditController reference edit controllers from the authority editors"
	authorityEditors do: [ :editor | editor updateModel ].
	"then update the Reagent from the EditingReagent"
	self model updateModel.! !

!ReagentEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/28/2014 01:25'!
window: aWindow
	"the window I use to do my rendering"

	super window: aWindow.
	self stockUnitField model addDependent: self.
! !

!ReagentEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/16/2014 22:05'!
windowTitle

	^'Reactivo'! !

ObjectEditor subclass: #ReagentInSolutionEditor
	uses: TBuildWindowFromForm
	instanceVariableNames: 'reagent unit concentration labProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Solutions'!

!ReagentInSolutionEditor commentStamp: 'CarlosLombardi 3/25/2015 20:39' prior: 0!
A bundle editor / edit controller for a ReagentInSolution
!

ReagentInSolutionEditor class
	uses: TBuildWindowFromForm classTrait
	instanceVariableNames: ''!

!ReagentInSolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/29/2015 06:27'!
buildConcentrationField
	"creates and answer a UI component to edit the concentration of my ReagentInSolution"

	| newField |
	newField := self uiBuilder
		newTextEntryFor: self 
		get: #concentration
		set: #concentration:  
		class: Float 
		getEnabled: nil 
		help: 'Concentración'.
	newField 
		width: 80 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	^newField
	
! !

!ReagentInSolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 01:50'!
buildConcentrationUnitField
	"creates and answer a UI component to edit the unit in which the concentration
	  of my ReagentInSolution is expressed"

	^(GenericDropListModel for: LabApplication current reagentInSolutionConcentrationUnits )
		helpText: 'Elegir la unidad usada en la concentración' ;
		renderSelector: #abbreviation ;
		width: 80 ;
		selectedObject: self unit ;
		setObjectSelectedBlock: [ :anUnit | self unit: anUnit ] ; 
		buildDropList
		
		
! !

!ReagentInSolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/25/2015 21:49'!
buildForm
	"build a test form"

	| newForm |
	newForm := self buildEmptyColumn.
	newForm addMorphBack: self buildRow .
	^newForm
! !

!ReagentInSolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/27/2015 01:21'!
buildReagentField
	"creates and answer a UI component to edit the reagent of my ReagentInSolution"

	| newField newEditor |
	newEditor := (ReagentListEditor for: self lab).
	newEditor selectedObject: self reagent.
	newEditor setObjectSelectedBlock: [ :selectedReagent | self reagent: selectedReagent ].
	newField := newEditor buildDropList.
	newField setNameTo: 'reagent'.
	^newField ! !

!ReagentInSolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 00:17'!
buildRow
	"build a row morph to edit my model"

	| newRow |
	newRow := self newRowFor: self.
	newRow 
		addMorphBack: self buildReagentField ;
		addMorphBack: self buildConcentrationField ; 
		addMorphBack: self buildConcentrationUnitField .
	^newRow
! !

!ReagentInSolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/25/2015 21:50'!
buildWindow
	"builds and returns a window which can be opened to edit my model"

	| newWindow |
	newWindow := self uiBuilder newPluggableDialogWindow: self windowTitle for: self buildForm.
	newWindow width: 500 ; minWidth: 500.
	^ newWindow! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 20:52'!
concentration
	^ concentration! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 20:52'!
concentration: anObject
	concentration := anObject! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2015 01:23'!
isComplete
	"indicates whether all the needed fields have some value"
	^ self reagent notNil & self concentration notNil & self unit notNil .! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:47'!
lab
	"my reference lab"
	^ labProvider lab! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:47'!
labProvider
	^ labProvider! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 21:47'!
labProvider: anObject
	labProvider := anObject! !

!ReagentInSolutionEditor methodsFor: 'as yet unclassified' stamp: 'CarlosLombardi 3/25/2015 21:44'!
model: aReagentInSolution
	super model: aReagentInSolution .
	self 
		reagent: aReagentInSolution reagent ;
		concentration: (aReagentInSolution concentration ifNotNil: [:conc | conc value ]) ;
		unit: (aReagentInSolution concentration ifNotNil: [:conc | conc unit ]) .
	! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 20:47'!
reagent
	^ reagent! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 20:47'!
reagent: anObject
	reagent := anObject! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 20:47'!
unit
	^ unit! !

!ReagentInSolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/25/2015 20:47'!
unit: anObject
	unit := anObject! !

!ReagentInSolutionEditor methodsFor: 'updating' stamp: 'CarlosLombardi 3/27/2015 01:20'!
updateModel
	"synchronize my model ReagentInSolution wrt the edited values"
	
	self isComplete ifTrue: [ 
		self model 
			reagent: self reagent ;
			concentration: (self concentration units: self unit) .
	] 
	ifFalse: [ self model reagent: nil ; concentration: nil ].
	

	! !

!ReagentInSolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/25/2015 21:45'!
windowTitle
	"the title for a test window"

	^'Testing the edition of a ReagentInSolution'! !

ObjectEditor subclass: #SolutionEditor
	uses: TBuildWindowFromForm @ {#baseBuildWindow->#buildWindow} + TBusinessObjectEditorEdit
	instanceVariableNames: 'reagentListEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Solutions'!

!SolutionEditor commentStamp: 'CarlosLombardi 3/26/2015 23:10' prior: 0!
An editor for a Solution. 
My model is, in fact, a SolutionEditController. I expect to be set such a controller by sending for: to my class method or model: to me.
!

SolutionEditor class
	uses: TBuildWindowFromForm classTrait + TBusinessObjectEditorEdit classTrait
	instanceVariableNames: ''!

!SolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/29/2015 06:41'!
buildForm
	"..."

	| form nameRow reagentListPane reagentListFrame reagentListTitle |
	reagentListEditor := ReagentInSolutionListEditor for: self model.
	reagentListPane := reagentListEditor buildPane .
	reagentListPane minWidth: 400 ; minHeight: 120.
	reagentListEditor objectList ifNotEmpty: [ 
		reagentListEditor selectedIndex: reagentListEditor objectList size 
	] .
	
	reagentListFrame := self buildEmptyColumn .
	reagentListFrame borderWidth: 3 ; borderColor: Color green darker darker darker ; layoutInset: 8.
	reagentListTitle := 'Componentes para preparación' asMorph 
		font: ('hola' asMorph font textStyle fontOfPointSize: 12 ) ;
		color: Color blue lighter ; yourself.
	reagentListFrame 
		addMorphBack: reagentListTitle ;
		"addMorphBack: (self buildColumnSpacer: 2) ;"
		addMorphBack: reagentListPane.
	
	form := self buildEmptyColumn .
	nameRow := self buildEmptyRow .
	nameRow 
		addMorphBack: 'Nombre' asMorph ;
		addMorphBack: self buildNameField.
	form 
		addMorphBack: (self buildColumnSpacer: 2) ;
		addMorphBack: nameRow ;
		addMorphBack: (self buildColumnSpacer: 8) ;
		addMorphBack: reagentListFrame ;
		addMorphBack: (self buildColumnSpacer: 2) .
	form setNameTo: 'mainPane'.
	^form
		! !

!SolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 23:25'!
buildNameField
	"..."

	| nameField |
	nameField := self uiBuilder
		newTextEntryFor: self model
		getText: #name
		setText: #name:
		help: 'Nombre '.
	nameField minWidth: 200 ; width: 200.
	^nameField
! !

!SolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/27/2015 00:11'!
buildWindow
	"builds and returns a window which can be opened to edit my model"

	| newWindow form |
	newWindow := self baseBuildWindow .
	form := newWindow submorphNamed: 'mainPane'.
	newWindow 
		width: (form submorphs collect: #width) max + 30 ;
		height: (form submorphs collect: #height) sum + 100.
	reagentListEditor window: newWindow.
	^ newWindow! !

!SolutionEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2015 01:35'!
businessObject
	"the object being edited"
	
	^self model model! !

!SolutionEditor methodsFor: 'updating' stamp: 'CarlosLombardi 3/29/2015 05:55'!
updateModel
	"reflect changes in my model, a SolutionEditController, and also in the controller's model,
	 which is the actual domain object edited"

	self model updateModel.! !

!SolutionEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/26/2015 23:20'!
windowTitle
	"..."

	^'Edición de una solución'! !

ObjectEditor subclass: #StockEventDetailEditor
	uses: TBuildWindowFromForm + TTotalAmountField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!StockEventDetailEditor commentStamp: '<historical>' prior: 0!
I know the UI-related configuration and handling for StockEventDetail instances.
An instance of EditingStockEventDetail handles the model-related activities of such an edition.!

StockEventDetailEditor class
	uses: TBuildWindowFromForm classTrait + TTotalAmountField classTrait
	instanceVariableNames: ''!

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/4/2014 02:54'!
buildElementField
	"creates and answer a UI component to edit the stock element of my StockEventDetail"

	| elementField elementEditor |
	elementEditor := (StockElementDropListModel for: self lab).
	elementEditor selectedObject: self model element.
	elementField := elementEditor buildDropList.
	elementField setNameTo: 'element'.
	^elementField ! !

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/2/2014 14:38'!
buildForm
	"... containing all my fields"

	| reagentForm |
	reagentForm := self uiBuilder
		newLabelGroup: { 
			'Reactivo:' -> self buildElementField .
			'Cantidad:' -> self buildQuantityField .
			'Unidad de stock:' -> self buildStockUnitField .
			'Precio unit.:' -> self buildUnitPriceField .
			'Importe: ' -> self buildTotalAmountField }.
	reagentForm setNameTo: 'form'.
	^reagentForm
! !

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/16/2014 21:58'!
buildQuantityField
	"creates and answer a UI component to edit the quantity of my StockEventDetail"

	| newField |
	newField := self uiBuilder
		newTextEntryFor: self model
		get: #quantity 
		set: #quantity:  
		class: Float 
		getEnabled: nil 
		help: 'Cantidad de reactivo'.
	newField 
		width: 80 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	^newField

! !

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/27/2014 01:48'!
buildStockUnitField
	"creates and answer a UI component to show the stock unit for the reagent of this event detail"

	| newField |
	newField := DynamicTextMorph 
		newTransparentFor: self model
		get: #stockUnit
		class: Float.
	newField 
		width: 100 ; height: newField font height ;
		hResizing: #rigid ;
		vResizing: #rigid ;
		cellPositioning: #leftCenter.
	^newField

! !

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 02:35'!
buildUnitPriceEditableField
	"creates and answer a UI component to edit the unit price of my StockEventDetail"

	| newField |
	newField := self uiBuilder
		newTextEntryFor: self model
		get: #unitPrice
		set: #unitPrice:  
		class: Float 
		getEnabled: nil 
		help: 'Precio unitario'.
	newField 
		width: 120 ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		acceptOnFocusChange: true.
	^newField

! !

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 02:37'!
buildUnitPriceField
	"creates and answer a UI component for the unit price of my StockEventDetail"

	^self model unitPriceIsEditable 
		ifTrue: [ self buildUnitPriceEditableField  ]
		ifFalse: [ self buildUnitPriceNonEditableField  ]
! !

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CLom 11/22/2014 02:36'!
buildUnitPriceNonEditableField
	"creates and answer a UI component to show the unit price of my StockEventDetail"

	| newField |
	newField := DynamicTextMorph 
		newTransparentFor: self model
		get: #unitPrice
		class: Float.
	newField 
		width: 120 ; height: newField font height ;
		hResizing: #rigid ;
		vResizing: #rigid ;
		cellPositioning: #leftCenter.
	^newField

! !

!StockEventDetailEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 5/2/2014 14:40'!
elementField
	"the field in my form corresponding to the reagent"

	^self window submorphNamed: 'element'! !

!StockEventDetailEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/16/2014 12:39'!
lab
	"the lab"

	^self model lab! !

!StockEventDetailEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 10/4/2014 10:46'!
model: obj
	"set the object I edit, in this case is a StockEventDetailEditController"

	super model: obj.
	model addDependent: self! !

!StockEventDetailEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/16/2014 15:29'!
quantityField
	"the field in my form corresponding to the quantity"

	^self window submorphNamed: #quantity! !

!StockEventDetailEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/27/2014 01:47'!
stockUnitField
	"the field in my form corresponding to the reagent stock unit"

	^self window submorphNamed: #stockUnit! !

!StockEventDetailEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/23/2014 11:14'!
totalAmountField
	"the field in my form corresponding to the total amount"

	^self window submorphNamed: #totalAmount! !

!StockEventDetailEditor methodsFor: 'ui accessing' stamp: 'CarlosLombardi 3/16/2014 15:29'!
unitPriceField
	"the field in my form corresponding to the unit price"

	^self window submorphNamed: #unitPrice! !

!StockEventDetailEditor methodsFor: 'updating' stamp: 'CLom 11/22/2014 02:51'!
update: aSymbol
	"handling of receiving events"

	"events from UI to model (and also to UI)"
	"reagent selection"
	(aSymbol = #selectedStockElementChanged) | (aSymbol = #selectedStockElementCleared)
		ifTrue: [
			self model element: self elementField model selectedObject .
			self stockUnitField textChanged.
		].
	
	"events from model to UI"
	"unit price change from the model"
	(aSymbol = #unitPrice) 
		ifTrue: [ self updateUnitPriceField ].
	"total amount changed"
	(aSymbol = #totalAmount)
		ifTrue: [ self totalAmountField textChanged ].
! !

!StockEventDetailEditor methodsFor: 'updating' stamp: 'CLom 11/22/2014 02:51'!
updateUnitPriceField
	"update the value of the unit price field upon a change from the model"
	self model unitPriceIsEditable
		ifTrue: [ self unitPriceField update: #unitPrice ]
		ifFalse: [ self unitPriceField textChanged ].
! !

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 5/2/2014 14:40'!
window: aWindow
	"the window I use to do my rendering"

	super window: aWindow.
	self elementField model addDependent: self.
! !

!StockEventDetailEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/16/2014 22:05'!
windowTitle

	^'Detalle de ingreso a stock'! !

ObjectEditor subclass: #StockUnitEditor
	uses: TBuildWindowFromForm
	instanceVariableNames: 'name prependX'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!StockUnitEditor commentStamp: '<historical>' prior: 0!
A simple editor for a StockUnit!

StockUnitEditor class
	uses: TBuildWindowFromForm classTrait
	instanceVariableNames: ''!

!StockUnitEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/28/2014 02:39'!
buildForm
	"builds and returns a form tailored to edit my reagent"

	| nameField prependXField stockUnitForm |
	nameField := self uiBuilder
		newTextEntryFor: self 
		getText: #name
		setText: #name:
		help: 'Nombre de la unidad de stock'.
	nameField minWidth: 200; acceptOnFocusChange: true.
	prependXField := self uiBuilder
		newCheckboxFor: self 
		getSelected: #prependX
		setSelected: #prependX: 
		label: '' 
		help: 'Elegir si se pone una "x" adelante del nombre o no'.
	prependXField
		hResizing: #rigid.
	
	stockUnitForm := self uiBuilder newLabelGroup: {
		'Nombre' -> nameField . 
		'Va "x" adelante' -> prependXField . 
	}.
	stockUnitForm setNameTo: 'form'.
	^stockUnitForm ! !

!StockUnitEditor methodsFor: 'bo edition' stamp: 'CLom 12/28/2014 00:52'!
businessObject
	^ self model! !

!StockUnitEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/28/2014 02:39'!
edit
	"opens a window to edit my stock unit"

	self openModal.
	self window cancelled
		ifFalse: [ self updateModel ].
	^ self window cancelled not! !

!StockUnitEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2014 02:38'!
model: obj
	"set the object I edit, in this case, an EditingReagent"

	super model: obj.
	self name: obj name ; prependX: obj prependX.! !

!StockUnitEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2014 02:37'!
name
	^ name! !

!StockUnitEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2014 02:37'!
name: anObject
	name := anObject! !

!StockUnitEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2014 02:37'!
prependX
	^ prependX! !

!StockUnitEditor methodsFor: 'accessing' stamp: 'CarlosLombardi 3/28/2014 02:37'!
prependX: anObject
	prependX := anObject! !

!StockUnitEditor methodsFor: 'actions' stamp: 'CarlosLombardi 3/28/2014 02:40'!
updateModel
	"update my model wrt the edited data"

	self model name: self name ; prependX: self prependX.! !

!StockUnitEditor methodsFor: 'ui building' stamp: 'CarlosLombardi 3/28/2014 02:30'!
windowTitle

	^'Unidad de stock'! !

Object subclass: #PolymorphCodeSnippets
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-CodeSnippets'!

!PolymorphCodeSnippets commentStamp: 'CarlosLombardi 2/12/2015 02:28' prior: 0!
Reunion of code snippets to understand the use of Polymorph objects
!

!PolymorphCodeSnippets methodsFor: 'snippets' stamp: 'CarlosLombardi 3/17/2015 09:23'!
unprocessedCodeSnippets
	"unedited copy of part of an old workspace, to organize if needed"

	| morfito morfin pepe titleBuilder titleMorph |
	UITheme builder browse.

	UITheme current browse.

	WidgetExamples new exampleBasicControls.

	WidgetExamples new exampleOtherControls.

	WidgetExamples new exampleWindowWithToolbars.



	UITheme current proceedIn: nil text: 'nola' title:  'hola'.



"	morphList := UITheme builder
		newMorphListFor: MyModelExample new
		list: #list 
		getSelected: #selected
		setSelected: #selected:
		help: 'This is a morph list'.
	morphList width: 300.
	morphList openInWindow.
"

	morfito := BorderedMorph new 
		borderWidth: 0 ;
		color: Color blue ;
		changeTableLayout ; 
		hResizing: #rigid ;
		vResizing: #rigid ;
		extent: 80@30.
	morfin := MultiRowMorphBuilder new.
	morfin borderColor: Color red ; 
		borderWidth: 4 ; fillStyle: Color cyan.
	morfin addMorph: 'Hola' asMorph.
	morfin addMorph: 'que tal' asMorph.
	morfin cr.
	morfin addMorph: 'Hola' asMorph.
	morfin addMorph: ('que tal' asMorph width: 200 ; yourself).
	morfin addMorph: 'amiguines' asMorph.
	"morfin addMorph: morfito."
	pepe := morfin morph.
	pepe position: 200@250 ; openInWorld.
	pepe delete.


	titleBuilder := TitleBuilder new.
	titleBuilder	addString: 'Detalle del evento seleccionado' centeredInWidth: 552.
	titleMorph := titleBuilder titleBox
			fillStyle: Color lightBlue ; borderColor: Color darkGray ;
			height: 25; yourself.
	titleMorph position: 200@250 ; openInWorld.
	titleMorph delete.


	"
	uiBuilder := UITheme builder.

	nameField := uiBuilder
		newTextEntryFor:  albumina
		getText:  #name
		setText:  #name: 
		help: 'Nombre del reactivo'.
	nameField minWidth: 200.
	sigmaReferenceField := uiBuilder
		newTextEntryFor:  albumina
		getText:  #sigmaReference
		setText:  #sigmaReference: 
		help: 'Nro de referencia SIGMA'.
	sigmaReferenceField minWidth: 80.
	cuadradito := BorderedMorph new 	
		color: Color blue ; 
		extent: 60@20.
	referenciaField := uiBuilder
		newTextEntryFor:  albumina
		getText:  #molecularWeight
		setText:  #molecularWeight: 
		help: 'Otra autoridad de referencia'.
	referenciaField 
	width: 60 ; hResizing: #rigid.
	referenciaComplexLabel := uiBuilder newRow: 
		{ 'Nro referencia' asMorph . referenciaField }.
	otroSigmaReferenceField := uiBuilder
		newTextEntryFor:  albumina
		getText:  #sigmaReference
		setText:  #sigmaReference: 
		help: 'Nro de referencia SIGMA'.
	otroSigmaReferenceField minWidth: 80.
	albuminaForm := uiBuilder
		newLabelGroup: { 
			cuadradito -> nameField.
			'Nro. referencia SIGMA' -> sigmaReferenceField.
			referenciaComplexLabel -> otroSigmaReferenceField }.
	albuminaWindow := uiBuilder
	newPluggableDialogWindow: 'Reactivo' for: albuminaForm.
	albuminaWindow open.
"
! !

Object subclass: #PriceCalculator
	instanceVariableNames: 'stockElement provider lab onlySpecifiedProvider onlySpecifiedLab defaultPrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Queries'!

!PriceCalculator commentStamp: '<historical>' prior: 0!
An object which provides the last price for a given stock element.
It is required to set a stock element.
It is optional to set a provider and/or a lab; either as defaults or as restrictions.

The criteria to compute the last price are, in order:
1. last price for the given provider and the given lab
2. last price for the given provider for any lab
3. last price for any provider for the given lab
4. last price for any provider and for any lab!

!PriceCalculator methodsFor: 'actions' stamp: 'CarlosLombardi 10/19/2014 10:18'!
checkCoherence
	"generates an error if I am not a coherent PriceCalculator"

	self stockElement isNil ifTrue:  [ self error: 'Must set stock element' ].
	(self onlySpecifiedLab & self lab isNil) ifTrue: [ self error: 'Must set lab' ].
	(self onlySpecifiedProvider & self provider isNil) ifTrue: [ self error: 'Must set provider' ].
	! !

!PriceCalculator methodsFor: 'price' stamp: 'CarlosLombardi 10/20/2014 10:39'!
defaultPrice
	"the price to give if no price is found for the given stock elements and restrictions."

	^defaultPrice! !

!PriceCalculator methodsFor: 'price' stamp: 'CarlosLombardi 10/20/2014 10:40'!
defaultPrice: aNumber
	"the price to give if no price is found for the given stock elements and restrictions."

	defaultPrice := aNumber! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:20'!
forAllLabs
	onlySpecifiedLab := false! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:20'!
forAllProviders
	onlySpecifiedProvider  := false! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
forOnlySpecifiedLab
	onlySpecifiedLab := true! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
forOnlySpecifiedProvider
	onlySpecifiedProvider  := true! !

!PriceCalculator methodsFor: 'initialize-release' stamp: 'CarlosLombardi 10/20/2014 10:40'!
initialize
	"I set up myself to life"

	super initialize.
	onlySpecifiedLab := false.
	onlySpecifiedProvider := false.
	defaultPrice := 0.
! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
lab
	^ lab! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
lab: anObject
	lab := anObject! !

!PriceCalculator methodsFor: 'price' stamp: 'CarlosLombardi 10/19/2014 10:44'!
lastPrice
	"the last price for the given stockElement and conditions. Defaults to self defaultPrice"

	| chain |
	self checkCoherence.
	
	chain := BlockChain new.
	self provider ifNotNil: [ 
		self lab ifNotNil: [ chain addBlock: [ self lastPriceByProvider: self provider andLab: self lab ] ].
		self onlySpecifiedLab ifFalse: [ chain addBlock: [ self lastPriceByProvider: self provider andLab: nil ] ].
	].
	self onlySpecifiedProvider ifFalse: [ 
		self lab ifNotNil: [ chain addBlock: [ self lastPriceByProvider: nil andLab: self lab ] ].
		self onlySpecifiedLab ifFalse: [ chain addBlock: [ self lastPriceByProvider: nil andLab: nil ] ].
	].
	chain defaultValue: self defaultPrice.
	^chain value  ! !

!PriceCalculator methodsFor: 'price' stamp: 'CarlosLombardi 10/19/2014 10:59'!
lastPriceByProvider: aProvider andLab: aLab
	"Private.
	 Last price for the specified provider and lab. 
 	 If the provider is nil, then any provider is considered; and analogously for the lab.
	 Defaults to nil"

	| matchingDetails |
	matchingDetails := EventQuery new
		forOnlyBuyingEvents ;
		forSortEventsByDate ;
		stockElement: self stockElement ;
		lab: aLab ;
		provider: aProvider ;
		details.
	
	^matchingDetails
		ifEmpty: [ nil ]
		ifNotEmpty: [ :details | details last unitPrice ]! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
onlySpecifiedLab
	^ onlySpecifiedLab! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
onlySpecifiedProvider
	^ onlySpecifiedProvider! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
provider
	^ provider! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
provider: anObject
	provider := anObject! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
stockElement
	^ stockElement! !

!PriceCalculator methodsFor: 'conditions and restrictions' stamp: 'CarlosLombardi 10/19/2014 03:19'!
stockElement: anObject
	stockElement := anObject! !

Object subclass: #ProviderInLab
	instanceVariableNames: 'provider lab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Queries'!

!ProviderInLab commentStamp: '<historical>' prior: 0!
the view of a provider wrt a lab!

!ProviderInLab class methodsFor: 'instance creation' stamp: 'CarlosLombardi 10/13/2014 11:11'!
for: aProvider inLab: aLab
	"creates and answers an instance modeling the view of aProvider focused on aLab"
	^self new
		provider: aProvider ; 
		lab: aLab ; 
		yourself! !

!ProviderInLab methodsFor: 'events' stamp: 'CLom 11/22/2014 21:17'!
allBuyingEvents
	"all the buying events related to this provider"

	^EventQuery new 
		provider: self provider ;
		forOnlyBuyingEvents ;
		events
	"^LabApplication current buyingEventsForProvider: self provider"! !

!ProviderInLab methodsFor: 'accessing' stamp: 'CarlosLombardi 10/19/2014 04:10'!
asBasicBusinessObject
	"the basic business object corresponding to me.
	 In this case it my provider"

	^self provider ! !

!ProviderInLab methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/13/2014 11:11'!
lab
	^ lab! !

!ProviderInLab methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/13/2014 11:11'!
lab: anObject
	lab := anObject! !

!ProviderInLab methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/13/2014 11:11'!
provider
	^ provider! !

!ProviderInLab methodsFor: 'basic accessing' stamp: 'CarlosLombardi 10/13/2014 11:11'!
provider: anObject
	provider := anObject! !

!ProviderInLab methodsFor: 'stock elements' stamp: 'CarlosLombardi 10/13/2014 11:29'!
providesStockElement: aStockElement
	"whether it is known that this provider provides the given stock element"

	^self allBuyingEvents anySatisfy: [ :event | event involvesElement: aStockElement ]! !

Object subclass: #Reagent
	uses: TBasicBusinessObject + TWithReferences
	instanceVariableNames: 'name references molecularWeight stockUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!Reagent commentStamp: '<historical>' prior: 0!
A Reagent used in a laboratory!

Reagent class
	uses: TBasicBusinessObject classTrait + TWithReferences classTrait
	instanceVariableNames: ''!

!Reagent class methodsFor: 'examples' stamp: 'CarlosLombardi 3/25/2014 23:41'!
exampleReagent
	"an example reagent to edit"

	| rea |
	rea := Reagent new.
	rea 
		name: 'Albúmina bovina';
		casNumber: 'D7538';
		molecularWeight: 3.15.
	^rea! !

!Reagent methodsFor: 'references' stamp: 'CarlosLombardi 3/26/2014 00:00'!
authoritiesWithoutCas
	"the authorities for which a reference ID for me exists, not considering CAS"
	
	^self authorities copyWithout: Lab casAuthority! !

!Reagent methodsFor: 'references' stamp: 'CarlosLombardi 10/3/2014 22:49'!
casNumber
	"my reference ID for CAS"

	^self referenceIdForAuthority: Lab casAuthority ! !

!Reagent methodsFor: 'references' stamp: 'CarlosLombardi 10/4/2014 12:53'!
casNumber: aRef
	"set my reference ID for CAS"

	^self referenceId: aRef forAuthority: (Lab casAuthority)! !

!Reagent methodsFor: 'magritteDescription' stamp: 'CarlosLombardi 3/25/2014 23:58'!
casNumberMagritteDescription
	"the Magritte description for the SIGMA reference attribute"
	<magritteDescription>
	
	^MAStringDescription new
		priority: 200;
		label: 'Nro. referencia SIGMA';
		accessor: #casNumber;
		yourself
	! !

!Reagent methodsFor: 'magritteDescription' stamp: 'CarlosLombardi 3/6/2014 16:23'!
descriptionContainer
	"little change to see whether it reacts"
	^super descriptionContainer 
		label: 'Reactivo';
		yourself! !

!Reagent methodsFor: 'initialize-release' stamp: 'clom 1/30/2013 20:19'!
initialize
	"I get ready for life"

	references := Dictionary new.
	^self! !

!Reagent methodsFor: 'accessing' stamp: 'clom 1/30/2013 20:27'!
molecularWeight
	^ molecularWeight! !

!Reagent methodsFor: 'accessing' stamp: 'clom 2/5/2013 13:45'!
molecularWeight: anObject
	molecularWeight := anObject! !

!Reagent methodsFor: 'accessing' stamp: 'clom 1/30/2013 20:26'!
name
	"a name which identifies me"
	^ name
! !

!Reagent methodsFor: 'accessing' stamp: 'clom 2/5/2013 13:45'!
name: anObject
	name := anObject! !

!Reagent methodsFor: 'magritteDescription' stamp: 'CarlosLombardi 3/6/2014 15:21'!
nameMagritteDescription
	"the Magritte description for the name attribute"
	<magritteDescription>
	
	^MAStringDescription new
		priority: 100;
		label: 'Nombre';
		accessor: #name;
		yourself
	! !

!Reagent methodsFor: 'references' stamp: 'CarlosLombardi 4/27/2014 19:35'!
privateReferences
	"private - a Dictionary authority/referenceID for my references.
	 For use in traits "
	
	^references ! !

!Reagent methodsFor: 'business references' stamp: 'CarlosLombardi 5/24/2015 20:20'!
referencesToMe
	"the references to this reagent in other business objects"

	^self solutionsReferencingToMe! !

!Reagent methodsFor: 'business references' stamp: 'CarlosLombardi 5/26/2015 15:06'!
solutionsReferencingToMe
	"the references to this reagent as a component in solutions"

	^(SolutionQuery new reagent: self) solutions 
		collect: [ :solu | ReagentAsComponentInSolution new solution: solu reagent: self ; yourself ]! !

!Reagent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 01:02'!
stockUnit
	^ stockUnit! !

!Reagent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 01:02'!
stockUnit: anObject
	stockUnit := anObject! !

Object subclass: #ReagentAsComponentInSolution
	uses: TBOReference
	instanceVariableNames: 'reagentInSolution solution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-BOReferences'!

ReagentAsComponentInSolution class
	uses: TBOReference classTrait
	instanceVariableNames: ''!

!ReagentAsComponentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 5/26/2015 15:09'!
description
	"..."

	^'Componente en solución: ', self solution name, ' (concentración ', self reagentInSolution concentration printStringAbbreviated , ')'! !

!ReagentAsComponentInSolution methodsFor: 'deletion' stamp: 'CarlosLombardi 5/26/2015 14:52'!
preventsDeletion
	"whether this reference prevents the deletion of the referenced object"

	^false .! !

!ReagentAsComponentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 5/26/2015 15:02'!
reagent
	^ reagentInSolution reagent! !

!ReagentAsComponentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 5/26/2015 15:02'!
reagentInSolution
	^ reagentInSolution ! !

!ReagentAsComponentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 20:49'!
solution
	^ solution! !

!ReagentAsComponentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 5/26/2015 15:07'!
solution: aSolution reagent: aReagent 
	"Solution and reagent must be set to me simultaneously"
	solution := aSolution .
	reagentInSolution := solution componentForReagent: aReagent .! !

Object subclass: #ReagentEditController
	uses: TBasicBusinessObjectIsElement + TDelegateNameEditionInBasicBusinessObject
	instanceVariableNames: 'name reagent lab referenceSetEditController stockUnit molecularWeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

!ReagentEditController commentStamp: '<historical>' prior: 0!
A model to edit a Reagent, including two references other than SIGMA.!

ReagentEditController class
	uses: TBasicBusinessObjectIsElement classTrait + TDelegateNameEditionInBasicBusinessObject classTrait
	instanceVariableNames: ''!

!ReagentEditController class methodsFor: 'instance creation' stamp: 'CarlosLombardi 3/11/2014 12:57'!
for: aReagent inLab: aLab
	"creates and returns a new EditingReagent to edit aReagent in the context of aLab"

	^self new
		reagent: aReagent lab: aLab ; 
		yourself.! !

!ReagentEditController methodsFor: 'reagent' stamp: 'CarlosLombardi 5/1/2014 12:13'!
casNumber
	"the CAS number of the reagent"

	^referenceSetEditController casNumber! !

!ReagentEditController methodsFor: 'reagent' stamp: 'CarlosLombardi 5/1/2014 12:13'!
casNumber: aString
	"the CAS number of the reagent"

	referenceSetEditController casNumber: aString
	! !

!ReagentEditController methodsFor: 'basic accessing' stamp: 'CarlosLombardi 4/29/2014 18:52'!
element
	^ self reagent! !

!ReagentEditController methodsFor: 'basic accessing' stamp: 'CarlosLombardi 3/11/2014 10:26'!
lab
	^ lab! !

!ReagentEditController methodsFor: 'basic accessing' stamp: 'CarlosLombardi 3/14/2014 17:00'!
model
	^ self reagent! !

!ReagentEditController methodsFor: 'reagent' stamp: 'CarlosLombardi 3/24/2015 00:39'!
molecularWeight
	"the molecular weight of the reagent. Just the number is edited; the unit is ignored in the edition."

	^molecularWeight ! !

!ReagentEditController methodsFor: 'reagent' stamp: 'CarlosLombardi 3/24/2015 00:39'!
molecularWeight: aNumber
	"the molecular weight of the reagent. Just the number is edited; the unit is ignored in the edition."

	^molecularWeight := aNumber ! !

!ReagentEditController methodsFor: 'reagent' stamp: 'CarlosLombardi 3/24/2015 00:57'!
molecularWeightUnit
	"the molecular weight to be shown"
	^self reagent molecularWeight 
		ifNil: [ LabApplication current molecularWeightUnit ]
		ifNotNil: [ :mw | mw unit ].
! !

!ReagentEditController methodsFor: 'basic accessing' stamp: 'CarlosLombardi 3/11/2014 10:26'!
reagent
	^ reagent! !

!ReagentEditController methodsFor: 'basic accessing' stamp: 'CarlosLombardi 4/14/2015 12:50'!
reagent: obj1 lab: obj2 
	reagent := obj1.
	lab := obj2.
	self setReferenceData.
	self stockUnit: reagent stockUnit.
	self molecularWeight: (reagent molecularWeight ifNil: [nil] ifNotNil: [:mw | mw value]).
! !

!ReagentEditController methodsFor: 'references' stamp: 'CarlosLombardi 5/1/2014 12:14'!
referenceEditControllers
	^ referenceSetEditController referenceEditControllers! !

!ReagentEditController methodsFor: 'private' stamp: 'CarlosLombardi 5/2/2014 09:50'!
setReferenceData
	"..."

	referenceSetEditController := BuyingReferenceSetEditController new.
	referenceSetEditController
		element: self model ; 
		lab: self lab .
! !

!ReagentEditController methodsFor: 'reagent' stamp: 'CarlosLombardi 3/28/2014 01:42'!
stockUnit
	"the stock unit of the reagent"

	^stockUnit! !

!ReagentEditController methodsFor: 'reagent' stamp: 'CarlosLombardi 3/28/2014 01:42'!
stockUnit: aStockUnit
	"the stock unit of the reagent"

	stockUnit := aStockUnit! !

!ReagentEditController methodsFor: 'reagent' stamp: 'CarlosLombardi 5/1/2014 22:40'!
stockUnitPrefix
	"the prefix for the stock unit of the reagent, either 'x ' or '' "

	^self stockUnit
		ifNil: [ '' ]
		ifNotNil: [ :su | su prependX ifTrue: [ 'x ' ] ifFalse: [ '' ] ]! !

!ReagentEditController methodsFor: 'actions' stamp: 'CarlosLombardi 3/24/2015 00:57'!
updateModel
	"update reagent, and eventually also lab"

	"name is automatically updated, cfr method name: in this class."
	
	"molecularWeight: must be set as an UnitValue"
	self reagent molecularWeight: (self molecularWeight units: self molecularWeightUnit).
	
	"references, including CAS number, delegated to referenceSetEditController"
	referenceSetEditController updateModel.
	
	"stock unit - to the reagent and to the lab"
	self reagent stockUnit: self stockUnit.
	self stockUnit ifNotNil: [ :stUnit | self lab addToStockUnits: stUnit ].
	
	! !

Object subclass: #ReagentInSolution
	instanceVariableNames: 'reagent concentration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!ReagentInSolution commentStamp: 'CarlosLombardi 3/17/2015 18:34' prior: 0!
One of the components needed to build Solutions. Indicates the reagent needed, and in what concentration must be used.!

!ReagentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:34'!
concentration
	^ concentration! !

!ReagentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:34'!
concentration: anObject
	concentration := anObject! !

!ReagentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 21:18'!
molecularWeight
	"the molecular weight of the reagent"
	^ reagent molecularWeight! !

!ReagentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:35'!
quantityNeededFor: aQuantityOfSolution
	"how much of the reagent at the given concentration is needed in order to produce 
	 the specified quantity of solution"
	
	self subclassResponsibility ! !

!ReagentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:34'!
reagent
	^ reagent! !

!ReagentInSolution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:34'!
reagent: anObject
	reagent := anObject! !

ReagentInSolution subclass: #ReagentInSolutionByFormula
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!ReagentInSolutionByFormula commentStamp: 'CarlosLombardi 3/24/2015 18:38' prior: 0!
I am a ReagentInSolution for which the calculation of the needed quantity of reagent to produce a given quantity of solution, is specified through a two-parameter block. 
The first parameter for this block is the ReagentInSolution, the second is the desired quantity of solution.!

ReagentInSolutionByFormula subclass: #ReagentInSolutionByConcentrationUnitFormula
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!ReagentInSolutionByConcentrationUnitFormula commentStamp: 'CarlosLombardi 3/24/2015 18:47' prior: 0!
A ReagentInSolutionByFormula whose formula depends on the units in which the reagent concentration is given.
!

!ReagentInSolutionByConcentrationUnitFormula methodsFor: 'accessing' stamp: 'CarlosLombardi 3/24/2015 18:48'!
formula
	"the formula, i.e. the two-parameter block, used to compute the needed quantity of reagent"

	^LabApplication current reagentInSolutionFormulas at: self concentration unit! !

ReagentInSolutionByFormula subclass: #ReagentInSolutionByExplicitFormula
	instanceVariableNames: 'formula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!ReagentInSolutionByExplicitFormula commentStamp: 'CarlosLombardi 3/24/2015 18:39' prior: 0!
I am a ReagentInSolutionByFormula whose formula is given explicitly.!

!ReagentInSolutionByExplicitFormula methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:39'!
formula
	^ formula! !

!ReagentInSolutionByExplicitFormula methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:39'!
formula: anObject
	formula := anObject! !

!ReagentInSolutionByFormula methodsFor: 'accessing' stamp: 'CarlosLombardi 3/24/2015 18:39'!
formula
	"the formula, i.e. the two-parameter block, used to compute the needed quantity of reagent"

	self subclassResponsibility ! !

!ReagentInSolutionByFormula methodsFor: 'accessing' stamp: 'CarlosLombardi 3/24/2015 18:36'!
quantityNeededFor: aQuantityOfSolution
	"how much of the reagent at the given concentration is needed in order to produce 
	 the specified quantity of solution"

	^self formula value: self value: aQuantityOfSolution ! !

Object subclass: #ReferenceAuthority
	instanceVariableNames: 'authName'
	classVariableNames: 'list'
	poolDictionaries: ''
	category: 'LaBook-Model'!

ReferenceAuthority subclass: #Provider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!Provider methodsFor: 'accessing' stamp: 'CarlosLombardi 10/3/2014 23:56'!
isProvider
	"am I a provider, eh?"
	^ true! !

!ReferenceAuthority class methodsFor: 'instance creation' stamp: 'clom 1/30/2013 20:15'!
addAuthorityNamed: theName
	"add a new ReferenceAuthority to the list, asigning the given name to it. 
	  Does nothing if an authority having this name is already in the list"

	| newAuthority |
	(self authorityNamed: theName) isNil ifTrue: [
		newAuthority := ReferenceAuthority new.
		newAuthority authName: theName.
		list add: newAuthority.
	]! !

!ReferenceAuthority class methodsFor: 'authority-list' stamp: 'clom 1/30/2013 20:02'!
authorityList
	"the listed ReferenceAuthority, sorted by name"

	^list asSortedCollection: [:a1 :a2 | a1 authName < a2 authName ]
	! !

!ReferenceAuthority class methodsFor: 'authority-list' stamp: 'clom 1/30/2013 20:04'!
authorityListWithout: anAuthority
	"the listed ReferenceAuthority except anAuthority, sorted by name"

	^(list reject: [:auth | auth = anAuthority ])
		asSortedCollection: [:a1 :a2 | a1 authName < a2 authName ]
	! !

!ReferenceAuthority class methodsFor: 'accessing' stamp: 'clom 1/30/2013 20:00'!
authorityNamed: theName
	"the ReferenceAuthority in the list, having the given name to it; 
	 nil if there is none"

	^list detect: [:authority | authority authName = theName ] ifNone: [nil]! !

!ReferenceAuthority class methodsFor: 'authority-list' stamp: 'clom 1/30/2013 20:38'!
clearList
	"clear the list of registered ReferenceAuthorities"

	list := Set new.
	! !

!ReferenceAuthority class methodsFor: 'instance creation' stamp: 'CarlosLombardi 10/4/2014 11:08'!
newNamed: theName
	"create a new instance, asigning the given name to it."

	| newAuthority |
	newAuthority := self new.
	newAuthority authName: theName.
	^newAuthority
! !

!ReferenceAuthority methodsFor: 'accessing' stamp: 'clom 1/30/2013 19:44'!
authName
	^ authName! !

!ReferenceAuthority methodsFor: 'accessing' stamp: 'clom 1/30/2013 19:44'!
authName: anObject
	authName := anObject! !

!ReferenceAuthority methodsFor: 'accessing' stamp: 'CarlosLombardi 10/3/2014 23:55'!
isProvider
	"am I a provider, eh?"
	^ false! !

!ReferenceAuthority methodsFor: 'accessing' stamp: 'clom 1/30/2013 20:17'!
name
	"a name which identifies me"
	^ self authName! !

!ReferenceAuthority methodsFor: 'printing' stamp: 'CarlosLombardi 10/4/2014 12:32'!
printOn: aStream
	"a String representation of myself is added to aStream"

	aStream nextPutAll: self name! !

Object subclass: #ReportGenerator
	instanceVariableNames: 'labProject logEntry pdfDoc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Log'!

!ReportGenerator commentStamp: '<historical>' prior: 0!
A ReportGenerator is xxxxxxxxx.

Instance Variables
	labProject:		<Object>
	logEntry:		<Object>

labProject
	- xxxxx

logEntry
	- xxxxx
!

!ReportGenerator methodsFor: 'logEntry tree page' stamp: 'FernandoDiMeglio 11/24/2015 15:55'!
addEntryDescriptionStringsToTree: substrings inPage: aPage withIdentation: aNumI withLineSeparator: aNumLS

	| yText |
	
	yText := aNumLS.
	substrings do: [:string |
					
			aPage add:
				(PDFFormattedTextElement new
					font: (PDFCourierFont size: 10 pt);
					from: aNumI mm @ yText mm;
					text: string).
							
			yText := yText + 5.
					
		].

	! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:05'!
attributesAt: charNumber
	"Returns the attributes in index charNumber of the current selection"

	|atts| 

	
	atts := (self logEntry editor selection attributesAt: charNumber) .
	atts size = 1 ifTrue:[^atts] ifFalse:[^ atts ].
! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:26'!
createPageIfNecessaryForCell: aString with: aLimit
	"Create a new page when it arrives to limit of axis y. It is for the cells"
	
	| height |
	
	height := self heightCellForText: aString with: aLimit.
	
	self createPageIfNecessaryWithHeight: height.
	! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 04:19'!
createPageIfNecessaryForSolutionPreparation: aSolutionPreparation
	"Create a new page when it arrives to limit of axis y. It is for the solutions"
	
	| height |
	
	height := 7 +  (self heightCellForSolution: aSolutionPreparation).
		
	aSolutionPreparation components do: [:comp |  
					
				| col |
					
				"Collection that makes it easy to get the maximum number (the height of the cell)"
				col := OrderedCollection new.
					
				col add: (self heightCellForText: comp reagent name  with: 24); 
				      add: (self heightCellForText: (comp reagentQuantity value asString), ' ', (comp reagentQuantity  unit abbreviation) with: 10). 
					
				height := height + (col max).
	
		] .
	
	self createPageIfNecessaryWithHeight: height.
	! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 04:01'!
createPageIfNecessaryWithHeight: height
	"Create a new page when it arrives to limit of axis y. It is for the texts"
	
	| lastElement |
		
	lastElement := self getLastElement.
	
	((lastElement from y value) + height) >= 265 ifTrue:[ 
		
		| newPage |
		
		newPage := PDFPage new.
		
		self generateTextIn: newPage 
			withText: ' '
			withFont: (PDFCourierFont size: 10 pt)
			withPosition: 20 mm @ 25 mm.
			
		pdfDoc add: newPage
		
	]
	! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:06'!
fontColorAt: charNumber
	"Returns the font color in index charNumber of the current selection"
	
	|colors|
	
	colors := (self attributesAt: charNumber)  reject:[:att | (att respondsTo: #color )not].
	colors size = 0 
	ifTrue:[^Color black rgbTriplet ] ifFalse:[^colors last color rgbTriplet].! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:06'!
fontNumberAt: charNumber
	"Returns the font size in index charNumber of the current selection"
	
	^(self logEntry editor selection fontAt:charNumber) pointSize .! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:25'!
generate
	"Generate the report for the selected activity"
	
	| myFont firstPage  cantPageOfLogEntriesTree cantPageWithHeader |
	
	pdfDoc := PDFDocument new.
	myFont := PDFCourierFont new 
				fontSize: 16 pt;
				bold: true.
	firstPage := PDFPage new.
	firstPage add: (PDFTextElement from: 20 mm @ 10 mm text: (self labProject description) font: myFont).
	firstPage add: (PDFTextElement from: 20 mm @ 25 mm text: 'Tareas' font: myFont).
	
	pdfDoc add: firstPage.
	
	self generateLogEntriesTree.
	cantPageOfLogEntriesTree := pdfDoc pages size.

	self generateDetailsOfTasks.
	cantPageWithHeader := (pdfDoc pages size) - cantPageOfLogEntriesTree.
	
	self generateHeaderWith: cantPageWithHeader.
	self generateFooter.
	
	^pdfDoc.! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/26/2015 13:33'!
generateAssociatedFiles
	"It generate the cells and the path correspondent clarifying whether exists or not exists"
	
	| fontSubTittle textFont |
	
	fontSubTittle := PDFCourierFont new 
				fontSize: 12 pt;
				bold: true.
				
	textFont := (PDFCourierFont size: 10 pt).
	
	self generateTextIn: (self getLastPage) 
			withText: 'Archivos asociados' 
			withFont: fontSubTittle 
			withPosition: 20 mm @ (((self getLastElement)  from y value)+12) mm.
	
	self logEntry attachedFiles isNotEmpty ifTrue: [
		| fileSystem pathOriginal exists substrings yCell yPath |
						
			yCell := ((self getLastElement) from y value)+12.
			fileSystem := FileSystem disk.
			
			self logEntry attachedFiles do: [:file | 
							
				pathOriginal := (file reference) fullName.
				exists := (fileSystem exists: pathOriginal) ifTrue: [ 'Existe' ] ifFalse: [ 'No existe'].
				
				self createPageIfNecessaryForCell: pathOriginal with: 60.
				
				substrings := self splitTextForLines: pathOriginal withLimit: 60.
				
				(self getLastElement) text = ' ' ifTrue: [ yCell := ((self getLastElement) from y value) + 10 ].
						
				self generateCellIn: (self getLastPage) 
					withText: ''
					withFont: textFont
					withPosition: 26 mm @ yCell mm
					withDimension: 136.5 mm @ (self heightCellForText: pathOriginal with: 60) mm
					withAlignment: PDFAlignment left.
			
				yPath := yCell - 2.
				substrings do: [:string |
					
						self generateTextIn: (self getLastPage)  
							withText: string
							withFont: textFont 
							withPosition:  27 mm @ yPath mm.
							
						 yPath := yPath + 5.	
					].
				
				self generateCellIn: (self getLastPage) 
					withText: exists
					withFont: textFont
					withPosition: 156.5 mm @ yCell mm
					withDimension: 20 mm @ (self heightCellForText: pathOriginal with: 60) mm
					withAlignment: PDFAlignment center.
							
				yCell := (self heightCellForText: pathOriginal with: 60) + ((self getLastElement) from y value) .
			].
		
		] ifFalse: [
		
				self generateTextIn: (self getLastPage)  
					withText: 'No Tiene'
					withFont: textFont 
					withPosition:  20 mm @ (((self getLastElement)  from y value)+8) mm.
			].! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 10/31/2015 16:00'!
generateCellIn: aPage withText: aString withFont: aFont withPosition: aPosition withDimension: aDimension withAlignment: anAlignment
	"Generate a cell with the data of the parameters"
	
	aPage add: ((PDFCellElement new
			from: aPosition;
			dimension: aDimension;
			text: aString;
			font: aFont;
			alignment: anAlignment) thickness: 0 mm).! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/23/2015 03:57'!
generateCellsForNotesFromX: xCell fromY: yCell withLines: aLines
	"Generate the quantity of the necessary cells for the notes"

	| total index tempTotal selection |
	
	total := 0.
	tempTotal := 0.
	index := aLines first at:2.
	aLines do:[:line | total := total + (self sizeCharHeight  at: (self greatestCharInLine: (line at:2))). index := index + 1].
	(total + yCell  <= 265) ifTrue:[
		self generateCellIn: (self getLastPage) 
				withText: '' 
				withFont: (PDFCourierFont size: 10 pt)
				withPosition:  xCell mm @ yCell mm
				withDimension:  156 mm @ total mm
				withAlignment: PDFAlignment center.
				aLines do:[:line|
				self logEntry editor selectFrom: (line at:1) to: (line at:3).
				selection := self logEntry editor selection.
				
				self printFromLeft: selection inPage: (self getLastPage) x: (xCell+1) y:(yCell+1).
				yCell:= yCell + 5.
			].
		]
	ifFalse:[
		| height splittedLines aLinesLeft newPage |
		height := (265 - yCell).
		self generateCellIn: (self getLastPage) 
				withText: '' 
				withFont: (PDFCourierFont size: 10 pt)
				withPosition:  xCell mm @ yCell mm
				withDimension:  156 mm @ height mm
				withAlignment: PDFAlignment center.
				splittedLines := aLines first: (self linesAblesToBeWrittenInCell: height).
				aLinesLeft := aLines last:(aLines size - splittedLines size).
			splittedLines do:[:line|
				self logEntry editor selectFrom: (line at:1) to: (line at:3).
				selection := self logEntry editor selection.
				
				self printFromLeft: selection inPage: (self getLastPage) x: (xCell+1) y:(yCell+1).
				yCell:= yCell + 5.
			].
		
		
		newPage := PDFPage new.
		
		self generateTextIn: newPage 
		withText: ' '
		withFont: (PDFCourierFont size: 10 pt)
		withPosition: 20 mm @ 25 mm.
			
		pdfDoc add: newPage.
		
		self generateCellsForNotesFromX: 20  fromY: 25 withLines: aLinesLeft.
		
		].! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:55'!
generateDetails
	"Generate all the detail of logEntry, name, child, associated files, notes, solutions"
		
	self generateDetailsWithDescription: self logEntry description 
	                withDescriptionParent: self logEntry parent description 
	                with: 'Es una tarea principal del proyecto'.
							
	self generateDetailsOfChildren. ! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:56'!
generateDetailsOfChildren
	"Generate all the details for each children"

	self logEntry children do: [:child | 
		
			self logEntry: child.
			self generateDetailsWithDescription: child description 
	              		 withDescriptionParent: child parent description 
	              		 with: 'Es parte de la tarea'.
					
			self generateDetailsOfChildren.
		 ].! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:56'!
generateDetailsOfTasks
	"Generate tasks' details of each child in pdfDoc"
	
	self labProject children do: [:child |
			self logEntry: child.
			self generateDetails
		].! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:51'!
generateDetailsWithDescription: aDescription withDescriptionParent: aDescriptionParent with: aString
	
	| page |
		
	page := PDFPage new.
	pdfDoc add: page.

	self generateTittleOfTheTaskWith: aDescription.	
	self generateNameOfParentWith: aString with: aDescriptionParent.
	self generateNamesOfTheMainSubdivisions.
	self generateInformationOfTheDates.
	self generateNotes.
	self generateAssociatedFiles.
	self generateSolutions.
! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:24'!
generateFooter
	"Generate a footer for each page with the quantity of pages and the current number"

	pdfDoc pages do:[:page | 
			page add: ((PDFLineElement from: 20 mm @ 275 mm to: 187 mm @ 275 mm) thickness: 0 mm).
			
			page add:
			(PDFFormattedTextElement new
				font: (PDFCourierFont size: 10 pt);
				from: 95 mm @ 278 mm;
				text: 'Página ', (pdfDoc pages indexOf: page) asString, ' de ',  (pdfDoc pages size) asString).	
		].
	! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:24'!
generateHeaderWith: cantPages
	"Generate a header for each page with the name of proyect"
	
	| pages |
	
	pages := pdfDoc pages last: cantPages.
	pages do:[:page | 
			page add: ((PDFLineElement from: 20 mm @ 25 mm to: 187 mm @ 25 mm) thickness: 0 mm).
			
			page add:
			(PDFFormattedTextElement new
				font: (PDFCourierFont size: 10 pt);
				from: 20 mm @ 15 mm;
				text: 'Tarea dentro del proyecto: ',  (self labProject description)).	
		].
	! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 04:10'!
generateInformationOfTheDates
	"Genera la informacion de las fechas de carga, estimada y terminada si es que se agregaron"

	| fontSubTittle |
	
	fontSubTittle := PDFCourierFont new 
				fontSize: 12 pt;
				bold: true.
					
	self generateTextIn: (self getLastPage)
			withText: 'Fechas'
			withFont: fontSubTittle
			withPosition: 20 mm @ (((self getLastElement) from y value)+10) mm.
								
	self createPageIfNecessaryWithHeight: 14.
						
	self generateCellIn: (self getLastPage) 
			withText: 'Carga'  
			withFont:  fontSubTittle
			withPosition:  26 mm @ (((self getLastElement) from y value)+12) mm
			withDimension:  50 mm @ 7 mm
			withAlignment: PDFAlignment center.
			
	self generateCellIn: (self getLastPage) 
			withText: 'Estimada'  
			withFont:  fontSubTittle
			withPosition:  (((self getLastElement) from x value)+50) mm @ ((self getLastElement) from y value) mm
			withDimension:  50 mm @ 7 mm
			withAlignment: PDFAlignment center.
			
	self generateCellIn: (self getLastPage) 
			withText: 'Terminada'  
			withFont:  fontSubTittle
			withPosition:  (((self getLastElement) from x value)+50) mm @ ((self getLastElement) from y value) mm
			withDimension:  50 mm @ 7 mm
			withAlignment: PDFAlignment center.
		
	self generateCellIn: (self getLastPage) 
			withText: (self logEntry loadDate isNotNil ifTrue: [ self logEntry loadDate printFormat: #(1 2 3 $/ 1 1 2).] ifFalse: [ '' ])
			withFont:  (PDFCourierFont size: 10 pt)
			withPosition:  26 mm @ (((self getLastElement) from y value)+7) mm
			withDimension:  50 mm @ 7 mm
			withAlignment: PDFAlignment center.
			
	self generateCellIn: (self getLastPage) 
			withText: (self logEntry toDoDate isNotNil ifTrue: [ self logEntry toDoDate printFormat: #(1 2 3 $/ 1 1 2).] ifFalse: [ '' ])
			withFont:  (PDFCourierFont size: 10 pt)
			withPosition:  (((self getLastElement) from x value)+50) mm @ ((self getLastElement) from y value) mm
			withDimension:  50 mm @ 7 mm
			withAlignment: PDFAlignment center.
			
	self generateCellIn: (self getLastPage) 
			withText: (self logEntry completionDate isNotNil ifTrue: [ self logEntry completionDate printFormat: #(1 2 3 $/ 1 1 2).] ifFalse: [ '' ])
			withFont:  (PDFCourierFont size: 10 pt)
			withPosition:  (((self getLastElement) from x value )+50) mm @ ((self getLastElement) from y value) mm
			withDimension:  50 mm @ 7 mm
			withAlignment: PDFAlignment center.
											
										! !

!ReportGenerator methodsFor: 'logEntry tree page' stamp: 'FernandoDiMeglio 11/24/2015 18:58'!
generateLogEntriesTree
	"Generate the tree of tasks of all the children"

	| lastPage y |

	self labProject children do:[:child |
			self logEntry: child.
			lastPage :=  self getLastPage.	
			y := self getLastElement from y value.
			self generateLogEntriesTreeInPage: lastPage withIdentation: 20 withLineSeparator: y+5.
		].! !

!ReportGenerator methodsFor: 'logEntry tree page' stamp: 'FernandoDiMeglio 11/23/2015 03:47'!
generateLogEntriesTreeInPage: aPage withIdentation: aNumI withLineSeparator: aNumLS
	"Add report all the tasks"
	| lastLine |
	
	lastLine := aPage elements last from y value.
	
	lastLine = 265 ifTrue: [  
		| newPage |
				
		newPage := PDFPage new.
		pdfDoc add: newPage.
					
		self generateTreeInPage: newPage withIdentation: aNumI withLineSeparator: 30.
		
	] ifFalse:[
		self generateTreeInPage: aPage withIdentation: aNumI withLineSeparator: aNumLS
		]
	

! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 04:09'!
generateNameOfParentWith: aString with: aDescriptionParent
	"Generate the father's name of 'self' "
		
	| fontSubTittle substrings yText |
	
	fontSubTittle := PDFCourierFont new 
				fontSize: 12 pt;
				bold: true.
				
	self generateTextIn: (self getLastPage)
			withText: aString 
			withFont:  fontSubTittle
			withPosition: 20 mm @ 50 mm.
			
			
	substrings := self splitTextForLines: aDescriptionParent withLimit: 80.
									
	yText := 58.
	substrings do: [:string |
					
			self generateTextIn: (self getLastPage)
				withText: string
				withFont: (PDFCourierFont size: 10 pt)
				withPosition: 20 mm @ yText mm.
							
			yText := yText + 4.
					
		].
! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:46'!
generateNamesOfTheMainSubdivisions
	"Generate only the names of its main children"
	
	| fontSubTittle yText substrings |
	
	fontSubTittle := PDFCourierFont new 
				fontSize: 12 pt;
				bold: true.
				
	self generateTextIn: (self getLastPage)
			withText: 'Subdivisiones principales' 
			withFont: fontSubTittle
			withPosition: 20 mm @ ((self getLastElement) from y value + 10) mm.
					
	yText := ((self getLastElement) from y value) + 7.
	self logEntry children isEmpty ifTrue: [ 
		
			self generateTextIn: (self getLastPage)
					withText: 'No tiene'
					withFont: (PDFCourierFont size: 10 pt)
					withPosition: 20 mm @ yText mm.
		 ] ifFalse: [ 
				self logEntry children do: [:child |  
					
					
				substrings := self splitTextForLines: child description withLimit: 80.
									
				substrings do: [:string |
					
						self generateTextIn: (self getLastPage)
							withText: string
							withFont: (PDFCourierFont size: 10 pt)
							withPosition: 20 mm @ yText mm.
							
						yText := ((self getLastElement) from y value) + 5.
					
					].
			].
		 ].! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 13:37'!
generateNotes
	"Generate all the text of the note with its style"
	
	| fontSubTittle noteEditorString notes |
	
	fontSubTittle := PDFCourierFont new 
				fontSize: 12 pt;
				bold: true.
				
	self generateTextIn:  (self getLastPage)
			withText: 'Notas' 
			withFont: fontSubTittle
			withPosition: 20 mm @ (((self getLastElement) from y value)+10) mm.
			
	noteEditorString := self logEntry noteEditor text asString.
	notes := self logEntry notes.
		
	notes isNotNil | noteEditorString isNotEmpty ifTrue: [  
		
		|xCell yCell  alines point |
		
		xCell := 26.		
		yCell:=  (((self getLastElement) from y value)+10).
		alines := self lines.
		point := xCell mm @ yCell mm. 
		self writeNotesWithLines: alines onPoint: point.
		
		] ifFalse: [
		
				self generateTextIn:  (self getLastPage)
					withText: 'No Tiene' 
					withFont: (PDFCourierFont size: 10 pt)
					withPosition: 20 mm @ (((self getLastElement) from y value)+8) mm
			].! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/26/2015 13:57'!
generateSolutions
	"Generate the table of solution, clarify name, quantity of the solution and reagents with its quantity"
	
	| fontSubTittle component position substrings yCell yText heightRowSolution |
	
	
	fontSubTittle := PDFCourierFont new 
				fontSize: 12 pt;
				bold: true.
				
	((self getLastElement) text) = 'Existe' | ((self getLastElement) text) = 'No existe' ifTrue:[
		position := ((self getLastElement) from y value)+
					((self getLastElement) dimension y value) + 5 ] ifFalse:[position:= ((self getLastElement) from y value) + 10].
	
	self generateTextIn: (self getLastPage) 
		withText: 'Preparación de soluciones'
		withFont: fontSubTittle
		withPosition: 20 mm @ position mm.
		
	self logEntry solutionPreparationActivities ifEmpty: [ 
		
			self generateTextIn: (self getLastPage) 
				withText: 'No Tiene' 
				withFont: (PDFCourierFont size: 10 pt)
				withPosition: 20 mm @ (((self getLastElement) from y value)+8) mm
					
		 ] ifNotEmpty: [
			| adjustmentOfSpace |
						
			adjustmentOfSpace := 12.
			self logEntry solutionPreparationActivities do:[:solutionPreparation | 
		
				self createPageIfNecessaryForSolutionPreparation: solutionPreparation.
		
				self generateCellIn: (self getLastPage) 
					withText: 'Solución' 
					withFont: fontSubTittle 
					withPosition: 26 mm @ (((self getLastElement) from y value)+adjustmentOfSpace) mm  
					withDimension: 53 mm @ 7 mm
					withAlignment: PDFAlignment left.
					
				adjustmentOfSpace := 18.
				
				self generateCellIn: (self getLastPage) 
					withText: 'Cantidad'
					withFont: fontSubTittle 
					withPosition: 79 mm @ ((self getLastElement) from y value) mm  
					withDimension: 23 mm @ 7 mm
					withAlignment: PDFAlignment left.
				
				self generateCellIn: (self getLastPage) 
					withText: 'Reactivo utilizado'
					withFont: fontSubTittle 
					withPosition: 102 mm @ ((self getLastElement) from y value) mm 
					withDimension: 53 mm @ 7 mm
					withAlignment: PDFAlignment left.
				
				self generateCellIn: (self getLastPage) 
					withText: 'Cantidad'
					withFont: fontSubTittle 
					withPosition: 155 mm @ ((self getLastElement) from y value) mm 
					withDimension: 23 mm @ 7 mm
					withAlignment: PDFAlignment left.
					
				heightRowSolution := self heightCellForSolution: solutionPreparation.
				
				"Begins--Name of the solution"	
				substrings := self splitTextForLines: solutionPreparation solution name withLimit: 24.
				yCell := ((self getLastElement)  from y value) + 7.
				
				self generateCellIn: (self getLastPage)  
					withText: ''
					withFont: (PDFCourierFont size: 10 pt) 
					withPosition: 26 mm @ yCell mm 
					withDimension: 53 mm @ heightRowSolution mm
					withAlignment: PDFAlignment left.
					
				yText := ((self getLastElement)  from y value) - 2.
				substrings do: [:string |
					
						self generateTextIn: (self getLastPage) 
							withText: string
							withFont: (PDFCourierFont size: 10 pt)
							withPosition: 27 mm @ yText mm.
							
						yText := yText + 5.
					
					  ].
				"End--Name of the solution"
				
				"Begins--Quantity of the solution"
				substrings := self splitTextForLines: ((solutionPreparation solutionQuantity asFloat round: 5) printStringAbbreviated) 
						 							  withLimit: 10.
													
					
				self generateCellIn: (self getLastPage) 
					withText: ''
					withFont: (PDFCourierFont size: 10 pt) 
					withPosition: 79 mm @ yCell mm 
					withDimension: 23 mm @ heightRowSolution mm
					withAlignment: PDFAlignment left.
					
				yText := ((self getLastElement) from y value) - 2.
				substrings do: [:string |
					
						self generateTextIn: (self getLastPage) 
							withText: string
							withFont: (PDFCourierFont size: 10 pt)
							withPosition: 80 mm @ yText mm.
							
						yText := yText + 5.
					
					  ].
				"End--Quantity of the solution"
				
				"Begins--Name of the first component"	
				component := solutionPreparation components first.
				
				substrings := self splitTextForLines: component reagent name withLimit: 24.
													
					
				self generateCellIn: (self getLastPage) 
					withText: ''
					withFont: (PDFCourierFont size: 10 pt) 
					withPosition: 102 mm @ yCell mm 
					withDimension: 53 mm @ heightRowSolution mm
					withAlignment: PDFAlignment left.
					
				yText := ((self getLastElement)  from y value) - 2.
				substrings do: [:string |
					
						self generateTextIn: (self getLastPage) 
							withText: string
							withFont: (PDFCourierFont size: 10 pt)
							withPosition: 103 mm @ yText mm.
							
						yText := yText + 5.
					
					  ].
				"End--Name of the first component"
				
				"Begins--Quantity of the first component"
				substrings := self splitTextForLines:  ((component reagentQuantity asFloat round: 5) printStringAbbreviated) withLimit: 10.
				
				self generateCellIn: (self getLastPage) 
					withText: ''
					withFont: (PDFCourierFont size: 10 pt) 
					withPosition: 155 mm @ yCell mm 
					withDimension: 23 mm @ heightRowSolution mm
					withAlignment: PDFAlignment left.
											
				yText := ((self getLastElement)  from y value) - 2.
				substrings do: [:string |
					
						self generateTextIn:  (self getLastPage) 
							withText: string
							withFont: (PDFCourierFont size: 10 pt)
							withPosition: 156 mm @ yText mm.
							
						yText := yText + 5.
					
					  ].								
				"End --Quantity of the first component"
		
				yCell := yCell + heightRowSolution. 
				solutionPreparation components allButFirst do: [:comp |  
					
					heightRowSolution := (self heightCellForText: comp reagent name  with: 24).
					
					substrings := self splitTextForLines: comp reagent name withLimit: 24.
											
					self generateCellIn: (self getLastPage) 
					withText: ''
					withFont: (PDFCourierFont size: 10 pt) 
					withPosition: 102 mm @ yCell mm 
					withDimension: 53 mm @ heightRowSolution mm
					withAlignment: PDFAlignment left.
					
					yText := ((self getLastElement)  from y value) - 2.
					substrings do: [:string |
					
						self generateTextIn: (self getLastPage) 
							withText: string
							withFont: (PDFCourierFont size: 10 pt)
							withPosition: 103 mm @ yText mm.
							
						yText := yText + 5.
					
					  ].
					
					substrings := self splitTextForLines:  ((comp reagentQuantity asFloat round: 5) printStringAbbreviated) withLimit: 10.
				
					self generateCellIn: (self getLastPage) 
							withText: ''
							withFont: (PDFCourierFont size: 10 pt) 
							withPosition: 155 mm @ yCell mm 
							withDimension: 23 mm @ heightRowSolution mm
							withAlignment: PDFAlignment left.
										
					yText := ((self getLastElement)  from y value) - 2.
					substrings do: [:string |
					
						self generateTextIn:  (self getLastPage) 
							withText: string
							withFont: (PDFCourierFont size: 10 pt)
							withPosition: 156 mm @ yText mm.
							
						yText := yText + 5.
					
					  ].	
					
					yCell := yCell + heightRowSolution.
										
				]		
			] 
		 ]
							
	! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 10/31/2015 16:16'!
generateTextIn: aPage withText: aString withFont: aFont withPosition: aPosition
	"Generate a text (aString) in aPage with the data of the parameters"

	(aPosition y value) >= 265 ifTrue:[ 
		
		| newPage |
		
		newPage := PDFPage new.
		
		self generateTextIn: newPage 
		withText: aString
		withFont: aFont
		withPosition: 20 mm @ 25 mm.
			
		(aPage document) add: newPage
		
		] ifFalse:[ 
			
			aPage add:
				(PDFFormattedTextElement new
				font: aFont;
				from: aPosition;
				text: aString).		
		 ].

	
		
	! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:43'!
generateTittleOfTheTaskWith: aDescription
	"Generate the tittle of the task (aDescription)"

	| fontTittle substrings yText |
	
	fontTittle := PDFCourierFont new 
				fontSize: 16 pt;
				bold: true.
				
	substrings := self splitTextForLines: aDescription withLimit: 50.
									
	yText := 30.
	substrings do: [:string |
					
			self generateTextIn: (self getLastPage)
				withText: string
				withFont: fontTittle
				withPosition: 20 mm @ yText mm.
							
			yText := yText + 5.
					
		].
				! !

!ReportGenerator methodsFor: 'logEntry tree page' stamp: 'FernandoDiMeglio 11/24/2015 19:45'!
generateTreeInPage: aPage withIdentation: aNumI withLineSeparator: aNumLS

	| substrings elementParent |
	
	substrings := self splitTextForLines: self logEntry description withLimit: 80.
	
	self addEntryDescriptionStringsToTree: substrings inPage: aPage withIdentation: aNumI withLineSeparator: aNumLS.						
	
	"get the element (PDFFormattedTextElement) parent of child"
	elementParent := aPage elements detect: [:element | element text = (substrings  first)].
	
	self logEntry children do:[:child | 
		
		|  x y lastPage |
		
		self logEntry: child.
							
		x := (elementParent from x value)+7.
		
		"This if is for getting the last page of report. It is necessary when jumping from page in any of your children 
		or grandchildren, and returning the next child. So lets use aPage (which was already filled) and continues to 
		use the last page of the report."
		(aPage elements last from y value) = 265 ifTrue: [ lastPage := pdfDoc pages last ] ifFalse:[ lastPage :=aPage ].
		
		y :=  (lastPage elements last from y value)+5.
		self generateLogEntriesTreeInPage: lastPage withIdentation: x withLineSeparator: y.
	]
	

	! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:43'!
getLastElement

	^(self getLastPage) elements last.! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 11/23/2015 03:36'!
getLastPage

	^pdfDoc pages last! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 10/16/2015 03:27'!
greatestCharInLine: lineNumber

	|oldStart oldStop greatest index|
	
	oldStart := self logEntry editor startIndex.
	oldStop := self logEntry editor stopIndex.
	self logEntry editor selectFrom: ((self lines at: lineNumber) at: 1) to: ((self lines at: lineNumber) at:3).
	greatest := 7.
	index := 1.
	self logEntry editor selection do:[:char | 
		((self fontNumberAt: index) >= greatest ) ifTrue:[greatest := self fontNumberAt: index].
		index := index + 1. 
		].
	
	self logEntry editor selectFrom: oldStart to: oldStop. 
	^greatest. ! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 10/31/2015 16:23'!
heightCellForSolution: aSolution
	"Return the highest height of a cell in the first row"

	| heightNameSolution heighNameComponent component col |	
		
	heightNameSolution := self heightCellForText: aSolution solution name with: 24.	
	component := aSolution components first.
	heighNameComponent := self heightCellForText:  component reagent name with: 24.							
	col := OrderedCollection new.

	col add: heightNameSolution; 
            add: heighNameComponent.
		
	^col max! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 10/31/2015 16:26'!
heightCellForText: aText with: aNum
	"Return the height of a cell for the text of parameter (aText)"
	
	| linesForText |
	
	linesForText := self linesForText:  aText with: aNum.

	linesForText = 1 ifTrue: [ ^7 ] ifFalse: [ ^7 * linesForText - 2]! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:07'!
isBoldAt: charNumber
	"True if the charNumber char in current selection is bold"

	|fonts|
	
	fonts := (self attributesAt: charNumber) reject:[:att |( att respondsTo: #emphasisCode) not] .
	^fonts contains:[:att | att emphasisCode = 1].! !

!ReportGenerator methodsFor: 'accesing' stamp: 'FernandoDiMeglio 10/16/2015 02:47'!
labProject
	^labProject! !

!ReportGenerator methodsFor: 'accesing' stamp: 'FernandoDiMeglio 10/16/2015 02:47'!
labProject: aLabProject
	labProject := aLabProject! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:07'!
limitLine: line
	"Returns a line that fits with the width of the notes cell in report"

	|total  index selIndex |
	
	total := 0.
	index := line at:1.
	selIndex := 1.
	self logEntry editor selection do:[:char | 
		total := total + ( self sizeCharMap at: (self fontNumberAt: selIndex)).
		(total >= 154) ifTrue:[
			
			^(Array with: (line at: 1) with: (line at: 2) with: index).
			].
		selIndex := selIndex + 1.
		index := index +1.
		 ].! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:08'!
lines
	"Returns a collection with the lines ready to fit in the notes cell"
	
	|cond index current newLines lines limitedLine|
	lines := self logEntry editor lines.
	newLines := OrderedCollection new.
	cond := true.
	index := 1.
	current := lines at: index.
		[ cond ] whileTrue:[
			self logEntry editor selectFrom: (current at:1) to: (current at:3).
			((self occupedSpaceOfLine: current) <= 157) ifTrue: [newLines add: current]
					ifFalse:[limitedLine := self limitLine: current.
							newLines add: limitedLine .
							lines add: (Array with:((limitedLine at: 3) + 1)
							with:  ((limitedLine at: 2) + 1)
							with: (current at: 3)) afterIndex: index.
							].
				(index = lines size) ifTrue:[cond := false].
							cond ifTrue:[
									index := index + 1.
									current := lines at: index.
								].
			].

	^newLines.! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:08'!
linesAblesToBeWrittenInCell: height
	"Returns the amount of lines that can fit y a cell with a determined height"

	|total index|

	total := 0.
	index := 1.
	self lines do:[:line | total := total + (self sizeCharHeight  at: (self greatestCharInLine: index)). 
						(total > height) ifTrue:[^index].
						index := index + 1].
! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 10/31/2015 16:30'!
linesForText: text with: aNum
	"Return the quantity of lines (lines that correspond to 'text')"
	
	 ^((text size roundUpTo: aNum) / aNum).! !

!ReportGenerator methodsFor: 'accesing' stamp: 'FernandoDiMeglio 10/16/2015 02:48'!
logEntry
	^logEntry! !

!ReportGenerator methodsFor: 'accesing' stamp: 'FernandoDiMeglio 10/16/2015 02:49'!
logEntry: alLgEntry
	logEntry := alLgEntry! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:09'!
occupedSpaceOfLine: line 
	"Returns the occuped space of a line "

	|total index|
	total := 0.
	index := 1.
	self logEntry editor selectFrom: (line at: 1) to: (line at: 3).
	
	self logEntry editor selection do:[:char| 
			total := total + (self sizeCharMap at: (self fontNumberAt: index)).
			index := index + 1.		
		].
	
	^total.! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:09'!
printFromLeft: line inPage: aPage x: xCell y:yCell
	"prints a line in report"

	|x y index|
	
	x:= xCell.
	y:= yCell.
	index := 1.
	
	line do:[:char | self putChar: char atPage: aPage fromIndex: index  x: x  y: y .
			x := x+ ((self fontNumberAt: index) / 5).
			index := index+1.
			].! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:09'!
putChar:char atPage: aPage fromIndex:index x: x y: y
	"prints a char in the report"

	|page font text color|
	
	page:= aPage.
	
	font := PDFCourierFont size: (self fontNumberAt: index) pt.
	(self isBoldAt: index) ifTrue:[font:=font bold].
	color := PDFColor r: ((self fontColorAt: index) at: 1)*255 g: ((self fontColorAt: index) at: 2)*255 b: ((self fontColorAt: index) at: 3)*255.
	text :=  (PDFTextElement new
						textColor: color;
						font: font;
						from: x mm @ (y - (self sizeCharShift at: (self fontNumberAt: index) )) mm;
						text: char asString).
	aPage add: text.
	! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:10'!
sizeCharHeight
	"Dictionary  with the ocupped height of each font size"

	|sizes|
	sizes := Dictionary new.
	sizes at: 7 put: 2.5.
	sizes at: 9 put: 5.
	sizes at: 12 put: 5.2.
	sizes at: 14 put: 5.5.
	sizes at: 18 put: 6.
	sizes at: 24 put: 7.
	
	^sizes.! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:10'!
sizeCharMap
	"Dictionary  with the ocupped width of each font size"

	|sizes|
	sizes := Dictionary new.
	sizes at: 7 put: 1.41.
	sizes at: 9 put: 1.81.
	sizes at: 12 put: 2.43.
	sizes at: 14 put: 2.83.
	sizes at: 18 put: 3.63.
	sizes at: 24 put: 4.80.
	
	^sizes.! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/24/2015 16:10'!
sizeCharShift
	"Dictionary  with the shift required based on each size"

	|sizes|
	sizes := Dictionary new.
	sizes at: 7 put: 0.
	sizes at: 9 put: 1.
	sizes at: 12 put: 2.
	sizes at: 14 put: 3.
	sizes at: 18 put: 4.
	sizes at: 24 put: 4.7.
	
	^sizes.! !

!ReportGenerator methodsFor: 'report' stamp: 'FernandoDiMeglio 10/31/2015 16:39'!
splitTextForLines: aText withLimit: aNum
	"Separate aText n times to enter in the width of the cell. 
	Return a list with n elements where each one is the division of aText to represent a line"

	| substrings cant textCopy|
	textCopy := aText copy.
	substrings := OrderedCollection new.
	cant := self linesForText: aText with: aNum.
	cant timesRepeat: [
		(textCopy size > aNum) 
		ifTrue:[
				substrings add: (textCopy first: aNum).
				textCopy := textCopy last: (textCopy size - aNum).
		] ifFalse:[
				substrings add: textCopy
			].
	].

	^substrings.! !

!ReportGenerator methodsFor: 'notes' stamp: 'FernandoDiMeglio 11/23/2015 03:43'!
writeNotesWithLines: aLines onPoint: aPoint
	"Prints the notes of a log entry"

	| total index tempTotal selection xCell yCell |
	
	xCell := aPoint x value.
	yCell := aPoint y value.
	
	total := 0.
	tempTotal := 0.
	index := aLines first at:2.
	aLines do:[:line | total := total + (self sizeCharHeight  at: (self greatestCharInLine: (line at:2))). index := index + 1].
	(total + yCell  <= 265) ifTrue:[
		self generateCellIn: (self getLastPage) 
				withText: '' 
				withFont: (PDFCourierFont size: 10 pt)
				withPosition:  xCell mm @ yCell mm
				withDimension:  156 mm @ total mm
				withAlignment: PDFAlignment center.
				aLines do:[:line|
				self logEntry editor selectFrom: (line at:1) to: (line at:3).
				selection := self logEntry editor selection.
				
				self printFromLeft: selection inPage: (self getLastPage) x: (xCell+1) y:(yCell+1).
				yCell:= yCell + 5.
			].
		]
	ifFalse:[
		| height splittedLines aLinesLeft newPage |
		height := (265 - yCell).
		self generateCellIn: (self getLastPage) 
				withText: '' 
				withFont: (PDFCourierFont size: 10 pt)
				withPosition:  xCell mm @ yCell mm
				withDimension:  156 mm @ height mm
				withAlignment: PDFAlignment center.
				splittedLines := aLines first: (self linesAblesToBeWrittenInCell: height).
				aLinesLeft := aLines last:(aLines size - splittedLines size).
			splittedLines do:[:line|
				self editor selectFrom: (line at:1) to: (line at:3).
				selection := self editor selection.
				
				self printFromLeft: selection inPage: (self getLastPage) x: (xCell+1) y:(yCell+1).
				yCell:= yCell + 5.
			].
		
		
		newPage := PDFPage new.
		
		self generateTextIn: newPage 
		withText: ' '
		withFont: (PDFCourierFont size: 10 pt)
		withPosition: 20 mm @ 25 mm.
			
		pdfDoc add: newPage.
		
		self writeNotesWithLines: aLinesLeft onPoint: (20 mm @ 25 mm) .
		
		].! !

Object subclass: #Solution
	uses: TWithComponentsForReagents
	instanceVariableNames: 'components name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!Solution commentStamp: 'CarlosLombardi 3/17/2015 18:30' prior: 0!
The object representing a solution. Preparation of quantities of solutions, based on reagents, are a possible part of lab activities.!

Solution class
	uses: TWithComponentsForReagents classTrait
	instanceVariableNames: ''!

!Solution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2015 01:07'!
addAllToComponents: aCollection
	components addAllLast: aCollection! !

!Solution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:32'!
addToComponents: aSolutionComponent
	components addLast: aSolutionComponent ! !

!Solution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2015 01:08'!
clearComponents
	"transforms my list of components into the empty list"
	components removeAll! !

!Solution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:32'!
components
	"The components needed to produce this solution. Each component comprises a reagent and a concentration,
	  i.e, is a SolutionComponent"
	^ components! !

!Solution methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/17/2015 18:35'!
initialize
	"preparation for life"

	super initialize .
	components := OrderedCollection new.! !

!Solution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:32'!
name
	"a name to identify me"
	^ name! !

!Solution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:30'!
name: anObject
	name := anObject! !

!Solution methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2015 01:08'!
removeFromComponents: aReagentInSolution
	components remove: aReagentInSolution ! !

!Solution methodsFor: 'accessing' stamp: 'CarlosLombardi 5/26/2015 14:55'!
removeReagentFromComponents: aReagent
	self removeFromComponents: (self componentForReagent: aReagent)! !

Object subclass: #SolutionEditController
	instanceVariableNames: 'model name components labProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Solutions'!

!SolutionEditController commentStamp: 'CarlosLombardi 3/29/2015 06:14' prior: 0!
A controller to edit a Solution. 
The elements of my list of components are ReagentInSolutionEditors, which act as both editors and edit controllers of each of the components of the Solution being edited.!

!SolutionEditController class methodsFor: 'instance creation' stamp: 'CarlosLombardi 5/20/2015 00:06'!
for: aSolution labProvider: aLabProvider
	"a new editor to edit the given solution, wrt the given lab provider"

	^self new
		labProvider: aLabProvider ;
		model: aSolution ;
		yourself! !

!SolutionEditController methodsFor: 'component list' stamp: 'CarlosLombardi 3/29/2015 06:38'!
addComponent: aRisEditor after: anotherRisEditor
	"adds aRisEditor as a new component, succeeding immediately anotherRisEditor"

	^components add: aRisEditor after: anotherRisEditor! !

!SolutionEditController methodsFor: 'component list' stamp: 'CarlosLombardi 3/29/2015 06:38'!
addFirstComponent: aRisEditor
	"adds aRisEditor as my first component"

	^components addFirst: aRisEditor! !

!SolutionEditController methodsFor: 'component list' stamp: 'CarlosLombardi 5/21/2015 01:36'!
addLastComponent: aRisEditor
	"adds aRisEditor as my last component"

	^components addLast: aRisEditor! !

!SolutionEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2015 19:48'!
components
	^ components! !

!SolutionEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2015 19:48'!
components: anObject
	components := anObject! !

!SolutionEditController methodsFor: 'component list' stamp: 'CarlosLombardi 3/29/2015 06:22'!
createEditorForNewComponent
	"create an editor for a new ReagentInSolution, which is intended to be included 
	 as one of my components"

	^(ReagentInSolutionEditor for: (ReagentInSolutionByConcentrationUnitFormula new))
		labProvider: self labProvider ; yourself! !

!SolutionEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 05:43'!
labProvider
	^ labProvider! !

!SolutionEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 05:43'!
labProvider: anObject
	labProvider := anObject! !

!SolutionEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2015 19:48'!
model
	^ model! !

!SolutionEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/29/2015 05:43'!
model: aSolution
	model := aSolution.
	self 
		name: aSolution name ;
		components: ( aSolution components collect: [ :rIS | 
			(ReagentInSolutionEditor for: rIS) labProvider: self labProvider ; yourself
		] ) .
	! !

!SolutionEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2015 19:48'!
name
	^ name! !

!SolutionEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/26/2015 19:48'!
name: anObject
	name := anObject! !

!SolutionEditController methodsFor: 'component list' stamp: 'CarlosLombardi 3/29/2015 06:19'!
removeComponent: aRisEditor
	"remove aRisEditor as my first component"

	^components remove: aRisEditor! !

!SolutionEditController methodsFor: 'updating' stamp: 'CarlosLombardi 3/29/2015 05:38'!
updateModel
	"reflect changes in my model, i.e. a Solution"

	self components do: [ :risEditor | risEditor updateModel ] .
	self model 
		name: self name ;
		clearComponents ; 
		addAllToComponents: ( self components 
			collect: [ :risEditor | risEditor model ]
			thenSelect: [ :reagentInSolution | reagentInSolution reagent notNil ] 
		).
	! !

Object subclass: #SolutionPreparationActivity
	uses: TWithComponentsForReagents
	instanceVariableNames: 'solution quantity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!SolutionPreparationActivity commentStamp: 'CarlosLombardi 3/17/2015 18:45' prior: 0!
A concrete activity whose aim is to prepare a certain quantity of a solution.!

SolutionPreparationActivity class
	uses: TWithComponentsForReagents classTrait
	instanceVariableNames: ''!

!SolutionPreparationActivity class methodsFor: 'instance creation' stamp: 'CarlosLombardi 3/20/2015 19:55'!
forLogEntry: aLogEntry
	"creates and returns a new SolutionPreparationActivity, related to the given LogEntry.
	 If such LogEntry is nil, then the created activity is unrelated to any log entry."

	^aLogEntry 
		ifNil: [ SolutionPreparationActivityAlone new ]
		ifNotNil: [ :entry | SolutionPreparationActivityInLogEntry new logEntry: entry ; yourself ].
	
! !

!SolutionPreparationActivity methodsFor: 'accessing' stamp: 'CarlosLombardi 3/20/2015 20:03'!
components
	^ self solution 
		ifNil: [ {  } ]
		ifNotNil: [ :sol | sol components collect: [ :comp | SolutionPreparationComponent for: comp wrt: self ] ].! !

!SolutionPreparationActivity methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:46'!
date
	"the date in which this activity was performed, or it is planned to be performed"

	^self subclassResponsibility ! !

!SolutionPreparationActivity methodsFor: 'accessing' stamp: 'FernandoDiMeglio 11/13/2015 00:59'!
postCopy
	super postCopy.
	self solutionQuantity: self solutionQuantity copy.
! !

!SolutionPreparationActivity methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 22:16'!
reagentQuantityFor: aReagent
	^ ( self componentForReagent: aReagent ) reagentQuantity! !

!SolutionPreparationActivity methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:45'!
solution
	^ solution! !

!SolutionPreparationActivity methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 18:45'!
solution: anObject
	solution := anObject! !

!SolutionPreparationActivity methodsFor: 'accessing' stamp: 'FernandoDiMeglio 9/13/2015 16:39'!
solutionQuantity

	^ quantity ifNil: [ 0 units: LabApplication current solutionQuantityUnit ]! !

!SolutionPreparationActivity methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 22:14'!
solutionQuantity: anObject
	quantity := anObject! !

SolutionPreparationActivity subclass: #SolutionPreparationActivityAlone
	instanceVariableNames: 'date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!SolutionPreparationActivityAlone commentStamp: 'CarlosLombardi 3/17/2015 21:53' prior: 0!
An independent SolutionPreparationActivity!

!SolutionPreparationActivityAlone methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 21:53'!
date
	^ date! !

!SolutionPreparationActivityAlone methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 21:53'!
date: anObject
	date := anObject! !

SolutionPreparationActivity subclass: #SolutionPreparationActivityInLogEntry
	instanceVariableNames: 'logEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!SolutionPreparationActivityInLogEntry commentStamp: 'CarlosLombardi 3/17/2015 20:50' prior: 0!
I am a SolutionPreparationActivity which is part of a LabProjectLogEntry.!

!SolutionPreparationActivityInLogEntry methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 20:57'!
date
	"the date in which this activity was performed, or it is planned to be performed"

	^ self logEntry date! !

!SolutionPreparationActivityInLogEntry methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 20:53'!
logEntry
	^ logEntry! !

!SolutionPreparationActivityInLogEntry methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 20:52'!
logEntry: anObject
	logEntry := anObject! !

Object subclass: #SolutionPreparationComponent
	instanceVariableNames: 'solutionComponent preparationActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Solutions'!

!SolutionPreparationComponent commentStamp: 'CarlosLombardi 3/17/2015 18:50' prior: 0!
A component indicating a reagent used in a SolutionPreparationActivity.!

!SolutionPreparationComponent class methodsFor: 'instance creation' stamp: 'CarlosLombardi 3/17/2015 22:03'!
for: aReagentInSolution wrt: aSolutionPreparationActivity
	"a new preparation the participation of a reagent
	  in a particular activity of solution preparation"

	^self new
		reagentInSolution: aReagentInSolution  ;
		preparationActivity: aSolutionPreparationActivity ;
		yourself! !

!SolutionPreparationComponent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 19:02'!
preparationActivity
	"my SolutionPreparationActivity "
	^ preparationActivity! !

!SolutionPreparationComponent methodsFor: 'private' stamp: 'CarlosLombardi 3/17/2015 19:02'!
preparationActivity: anObject
	"cfr SolutionPreparationActivity class>>for:wrt:"
	preparationActivity := anObject! !

!SolutionPreparationComponent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 22:01'!
reagent
	"the reagent used"
	^ self reagentInSolution reagent! !

!SolutionPreparationComponent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 22:02'!
reagentConcentration
	"the concentration of the reagent used for this preparation"
	^ self reagentInSolution concentration! !

!SolutionPreparationComponent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 22:01'!
reagentInSolution
	"the ReagentInSolution corresponding to the reagent needed for the solution"
	^ solutionComponent! !

!SolutionPreparationComponent methodsFor: 'private' stamp: 'CarlosLombardi 3/17/2015 22:03'!
reagentInSolution: anObject
	"cfr SolutionPreparationActivity class>>for:wrt:"
	solutionComponent := anObject! !

!SolutionPreparationComponent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 22:02'!
reagentQuantity
	"the quantity of my reagent used to prepare the indicated quantity of solution"
	^ self reagentInSolution quantityNeededFor: self solutionQuantity! !

!SolutionPreparationComponent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 20:40'!
solution
	"the solution being prepared"
	^ self preparationActivity solution! !

!SolutionPreparationComponent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/17/2015 22:14'!
solutionQuantity
	"the quantity of solution prepared"
	^ self preparationActivity solutionQuantity ! !

Object subclass: #SolutionQuery
	uses: TSortByName
	instanceVariableNames: 'lab reagent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Queries'!

!SolutionQuery commentStamp: 'CarlosLombardi 5/24/2015 19:53' prior: 0!
An object which knows how to obtain the set of solutions satisfying a series of restrictions. Sorts the results by name.!

SolutionQuery class
	uses: TSortByName classTrait
	instanceVariableNames: ''!

!SolutionQuery methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 19:49'!
lab
	^ lab! !

!SolutionQuery methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 19:49'!
lab: anObject
	lab := anObject! !

!SolutionQuery methodsFor: 'solutions' stamp: 'CarlosLombardi 5/26/2015 14:58'!
mustInclude: aSolution
	"whether aSolution satisfies my criteria, except the filter by Lab"

	^self reagent isNil or: [ (aSolution componentForReagent: self reagent) isNotNil ]
! !

!SolutionQuery methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 19:49'!
reagent
	^ reagent! !

!SolutionQuery methodsFor: 'accessing' stamp: 'CarlosLombardi 5/24/2015 19:50'!
reagent: aReaegent
	"Restrict the query to the solutions including the given reagent as a component"
	reagent := aReaegent ! !

!SolutionQuery methodsFor: 'solutions' stamp: 'CarlosLombardi 5/24/2015 20:14'!
solutions
	"the set of solutions which satisfy my criteria"

	| unsortedSolutions |
	unsortedSolutions := self lab isNil
		ifTrue: [ LabApplication current labs 
				inject: Set new 
				into: [ :set :theLab | set addAll: (self solutionsInLab: theLab) ; yourself ] ] 
		ifFalse: [ self solutionsInLab: self lab ].
	^self sortByUppercaseName: unsortedSolutions .
! !

!SolutionQuery methodsFor: 'solutions' stamp: 'CarlosLombardi 5/24/2015 19:55'!
solutionsInLab: aLab
	"the set of solutions registered in aLab which satisfy my criteria"

	^aLab solutions select: [ :solu | self mustInclude: solu ]
	
! !

Object subclass: #StockElementInLab
	instanceVariableNames: 'reagent lab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model-Queries'!

!StockElementInLab commentStamp: '<historical>' prior: 0!
the view of a stock element (anything having stock, a Reagent or a Consumable at the moment) wrt a lab!

!StockElementInLab class methodsFor: 'instance creation' stamp: 'CarlosLombardi 4/29/2014 00:15'!
for: aStockElement inLab: aLab
	"creates and answers an instance modeling the view of aStockElement focused on aLab"
	^self new
		element: aStockElement ; 
		lab: aLab ; 
		yourself! !

!StockElementInLab methodsFor: 'accessing' stamp: 'CarlosLombardi 10/19/2014 23:56'!
asBasicBusinessObject
	"the basic business object corresponding to me.
	 In this case it my element"

	^self element asBasicBusinessObject! !

!StockElementInLab methodsFor: 'stock' stamp: 'CarlosLombardi 10/20/2014 11:02'!
currentStock
	"the current stock of this reagent in the lab"

	| stockEventDetails |
	stockEventDetails := EventQuery new 
		lab: self lab ; 
		stockElement: self asBasicBusinessObject ; 
		details.
	^stockEventDetails
		ifEmpty: [ 0 ]
		ifNotEmpty: [ :coll | coll sum: #stockVariation ]! !

!StockElementInLab methodsFor: 'basic accessing' stamp: 'CarlosLombardi 4/29/2014 18:39'!
element
	^ reagent! !

!StockElementInLab methodsFor: 'basic accessing' stamp: 'CarlosLombardi 4/29/2014 00:17'!
element: anObject
	reagent := anObject! !

!StockElementInLab methodsFor: 'basic accessing' stamp: 'CarlosLombardi 3/12/2014 23:48'!
lab
	^ lab! !

!StockElementInLab methodsFor: 'basic accessing' stamp: 'CarlosLombardi 3/12/2014 23:48'!
lab: anObject
	lab := anObject! !

!StockElementInLab methodsFor: 'price' stamp: 'CarlosLombardi 10/20/2014 00:00'!
priceCalculator
	"a price calculator for this stockElement"

	^PriceCalculator new
		stockElement: self element ;
		lab: self lab ;
		yourself.! !

Object subclass: #StockElementUIComponentBuilder
	uses: TUIGoodies
	instanceVariableNames: 'element lab editor authorityEditors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!StockElementUIComponentBuilder commentStamp: '<historical>' prior: 0!
A helper to create a row for a StockElement!

StockElementUIComponentBuilder class
	uses: TUIGoodies classTrait
	instanceVariableNames: ''!

!StockElementUIComponentBuilder methodsFor: 'table' stamp: 'CarlosLombardi 4/28/2014 20:53'!
addCasNumberColumnTo:  aRow
	"add a column showing the CAS number of my element into row"

	| casNumberString |
	casNumberString := self element casNumber ifNil: [ '' ].
	aRow addMorphBack: 
		( casNumberString asMorph width: 120 ; yourself ).

! !

!StockElementUIComponentBuilder methodsFor: 'form' stamp: 'CarlosLombardi 4/28/2014 20:46'!
addCasNumberFieldRowTo:  aCollection
	"add a row to edit the CAS number of my element into aCollection"

	| casNumberField |
	casNumberField := self uiBuilder
		newTextEntryFor: self element
		getText: #casNumber
		setText: #casNumber:
		help: 'Nro CAS'.
	casNumberField
		width: 80;
		hResizing: #rigid.	"minWidth: 80 ;"
	aCollection addLast: 'Nro. CAS' -> casNumberField.

! !

!StockElementUIComponentBuilder methodsFor: 'table' stamp: 'CarlosLombardi 10/20/2014 10:43'!
addCurrentPriceColumnTo:  aRow
	"add a column showing the current price of my element into row"

	| price priceString |
	price := self stockElementInLab priceCalculator
		defaultPrice: nil ;
		lastPrice.
	priceString := price ifNil: ['---'] ifNotNil: [ price asString ].
	aRow addMorphBack: 
		( (StringMorph contents: priceString) width: 120 ; yourself ).
! !

!StockElementUIComponentBuilder methodsFor: 'table' stamp: 'CarlosLombardi 4/28/2014 01:16'!
addCurrentStockColumnTo:  aRow
	"add a column showing the current stock of my element into row"

	aRow addMorphBack: 
		( (StringMorph contents: self stockElementInLab currentStock asString) width: 80 ; yourself ).

! !

!StockElementUIComponentBuilder methodsFor: 'table' stamp: 'CarlosLombardi 3/24/2015 12:23'!
addMolecularWeightColumnTo:  aRow
	"add a column showing the molecular weight for my element into the given row"

	aRow addMorphBack: ( self element molecularWeight printStringAbbreviated asMorph width: 120 ; yourself ).

! !

!StockElementUIComponentBuilder methodsFor: 'form' stamp: 'CarlosLombardi 3/24/2015 00:58'!
addMolecularWeightFieldRowTo:  aCollection
	"add a row to edit the molecular weight of my element into aCollection"

	| molecularWeightField mwRow |
	molecularWeightField := self uiBuilder
		newTextEntryFor: self element
		get: #molecularWeight
		set: #molecularWeight:
		class: Float
		getEnabled: nil
		help: 'Peso molecular'.
	molecularWeightField
		width: 120;
		hResizing: #rigid.
	mwRow := self buildEmptyRow .
	mwRow 
		addMorphBack: molecularWeightField ;
		addMorphBack: (self buildRowSpacer: 10) ;
		addMorphBack: self element molecularWeightUnit abbreviation asMorph.
	aCollection addLast: 'Peso molecular' translated -> mwRow.

! !

!StockElementUIComponentBuilder methodsFor: 'table' stamp: 'CarlosLombardi 4/28/2014 20:53'!
addNameColumnTo:  aRow
	"add a column showing the name of my element into row"

	aRow addMorphBack: 
		( self element name asMorph width: 200 ; yourself ).

! !

!StockElementUIComponentBuilder methodsFor: 'form' stamp: 'CarlosLombardi 4/28/2014 20:45'!
addNameFieldRowTo:  aCollection
	"add a row to edit the name of my element into aCollection"

	| nameField |
	nameField := self uiBuilder
		newTextEntryFor: self element
		getText: #name
		setText: #name:
		help: 'Nombre '.
	nameField minWidth: 200.
	aCollection	addLast: 'Nombre:' -> nameField.

! !

!StockElementUIComponentBuilder methodsFor: 'form' stamp: 'CarlosLombardi 4/29/2014 18:46'!
addReferenceRowsTo:  aCollection
	"add a row to edit the references for my element into aCollection"

	| authorityBox referenceField |
	self element referenceEditControllers
		with: self authorityEditors
		do: [ :controller :authEditor | 
			authorityBox := self uiBuilder newRow:	{ 'Nro. referencia' asMorph .  authEditor buildField }.
			referenceField := self uiBuilder
				newTextEntryFor: controller
				getText: #referenceId
				setText: #referenceId:
				help: 'Nro de referencia'.
			referenceField
				width: 80;
				hResizing: #rigid.
			aCollection addLast: authorityBox -> referenceField ].

! !

!StockElementUIComponentBuilder methodsFor: 'table' stamp: 'CarlosLombardi 4/28/2014 01:17'!
addStockUnitColumnTo:  aRow
	"add a column showing the stock unit for my element into row"

	| stockUnitString |
	stockUnitString := self element stockUnit ifNil: [''] ifNotNil: [:unit | unit asString ].
	aRow addMorphBack: ( stockUnitString asMorph width: 100 ; yourself ).

! !

!StockElementUIComponentBuilder methodsFor: 'form' stamp: 'CarlosLombardi 3/24/2015 01:03'!
addStockUnitFieldRowTo:  aCollection
	"add a row to edit the name of my element into aCollection"

	aCollection
		addLast: 'Unidad de Stock para compras' -> self buildStockUnitMiniRow.

! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/29/2014 18:46'!
authorityEditors
	self createAuthorityEditors.
	^ authorityEditors! !

!StockElementUIComponentBuilder methodsFor: 'ui building' stamp: 'CarlosLombardi 4/29/2014 18:20'!
buildStockUnitMiniRow
	"builds and returns a 'mini-row' for the stock unit edition "

	| stockUnitField prefixField editButton stockUnitEditor |
	stockUnitEditor := StockUnitListEditor for: self element.
	stockUnitField := stockUnitEditor buildField.
	stockUnitField setNameTo: 'stockUnit'.
	
	prefixField := DynamicTextMorph 
		newTransparentFor: self element
		get: #stockUnitPrefix
		class: String.
	prefixField 
		width: 10 ; height: prefixField font height ;
		hResizing: #rigid ; vResizing: #rigid ; cellPositioning: #leftCenter.

	editButton := self uiBuilder 
		newButtonFor: self editor
		action: #editStockUnit
    		label: 'Editar' translated 
		help: 'Editar la unidad de stock elegida' translated.
	
	^self uiBuilder 
		newRow: { prefixField . stockUnitField . editButton } .

	
! !

!StockElementUIComponentBuilder methodsFor: 'private' stamp: 'CarlosLombardi 4/29/2014 18:38'!
createAuthorityEditors
	"private - create the autorityEditors if not done before"

	authorityEditors ifNil: [ 
		authorityEditors := OrderedCollection new.
		self element referenceEditControllers do: [ :controller | 
			authorityEditors addLast: (AuthorityInReagentEditor for: controller) 
		].
	].! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/29/2014 18:17'!
editor
	^ editor! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/29/2014 18:17'!
editor: anObject
	editor := anObject! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/28/2014 00:58'!
element
	^ element! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/28/2014 00:58'!
element: anObject
	element := anObject! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/28/2014 01:15'!
lab
	^ lab! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/28/2014 01:15'!
lab: anObject
	lab := anObject! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/28/2014 00:58'!
row
	^ row! !

!StockElementUIComponentBuilder methodsFor: 'accessing' stamp: 'CarlosLombardi 4/28/2014 01:15'!
stockElementInLab
	"the object representing my stock element in the context of my lab"

	^StockElementInLab for: self element inLab: self lab.
! !

Object subclass: #StockEvent
	uses: TBasicBusinessObject
	instanceVariableNames: 'details lab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

StockEvent class
	uses: TBasicBusinessObject classTrait
	instanceVariableNames: ''!

StockEvent subclass: #BuyingProposal
	uses: TEventComputations
	instanceVariableNames: 'provider originalRequirement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!BuyingProposal commentStamp: '<historical>' prior: 0!
The part of (the remainder of a) requirement which can be satisfied by a certain provider.!

BuyingProposal class
	uses: TEventComputations classTrait
	instanceVariableNames: ''!

!BuyingProposal class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:13'!
extraAmountIsRelevant
	"whether the extra amount is relevant for my instances"

	^false! !

!BuyingProposal class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:13'!
providerIsRelevant
	"whether the provider is relevant for my instances"

	^true! !

!BuyingProposal class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:13'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for my instances"

	^false! !

!BuyingProposal methodsFor: 'accessing' stamp: 'CLom 12/6/2014 16:07'!
date
	^ self originalRequirement date! !

!BuyingProposal methodsFor: 'accessing' stamp: 'CLom 11/16/2014 23:30'!
extraAmount
	^ 0! !

!BuyingProposal methodsFor: 'testing' stamp: 'CLom 12/17/2014 11:44'!
isAPendingState
	"testing"

	^originalRequirement isAPendingState! !

!BuyingProposal methodsFor: 'accessing' stamp: 'CLom 11/16/2014 23:32'!
normalisedTotalAmount
	"the amount of this Proposal, taking element prices in a normalised basis"
	^self details
		ifEmpty: [ 0 ]
		ifNotEmpty: [ :dets | dets sum: #normalisedAmount ]! !

!BuyingProposal methodsFor: 'accessing' stamp: 'CLom 12/6/2014 16:04'!
originalRequirement
	^ originalRequirement originalRequirement! !

!BuyingProposal methodsFor: 'accessing' stamp: 'CarlosLombardi 10/21/2014 09:27'!
originalRequirement: anObject
	originalRequirement := anObject! !

!BuyingProposal methodsFor: 'accessing' stamp: 'CarlosLombardi 10/21/2014 00:14'!
provider
	^ provider! !

!BuyingProposal methodsFor: 'accessing' stamp: 'CarlosLombardi 10/21/2014 00:14'!
provider: anObject
	provider := anObject! !

!BuyingProposal methodsFor: 'details and stock' stamp: 'CLom 11/22/2014 02:59'!
stockVariationSign
	"a buying proposal does not imply any change of stock"
	^0! !

StockEvent subclass: #BuyingRequirement
	uses: TProviderInLabHome + TEventComputations + TProposalCalculations
	instanceVariableNames: 'date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!BuyingRequirement commentStamp: '<historical>' prior: 0!
A requirement to buy stock elements!

BuyingRequirement class
	uses: TProviderInLabHome classTrait + TEventComputations classTrait + TProposalCalculations classTrait
	instanceVariableNames: ''!

!BuyingRequirement class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:14'!
extraAmountIsRelevant
	"whether the extra amount is relevant for my instances"

	^false! !

!BuyingRequirement class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:14'!
providerIsRelevant
	"whether the provider is relevant for my instances"

	^false! !

!BuyingRequirement class methodsFor: 'configuration' stamp: 'CLom 11/22/2014 03:49'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for my instances"

	^true! !

!BuyingRequirement methodsFor: 'accessing' stamp: 'CLom 11/17/2014 00:18'!
date
	^ date! !

!BuyingRequirement methodsFor: 'accessing' stamp: 'CLom 11/17/2014 00:18'!
date: anObject
	date := anObject! !

!BuyingRequirement methodsFor: 'accessing' stamp: 'CLom 11/23/2014 21:09'!
extraAmount
	^ 0! !

!BuyingRequirement methodsFor: 'testing' stamp: 'CLom 11/22/2014 11:55'!
isABuyingRequirement
	"testing"

	^true! !

!BuyingRequirement methodsFor: 'accessing' stamp: 'CLom 12/6/2014 16:04'!
originalRequirement
	"the original requirement, to be polymorphic with pending state and proposal"
	^ self! !

!BuyingRequirement methodsFor: 'fulfillment' stamp: 'CLom 11/25/2014 18:44'!
pendingState
	"a BuyingRequirementPendingState representing my pending quantities"

	| pendingDetails satisfactions applyingDetails quantityToApply appDetail quantityForThisDetail result |
	result := BuyingRequirementPendingState new.
	result originalRequirement: self.
	pendingDetails := self details 
		collect: [ :det | BuyingRequirementPendingDetail for: det ]
		into: (SortedCollection sortBlock: [ :det1 :det2 | det1 originalQuantity < det2 originalQuantity ]).
	pendingDetails do: [ :det | det event: result ].
	satisfactions := EventQuery new 
		addToExplicitConditions: [ :event | event isABuyingRequirementSatisfaction  ] ;
		addToExplicitConditions: [ :event | event buyingRequirement = self ] ;
		details.
	satisfactions do: [ :satis |  
		quantityToApply := satis quantity.
		applyingDetails := FilteredReadStream 
			on: pendingDetails 
			filterBy: [ :det | (det element = satis element) & det isFulfilled not  ].
		[ applyingDetails atEnd | (quantityToApply <= 0) ] whileFalse: [ 
			appDetail := applyingDetails next.
			quantityForThisDetail := quantityToApply min: appDetail quantity.
			appDetail decreaseQuantity: quantityForThisDetail.
			quantityToApply := quantityToApply - quantityForThisDetail.
		].
	].
	pendingDetails do: [ :det | result addToDetails: det ].
	^result








! !

!BuyingRequirement methodsFor: 'details and stock' stamp: 'CLom 11/22/2014 02:59'!
stockVariationSign
	"a requirement does not imply any change of stock"
	^0! !

StockEvent subclass: #BuyingRequirementPendingState
	uses: TProposalCalculations
	instanceVariableNames: 'originalRequirement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

BuyingRequirementPendingState class
	uses: TProposalCalculations classTrait
	instanceVariableNames: ''!

!BuyingRequirementPendingState class methodsFor: 'configuration' stamp: 'CLom 11/25/2014 11:14'!
extraAmountIsRelevant
	"whether the extra amount is relevant for my instances"

	^false! !

!BuyingRequirementPendingState class methodsFor: 'configuration' stamp: 'CLom 11/25/2014 11:14'!
providerIsRelevant
	"whether the provider is relevant for my instances"

	^false! !

!BuyingRequirementPendingState class methodsFor: 'configuration' stamp: 'CLom 11/25/2014 11:14'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for my instances"

	^false! !

!BuyingRequirementPendingState methodsFor: 'details and stock' stamp: 'CLom 11/25/2014 18:58'!
allDetails
	"all the details, pending or fulfilled"
	^ super details ! !

!BuyingRequirementPendingState methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:27'!
date
	^ self originalRequirement date! !

!BuyingRequirementPendingState methodsFor: 'details and stock' stamp: 'CLom 11/25/2014 11:31'!
details
	"the only proper details for a pending state are the non-fulfilled ones"
	^ super details reject: [ :det | det isFulfilled ]! !

!BuyingRequirementPendingState methodsFor: 'details and stock' stamp: 'CLom 11/25/2014 11:32'!
fulfilledDetails
	"the details of my original requirement which have been totally fulfilled"
	^ super details select: [ :det | det isFulfilled ]! !

!BuyingRequirementPendingState methodsFor: 'testing' stamp: 'CLom 12/17/2014 10:52'!
isAPendingState
	"testing"

	^true! !

!BuyingRequirementPendingState methodsFor: 'accessing' stamp: 'CLom 11/25/2014 16:20'!
lab
	^ self originalRequirement lab! !

!BuyingRequirementPendingState methodsFor: 'accessing' stamp: 'CLom 12/6/2014 16:04'!
originalRequirement
	^ originalRequirement originalRequirement! !

!BuyingRequirementPendingState methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:10'!
originalRequirement: anObject
	originalRequirement := anObject! !

!BuyingRequirementPendingState methodsFor: 'details and stock' stamp: 'CLom 11/25/2014 11:13'!
stockVariationSign
	"no stock variation is implied by me"

	^0! !

!BuyingRequirementPendingState methodsFor: 'accessing' stamp: 'CLom 11/25/2014 18:53'!
totalAmount
	"the total amount for this event"

	| result |
	result := self details ifEmpty: [ 0 ] ifNotEmpty: [ :theDetails | theDetails sum: #totalAmount ].
	^ result round: 2! !

!BuyingRequirementPendingState methodsFor: 'accessing' stamp: 'CLom 11/25/2014 18:58'!
totalAmountForOriginalQuantities
	"the total amount for this event, considering the original quantity of each detail, and including fulfilled details"

	| result |
	result := self allDetails ifEmpty: [ 0 ] ifNotEmpty: [ :theDetails | theDetails sum: #amountForOriginalQuantity ].
	^ result round: 2! !

!BuyingRequirementPendingState methodsFor: 'accessing' stamp: 'CLom 11/25/2014 18:59'!
totalOriginalQuantity
	"the total of the original quantities for this event, including fulfilled details"

	| result |
	result := self allDetails ifEmpty: [ 0 ] ifNotEmpty: [ :theDetails | theDetails sum: #originalQuantity ].
	^ result round: 2! !

StockEvent subclass: #BuyingRequirementSatisfaction
	instanceVariableNames: 'buyingRequirement buyingEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!BuyingRequirementSatisfaction commentStamp: '<historical>' prior: 0!
I represent the way in which a BuyingEvent satisfies a BuyingRequirement.

My date is that of the BuyingEvent.

Each of my details describe the way a buying detail satisfies the given requirement.!

!BuyingRequirementSatisfaction class methodsFor: 'configuration' stamp: 'CLom 11/25/2014 11:01'!
extraAmountIsRelevant
	"whether the extra amount is relevant for my instances"

	^false! !

!BuyingRequirementSatisfaction class methodsFor: 'configuration' stamp: 'CLom 11/25/2014 11:01'!
providerIsRelevant
	"whether the provider is relevant for my instances"

	^false! !

!BuyingRequirementSatisfaction class methodsFor: 'configuration' stamp: 'CLom 11/25/2014 11:01'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for my instances"

	^false! !

!BuyingRequirementSatisfaction methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:06'!
buyingEvent
	^ buyingEvent! !

!BuyingRequirementSatisfaction methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:06'!
buyingEvent: anObject
	buyingEvent := anObject! !

!BuyingRequirementSatisfaction methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:08'!
buyingRequirement
	^ buyingRequirement! !

!BuyingRequirementSatisfaction methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:08'!
buyingRequirement: anObject
	buyingRequirement := anObject! !

!BuyingRequirementSatisfaction methodsFor: 'accessing' stamp: 'CLom 12/13/2014 19:13'!
date
	^ self buyingEvent date! !

!BuyingRequirementSatisfaction methodsFor: 'testing' stamp: 'CLom 11/25/2014 11:03'!
isABuyingRequirementSatisfaction
	"testing"

	^true! !

StockEvent subclass: #ReagentBuyingEvent
	uses: TEventComputations
	instanceVariableNames: 'date provider extraAmount identification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!ReagentBuyingEvent commentStamp: '<historical>' prior: 0!
The record of an activity of buying reagents!

ReagentBuyingEvent class
	uses: TEventComputations classTrait
	instanceVariableNames: ''!

!ReagentBuyingEvent class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:14'!
extraAmountIsRelevant
	"whether the extra amount is relevant for my instances"

	^true! !

!ReagentBuyingEvent class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:14'!
providerIsRelevant
	"whether the provider is relevant for my instances"

	^true! !

!ReagentBuyingEvent class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:14'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for my instances"

	^true! !

!ReagentBuyingEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:27'!
date
	^ date! !

!ReagentBuyingEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:27'!
date: anObject
	date := anObject! !

!ReagentBuyingEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:48'!
extraAmount
	" the amount involved in the operation which is not related with a particular detail, e.g. taxes"
	^ extraAmount! !

!ReagentBuyingEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:47'!
extraAmount: anObject
	extraAmount := anObject! !

!ReagentBuyingEvent methodsFor: 'actions' stamp: 'CLom 12/13/2014 13:57'!
generateSatisfactionForRequirement: aBuyingReq
	"a new BuyingRequirementSatisfaction for the quantities in this BuyingEvent which can satisfy 
	 the given BuyingRequirement "

	| tempDetails quantityToApply filteredDetails result tempDetailToApply quantityForThisDetail newSatisfactionDetail |
	result := BuyingRequirementSatisfaction new.
	result 
		buyingRequirement: aBuyingReq  ; 
		buyingEvent: self.
		
	"tempDetails: a copy of my buying details for decreasing "
	tempDetails := self details collect: [ :det | StockEventPartialQuantity for: det ].
	
	"for each pending detail in aBuaBuyingReq, generate one satisfaction detail for each buying detail 
	  applying to it"
	aBuyingReq pendingState details do: [ :pendingDet |
		"quantityToApply: the quantity remaining after each application of pendingDet to a buying detail"
		quantityToApply := pendingDet quantity.
		
		"filteredDetails: the buying details which can apply to pendingDet"
		filteredDetails := FilteredReadStream 
			on: tempDetails 
			filterBy: [ :det | (det element = pendingDet element) & det isFulfilled not ].
			
		[ filteredDetails atEnd | (quantityToApply <= 0) ] whileFalse: [ 
			tempDetailToApply := filteredDetails next.
			quantityForThisDetail := quantityToApply min: tempDetailToApply quantity.
			(quantityForThisDetail > 0) ifTrue: [ 
				newSatisfactionDetail := BuyingRequirementSatisfactionDetail new.
				newSatisfactionDetail 
					buyingDetail: tempDetailToApply originalDetail ;
					quantity: quantityForThisDetail .
				result addToDetails: newSatisfactionDetail .
				tempDetailToApply decreaseQuantity: quantityForThisDetail .
				quantityToApply := quantityToApply - quantityForThisDetail .
			]
		].
	].
	^result











! !

!ReagentBuyingEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:47'!
identification
	" an arbitrary identification for this event, e.g. invoice number "
	^ identification! !

!ReagentBuyingEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:47'!
identification: anObject
	identification := anObject! !

!ReagentBuyingEvent methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/13/2014 09:11'!
initialize
	"I set up myself to life"

	super initialize.
	details := OrderedCollection new.
	extraAmount  := 0.! !

!ReagentBuyingEvent methodsFor: 'testing' stamp: 'CarlosLombardi 3/13/2014 00:43'!
involvesStock
	"any buying event involves stock"

	^true! !

!ReagentBuyingEvent methodsFor: 'testing' stamp: 'CarlosLombardi 3/15/2014 16:02'!
isABuying
	"testing"

	^true! !

!ReagentBuyingEvent methodsFor: 'provider' stamp: 'CarlosLombardi 3/13/2014 00:27'!
provider
	^ provider! !

!ReagentBuyingEvent methodsFor: 'provider' stamp: 'CarlosLombardi 3/13/2014 00:27'!
provider: anObject
	provider := anObject! !

!ReagentBuyingEvent methodsFor: 'details and stock' stamp: 'CarlosLombardi 10/3/2014 11:04'!
stockVariationSign
	"a buying event implies increase of stock"
	^1! !

!StockEvent class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 22:21'!
extraAmountIsRelevant
	"whether the extra amount is relevant for my instances"

	self subclassResponsibility ! !

!StockEvent class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 22:21'!
providerIsRelevant
	"whether the provider is relevant for my instances"

	self subclassResponsibility ! !

!StockEvent class methodsFor: 'configuration' stamp: 'CLom 11/21/2014 23:08'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for my instances"

	self subclassResponsibility ! !

!StockEvent methodsFor: 'details and stock' stamp: 'CLom 11/25/2014 16:31'!
addToDetails: aDetail
	"add a new item into my details"
	
	details add: aDetail.
	( ((aDetail respondsTo: #event) & (aDetail respondsTo: #event:)) and: [aDetail event isNil] ) 
		ifTrue: [ aDetail event: self ].! !

!StockEvent methodsFor: 'details and stock' stamp: 'CarlosLombardi 10/3/2014 11:04'!
details
	^ details! !

!StockEvent methodsFor: 'details and stock' stamp: 'CarlosLombardi 10/3/2014 11:04'!
detailsForElement: aReagent 
	"the subset of my details which correspond to buying aReagent"
	^self details select: [ :detail | detail element = aReagent ]! !

!StockEvent methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:31'!
extraAmountIsRelevant
	"whether the extra amount is relevant for me"

	^self class extraAmountIsRelevant ! !

!StockEvent methodsFor: 'initialize-release' stamp: 'CarlosLombardi 10/14/2014 02:24'!
initialize
	"I set up myself to life"

	super initialize.
	details := OrderedCollection new.
! !

!StockEvent methodsFor: 'details and stock' stamp: 'CarlosLombardi 10/3/2014 11:04'!
involvesElement: aStockElement 
	"true iff the given element is involved in this event"
	^  self details anySatisfy: [ :detail | detail element = aStockElement ]! !

!StockEvent methodsFor: 'testing' stamp: 'CLom 11/22/2014 02:57'!
isABuying
	"testing"

	^false! !

!StockEvent methodsFor: 'testing' stamp: 'CLom 11/22/2014 11:54'!
isABuyingRequirement
	"testing"

	^false! !

!StockEvent methodsFor: 'testing' stamp: 'CLom 11/25/2014 11:03'!
isABuyingRequirementSatisfaction
	"testing"

	^false! !

!StockEvent methodsFor: 'testing' stamp: 'CLom 12/17/2014 10:52'!
isAPendingState
	"testing"

	^false! !

!StockEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 10/3/2014 23:50'!
lab
	^ lab! !

!StockEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 10/3/2014 23:50'!
lab: anObject
	lab := anObject! !

!StockEvent methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:32'!
providerIsRelevant
	"whether the provider is relevant for me"

	^self class providerIsRelevant! !

!StockEvent methodsFor: 'details and stock' stamp: 'CarlosLombardi 10/13/2014 11:48'!
stockElements
	"a set containing the stock elements I am concerned with"
	^  self details collect: [ :detail | detail element ] into: Set new! !

!StockEvent methodsFor: 'details and stock' stamp: 'CLom 11/25/2014 11:14'!
stockVariationSign
	"1 / -1 / 0 depending on whether my details imply an increase / decrease / no change of stock"
	self subclassResponsibility ! !

!StockEvent methodsFor: 'details and stock' stamp: 'CLom 11/22/2014 20:37'!
totalQuantity
	"the total quantity of my details"
	^  self details sum: #quantity! !

!StockEvent methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:33'!
unitPriceIsEditable
	"whether the unit price of each of my details can be changed by the user"

	^self class unitPriceIsEditable ! !

Object subclass: #StockEventDetail
	uses: TBasicBusinessObject + TEventDetailComputations + TEventDetailInitialization + TCreateStockEventDetailCopier
	instanceVariableNames: 'unitPrice quantity event element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!StockEventDetail commentStamp: '<historical>' prior: 0!
A detail, related to a single reagent and a quantity, in an event affecting the stock of reagents!

StockEventDetail class
	uses: TBasicBusinessObject classTrait + TEventDetailComputations classTrait + TEventDetailInitialization classTrait + TCreateStockEventDetailCopier classTrait
	instanceVariableNames: ''!

StockEventDetail subclass: #BuyingProposalDetail
	instanceVariableNames: 'originalDetail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!BuyingProposalDetail commentStamp: '<historical>' prior: 0!
A BuyingProposalDetail is a detail with some behavior specific for the details of a BuyingProposal.!

!BuyingProposalDetail methodsFor: 'accessing' stamp: 'CLom 11/16/2014 23:29'!
normalisedAmount
	"amount of this detail in a standard basis, adequate for comparisons"

	^self normalisedUnitPrice * self quantity! !

!BuyingProposalDetail methodsFor: 'accessing' stamp: 'CLom 11/16/2014 23:28'!
normalisedUnitPrice
	"unit price in a standard basis, adequate for comparisons"

	^PriceCalculator new
		stockElement: self element ;
		lastPrice! !

!BuyingProposalDetail methodsFor: 'details and stock' stamp: 'CLom 12/6/2014 16:25'!
originalDetail
	^ originalDetail originalDetail! !

!BuyingProposalDetail methodsFor: 'details and stock' stamp: 'CLom 12/6/2014 16:23'!
originalDetail: anObject
	originalDetail := anObject! !

!BuyingProposalDetail methodsFor: 'accessing' stamp: 'CLom 11/16/2014 23:27'!
provider
	"the provider corresponding to this detail"

	^self event provider! !

!BuyingProposalDetail methodsFor: 'details and stock' stamp: 'CLom 11/25/2014 18:45'!
stockVariationSign
	"a satisfaction does not change the stock; the stock increase is testified by the buying event"

	^0! !

!BuyingProposalDetail methodsFor: 'accessing' stamp: 'CLom 11/16/2014 23:25'!
unitPrice
	"is computed for a BusinessProposalDetail"

	^PriceCalculator new 
		lab: self lab ;
		provider: self provider ; 
		stockElement: self element ; 
		lastPrice! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:14'!
date
	^ self event date! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 10:58'!
element
	^ element! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 10:58'!
element: anObject
	element := anObject! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:13'!
event
	^ event! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:13'!
event: anObject
	event := anObject! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CLom 11/16/2014 23:26'!
lab
	^ self event lab! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CLom 12/6/2014 16:25'!
originalDetail
	"the detail which originated myself - for polymorphism with partial quantity and buying proposal details"
	^ self ! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:13'!
quantity
	^ quantity! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:13'!
quantity: anObject
	quantity := anObject! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:13'!
stockVariation
	^ self quantity * self event stockVariationSign! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:13'!
unitPrice
	^ unitPrice! !

!StockEventDetail methodsFor: 'accessing' stamp: 'CarlosLombardi 3/13/2014 00:13'!
unitPrice: anObject
	unitPrice := anObject! !

Object subclass: #StockEventDetailEditController
	uses: TEventDetailComputations + TEventDetailInitialization
	instanceVariableNames: 'model reagentInLab quantity unitPrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

!StockEventDetailEditController commentStamp: '<historical>' prior: 0!
The edition of a StockEventDetail!

StockEventDetailEditController class
	uses: TEventDetailComputations classTrait + TEventDetailInitialization classTrait
	instanceVariableNames: ''!

!StockEventDetailEditController class methodsFor: 'instance creation' stamp: 'CarlosLombardi 5/4/2014 02:41'!
forNewDetailInLab: aLab
	"creates and an instance to edit a new StockEventDetail in the context of aLab"
	
	^StockEventDetailEditControllerByItself new
		model: (StockEventDetail new) ;
		lab: aLab ;
		yourself! !

!StockEventDetailEditController class methodsFor: 'instance creation' stamp: 'CarlosLombardi 5/4/2014 02:42'!
forNewDetailInsideEvent: anEvent
	"creates and an instance to edit a new StockEventDetail in the context of anEvent"
	
	^StockEventDetailEditControllerInsideEvent new
		model: (StockEventDetail new) ;
		event: anEvent
		yourself! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/4/2014 02:54'!
element
	"the reagent for this editing detail. Cfr. >>reagentInLab "
	^self elementInLab ifNotNil: [ :stockElemInLab | stockElemInLab element ]! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/4/2014 02:54'!
element: aReagent
	"change the reagent being edited to anObject, nil if there is no reagent seleced at the moment"

	(aReagent = self element) ifFalse: [ 
		reagentInLab := aReagent ifNil: [ nil ] ifNotNil: [ StockElementInLab for: aReagent inLab: self lab ].
		self recomputeUnitPrice 
	]! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/4/2014 02:45'!
elementInLab
	"My model of the reagent is a ReagentInLab"
	^reagentInLab! !

!StockEventDetailEditController methodsFor: 'testing' stamp: 'CarlosLombardi 5/4/2014 02:54'!
isBlank
	"true iff the data edited is not enough to build a proper StockEventDetail"

	^self element isNil | (self quantity = 0)! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 18:40'!
lab
	"the lab I use as a info repository"
	^ self subclassResponsibility! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/15/2014 16:15'!
model
	^ model! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/15/2014 16:15'!
model: anObject
	model := anObject! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 18:40'!
provider
	"the provider related with this detail, if any"
	^ self subclassResponsibility! !

!StockEventDetailEditController methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:23'!
providerIsRelevant
	"whether the provider is relevant for the event being edited"

	self subclassResponsibility ! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/15/2014 16:15'!
quantity
	^ quantity! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/23/2014 11:28'!
quantity: anObject
	"set the quantity for this editing detail"
	quantity := anObject.
	self changed: #totalAmount! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CLom 11/22/2014 02:21'!
recomputeUnitPrice
	self unitPriceFromModel:
		( self elementInLab 
		ifNil: [ 0 ]
		ifNotNil: 
		[ :elemInLab | |  priceCalc | 
			priceCalc := elemInLab priceCalculator.
			self providerIsRelevant ifTrue: [ priceCalc provider: self provider. ].
			priceCalc lastPrice
		] ).! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 5/4/2014 02:54'!
stockUnit
	"the stock unit to show"
	^self element 
		ifNil: [ '' ] 
		ifNotNil: [ :reagent | reagent stockUnit asString ]! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/15/2014 16:15'!
unitPrice
	^ unitPrice! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/23/2014 11:27'!
unitPrice: anObject
	"the editing unit price has changed"
	unitPrice := anObject.
	self changed: #totalAmount! !

!StockEventDetailEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/15/2014 16:41'!
unitPriceFromModel: anObject
	"the editing unit price has changed upon model decision, i.e. editing devices must be informed"
	self unitPrice: anObject.
	self changed: #unitPrice.! !

!StockEventDetailEditController methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:23'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for the event being edited"

	self subclassResponsibility ! !

!StockEventDetailEditController methodsFor: 'actions' stamp: 'CarlosLombardi 5/4/2014 02:54'!
updateModel
	"update the StockEventDetail I am editing from the edited data I know"
	
	self model
		element: self element ;
		quantity: self quantity ;
		unitPrice: self unitPrice.

! !

StockEventDetailEditController subclass: #StockEventDetailEditControllerByItself
	instanceVariableNames: 'lab provider providerIsRelevant unitPriceIsEditable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

!StockEventDetailEditControllerByItself commentStamp: '<historical>' prior: 0!
An EditingStockEventDetail without context, i.e. it knows directly  to which lab and provider it must refer to!

!StockEventDetailEditControllerByItself methodsFor: 'initialize-release' stamp: 'CLom 11/22/2014 02:50'!
initialize
	"preparation for life"

	super initialize.
	self 
		providerIsRelevant: true ; 
		unitPriceIsEditable: true.! !

!StockEventDetailEditControllerByItself methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 18:38'!
lab
	^ lab! !

!StockEventDetailEditControllerByItself methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 18:38'!
lab: anObject
	lab := anObject! !

!StockEventDetailEditControllerByItself methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 18:38'!
provider
	^ provider! !

!StockEventDetailEditControllerByItself methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 18:38'!
provider: anObject
	provider := anObject! !

!StockEventDetailEditControllerByItself methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:26'!
providerIsRelevant
	"whether the provider is relevant for the event being edited"

	^providerIsRelevant 
	! !

!StockEventDetailEditControllerByItself methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:27'!
providerIsRelevant: trueOrFalse
	"whether the provider is relevant for the event being edited"

	providerIsRelevant := trueOrFalse
	! !

!StockEventDetailEditControllerByItself methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:26'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for the event being edited"

	^unitPriceIsEditable ! !

!StockEventDetailEditControllerByItself methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:27'!
unitPriceIsEditable: trueOrFalse
	"whether the unit price of each detail can be changed by the user, for the event being edited"

	unitPriceIsEditable := trueOrFalse! !

StockEventDetailEditController subclass: #StockEventDetailEditControllerInsideEvent
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

!StockEventDetailEditControllerInsideEvent commentStamp: '<historical>' prior: 0!
An EditingStockEventDetail which context is provided by a (n Editing)BuyingEvent.
!

!StockEventDetailEditControllerInsideEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 19:21'!
event
	^ event! !

!StockEventDetailEditControllerInsideEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 19:21'!
event: anObject
	event := anObject! !

!StockEventDetailEditControllerInsideEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 19:22'!
lab
	"the lab I use as a info repository"

	^self event lab! !

!StockEventDetailEditControllerInsideEvent methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 19:22'!
provider
	"the provider related with this detail, if any"

	^self event provider! !

!StockEventDetailEditControllerInsideEvent methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:30'!
providerIsRelevant
	"whether the provider is relevant for the event being edited"

	^self event providerIsRelevant ! !

!StockEventDetailEditControllerInsideEvent methodsFor: 'configuration' stamp: 'CLom 11/22/2014 02:30'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for the event being edited"

	^self event unitPriceIsEditable ! !

Object subclass: #StockEventEditController
	uses: TEventComputations
	instanceVariableNames: 'lab eventClass provider date editingDetails extraAmount savedEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

!StockEventEditController commentStamp: '<historical>' prior: 0!
An edition controller for a stock event.

Instance variables:

savedEvent
Is the event created and saved by this edit controller, cfr. saveEvent. 
It can be useful for additional save actions in subclasses. This is the only reason to include this instance variable.

!

StockEventEditController class
	uses: TEventComputations classTrait
	instanceVariableNames: ''!

StockEventEditController subclass: #BuyingEventController
	instanceVariableNames: 'requirement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Model'!

!BuyingEventController commentStamp: '<historical>' prior: 0!
An edition controller for a BuyingEvent!

!BuyingEventController class methodsFor: 'instance creation' stamp: 'CLom 12/7/2014 00:33'!
forNewEvent
	"a new EditController to edit a new BuyingEvent"

	^self forNewEventOfClass: ReagentBuyingEvent.! !

!BuyingEventController methodsFor: 'accessing' stamp: 'CLom 12/7/2014 00:34'!
buyingRequirement
	^ requirement! !

!BuyingEventController methodsFor: 'accessing' stamp: 'CLom 12/13/2014 12:59'!
buyingRequirement: anObject
	"a requirement is set; the detail list is filled with the requirement details"
	| newDetail oldRequirement |
	
	oldRequirement := requirement.
	requirement := anObject.
	
	requirement ifNotNil: [ 
		self clearDetails.
		requirement details do: [ :rdet |
			newDetail := StockEventDetailEditController forNewDetailInsideEvent: self.
			newDetail 
				element: rdet element ;
				quantity: rdet quantity.
			self  addToDetails: newDetail.
		].
		((5 - requirement details size) max: 2) timesRepeat: [ self addNewDetail ].
		self changed: #detailList ; changed: #totalAmount.
	].

	(requirement isNil & oldRequirement notNil) ifTrue: [ 
		self clearDetails.
		5 timesRepeat: [ self addNewDetail ].
		self changed: #detailList ; changed: #totalAmount.
	 ]
! !

!BuyingEventController methodsFor: 'actions' stamp: 'CLom 12/13/2014 14:15'!
saveEvent
	"save the editing event in the reference lab. 
 	 Up to now, only the record of a new event is implemented.
	 The update of an existing event is left for future work"

	| satisfaction |
	super saveEvent.
	self buyingRequirement ifNotNil: [ 
		satisfaction := savedEvent generateSatisfactionForRequirement: self buyingRequirement originalRequirement.
		satisfaction details notEmpty ifTrue: [ 
			self lab addToEvents: satisfaction.
		].
	].
! !

!StockEventEditController class methodsFor: 'instance creation' stamp: 'CLom 11/22/2014 01:02'!
forNewEventOfClass: anEventClass
	"creates a new model-side controller for the edition of a new instance of anEventClass"

	| newEditingEvent |
	newEditingEvent := self new.
	newEditingEvent eventClass: anEventClass.
	5 timesRepeat: [ newEditingEvent addNewDetail ].
	^newEditingEvent! !

!StockEventEditController methodsFor: 'details' stamp: 'CarlosLombardi 5/4/2014 02:41'!
addNewDetail
	"add a new, blank detail, at the bottom of the list of details"

	| newDetail |
	newDetail := StockEventDetailEditController forNewDetailInsideEvent: self.
	editingDetails addLast: newDetail.
	newDetail addDependent: self.
! !

!StockEventEditController methodsFor: 'details' stamp: 'CLom 12/7/2014 00:51'!
addToDetails: aStockEventDetailEditController
	"add the given detail at the bottom of the list of details"

	editingDetails addLast: aStockEventDetailEditController.
	aStockEventDetailEditController addDependent: self.
! !

!StockEventEditController methodsFor: 'details' stamp: 'CLom 12/7/2014 00:48'!
clearDetails
	"clear the set of editing details"

	editingDetails := OrderedCollection new.
! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/19/2014 22:11'!
date
	^ date! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/19/2014 22:11'!
date: anObject
	date := anObject! !

!StockEventEditController methodsFor: 'details' stamp: 'CarlosLombardi 3/25/2014 00:16'!
details
	"the StockEventDetail corresponding to the details I am editing"

	^self editingDetails ! !

!StockEventEditController methodsFor: 'details' stamp: 'CarlosLombardi 3/18/2014 20:34'!
editingDetails
	"a list including the view-model representation (i.e. instances of EditingStockEventDetail)
	 included in this editing action"

	^editingDetails! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CLom 11/22/2014 01:01'!
eventClass
	^ eventClass! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CLom 11/22/2014 01:01'!
eventClass: anObject
	eventClass := anObject! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/23/2014 10:19'!
extraAmount
	^ extraAmount! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/23/2014 11:37'!
extraAmount: anObject
	extraAmount := anObject.
	self changed: #totalAmount! !

!StockEventEditController methodsFor: 'configuration' stamp: 'CLom 11/22/2014 01:56'!
extraAmountIsRelevant
	"whether the extra amount is relevant for the event being edited"

	^self eventClass extraAmountIsRelevant ! !

!StockEventEditController methodsFor: 'initialize-release' stamp: 'CLom 12/7/2014 00:48'!
initialize
	"preparation for life"

	self clearDetails.
	extraAmount := 0.
	date := Date today.! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 19:32'!
lab
	^ lab! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 19:32'!
lab: anObject
	lab := anObject! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CarlosLombardi 3/18/2014 19:32'!
provider
	^ provider! !

!StockEventEditController methodsFor: 'accessing' stamp: 'CLom 12/7/2014 01:45'!
provider: newProvider
	| oldProvider |
	oldProvider :=  self provider .
	provider := newProvider.
	(oldProvider = newProvider) ifFalse: [ 
		self editingDetails do: [ :detail | detail recomputeUnitPrice ] .
		self changed: #providerChangedFromModel .
	]! !

!StockEventEditController methodsFor: 'configuration' stamp: 'CLom 11/22/2014 01:57'!
providerIsRelevant
	"whether the provider is relevant for the event being edited"

	^self eventClass providerIsRelevant ! !

!StockEventEditController methodsFor: 'details' stamp: 'CarlosLombardi 3/18/2014 20:46'!
removeFromEditingDetails: anEditingDetail
	"..."

	editingDetails remove: anEditingDetail ! !

!StockEventEditController methodsFor: 'actions' stamp: 'CLom 12/17/2014 00:51'!
saveEvent
	"save the editing event in the reference lab. 
 	 Up to now, only the record of a new event is implemented.
	 The update of an existing event is left for future work"

	| newEvent newDetail |
	self editingDetails do: [ :detail | detail updateModel ].
	newEvent := self eventClass new.
	newEvent 
		lab: self lab ;
		date: self date.
	self providerIsRelevant ifTrue: [ newEvent provider: self provider ].
	self extraAmountIsRelevant ifTrue: [ newEvent extraAmount: self extraAmount ].
	self editingDetails reject: [:editingDetail | editingDetail isBlank ] thenDo: [ :editingDetail | 
		newDetail := editingDetail model.
		newEvent addToDetails: newDetail.
		newDetail event: newEvent ].
	self lab addToEvents: newEvent.
	savedEvent := newEvent.
	
	"must also add the provider to the lab, if it is not already registered"
	self providerIsRelevant ifTrue: [ self lab addToReferenceAuthorities: self provider. ].! !

!StockEventEditController methodsFor: 'configuration' stamp: 'CLom 11/22/2014 01:57'!
unitPriceIsEditable
	"whether the unit price of each detail can be changed by the user, for the event being edited"

	^self eventClass unitPriceIsEditable! !

!StockEventEditController methodsFor: 'updating' stamp: 'CarlosLombardi 3/23/2014 11:28'!
update: aSymbol
	"handling of receiving events"

	"events from the details"
	"total amount of a detail changed"
	(aSymbol = #totalAmount)
		ifTrue: [ self changed: #totalAmount ].
! !

Object subclass: #StockEventPartialQuantity
	uses: TCreateStockEventDetailCopier
	instanceVariableNames: 'originalDetail quantity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

StockEventPartialQuantity class
	uses: TCreateStockEventDetailCopier classTrait
	instanceVariableNames: ''!

StockEventPartialQuantity subclass: #BuyingRequirementPendingDetail
	uses: TEventDetailComputations
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

BuyingRequirementPendingDetail class
	uses: TEventDetailComputations classTrait
	instanceVariableNames: ''!

!BuyingRequirementPendingDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:20'!
amountForOriginalQuantity
	"the total amount corresponding to this detail, for its original quantity"

	^(self unitPrice * self originalQuantity) round: 2! !

!BuyingRequirementPendingDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:18'!
event
	^ event! !

!BuyingRequirementPendingDetail methodsFor: 'accessing' stamp: 'CLom 11/25/2014 11:18'!
event: anObject
	event := anObject! !

!BuyingRequirementPendingDetail methodsFor: 'accessing' stamp: 'CLom 12/22/2014 03:11'!
unitPrice
	"the current unit price for this detail"

	^PriceCalculator new
		lab: self event lab ;
		stockElement: self element ;
		lastPrice
"	^(PriceCalculator new
		lab: self event lab ;
		stockElement: self element ;
		lastPrice)
	  max: self originalDetail unitPrice"! !

!StockEventPartialQuantity class methodsFor: 'instance creation' stamp: 'CLom 11/25/2014 16:23'!
for: aBuyingRequirementDetail
	"creates and answers an object representing the pending state of the given requirement detail"

	^self new 
		originalDetail: aBuyingRequirementDetail ; 
		quantity: aBuyingRequirementDetail quantity ;
		yourself! !

!StockEventPartialQuantity methodsFor: 'accessing' stamp: 'CLom 11/25/2014 16:19'!
decreaseQuantity: anAmount
	"decrease my pending quantity by anAmount"
	quantity := quantity - anAmount! !

!StockEventPartialQuantity methodsFor: 'accessing' stamp: 'CLom 11/25/2014 16:18'!
element
	"the stock element being required"
	^ self originalDetail element ! !

!StockEventPartialQuantity methodsFor: 'accessing' stamp: 'CLom 11/25/2014 16:19'!
isFulfilled
	^ self quantity <= 0! !

!StockEventPartialQuantity methodsFor: 'accessing' stamp: 'CLom 12/6/2014 16:25'!
originalDetail
	^ originalDetail originalDetail! !

!StockEventPartialQuantity methodsFor: 'accessing' stamp: 'CLom 11/25/2014 16:18'!
originalDetail: anObject
	originalDetail := anObject! !

!StockEventPartialQuantity methodsFor: 'accessing' stamp: 'CLom 11/25/2014 16:18'!
originalQuantity
	"the quantity originally required"
	^ self originalDetail quantity ! !

!StockEventPartialQuantity methodsFor: 'accessing' stamp: 'CLom 11/25/2014 16:18'!
quantity
	^ quantity! !

!StockEventPartialQuantity methodsFor: 'accessing' stamp: 'CLom 11/25/2014 16:18'!
quantity: anObject
	quantity := anObject! !

Object subclass: #StockUnit
	instanceVariableNames: 'name prependX'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Model'!

!StockUnit commentStamp: '<historical>' prior: 0!
A unit to measure stock, e.g. 
unidad
caja
10 ml
!

!StockUnit methodsFor: 'printing' stamp: 'CarlosLombardi 3/27/2014 22:54'!
asString
	"a String to render me"

	^self name 
		ifNil: [ '' ] 
		ifNotNil: [ :theName | (self prependX ifTrue: [ 'x ' ] ifFalse: [ '' ]), theName ]! !

!StockUnit methodsFor: 'initialize-release' stamp: 'CarlosLombardi 3/27/2014 23:16'!
initialize
	"preparation for life"

	super initialize.
	prependX  := true.! !

!StockUnit methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 22:52'!
name
	^ name! !

!StockUnit methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 22:52'!
name: anObject
	name := anObject! !

!StockUnit methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 22:53'!
prependX
	"whether a legend 'x ' must be prepended when showing this stock unit"
	^ prependX! !

!StockUnit methodsFor: 'accessing' stamp: 'CarlosLombardi 3/27/2014 22:53'!
prependX: anObject
	"whether a legend 'x ' must be prepended when showing this stock unit"
	prependX := anObject! !

Object subclass: #TitleBuilder
	uses: TUIGoodies
	instanceVariableNames: 'morphBuilder'
	classVariableNames: 'DateConverter'
	poolDictionaries: ''
	category: 'LaBook-View-Polymorph'!

!TitleBuilder commentStamp: '<historical>' prior: 0!
A helper to create the titleBox of a morphListEditor!

TitleBuilder class
	uses: TUIGoodies classTrait
	instanceVariableNames: ''!

!TitleBuilder methodsFor: 'actions' stamp: 'CLom 12/27/2014 03:15'!
addMorph: aMorph
	"add the given morph to the title box"

	morphBuilder addMorph: aMorph.
! !

!TitleBuilder methodsFor: 'actions' stamp: 'CLom 12/27/2014 11:33'!
addMorph: aMorph centeredInWidth: aNumber
	"add the given morph to the title box"

	morphBuilder addMorph: (self morph: aMorph centeredInWidth: aNumber).
! !

!TitleBuilder methodsFor: 'actions' stamp: 'CLom 12/27/2014 03:15'!
addString: aString centeredInWidth: aNumber
	"add a new column to the title box, centered wrt the given width"

	self addMorph: (self stringMorphFor: aString centeredInWidth: aNumber).
! !

!TitleBuilder methodsFor: 'actions' stamp: 'CLom 12/27/2014 03:15'!
addString: aString width: aNumber
	"add a new column to the title box. Include backslashes in the string in order 
	  to add a multi-line column"

	| columnTitleMorph |
	columnTitleMorph := (self stringMorphFor: aString) width: aNumber ; yourself.
	self addMorph: columnTitleMorph.
! !

!TitleBuilder methodsFor: 'actions' stamp: 'CLom 12/27/2014 16:33'!
cr
	"jumps to a new line"

	morphBuilder cr.
! !

!TitleBuilder methodsFor: 'private' stamp: 'CLom 12/27/2014 03:14'!
createMorphBuilder
	"a new morph builder"
	
	^MultiRowMorphBuilder new
		borderWidth: 2 ;
		fillStyle: Color veryVeryLightGray ;
		borderColor: Color darkGray ; 
		yourself
! !

!TitleBuilder methodsFor: 'initialize-release' stamp: 'CLom 12/27/2014 03:07'!
initialize
	"setup for life"

	super initialize.
	morphBuilder := self createMorphBuilder.
	^self! !

!TitleBuilder methodsFor: 'actions' stamp: 'CLom 12/27/2014 03:15'!
titleBox
	"the built title box"

	^morphBuilder morph! !

Object subclass: #TrivialRowDecorator
	uses: TRowDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Addons'!

!TrivialRowDecorator commentStamp: 'CarlosLombardi 5/24/2015 21:14' prior: 0!
A RowDecorator having no content.
!

TrivialRowDecorator class
	uses: TRowDecorator classTrait
	instanceVariableNames: ''!

!TrivialRowDecorator methodsFor: 'decorating' stamp: 'CarlosLombardi 5/24/2015 21:16'!
decoratedRowFor: aRowMorph inOrder: aNumber
	"returns the decorated row corresponding to the given parameters.
	 As I am a trivial row decorator, I just return the given row without changes"

	^aRowMorph! !

Object subclass: #UIConverters
	instanceVariableNames: ''
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'LaBook-View-Basics'!

!UIConverters commentStamp: 'CarlosLombardi 5/22/2015 11:13' prior: 0!
Utility class giving access to standard data converters.
!

!UIConverters class methodsFor: 'private - registry setting' stamp: 'CarlosLombardi 5/22/2015 11:42'!
clearRegistry
	"private - ..."

	Registry := nil .
! !

!UIConverters class methodsFor: 'converters' stamp: 'CarlosLombardi 5/22/2015 11:44'!
dateConverter
	"a ObjectStringConverter for dates using dd/mm/yyyy as format"

	^self registry at: #date
! !

!UIConverters class methodsFor: 'converters' stamp: 'CarlosLombardi 5/22/2015 11:44'!
positiveNumberConverter
	"a ObjectStringConverter for positive real numbers (i.e. not restricted to integers) "

	^self registry at: #positiveNumber
! !

!UIConverters class methodsFor: 'private - registry setting' stamp: 'CarlosLombardi 5/22/2015 11:42'!
registerDateConverter
	"private - ..."

	Registry at: #date put: ObjectEditor dateConverter
	
! !

!UIConverters class methodsFor: 'private - registry setting' stamp: 'CarlosLombardi 5/22/2015 11:26'!
registerPositiveNumberConverter
	"private - ..."

	| newConverter |
	newConverter := ObjectStringConverter new.
	newConverter objectClass: Number ;
		regexString: '[0-9]+';
		stringTransformBlock: [:s | s select: [:c | c isDigit | (c = $.) ] ] .
	
	Registry at: #positiveNumber put: newConverter .
	
! !

!UIConverters class methodsFor: 'private - registry setting' stamp: 'CarlosLombardi 5/22/2015 11:27'!
registerStandardConverters
	"private - ..."

	self registerDateConverter .
	self registerPositiveNumberConverter .	
! !

!UIConverters class methodsFor: 'private - registry setting' stamp: 'CarlosLombardi 5/22/2015 11:44'!
registry
	"private - the registry for ready-to-use converters"

	^Registry ifNil: [ 
		Registry := Dictionary new .
		self registerStandardConverters .
		Registry .
	]
	
! !

!Trait methodsFor: '*LaBook' stamp: 'CLom 11/25/2014 19:19'!
prettyName

	^ self printString! !

BorderedMorph subclass: #ActiveFileFieldMorph
	uses: TUIGoodies
	instanceVariableNames: 'model fullNameField existenceMarkField actionButton fileChooserButton defaultPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!ActiveFileFieldMorph commentStamp: 'CarlosLombardi 2/17/2015 20:31' prior: 0!
An object who knows how to edit a ActiveFile as a field.
!

ActiveFileFieldMorph class
	uses: TUIGoodies classTrait
	instanceVariableNames: ''!

!ActiveFileFieldMorph methodsFor: 'ui accessing' stamp: 'CarlosLombardi 2/18/2015 00:54'!
actionButton
	"the action button"

	^actionButton! !

!ActiveFileFieldMorph methodsFor: 'ui building' stamp: 'CarlosLombardi 2/17/2015 21:04'!
buildActionButton
	"build the button leading to the external action on my model file"

	| newButton |
	newButton := self uiBuilder
		newButtonFor: self model
		action: #performAction
		label: 'Abrir' translated
		help: 'Abrir el archivo seleccionado' translated.
	newButton 
		setNameTo: 'actionButton' ;
		enabled: false.
	^ newButton! !

!ActiveFileFieldMorph methodsFor: 'ui building' stamp: 'CarlosLombardi 2/18/2015 02:27'!
buildExistenceField
	"Private - builds and returns a Morph to show whether my model corresponds to an existing file"

	| newField |
	newField := self 
		buildDynamicTextFor: self model 
		get: [ :file | file fullName ifEmpty: [ '' ] ifNotEmpty: [ file exists ifTrue: [ 'Existe' ] ifFalse: [ 'No existe' ] ] ]
		class: String 
		width: ('No existe' asMorph width).
	newField setNameTo: 'existenceMark'.
	^newField
! !

!ActiveFileFieldMorph methodsFor: 'ui building' stamp: 'EstebanTolaba 9/4/2015 17:32'!
buildFileChooserButton
	"build the button leading to the external action on my model file"

	| newButton |
	newButton := self uiBuilder
		newButtonFor: self 
		action: #chooseFile
		label: Smalltalk ui icons smallOpenIcon asMorph
		help: 'Elegir archivo' translated.
	newButton 
		setNameTo: 'fileChooserButton' ;
		enabled: true.
	^ newButton! !

!ActiveFileFieldMorph methodsFor: 'ui building' stamp: 'CarlosLombardi 2/28/2015 01:07'!
buildFullNameField
	"Private - builds and returns a Morph to edit my fullname"

	| newField |
	newField := self uiBuilder
		newSingleLineTextEntryFor: self model
		getText: #fullName
		setText: #fullName:
		help: 'Path completo del archivo'.
	newField 
		acceptOnCR: true ;
		acceptOnFocusChange: true ;
		minWidth: 400.
	^newField
! !

!ActiveFileFieldMorph methodsFor: 'ui building' stamp: 'CarlosLombardi 2/18/2015 02:03'!
buildMorph
	"builds the composite morph inside me"

	| result |
	result := self buildEmptyRow.
	fullNameField := self buildFullNameField.
	existenceMarkField := self buildExistenceField.
	actionButton := self buildActionButton.
	fileChooserButton := self buildFileChooserButton.
	
	result
		addMorphBack: fileChooserButton ;
		addMorphBack: fullNameField ;
		addMorphBack: existenceMarkField ;
		addMorphBack: actionButton .
	
	self removeAllMorphs ; addMorphBack: result.! !

!ActiveFileFieldMorph methodsFor: 'ui actions' stamp: 'CarlosLombardi 2/28/2015 01:43'!
chooseFile
	"open the file chooser"

	| result |
	result := self uiBuilder theme 
		chooseFullFileNameIn: self uiBuilder 
		title: 'Archivo a vincular con la actividad' 
		extensions: nil 
		path: self pathToFindFiles 
		preview: nil.
	result ifNotNil: [ self model fullName: result ]
	! !

!ActiveFileFieldMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 2/28/2015 02:32'!
defaultPathFullName: aString
	"set the full name of the default path for me"

	defaultPath :=
		( ( aString isNil or: [aString isEmpty] ) ifTrue: [ nil ]
		  ifFalse: [ 
				(FileReference 
					fileSystem: FileSystem disk 
					path: (FileSystem disk resolveString: aString))
		  ] )
! !

!ActiveFileFieldMorph methodsFor: 'ui accessing' stamp: 'CarlosLombardi 2/18/2015 00:54'!
existenceMarkField
	"the field marking the (non) existence of the file being referenced by my model"

	^existenceMarkField! !

!ActiveFileFieldMorph methodsFor: 'ui accessing' stamp: 'CarlosLombardi 2/18/2015 00:54'!
fullNameField
	"the field to edit the name of the file being referenced by my model"

	^fullNameField! !

!ActiveFileFieldMorph methodsFor: 'initailize-release' stamp: 'CarlosLombardi 2/18/2015 00:31'!
initialize
	"preparation for life"

	super initialize.
	self 
		color: Color transparent ; borderColor: Color transparent ;
		borderWidth: 0 ; width: 0 ; height: 0 .
! !

!ActiveFileFieldMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 2/17/2015 20:41'!
model
	"the model I am editing, which should be an ActiveFile"

	^model! !

!ActiveFileFieldMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 2/18/2015 00:49'!
model: anActiveFile
	"the model I am editing, which should be an ActiveFile"

	model := anActiveFile.
	anActiveFile addDependent: self.
	self buildMorph.
	self updateView.! !

!ActiveFileFieldMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 2/28/2015 01:19'!
pathToFindFiles
	"the full name of the path where my file chooser must open upon"

	self model reference ifNotNil: [ :ref | ^ref parent fullName ].
	( defaultPath notNil and: [ defaultPath exists ] ) ifTrue: [ ^defaultPath fullName ].
	^nil
! !

!ActiveFileFieldMorph methodsFor: 'updating' stamp: 'CarlosLombardi 2/28/2015 02:17'!
update: aSymbol
	"process incomiing events"

	(aSymbol = #fileReference) ifTrue: [ 
		self updateView .
		self changed: #activeFile with: self model .
	] .
! !

!ActiveFileFieldMorph methodsFor: 'updating' stamp: 'CarlosLombardi 2/28/2015 01:07'!
updateView
	"update upon changes in my model"

"	self fullNameField 
		textColor: (self model exists ifTrue: [ Color r: 0.1 g: 0.7 b: 0.5 ] ifFalse: [ Color red ] ).
"
	self fullNameField setText: (self fullNameField getText).
	self fullNameField setExplicitColor: 
		( (self model reference isNil | self model exists) ifTrue: [ Color white ] ifFalse: [ Color r: 1 g: 0.9 b: 0.9 ] ) .
	self existenceMarkField 
		textColor: (self model exists ifTrue: [ Color r: 0.1 g: 0.7 b: 0.5 ] ifFalse: [ Color red ] ) ;
		textChanged.
	self actionButton enabled: ( self model hasAvailableAction  )! !

BorderedMorph subclass: #DynamicTextMorph
	instanceVariableNames: 'model converter getSelector textColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-Morphic-Addons'!

!DynamicTextMorph commentStamp: '<historical>' prior: 0!
A graphical representation of the result of sending a message to an object. This value is rendered through its #asString inside a bordered morph.
At the moment, automatic update is not supported. In order to update me, you have to send me the #textChanged message.!

!DynamicTextMorph class methodsFor: 'instance creation' stamp: 'CLom 11/24/2014 00:28'!
newTransparentFor: obj get: aSelectorOrBlock class: aClass
	"create and answer a new DynamicTextMorph to show the result of obj>>aSelectorOrBlock, 
	  or aSelectorOrBlock value: obj, formated as an aClass instance.
	  I am transparent except for the text to render. My size is that of the text I render. "

	^self new
		model: obj ; 
		getSelectorOrBlock: aSelectorOrBlock ;
		converter: (ObjectStringConverter forClass: aClass) ;
		borderWidth: 0 ;
		color: Color transparent ;
		fillStyle: Color transparent ;
		changeTableLayout ;
		hResizing: #shrinkWrap ;
		vResizing: #shrinkWrap ;
		yourself! !

!DynamicTextMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 3/14/2014 18:28'!
converter
	^ converter! !

!DynamicTextMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 3/14/2014 18:35'!
converter: anObject
	converter := anObject.
	self textChanged.! !

!DynamicTextMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 3/16/2014 22:10'!
font
	^ self textSubmorph font! !

!DynamicTextMorph methodsFor: 'text' stamp: 'CLom 11/24/2014 00:46'!
getSelector
	"it is useful for Morph>>submorphNamed:"
	^ getSelector isSymbol 
		ifTrue: [ getSelector ]
		ifFalse: [ nil ]! !

!DynamicTextMorph methodsFor: 'text' stamp: 'CLom 11/24/2014 00:29'!
getSelectorOrBlock
	^ getSelector! !

!DynamicTextMorph methodsFor: 'text' stamp: 'CLom 11/24/2014 00:28'!
getSelectorOrBlock: anObject
	getSelector := anObject.
	self textChanged.! !

!DynamicTextMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 3/14/2014 18:28'!
model
	^ model! !

!DynamicTextMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 3/14/2014 18:34'!
model: anObject
	model := anObject.
	self textChanged.! !

!DynamicTextMorph methodsFor: 'text' stamp: 'CarlosLombardi 3/14/2014 18:46'!
text
	^ self converter 
		ifNil: [ nil ]
		ifNotNil: [ :conv | conv objectAsString: self valueToRender  ] ! !

!DynamicTextMorph methodsFor: 'updating' stamp: 'CLom 11/24/2014 21:13'!
textChanged
	"I have to adapt to changes in my model"

	| textMorph |
	textMorph := StringMorph contents: self text.
	self textColor ifNotNil: [ : theColor | textMorph color: theColor ].
	self
		removeAllMorphs;
		addMorphBack: textMorph ! !

!DynamicTextMorph methodsFor: 'accessing' stamp: 'CLom 11/24/2014 21:11'!
textColor
	^ textColor! !

!DynamicTextMorph methodsFor: 'accessing' stamp: 'CLom 11/24/2014 21:11'!
textColor: anObject
	textColor := anObject! !

!DynamicTextMorph methodsFor: 'accessing' stamp: 'CarlosLombardi 3/16/2014 22:10'!
textSubmorph 
	^ self submorphs first! !

!DynamicTextMorph methodsFor: 'text' stamp: 'CLom 11/24/2014 00:50'!
valueToRender
	^ (self model isNil | self getSelectorOrBlock isNil)
		ifFalse: [ self getSelectorOrBlock value: self model ]
		ifTrue: [ nil ]! !

!UITheme methodsFor: '*LaBook' stamp: 'FernandoDiMeglio 11/3/2015 23:37'!
newLogEntryDialogWindowIn: aThemedMorph title: title for: contentMorph
    "Answer a new pluggable dialog panel with the given content."

    |answer|
    answer := LogEntryDialogWindow new
        setWindowColor: aThemedMorph paneColor;
        title: title;
        contentMorph: contentMorph.
    contentMorph ifNotNil: [answer model: nil].
    ^answer! !

!UITheme methodsFor: '*LaBook' stamp: 'CarlosLombardi 2/14/2015 16:08'!
newSingleLineTextEntryIn: aThemedMorph for: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a single-line text entry for the given model."

	|pt|
	pt := PluggableTextSingleLineFieldMorph new
		convertTo: aClass;
		alwaysAccept: true;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: (self textEntryCornerStyleIn: aThemedMorph);
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		selectionColor: self selectionColor;
		hideScrollBarsIndefinitely;
		extent: 24@(self textFont height + 8);
		setBalloonText: helpText.
	pt textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	^pt! !

!UITheme methodsFor: '*LaBook' stamp: 'FernandoDiMeglio 10/27/2015 21:38'!
newTextMorphKeyStrokeSignalIn: aThemedMorph context: aLabProjectEditor for: aModel get: getSel set: setSel class: aClass getEnabled: enabledSel help: helpText
	"Answer a single-line text entry for the given model."

	|pt|
	pt := TextMorphKeyStrokeSignal new
		convertTo: aClass;
		alwaysAccept: true;
		on: aModel
		text: getSel
		accept: setSel
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: enabledSel;
		font: self textFont;
		cornerStyle: (self textEntryCornerStyleIn: aThemedMorph);
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		selectionColor: self selectionColor;
		hideScrollBarsIndefinitely;
		extent: 24@(self textFont height + 8);
		setBalloonText: helpText.
	pt textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	pt
		context: aLabProjectEditor ;
		acceptOnFocusChange: false ;
		width: 200;
		hResizing: #rigid;
		vResizing: #rigid.
	^ pt! !

!TEasilyThemed methodsFor: '*LaBook' stamp: 'CarlosLombardi 2/14/2015 16:27'!
newSingleLineTextEntryFor: aModel getText: getSel setText: setSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newSingleLineTextEntryIn: self
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: nil
		help: helpText! !

!TEasilyThemed methodsFor: '*LaBook' stamp: 'FernandoDiMeglio 10/27/2015 20:56'!
newTextMorphKeyStrokeSignalFor: aModel context: aLabProjectEditor getText: getSel setText: setSel help: helpText
	"Answer a text entry for the given model."

	^self theme
		newTextMorphKeyStrokeSignalIn: self
		context: aLabProjectEditor
		for: aModel
		get: getSel
		set: setSel
		class: String
		getEnabled: nil
		help: helpText! !

MorphTreeNodeModel subclass: #LabProjectLogEntryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LaBook-View-Log'!

!LabProjectLogEntryNode commentStamp: 'CarlosLombardi 3/5/2015 12:27' prior: 0!
I handle the inclusion of a log entry in a tree view.
!

!LabProjectLogEntryNode methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 12:31'!
childNodeClassFromItem: anItem
	"the adequate class to handle the given item, i.e., log entry"

	^self class! !

!LabProjectLogEntryNode methodsFor: 'accessing' stamp: 'CarlosLombardi 3/5/2015 12:30'!
childrenItems
	"my chidren in the log entry tree"

	^self item children! !
DialogWindow initialize!
